with GNATCOM.Dispinterface;

package IE.DWebBrowserEvents2_Object is

   type DWebBrowserEvents2_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure StatusTextChange
     (This : DWebBrowserEvents2_Type;
      Text : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Statusbar text changed.

   procedure ProgressChange
     (This        : DWebBrowserEvents2_Type;
      Progress    : GNATCOM.Types.VARIANT;
      ProgressMax : GNATCOM.Types.VARIANT;
      Free        : Boolean := True);
   --  Fired when download progress is updated.

   procedure CommandStateChange
     (This    : DWebBrowserEvents2_Type;
      Command : GNATCOM.Types.VARIANT;
      Enable  : GNATCOM.Types.VARIANT;
      Free    : Boolean := True);
   --  The enabled state of a command changed.

   procedure DownloadBegin
     (This : DWebBrowserEvents2_Type);
   --  Download of a page started.

   procedure DownloadComplete
     (This : DWebBrowserEvents2_Type);
   --  Download of page complete.

   procedure TitleChange
     (This : DWebBrowserEvents2_Type;
      Text : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Document title changed.

   procedure PropertyChange
     (This       : DWebBrowserEvents2_Type;
      szProperty : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);
   --  Fired when the PutProperty method has been called.

   procedure BeforeNavigate2
     (This            : DWebBrowserEvents2_Type;
      pDisp           : GNATCOM.Types.VARIANT;
      URL             : GNATCOM.Types.VARIANT;
      Flags           : GNATCOM.Types.VARIANT;
      TargetFrameName : GNATCOM.Types.VARIANT;
      PostData        : GNATCOM.Types.VARIANT;
      Headers         : GNATCOM.Types.VARIANT;
      Cancel          : GNATCOM.Types.VARIANT;
      Free            : Boolean := True);
   --  Fired before navigate occurs in the given WebBrowser (window or frameset
   --  element). The processing of this navigation may be modified.

   procedure NewWindow2
     (This   : DWebBrowserEvents2_Type;
      ppDisp : GNATCOM.Types.VARIANT;
      Cancel : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);
   --  A new, hidden, non-navigated WebBrowser window is needed.

   procedure NavigateComplete2
     (This  : DWebBrowserEvents2_Type;
      pDisp : GNATCOM.Types.VARIANT;
      URL   : GNATCOM.Types.VARIANT;
      Free  : Boolean := True);
   --  Fired when the document being navigated to becomes visible and enters
   --  the navigation stack.

   procedure DocumentComplete
     (This  : DWebBrowserEvents2_Type;
      pDisp : GNATCOM.Types.VARIANT;
      URL   : GNATCOM.Types.VARIANT;
      Free  : Boolean := True);
   --  Fired when the document being navigated to reaches ReadyState_Complete.

   procedure OnQuit
     (This : DWebBrowserEvents2_Type);
   --  Fired when application is quiting.

   procedure OnVisible
     (This    : DWebBrowserEvents2_Type;
      Visible : GNATCOM.Types.VARIANT;
      Free    : Boolean := True);
   --  Fired when the window should be shown/hidden

   procedure OnToolBar
     (This    : DWebBrowserEvents2_Type;
      ToolBar : GNATCOM.Types.VARIANT;
      Free    : Boolean := True);
   --  Fired when the toolbar  should be shown/hidden

   procedure OnMenuBar
     (This    : DWebBrowserEvents2_Type;
      MenuBar : GNATCOM.Types.VARIANT;
      Free    : Boolean := True);
   --  Fired when the menubar should be shown/hidden

   procedure OnStatusBar
     (This      : DWebBrowserEvents2_Type;
      StatusBar : GNATCOM.Types.VARIANT;
      Free      : Boolean := True);
   --  Fired when the statusbar should be shown/hidden

   procedure OnFullScreen
     (This       : DWebBrowserEvents2_Type;
      FullScreen : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);
   --  Fired when fullscreen mode should be on/off

   procedure OnTheaterMode
     (This        : DWebBrowserEvents2_Type;
      TheaterMode : GNATCOM.Types.VARIANT;
      Free        : Boolean := True);
   --  Fired when theater mode should be on/off

end IE.DWebBrowserEvents2_Object;

