with GNATCOM.Interface;

with GNATCOM.Errors;

package body IE.ISearch_Interface is

   procedure Initialize (This : in out ISearch_Type) is
   begin
      Set_IID (This, IID_ISearch);
   end Initialize;

   function Pointer (This : ISearch_Type)
     return Pointer_To_ISearch
   is
   begin
      return To_Pointer_To_ISearch (Address (This));
   end Pointer;

   procedure Attach (This    : in out ISearch_Type;
                     Pointer : in     Pointer_To_ISearch)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_Title
     (This       : ISearch_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Title
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Title;

    function Get_Id
     (This    : ISearch_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Id
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Id;

    function Get_URL
     (This     : ISearch_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_URL
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_URL;

end IE.ISearch_Interface;

