with GNATCOM.Dispinterface;

package IE.ISearchAssistantOC_Interface is

   type ISearchAssistantOC_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out ISearchAssistantOC_Type);

   function Pointer (This : ISearchAssistantOC_Type)
     return Pointer_To_ISearchAssistantOC;

   procedure Attach (This    : in out ISearchAssistantOC_Type;
                     Pointer : in     Pointer_To_ISearchAssistantOC);

   procedure AddNextMenuItem
     (This     : ISearchAssistantOC_Type;
      bstrText : GNATCOM.Types.BSTR;
      idItem   : Interfaces.C.long;
      Free     : Boolean := True);

   procedure SetDefaultSearchUrl
     (This    : ISearchAssistantOC_Type;
      bstrUrl : GNATCOM.Types.BSTR;
      Free    : Boolean := True);

   procedure NavigateToDefaultSearch
     (This : ISearchAssistantOC_Type);

   function IsRestricted
     (This     : ISearchAssistantOC_Type;
      bstrGuid : GNATCOM.Types.BSTR;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL;

   function Get_ShellFeaturesEnabled
     (This : ISearchAssistantOC_Type)
     return GNATCOM.Types.VARIANT_BOOL;
   --  property ShellFeaturesEnabled

   function Get_SearchAssistantDefault
     (This : ISearchAssistantOC_Type)
     return GNATCOM.Types.VARIANT_BOOL;
   --  property SearchAssistantDefault

   function Get_Searches
     (This : ISearchAssistantOC_Type)
     return Pointer_To_ISearches;
   --  Get searches

   function Get_InWebFolder
     (This : ISearchAssistantOC_Type)
     return GNATCOM.Types.VARIANT_BOOL;
   --  Returns true if the current folder is web folder

   procedure PutProperty
     (This       : ISearchAssistantOC_Type;
      bPerLocale : GNATCOM.Types.VARIANT_BOOL;
      bstrName   : GNATCOM.Types.BSTR;
      bstrValue  : GNATCOM.Types.BSTR;
      Free       : Boolean := True);

   function GetProperty
     (This       : ISearchAssistantOC_Type;
      bPerLocale : GNATCOM.Types.VARIANT_BOOL;
      bstrName   : GNATCOM.Types.BSTR;
      Free       : Boolean := True)
     return GNATCOM.Types.BSTR;

   procedure Put_EventHandled
     (This : ISearchAssistantOC_Type;
      P1   : GNATCOM.Types.VARIANT_BOOL);

   procedure ResetNextMenu
     (This : ISearchAssistantOC_Type);

   procedure FindOnWeb
     (This : ISearchAssistantOC_Type);

   procedure FindFilesOrFolders
     (This : ISearchAssistantOC_Type);

   procedure FindComputer
     (This : ISearchAssistantOC_Type);

   procedure FindPrinter
     (This : ISearchAssistantOC_Type);

   procedure FindPeople
     (This : ISearchAssistantOC_Type);

   function GetSearchAssistantURL
     (This        : ISearchAssistantOC_Type;
      bSubstitute : GNATCOM.Types.VARIANT_BOOL;
      bCustomize  : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.BSTR;

   procedure NotifySearchSettingsChanged
     (This : ISearchAssistantOC_Type);

   procedure Put_ASProvider
     (This      : ISearchAssistantOC_Type;
      pProvider : GNATCOM.Types.BSTR;
      Free      : Boolean := True);

   function Get_ASProvider
     (This      : ISearchAssistantOC_Type)
     return GNATCOM.Types.BSTR;

   procedure Put_ASSetting
     (This     : ISearchAssistantOC_Type;
      pSetting : Interfaces.C.int);

   function Get_ASSetting
     (This     : ISearchAssistantOC_Type)
     return Interfaces.C.int;

   procedure NETDetectNextNavigate
     (This : ISearchAssistantOC_Type);

   procedure PutFindText
     (This     : ISearchAssistantOC_Type;
      FindText : GNATCOM.Types.BSTR;
      Free     : Boolean := True);

   function Get_Version
     (This     : ISearchAssistantOC_Type)
     return Interfaces.C.int;

   function EncodeString
     (This        : ISearchAssistantOC_Type;
      bstrValue   : GNATCOM.Types.BSTR;
      bstrCharSet : GNATCOM.Types.BSTR;
      bUseUTF8    : GNATCOM.Types.VARIANT_BOOL;
      Free        : Boolean := True)
     return GNATCOM.Types.BSTR;

end IE.ISearchAssistantOC_Interface;

