package body IE.ISearchAssistantOC_Object is

   procedure AddNextMenuItem
     (This     : ISearchAssistantOC_Type;
      bstrText : GNATCOM.Types.VARIANT;
      idItem   : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         ISearchAssistantOC_AddNextMenuItem,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => idItem,
          2 => bstrText),
         Free);
   end AddNextMenuItem;

   procedure SetDefaultSearchUrl
     (This    : ISearchAssistantOC_Type;
      bstrUrl : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         ISearchAssistantOC_SetDefaultSearchUrl,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bstrUrl),
         Free);
   end SetDefaultSearchUrl;

   procedure NavigateToDefaultSearch
     (This : ISearchAssistantOC_Type)
   is
   begin
      Invoke (This, ISearchAssistantOC_NavigateToDefaultSearch);
   end NavigateToDefaultSearch;

   function IsRestricted
     (This     : ISearchAssistantOC_Type;
      bstrGuid : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         ISearchAssistantOC_IsRestricted,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bstrGuid),
         Free);
   end IsRestricted;

   function Get_ShellFeaturesEnabled
     (This : ISearchAssistantOC_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, ISearchAssistantOC_Get_ShellFeaturesEnabled);
   end Get_ShellFeaturesEnabled;

   function Get_SearchAssistantDefault
     (This : ISearchAssistantOC_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, ISearchAssistantOC_Get_SearchAssistantDefault);
   end Get_SearchAssistantDefault;

   function Get_Searches
     (This : ISearchAssistantOC_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, ISearchAssistantOC_Get_Searches);
   end Get_Searches;

   function Get_InWebFolder
     (This : ISearchAssistantOC_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, ISearchAssistantOC_Get_InWebFolder);
   end Get_InWebFolder;

   procedure PutProperty
     (This       : ISearchAssistantOC_Type;
      bPerLocale : GNATCOM.Types.VARIANT;
      bstrName   : GNATCOM.Types.VARIANT;
      bstrValue  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
   is
   begin
      Invoke
        (This,
         ISearchAssistantOC_PutProperty,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bstrValue,
          2 => bstrName,
          3 => bPerLocale),
         Free);
   end PutProperty;

   function GetProperty
     (This       : ISearchAssistantOC_Type;
      bPerLocale : GNATCOM.Types.VARIANT;
      bstrName   : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         ISearchAssistantOC_GetProperty,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bstrName,
          2 => bPerLocale),
         Free);
   end GetProperty;

   procedure Put_EventHandled
     (This : ISearchAssistantOC_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         ISearchAssistantOC_Put_EventHandled,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_EventHandled;

   procedure ResetNextMenu
     (This : ISearchAssistantOC_Type)
   is
   begin
      Invoke (This, ISearchAssistantOC_ResetNextMenu);
   end ResetNextMenu;

   procedure FindOnWeb
     (This : ISearchAssistantOC_Type)
   is
   begin
      Invoke (This, ISearchAssistantOC_FindOnWeb);
   end FindOnWeb;

   procedure FindFilesOrFolders
     (This : ISearchAssistantOC_Type)
   is
   begin
      Invoke (This, ISearchAssistantOC_FindFilesOrFolders);
   end FindFilesOrFolders;

   procedure FindComputer
     (This : ISearchAssistantOC_Type)
   is
   begin
      Invoke (This, ISearchAssistantOC_FindComputer);
   end FindComputer;

   procedure FindPrinter
     (This : ISearchAssistantOC_Type)
   is
   begin
      Invoke (This, ISearchAssistantOC_FindPrinter);
   end FindPrinter;

   procedure FindPeople
     (This : ISearchAssistantOC_Type)
   is
   begin
      Invoke (This, ISearchAssistantOC_FindPeople);
   end FindPeople;

   function GetSearchAssistantURL
     (This        : ISearchAssistantOC_Type;
      bSubstitute : GNATCOM.Types.VARIANT;
      bCustomize  : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         ISearchAssistantOC_GetSearchAssistantURL,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bCustomize,
          2 => bSubstitute),
         Free);
   end GetSearchAssistantURL;

   procedure NotifySearchSettingsChanged
     (This : ISearchAssistantOC_Type)
   is
   begin
      Invoke (This, ISearchAssistantOC_NotifySearchSettingsChanged);
   end NotifySearchSettingsChanged;

   procedure Put_ASProvider
     (This : ISearchAssistantOC_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         ISearchAssistantOC_Put_ASProvider,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_ASProvider;

   function Get_ASProvider
     (This : ISearchAssistantOC_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, ISearchAssistantOC_Get_ASProvider);
   end Get_ASProvider;

   procedure Put_ASSetting
     (This : ISearchAssistantOC_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         ISearchAssistantOC_Put_ASSetting,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_ASSetting;

   function Get_ASSetting
     (This : ISearchAssistantOC_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, ISearchAssistantOC_Get_ASSetting);
   end Get_ASSetting;

   procedure NETDetectNextNavigate
     (This : ISearchAssistantOC_Type)
   is
   begin
      Invoke (This, ISearchAssistantOC_NETDetectNextNavigate);
   end NETDetectNextNavigate;

   procedure PutFindText
     (This     : ISearchAssistantOC_Type;
      FindText : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         ISearchAssistantOC_PutFindText,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => FindText),
         Free);
   end PutFindText;

   function Get_Version
     (This : ISearchAssistantOC_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, ISearchAssistantOC_Get_Version);
   end Get_Version;

   function EncodeString
     (This        : ISearchAssistantOC_Type;
      bstrValue   : GNATCOM.Types.VARIANT;
      bstrCharSet : GNATCOM.Types.VARIANT;
      bUseUTF8    : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         ISearchAssistantOC_EncodeString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bUseUTF8,
          2 => bstrCharSet,
          3 => bstrValue),
         Free);
   end EncodeString;

end IE.ISearchAssistantOC_Object;

