with GNATCOM.Interface;

with GNATCOM.Errors;

package body IE.ISearches_Interface is

   procedure Initialize (This : in out ISearches_Type) is
   begin
      Set_IID (This, IID_ISearches);
   end Initialize;

   function Pointer (This : ISearches_Type)
     return Pointer_To_ISearches
   is
   begin
      return To_Pointer_To_ISearches (Address (This));
   end Pointer;

   procedure Attach (This    : in out ISearches_Type;
                     Pointer : in     Pointer_To_ISearches)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_Count
     (This    : ISearches_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Count
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Count;

    function Get_Default
     (This         : ISearches_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Default
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Default;

    function Item
     (This  : ISearches_Type;
      index : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free  : Boolean := True)
     return Pointer_To_ISearch
   is
       RetVal : aliased Pointer_To_ISearch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Item
         (Pointer (This),
          index,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (index);
      
      end if;

      return RetVal;
   end Item;

    function uNewEnum
     (This  : ISearches_Type)
     return GNATCOM.Types.Pointer_To_IUnknown
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IUnknown;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.uNewEnum
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end uNewEnum;

end IE.ISearches_Interface;

