with GNATCOM.Errors;

package body MSHTML.IActiveIMMApp_Interface is

   procedure Initialize (This : in out IActiveIMMApp_Type) is
   begin
      Set_IID (This, IID_IActiveIMMApp);
   end Initialize;

   function Pointer (This : IActiveIMMApp_Type)
     return Pointer_To_IActiveIMMApp
   is
   begin
      return To_Pointer_To_IActiveIMMApp (Address (This));
   end Pointer;

   procedure Attach (This    : in out IActiveIMMApp_Type;
                     Pointer : in     Pointer_To_IActiveIMMApp)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure AssociateContext
     (This   : IActiveIMMApp_Type;
      hWnd   : wireHWND;
      hIME   : Interfaces.C.unsigned_long;
      phPrev : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.AssociateContext
         (Pointer (This),
          hWnd,
          hIME,
          phPrev));

   end AssociateContext;

   procedure ConfigureIMEA
     (This   : IActiveIMMApp_Type;
      hKL    : GNATCOM.Types.Pointer_To_Void;
      hWnd   : wireHWND;
      dwMode : Interfaces.C.unsigned_long;
      pData  : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0001)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.ConfigureIMEA
         (Pointer (This),
          hKL,
          hWnd,
          dwMode,
          pData));

   end ConfigureIMEA;

   procedure ConfigureIMEW
     (This   : IActiveIMMApp_Type;
      hKL    : GNATCOM.Types.Pointer_To_Void;
      hWnd   : wireHWND;
      dwMode : Interfaces.C.unsigned_long;
      pData  : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0002)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.ConfigureIMEW
         (Pointer (This),
          hKL,
          hWnd,
          dwMode,
          pData));

   end ConfigureIMEW;

   procedure CreateContext
     (This  : IActiveIMMApp_Type;
      phIMC : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.CreateContext
         (Pointer (This),
          phIMC));

   end CreateContext;

   procedure DestroyContext
     (This : IActiveIMMApp_Type;
      hIME : Interfaces.C.unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.DestroyContext
         (Pointer (This),
          hIME));

   end DestroyContext;

   procedure EnumRegisterWordA
     (This       : IActiveIMMApp_Type;
      hKL        : GNATCOM.Types.Pointer_To_Void;
      szReading  : GNATCOM.Types.LPSTR;
      dwStyle    : Interfaces.C.unsigned_long;
      szRegister : GNATCOM.Types.LPSTR;
      pData      : GNATCOM.Types.Pointer_To_Void;
      pEnum      : Pointer_To_Pointer_To_IEnumRegisterWordA)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.EnumRegisterWordA
         (Pointer (This),
          hKL,
          szReading,
          dwStyle,
          szRegister,
          pData,
          pEnum));

   end EnumRegisterWordA;

   procedure EnumRegisterWordW
     (This       : IActiveIMMApp_Type;
      hKL        : GNATCOM.Types.Pointer_To_Void;
      szReading  : GNATCOM.Types.LPWSTR;
      dwStyle    : Interfaces.C.unsigned_long;
      szRegister : GNATCOM.Types.LPWSTR;
      pData      : GNATCOM.Types.Pointer_To_Void;
      pEnum      : Pointer_To_Pointer_To_IEnumRegisterWordW)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.EnumRegisterWordW
         (Pointer (This),
          hKL,
          szReading,
          dwStyle,
          szRegister,
          pData,
          pEnum));

   end EnumRegisterWordW;

   procedure EscapeA
     (This     : IActiveIMMApp_Type;
      hKL      : GNATCOM.Types.Pointer_To_Void;
      hIMC     : Interfaces.C.unsigned_long;
      uEscape  : Interfaces.C.unsigned;
      pData    : GNATCOM.Types.Pointer_To_Void;
      plResult : GNATCOM.Types.Pointer_To_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.EscapeA
         (Pointer (This),
          hKL,
          hIMC,
          uEscape,
          pData,
          plResult));

   end EscapeA;

   procedure EscapeW
     (This     : IActiveIMMApp_Type;
      hKL      : GNATCOM.Types.Pointer_To_Void;
      hIMC     : Interfaces.C.unsigned_long;
      uEscape  : Interfaces.C.unsigned;
      pData    : GNATCOM.Types.Pointer_To_Void;
      plResult : GNATCOM.Types.Pointer_To_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.EscapeW
         (Pointer (This),
          hKL,
          hIMC,
          uEscape,
          pData,
          plResult));

   end EscapeW;

   procedure GetCandidateListA
     (This      : IActiveIMMApp_Type;
      hIMC      : Interfaces.C.unsigned_long;
      dwIndex   : Interfaces.C.unsigned_long;
      uBufLen   : Interfaces.C.unsigned;
      pCandList : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0007;
      puCopied  : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCandidateListA
         (Pointer (This),
          hIMC,
          dwIndex,
          uBufLen,
          pCandList,
          puCopied));

   end GetCandidateListA;

   procedure GetCandidateListW
     (This      : IActiveIMMApp_Type;
      hIMC      : Interfaces.C.unsigned_long;
      dwIndex   : Interfaces.C.unsigned_long;
      uBufLen   : Interfaces.C.unsigned;
      pCandList : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0007;
      puCopied  : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCandidateListW
         (Pointer (This),
          hIMC,
          dwIndex,
          uBufLen,
          pCandList,
          puCopied));

   end GetCandidateListW;

   procedure GetCandidateListCountA
     (This        : IActiveIMMApp_Type;
      hIMC        : Interfaces.C.unsigned_long;
      pdwListSize : GNATCOM.Types.Pointer_To_unsigned_long;
      pdwBufLen   : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCandidateListCountA
         (Pointer (This),
          hIMC,
          pdwListSize,
          pdwBufLen));

   end GetCandidateListCountA;

   procedure GetCandidateListCountW
     (This        : IActiveIMMApp_Type;
      hIMC        : Interfaces.C.unsigned_long;
      pdwListSize : GNATCOM.Types.Pointer_To_unsigned_long;
      pdwBufLen   : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCandidateListCountW
         (Pointer (This),
          hIMC,
          pdwListSize,
          pdwBufLen));

   end GetCandidateListCountW;

   procedure GetCandidateWindow
     (This       : IActiveIMMApp_Type;
      hIMC       : Interfaces.C.unsigned_long;
      dwIndex    : Interfaces.C.unsigned_long;
      pCandidate : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0005)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCandidateWindow
         (Pointer (This),
          hIMC,
          dwIndex,
          pCandidate));

   end GetCandidateWindow;

   procedure GetCompositionFontA
     (This : IActiveIMMApp_Type;
      hIMC : Interfaces.C.unsigned_long;
      plf  : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0003)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCompositionFontA
         (Pointer (This),
          hIMC,
          plf));

   end GetCompositionFontA;

   procedure GetCompositionFontW
     (This : IActiveIMMApp_Type;
      hIMC : Interfaces.C.unsigned_long;
      plf  : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0004)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCompositionFontW
         (Pointer (This),
          hIMC,
          plf));

   end GetCompositionFontW;

   procedure GetCompositionStringA
     (This     : IActiveIMMApp_Type;
      hIMC     : Interfaces.C.unsigned_long;
      dwIndex  : Interfaces.C.unsigned_long;
      dwBufLen : Interfaces.C.unsigned_long;
      plCopied : GNATCOM.Types.Pointer_To_long;
      pBuf     : GNATCOM.Types.Pointer_To_Void)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCompositionStringA
         (Pointer (This),
          hIMC,
          dwIndex,
          dwBufLen,
          plCopied,
          pBuf));

   end GetCompositionStringA;

   procedure GetCompositionStringW
     (This     : IActiveIMMApp_Type;
      hIMC     : Interfaces.C.unsigned_long;
      dwIndex  : Interfaces.C.unsigned_long;
      dwBufLen : Interfaces.C.unsigned_long;
      plCopied : GNATCOM.Types.Pointer_To_long;
      pBuf     : GNATCOM.Types.Pointer_To_Void)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCompositionStringW
         (Pointer (This),
          hIMC,
          dwIndex,
          dwBufLen,
          plCopied,
          pBuf));

   end GetCompositionStringW;

   procedure GetCompositionWindow
     (This      : IActiveIMMApp_Type;
      hIMC      : Interfaces.C.unsigned_long;
      pCompForm : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0006)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCompositionWindow
         (Pointer (This),
          hIMC,
          pCompForm));

   end GetCompositionWindow;

   procedure GetContext
     (This  : IActiveIMMApp_Type;
      hWnd  : wireHWND;
      phIMC : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetContext
         (Pointer (This),
          hWnd,
          phIMC));

   end GetContext;

   procedure GetConversionListA
     (This     : IActiveIMMApp_Type;
      hKL      : GNATCOM.Types.Pointer_To_Void;
      hIMC     : Interfaces.C.unsigned_long;
      pSrc     : GNATCOM.Types.LPSTR;
      uBufLen  : Interfaces.C.unsigned;
      uFlag    : Interfaces.C.unsigned;
      pDst     : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0007;
      puCopied : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetConversionListA
         (Pointer (This),
          hKL,
          hIMC,
          pSrc,
          uBufLen,
          uFlag,
          pDst,
          puCopied));

   end GetConversionListA;

   procedure GetConversionListW
     (This     : IActiveIMMApp_Type;
      hKL      : GNATCOM.Types.Pointer_To_Void;
      hIMC     : Interfaces.C.unsigned_long;
      pSrc     : GNATCOM.Types.LPWSTR;
      uBufLen  : Interfaces.C.unsigned;
      uFlag    : Interfaces.C.unsigned;
      pDst     : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0007;
      puCopied : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetConversionListW
         (Pointer (This),
          hKL,
          hIMC,
          pSrc,
          uBufLen,
          uFlag,
          pDst,
          puCopied));

   end GetConversionListW;

   procedure GetConversionStatus
     (This           : IActiveIMMApp_Type;
      hIMC           : Interfaces.C.unsigned_long;
      pfdwConversion : GNATCOM.Types.Pointer_To_unsigned_long;
      pfdwSentence   : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetConversionStatus
         (Pointer (This),
          hIMC,
          pfdwConversion,
          pfdwSentence));

   end GetConversionStatus;

   procedure GetDefaultIMEWnd
     (This     : IActiveIMMApp_Type;
      hWnd     : wireHWND;
      phDefWnd : Pointer_To_wireHWND)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetDefaultIMEWnd
         (Pointer (This),
          hWnd,
          phDefWnd));

   end GetDefaultIMEWnd;

   procedure GetDescriptionA
     (This          : IActiveIMMApp_Type;
      hKL           : GNATCOM.Types.Pointer_To_Void;
      uBufLen       : Interfaces.C.unsigned;
      szDescription : GNATCOM.Types.LPSTR;
      puCopied      : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetDescriptionA
         (Pointer (This),
          hKL,
          uBufLen,
          szDescription,
          puCopied));

   end GetDescriptionA;

   procedure GetDescriptionW
     (This          : IActiveIMMApp_Type;
      hKL           : GNATCOM.Types.Pointer_To_Void;
      uBufLen       : Interfaces.C.unsigned;
      szDescription : GNATCOM.Types.LPWSTR;
      puCopied      : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetDescriptionW
         (Pointer (This),
          hKL,
          uBufLen,
          szDescription,
          puCopied));

   end GetDescriptionW;

   procedure GetGuideLineA
     (This      : IActiveIMMApp_Type;
      hIMC      : Interfaces.C.unsigned_long;
      dwIndex   : Interfaces.C.unsigned_long;
      dwBufLen  : Interfaces.C.unsigned_long;
      pBuf      : GNATCOM.Types.LPSTR;
      pdwResult : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetGuideLineA
         (Pointer (This),
          hIMC,
          dwIndex,
          dwBufLen,
          pBuf,
          pdwResult));

   end GetGuideLineA;

   procedure GetGuideLineW
     (This      : IActiveIMMApp_Type;
      hIMC      : Interfaces.C.unsigned_long;
      dwIndex   : Interfaces.C.unsigned_long;
      dwBufLen  : Interfaces.C.unsigned_long;
      pBuf      : GNATCOM.Types.LPWSTR;
      pdwResult : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetGuideLineW
         (Pointer (This),
          hIMC,
          dwIndex,
          dwBufLen,
          pBuf,
          pdwResult));

   end GetGuideLineW;

   procedure GetIMEFileNameA
     (This       : IActiveIMMApp_Type;
      hKL        : GNATCOM.Types.Pointer_To_Void;
      uBufLen    : Interfaces.C.unsigned;
      szFileName : GNATCOM.Types.LPSTR;
      puCopied   : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetIMEFileNameA
         (Pointer (This),
          hKL,
          uBufLen,
          szFileName,
          puCopied));

   end GetIMEFileNameA;

   procedure GetIMEFileNameW
     (This       : IActiveIMMApp_Type;
      hKL        : GNATCOM.Types.Pointer_To_Void;
      uBufLen    : Interfaces.C.unsigned;
      szFileName : GNATCOM.Types.LPWSTR;
      puCopied   : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetIMEFileNameW
         (Pointer (This),
          hKL,
          uBufLen,
          szFileName,
          puCopied));

   end GetIMEFileNameW;

   procedure GetOpenStatus
     (This : IActiveIMMApp_Type;
      hIMC : Interfaces.C.unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetOpenStatus
         (Pointer (This),
          hIMC));

   end GetOpenStatus;

   procedure GetProperty
     (This        : IActiveIMMApp_Type;
      hKL         : GNATCOM.Types.Pointer_To_Void;
      fdwIndex    : Interfaces.C.unsigned_long;
      pdwProperty : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetProperty
         (Pointer (This),
          hKL,
          fdwIndex,
          pdwProperty));

   end GetProperty;

   procedure GetRegisterWordStyleA
     (This      : IActiveIMMApp_Type;
      hKL       : GNATCOM.Types.Pointer_To_Void;
      nItem     : Interfaces.C.unsigned;
      pStyleBuf : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0008;
      puCopied  : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetRegisterWordStyleA
         (Pointer (This),
          hKL,
          nItem,
          pStyleBuf,
          puCopied));

   end GetRegisterWordStyleA;

   procedure GetRegisterWordStyleW
     (This      : IActiveIMMApp_Type;
      hKL       : GNATCOM.Types.Pointer_To_Void;
      nItem     : Interfaces.C.unsigned;
      pStyleBuf : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0009;
      puCopied  : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetRegisterWordStyleW
         (Pointer (This),
          hKL,
          nItem,
          pStyleBuf,
          puCopied));

   end GetRegisterWordStyleW;

   procedure GetStatusWindowPos
     (This   : IActiveIMMApp_Type;
      hIMC   : Interfaces.C.unsigned_long;
      pptPos : Pointer_To_tagPOINT)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetStatusWindowPos
         (Pointer (This),
          hIMC,
          pptPos));

   end GetStatusWindowPos;

   procedure GetVirtualKey
     (This         : IActiveIMMApp_Type;
      hWnd         : wireHWND;
      puVirtualKey : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetVirtualKey
         (Pointer (This),
          hWnd,
          puVirtualKey));

   end GetVirtualKey;

   procedure InstallIMEA
     (This          : IActiveIMMApp_Type;
      szIMEFileName : GNATCOM.Types.LPSTR;
      szLayoutText  : GNATCOM.Types.LPSTR;
      phKL          : GNATCOM.Types.Pointer_To_Pointer_To_Void)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.InstallIMEA
         (Pointer (This),
          szIMEFileName,
          szLayoutText,
          phKL));

   end InstallIMEA;

   procedure InstallIMEW
     (This          : IActiveIMMApp_Type;
      szIMEFileName : GNATCOM.Types.LPWSTR;
      szLayoutText  : GNATCOM.Types.LPWSTR;
      phKL          : GNATCOM.Types.Pointer_To_Pointer_To_Void)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.InstallIMEW
         (Pointer (This),
          szIMEFileName,
          szLayoutText,
          phKL));

   end InstallIMEW;

   procedure IsIME
     (This : IActiveIMMApp_Type;
      hKL  : GNATCOM.Types.Pointer_To_Void)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.IsIME
         (Pointer (This),
          hKL));

   end IsIME;

   procedure IsUIMessageA
     (This    : IActiveIMMApp_Type;
      hWndIME : wireHWND;
      msg     : Interfaces.C.unsigned;
      wParam  : Interfaces.C.unsigned_long;
      lParam  : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.IsUIMessageA
         (Pointer (This),
          hWndIME,
          msg,
          wParam,
          lParam));

   end IsUIMessageA;

   procedure IsUIMessageW
     (This    : IActiveIMMApp_Type;
      hWndIME : wireHWND;
      msg     : Interfaces.C.unsigned;
      wParam  : Interfaces.C.unsigned_long;
      lParam  : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.IsUIMessageW
         (Pointer (This),
          hWndIME,
          msg,
          wParam,
          lParam));

   end IsUIMessageW;

   procedure NotifyIME
     (This     : IActiveIMMApp_Type;
      hIMC     : Interfaces.C.unsigned_long;
      dwAction : Interfaces.C.unsigned_long;
      dwIndex  : Interfaces.C.unsigned_long;
      dwValue  : Interfaces.C.unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.NotifyIME
         (Pointer (This),
          hIMC,
          dwAction,
          dwIndex,
          dwValue));

   end NotifyIME;

   procedure RegisterWordA
     (This       : IActiveIMMApp_Type;
      hKL        : GNATCOM.Types.Pointer_To_Void;
      szReading  : GNATCOM.Types.LPSTR;
      dwStyle    : Interfaces.C.unsigned_long;
      szRegister : GNATCOM.Types.LPSTR)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.RegisterWordA
         (Pointer (This),
          hKL,
          szReading,
          dwStyle,
          szRegister));

   end RegisterWordA;

   procedure RegisterWordW
     (This       : IActiveIMMApp_Type;
      hKL        : GNATCOM.Types.Pointer_To_Void;
      szReading  : GNATCOM.Types.LPWSTR;
      dwStyle    : Interfaces.C.unsigned_long;
      szRegister : GNATCOM.Types.LPWSTR)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.RegisterWordW
         (Pointer (This),
          hKL,
          szReading,
          dwStyle,
          szRegister));

   end RegisterWordW;

   procedure ReleaseContext
     (This : IActiveIMMApp_Type;
      hWnd : wireHWND;
      hIMC : Interfaces.C.unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.ReleaseContext
         (Pointer (This),
          hWnd,
          hIMC));

   end ReleaseContext;

   procedure SetCandidateWindow
     (This       : IActiveIMMApp_Type;
      hIMC       : Interfaces.C.unsigned_long;
      pCandidate : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0005)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetCandidateWindow
         (Pointer (This),
          hIMC,
          pCandidate));

   end SetCandidateWindow;

   procedure SetCompositionFontA
     (This : IActiveIMMApp_Type;
      hIMC : Interfaces.C.unsigned_long;
      plf  : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0003)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetCompositionFontA
         (Pointer (This),
          hIMC,
          plf));

   end SetCompositionFontA;

   procedure SetCompositionFontW
     (This : IActiveIMMApp_Type;
      hIMC : Interfaces.C.unsigned_long;
      plf  : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0004)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetCompositionFontW
         (Pointer (This),
          hIMC,
          plf));

   end SetCompositionFontW;

   procedure SetCompositionStringA
     (This      : IActiveIMMApp_Type;
      hIMC      : Interfaces.C.unsigned_long;
      dwIndex   : Interfaces.C.unsigned_long;
      pComp     : GNATCOM.Types.Pointer_To_Void;
      dwCompLen : Interfaces.C.unsigned_long;
      pRead     : GNATCOM.Types.Pointer_To_Void;
      dwReadLen : Interfaces.C.unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetCompositionStringA
         (Pointer (This),
          hIMC,
          dwIndex,
          pComp,
          dwCompLen,
          pRead,
          dwReadLen));

   end SetCompositionStringA;

   procedure SetCompositionStringW
     (This      : IActiveIMMApp_Type;
      hIMC      : Interfaces.C.unsigned_long;
      dwIndex   : Interfaces.C.unsigned_long;
      pComp     : GNATCOM.Types.Pointer_To_Void;
      dwCompLen : Interfaces.C.unsigned_long;
      pRead     : GNATCOM.Types.Pointer_To_Void;
      dwReadLen : Interfaces.C.unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetCompositionStringW
         (Pointer (This),
          hIMC,
          dwIndex,
          pComp,
          dwCompLen,
          pRead,
          dwReadLen));

   end SetCompositionStringW;

   procedure SetCompositionWindow
     (This      : IActiveIMMApp_Type;
      hIMC      : Interfaces.C.unsigned_long;
      pCompForm : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0006)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetCompositionWindow
         (Pointer (This),
          hIMC,
          pCompForm));

   end SetCompositionWindow;

   procedure SetConversionStatus
     (This          : IActiveIMMApp_Type;
      hIMC          : Interfaces.C.unsigned_long;
      fdwConversion : Interfaces.C.unsigned_long;
      fdwSentence   : Interfaces.C.unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetConversionStatus
         (Pointer (This),
          hIMC,
          fdwConversion,
          fdwSentence));

   end SetConversionStatus;

   procedure SetOpenStatus
     (This  : IActiveIMMApp_Type;
      hIMC  : Interfaces.C.unsigned_long;
      fOpen : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetOpenStatus
         (Pointer (This),
          hIMC,
          fOpen));

   end SetOpenStatus;

   procedure SetStatusWindowPos
     (This   : IActiveIMMApp_Type;
      hIMC   : Interfaces.C.unsigned_long;
      pptPos : Pointer_To_tagPOINT)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetStatusWindowPos
         (Pointer (This),
          hIMC,
          pptPos));

   end SetStatusWindowPos;

   procedure SimulateHotKey
     (This       : IActiveIMMApp_Type;
      hWnd       : wireHWND;
      dwHotKeyID : Interfaces.C.unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SimulateHotKey
         (Pointer (This),
          hWnd,
          dwHotKeyID));

   end SimulateHotKey;

   procedure UnregisterWordA
     (This         : IActiveIMMApp_Type;
      hKL          : GNATCOM.Types.Pointer_To_Void;
      szReading    : GNATCOM.Types.LPSTR;
      dwStyle      : Interfaces.C.unsigned_long;
      szUnregister : GNATCOM.Types.LPSTR)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.UnregisterWordA
         (Pointer (This),
          hKL,
          szReading,
          dwStyle,
          szUnregister));

   end UnregisterWordA;

   procedure UnregisterWordW
     (This         : IActiveIMMApp_Type;
      hKL          : GNATCOM.Types.Pointer_To_Void;
      szReading    : GNATCOM.Types.LPWSTR;
      dwStyle      : Interfaces.C.unsigned_long;
      szUnregister : GNATCOM.Types.LPWSTR)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.UnregisterWordW
         (Pointer (This),
          hKL,
          szReading,
          dwStyle,
          szUnregister));

   end UnregisterWordW;

   procedure Activate
     (This           : IActiveIMMApp_Type;
      fRestoreLayout : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Activate
         (Pointer (This),
          fRestoreLayout));

   end Activate;

   procedure Deactivate
     (This : IActiveIMMApp_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Deactivate
         (Pointer (This)));

   end Deactivate;

   procedure OnDefWindowProc
     (This     : IActiveIMMApp_Type;
      hWnd     : wireHWND;
      msg      : Interfaces.C.unsigned;
      wParam   : Interfaces.C.unsigned_long;
      lParam   : Interfaces.C.long;
      plResult : GNATCOM.Types.Pointer_To_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.OnDefWindowProc
         (Pointer (This),
          hWnd,
          msg,
          wParam,
          lParam,
          plResult));

   end OnDefWindowProc;

   procedure FilterClientWindows
     (This        : IActiveIMMApp_Type;
      aaClassList : GNATCOM.Types.Pointer_To_unsigned_short;
      uSize       : Interfaces.C.unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.FilterClientWindows
         (Pointer (This),
          aaClassList,
          uSize));

   end FilterClientWindows;

   procedure GetCodePageA
     (This      : IActiveIMMApp_Type;
      hKL       : GNATCOM.Types.Pointer_To_Void;
      uCodePage : GNATCOM.Types.Pointer_To_unsigned)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetCodePageA
         (Pointer (This),
          hKL,
          uCodePage));

   end GetCodePageA;

   procedure GetLangId
     (This : IActiveIMMApp_Type;
      hKL  : GNATCOM.Types.Pointer_To_Void;
      plid : GNATCOM.Types.Pointer_To_unsigned_short)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetLangId
         (Pointer (This),
          hKL,
          plid));

   end GetLangId;

   procedure AssociateContextEx
     (This    : IActiveIMMApp_Type;
      hWnd    : wireHWND;
      hIMC    : Interfaces.C.unsigned_long;
      dwFlags : Interfaces.C.unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.AssociateContextEx
         (Pointer (This),
          hWnd,
          hIMC,
          dwFlags));

   end AssociateContextEx;

   procedure DisableIME
     (This     : IActiveIMMApp_Type;
      idThread : Interfaces.C.unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.DisableIME
         (Pointer (This),
          idThread));

   end DisableIME;

   procedure GetImeMenuItemsA
     (This           : IActiveIMMApp_Type;
      hIMC           : Interfaces.C.unsigned_long;
      dwFlags        : Interfaces.C.unsigned_long;
      dwType         : Interfaces.C.unsigned_long;
      pImeParentMenu : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0010;
      pImeMenu       : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0010;
      dwSize         : Interfaces.C.unsigned_long;
      pdwResult      : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetImeMenuItemsA
         (Pointer (This),
          hIMC,
          dwFlags,
          dwType,
          pImeParentMenu,
          pImeMenu,
          dwSize,
          pdwResult));

   end GetImeMenuItemsA;

   procedure GetImeMenuItemsW
     (This           : IActiveIMMApp_Type;
      hIMC           : Interfaces.C.unsigned_long;
      dwFlags        : Interfaces.C.unsigned_long;
      dwType         : Interfaces.C.unsigned_long;
      pImeParentMenu : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0011;
      pImeMenu       : Pointer_To_u_MIDLuu_MIDL_itf_mshtml_0245_0011;
      dwSize         : Interfaces.C.unsigned_long;
      pdwResult      : GNATCOM.Types.Pointer_To_unsigned_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetImeMenuItemsW
         (Pointer (This),
          hIMC,
          dwFlags,
          dwType,
          pImeParentMenu,
          pImeMenu,
          dwSize,
          pdwResult));

   end GetImeMenuItemsW;

   procedure EnumInputContext
     (This     : IActiveIMMApp_Type;
      idThread : Interfaces.C.unsigned_long;
      ppEnum   : Pointer_To_Pointer_To_IEnumInputContext)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.EnumInputContext
         (Pointer (This),
          idThread,
          ppEnum));

   end EnumInputContext;

end MSHTML.IActiveIMMApp_Interface;

