with GNATCOM.Errors;

package body MSHTML.IElementBehavior_Interface is

   procedure Initialize (This : in out IElementBehavior_Type) is
   begin
      Set_IID (This, IID_IElementBehavior);
   end Initialize;

   function Pointer (This : IElementBehavior_Type)
     return Pointer_To_IElementBehavior
   is
   begin
      return To_Pointer_To_IElementBehavior (Address (This));
   end Pointer;

   procedure Attach (This    : in out IElementBehavior_Type;
                     Pointer : in     Pointer_To_IElementBehavior)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Init
     (This          : IElementBehavior_Type;
      pBehaviorSite : Pointer_To_IElementBehaviorSite)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Init
         (Pointer (This),
          pBehaviorSite));

   end Init;

   procedure Notify
     (This   : IElementBehavior_Type;
      lEvent : Interfaces.C.long;
      pVar   : access GNATCOM.Types.VARIANT :=
        GNATCOM.Types.PVARIANT_MISSING)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Notify
         (Pointer (This),
          lEvent,
          pVar));

   end Notify;

   procedure Detach
     (This : IElementBehavior_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Detach
         (Pointer (This)));

   end Detach;

end MSHTML.IElementBehavior_Interface;

