with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTCDescBehavior_Interface is

   procedure Initialize (This : in out IHTCDescBehavior_Type) is
   begin
      Set_IID (This, IID_IHTCDescBehavior);
   end Initialize;

   function Pointer (This : IHTCDescBehavior_Type)
     return Pointer_To_IHTCDescBehavior
   is
   begin
      return To_Pointer_To_IHTCDescBehavior (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTCDescBehavior_Type;
                     Pointer : in     Pointer_To_IHTCDescBehavior)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_urn
     (This : IHTCDescBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_urn
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_urn;

    function Get_name
     (This : IHTCDescBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_name
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_name;

end MSHTML.IHTCDescBehavior_Interface;

