with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLAnchorElement_Interface is

   procedure Initialize (This : in out IHTMLAnchorElement_Type) is
   begin
      Set_IID (This, IID_IHTMLAnchorElement);
   end Initialize;

   function Pointer (This : IHTMLAnchorElement_Type)
     return Pointer_To_IHTMLAnchorElement
   is
   begin
      return To_Pointer_To_IHTMLAnchorElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLAnchorElement_Type;
                     Pointer : in     Pointer_To_IHTMLAnchorElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_href
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_href
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_href;

    function Get_href
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_href
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_href;

   procedure Put_target
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_target
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_target;

    function Get_target
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_target
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_target;

   procedure Put_rel
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_rel
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_rel;

    function Get_rel
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_rel
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_rel;

   procedure Put_rev
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_rev
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_rev;

    function Get_rev
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_rev
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_rev;

   procedure Put_urn
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_urn
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_urn;

    function Get_urn
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_urn
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_urn;

   procedure Put_Methods
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_Methods
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_Methods;

    function Get_Methods
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Methods
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Methods;

   procedure Put_name
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_name
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_name;

    function Get_name
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_name
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_name;

   procedure Put_host
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_host
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_host;

    function Get_host
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_host
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_host;

   procedure Put_hostname
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_hostname
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_hostname;

    function Get_hostname
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_hostname
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_hostname;

   procedure Put_pathname
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_pathname
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_pathname;

    function Get_pathname
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_pathname
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_pathname;

   procedure Put_port
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_port
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_port;

    function Get_port
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_port
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_port;

   procedure Put_protocol
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_protocol
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_protocol;

    function Get_protocol
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_protocol
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_protocol;

   procedure Put_search
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_search
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_search;

    function Get_search
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_search
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_search;

   procedure Put_hash
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_hash
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_hash;

    function Get_hash
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_hash
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_hash;

   procedure Put_onblur
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onblur
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onblur;

    function Get_onblur
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onblur
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onblur;

   procedure Put_onfocus
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onfocus
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onfocus;

    function Get_onfocus
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onfocus
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onfocus;

   procedure Put_accessKey
     (This : IHTMLAnchorElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_accessKey
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_accessKey;

    function Get_accessKey
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_accessKey
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_accessKey;

    function Get_protocolLong
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_protocolLong
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_protocolLong;

    function Get_mimeType
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_mimeType
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_mimeType;

    function Get_nameProp
     (This : IHTMLAnchorElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_nameProp
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_nameProp;

   procedure Put_tabIndex
     (This : IHTMLAnchorElement_Type;
      p    : Interfaces.C.short)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_tabIndex
         (Pointer (This),
          p));

   end Put_tabIndex;

    function Get_tabIndex
     (This : IHTMLAnchorElement_Type)
     return Interfaces.C.short
   is
       RetVal : aliased Interfaces.C.short;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_tabIndex
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_tabIndex;

   procedure focus
     (This : IHTMLAnchorElement_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.focus
         (Pointer (This)));

   end focus;

   procedure blur
     (This : IHTMLAnchorElement_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.blur
         (Pointer (This)));

   end blur;

end MSHTML.IHTMLAnchorElement_Interface;

