with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLAppBehavior_Interface is

   procedure Initialize (This : in out IHTMLAppBehavior_Type) is
   begin
      Set_IID (This, IID_IHTMLAppBehavior);
   end Initialize;

   function Pointer (This : IHTMLAppBehavior_Type)
     return Pointer_To_IHTMLAppBehavior
   is
   begin
      return To_Pointer_To_IHTMLAppBehavior (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLAppBehavior_Type;
                     Pointer : in     Pointer_To_IHTMLAppBehavior)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_applicationName
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_applicationName
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_applicationName;

    function Get_applicationName
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_applicationName
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_applicationName;

   procedure Put_version
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_version
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_version;

    function Get_version
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_version
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_version;

   procedure Put_icon
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_icon
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_icon;

    function Get_icon
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_icon
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_icon;

   procedure Put_singleInstance
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_singleInstance
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_singleInstance;

    function Get_singleInstance
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_singleInstance
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_singleInstance;

   procedure Put_minimizeButton
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_minimizeButton
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_minimizeButton;

    function Get_minimizeButton
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_minimizeButton
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_minimizeButton;

   procedure Put_maximizeButton
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_maximizeButton
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_maximizeButton;

    function Get_maximizeButton
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_maximizeButton
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_maximizeButton;

   procedure Put_border
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_border
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_border;

    function Get_border
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_border
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_border;

   procedure Put_borderStyle
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_borderStyle
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_borderStyle;

    function Get_borderStyle
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderStyle
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderStyle;

   procedure Put_sysMenu
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_sysMenu
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_sysMenu;

    function Get_sysMenu
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_sysMenu
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_sysMenu;

   procedure Put_caption
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_caption
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_caption;

    function Get_caption
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_caption
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_caption;

   procedure Put_windowState
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_windowState
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_windowState;

    function Get_windowState
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_windowState
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_windowState;

   procedure Put_showInTaskBar
     (This : IHTMLAppBehavior_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_showInTaskBar
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_showInTaskBar;

    function Get_showInTaskBar
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_showInTaskBar
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_showInTaskBar;

    function Get_commandLine
     (This : IHTMLAppBehavior_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_commandLine
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_commandLine;

end MSHTML.IHTMLAppBehavior_Interface;

