with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLAreaElement_Interface is

   procedure Initialize (This : in out IHTMLAreaElement_Type) is
   begin
      Set_IID (This, IID_IHTMLAreaElement);
   end Initialize;

   function Pointer (This : IHTMLAreaElement_Type)
     return Pointer_To_IHTMLAreaElement
   is
   begin
      return To_Pointer_To_IHTMLAreaElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLAreaElement_Type;
                     Pointer : in     Pointer_To_IHTMLAreaElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_shape
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_shape
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_shape;

    function Get_shape
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_shape
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_shape;

   procedure Put_coords
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_coords
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_coords;

    function Get_coords
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_coords
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_coords;

   procedure Put_href
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_href
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_href;

    function Get_href
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_href
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_href;

   procedure Put_target
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_target
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_target;

    function Get_target
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_target
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_target;

   procedure Put_alt
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_alt
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_alt;

    function Get_alt
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_alt
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_alt;

   procedure Put_noHref
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_noHref
         (Pointer (This),
          p));

   end Put_noHref;

    function Get_noHref
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_noHref
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_noHref;

   procedure Put_host
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_host
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_host;

    function Get_host
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_host
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_host;

   procedure Put_hostname
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_hostname
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_hostname;

    function Get_hostname
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_hostname
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_hostname;

   procedure Put_pathname
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_pathname
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_pathname;

    function Get_pathname
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_pathname
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_pathname;

   procedure Put_port
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_port
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_port;

    function Get_port
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_port
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_port;

   procedure Put_protocol
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_protocol
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_protocol;

    function Get_protocol
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_protocol
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_protocol;

   procedure Put_search
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_search
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_search;

    function Get_search
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_search
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_search;

   procedure Put_hash
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_hash
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_hash;

    function Get_hash
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_hash
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_hash;

   procedure Put_onblur
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onblur
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onblur;

    function Get_onblur
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onblur
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onblur;

   procedure Put_onfocus
     (This : IHTMLAreaElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onfocus
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onfocus;

    function Get_onfocus
     (This : IHTMLAreaElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onfocus
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onfocus;

   procedure Put_tabIndex
     (This : IHTMLAreaElement_Type;
      p    : Interfaces.C.short)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_tabIndex
         (Pointer (This),
          p));

   end Put_tabIndex;

    function Get_tabIndex
     (This : IHTMLAreaElement_Type)
     return Interfaces.C.short
   is
       RetVal : aliased Interfaces.C.short;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_tabIndex
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_tabIndex;

   procedure focus
     (This : IHTMLAreaElement_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.focus
         (Pointer (This)));

   end focus;

   procedure blur
     (This : IHTMLAreaElement_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.blur
         (Pointer (This)));

   end blur;

end MSHTML.IHTMLAreaElement_Interface;

