with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLAttributeCollection_Interface is

   procedure Initialize (This : in out IHTMLAttributeCollection_Type) is
   begin
      Set_IID (This, IID_IHTMLAttributeCollection);
   end Initialize;

   function Pointer (This : IHTMLAttributeCollection_Type)
     return Pointer_To_IHTMLAttributeCollection
   is
   begin
      return To_Pointer_To_IHTMLAttributeCollection (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLAttributeCollection_Type;
                     Pointer : in     Pointer_To_IHTMLAttributeCollection)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_length
     (This : IHTMLAttributeCollection_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_length
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_length;

    function Getu_newEnum
     (This : IHTMLAttributeCollection_Type)
     return GNATCOM.Types.Pointer_To_IUnknown
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IUnknown;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Getu_newEnum
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Getu_newEnum;

    function item
     (This  : IHTMLAttributeCollection_Type;
      name  : access GNATCOM.Types.VARIANT :=
        GNATCOM.Types.PVARIANT_MISSING)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.item
         (Pointer (This),
          name,
          RetVal'Unchecked_Access));

      return RetVal;
   end item;

end MSHTML.IHTMLAttributeCollection_Interface;

