with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLBaseElement_Interface is

   procedure Initialize (This : in out IHTMLBaseElement_Type) is
   begin
      Set_IID (This, IID_IHTMLBaseElement);
   end Initialize;

   function Pointer (This : IHTMLBaseElement_Type)
     return Pointer_To_IHTMLBaseElement
   is
   begin
      return To_Pointer_To_IHTMLBaseElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLBaseElement_Type;
                     Pointer : in     Pointer_To_IHTMLBaseElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_href
     (This : IHTMLBaseElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_href
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_href;

    function Get_href
     (This : IHTMLBaseElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_href
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_href;

   procedure Put_target
     (This : IHTMLBaseElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_target
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_target;

    function Get_target
     (This : IHTMLBaseElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_target
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_target;

end MSHTML.IHTMLBaseElement_Interface;

