with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLBlockElement_Interface is

   procedure Initialize (This : in out IHTMLBlockElement_Type) is
   begin
      Set_IID (This, IID_IHTMLBlockElement);
   end Initialize;

   function Pointer (This : IHTMLBlockElement_Type)
     return Pointer_To_IHTMLBlockElement
   is
   begin
      return To_Pointer_To_IHTMLBlockElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLBlockElement_Type;
                     Pointer : in     Pointer_To_IHTMLBlockElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_clear
     (This : IHTMLBlockElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_clear
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_clear;

    function Get_clear
     (This : IHTMLBlockElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_clear
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_clear;

end MSHTML.IHTMLBlockElement_Interface;

