with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLBookmarkCollection_Interface is

   procedure Initialize (This : in out IHTMLBookmarkCollection_Type) is
   begin
      Set_IID (This, IID_IHTMLBookmarkCollection);
   end Initialize;

   function Pointer (This : IHTMLBookmarkCollection_Type)
     return Pointer_To_IHTMLBookmarkCollection
   is
   begin
      return To_Pointer_To_IHTMLBookmarkCollection (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLBookmarkCollection_Type;
                     Pointer : in     Pointer_To_IHTMLBookmarkCollection)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_length
     (This : IHTMLBookmarkCollection_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_length
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_length;

    function Getu_newEnum
     (This : IHTMLBookmarkCollection_Type)
     return GNATCOM.Types.Pointer_To_IUnknown
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IUnknown;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Getu_newEnum
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Getu_newEnum;

    function item
     (This         : IHTMLBookmarkCollection_Type;
      index        : Interfaces.C.long)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.item
         (Pointer (This),
          index,
          RetVal'Unchecked_Access));

      return RetVal;
   end item;

end MSHTML.IHTMLBookmarkCollection_Interface;

