with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLBRElement_Interface is

   procedure Initialize (This : in out IHTMLBRElement_Type) is
   begin
      Set_IID (This, IID_IHTMLBRElement);
   end Initialize;

   function Pointer (This : IHTMLBRElement_Type)
     return Pointer_To_IHTMLBRElement
   is
   begin
      return To_Pointer_To_IHTMLBRElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLBRElement_Type;
                     Pointer : in     Pointer_To_IHTMLBRElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_clear
     (This : IHTMLBRElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_clear
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_clear;

    function Get_clear
     (This : IHTMLBRElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_clear
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_clear;

end MSHTML.IHTMLBRElement_Interface;

