with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLCurrentStyle_Interface is

   procedure Initialize (This : in out IHTMLCurrentStyle_Type) is
   begin
      Set_IID (This, IID_IHTMLCurrentStyle);
   end Initialize;

   function Pointer (This : IHTMLCurrentStyle_Type)
     return Pointer_To_IHTMLCurrentStyle
   is
   begin
      return To_Pointer_To_IHTMLCurrentStyle (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLCurrentStyle_Type;
                     Pointer : in     Pointer_To_IHTMLCurrentStyle)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_position
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_position
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_position;

    function Get_styleFloat
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_styleFloat
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_styleFloat;

    function Get_color
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_color
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_color;

    function Get_backgroundColor
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_backgroundColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_backgroundColor;

    function Get_fontFamily
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fontFamily
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fontFamily;

    function Get_fontStyle
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fontStyle
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fontStyle;

    function Get_fontVariant
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fontVariant
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fontVariant;

    function Get_fontWeight
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fontWeight
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fontWeight;

    function Get_fontSize
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fontSize
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fontSize;

    function Get_backgroundImage
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_backgroundImage
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_backgroundImage;

    function Get_backgroundPositionX
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_backgroundPositionX
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_backgroundPositionX;

    function Get_backgroundPositionY
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_backgroundPositionY
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_backgroundPositionY;

    function Get_backgroundRepeat
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_backgroundRepeat
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_backgroundRepeat;

    function Get_borderLeftColor
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderLeftColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderLeftColor;

    function Get_borderTopColor
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderTopColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderTopColor;

    function Get_borderRightColor
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderRightColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderRightColor;

    function Get_borderBottomColor
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderBottomColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderBottomColor;

    function Get_borderTopStyle
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderTopStyle
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderTopStyle;

    function Get_borderRightStyle
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderRightStyle
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderRightStyle;

    function Get_borderBottomStyle
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderBottomStyle
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderBottomStyle;

    function Get_borderLeftStyle
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderLeftStyle
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderLeftStyle;

    function Get_borderTopWidth
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderTopWidth
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderTopWidth;

    function Get_borderRightWidth
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderRightWidth
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderRightWidth;

    function Get_borderBottomWidth
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderBottomWidth
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderBottomWidth;

    function Get_borderLeftWidth
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderLeftWidth
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderLeftWidth;

    function Get_left
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_left
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_left;

    function Get_top
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_top
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_top;

    function Get_width
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_width
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_width;

    function Get_height
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_height
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_height;

    function Get_paddingLeft
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_paddingLeft
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_paddingLeft;

    function Get_paddingTop
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_paddingTop
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_paddingTop;

    function Get_paddingRight
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_paddingRight
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_paddingRight;

    function Get_paddingBottom
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_paddingBottom
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_paddingBottom;

    function Get_textAlign
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_textAlign
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_textAlign;

    function Get_textDecoration
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_textDecoration
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_textDecoration;

    function Get_display
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_display
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_display;

    function Get_visibility
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_visibility
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_visibility;

    function Get_zIndex
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_zIndex
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_zIndex;

    function Get_letterSpacing
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_letterSpacing
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_letterSpacing;

    function Get_lineHeight
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_lineHeight
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_lineHeight;

    function Get_textIndent
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_textIndent
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_textIndent;

    function Get_verticalAlign
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_verticalAlign
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_verticalAlign;

    function Get_backgroundAttachment
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_backgroundAttachment
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_backgroundAttachment;

    function Get_marginTop
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_marginTop
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_marginTop;

    function Get_marginRight
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_marginRight
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_marginRight;

    function Get_marginBottom
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_marginBottom
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_marginBottom;

    function Get_marginLeft
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_marginLeft
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_marginLeft;

    function Get_clear
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_clear
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_clear;

    function Get_listStyleType
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_listStyleType
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_listStyleType;

    function Get_listStylePosition
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_listStylePosition
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_listStylePosition;

    function Get_listStyleImage
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_listStyleImage
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_listStyleImage;

    function Get_clipTop
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_clipTop
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_clipTop;

    function Get_clipRight
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_clipRight
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_clipRight;

    function Get_clipBottom
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_clipBottom
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_clipBottom;

    function Get_clipLeft
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_clipLeft
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_clipLeft;

    function Get_overflow
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_overflow
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_overflow;

    function Get_pageBreakBefore
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_pageBreakBefore
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_pageBreakBefore;

    function Get_pageBreakAfter
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_pageBreakAfter
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_pageBreakAfter;

    function Get_cursor
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_cursor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_cursor;

    function Get_tableLayout
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_tableLayout
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_tableLayout;

    function Get_borderCollapse
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderCollapse
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderCollapse;

    function Get_direction
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_direction
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_direction;

    function Get_behavior
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_behavior
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_behavior;

    function getAttribute
     (This             : IHTMLCurrentStyle_Type;
      strAttributeName : GNATCOM.Types.BSTR;
      lFlags           : Interfaces.C.long;
      Free             : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.getAttribute
         (Pointer (This),
          strAttributeName,
          lFlags,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (strAttributeName);
      
      end if;

      return RetVal;
   end getAttribute;

    function Get_unicodeBidi
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_unicodeBidi
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_unicodeBidi;

    function Get_right
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_right
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_right;

    function Get_bottom
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_bottom
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_bottom;

    function Get_imeMode
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_imeMode
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_imeMode;

    function Get_rubyAlign
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_rubyAlign
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_rubyAlign;

    function Get_rubyPosition
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_rubyPosition
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_rubyPosition;

    function Get_rubyOverhang
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_rubyOverhang
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_rubyOverhang;

    function Get_textAutospace
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_textAutospace
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_textAutospace;

    function Get_lineBreak
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_lineBreak
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_lineBreak;

    function Get_wordBreak
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_wordBreak
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_wordBreak;

    function Get_textJustify
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_textJustify
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_textJustify;

    function Get_textJustifyTrim
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_textJustifyTrim
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_textJustifyTrim;

    function Get_textKashida
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_textKashida
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_textKashida;

    function Get_blockDirection
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_blockDirection
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_blockDirection;

    function Get_layoutGridChar
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_layoutGridChar
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_layoutGridChar;

    function Get_layoutGridLine
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_layoutGridLine
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_layoutGridLine;

    function Get_layoutGridMode
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_layoutGridMode
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_layoutGridMode;

    function Get_layoutGridType
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_layoutGridType
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_layoutGridType;

    function Get_borderStyle
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderStyle
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderStyle;

    function Get_borderColor
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderColor;

    function Get_borderWidth
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderWidth
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderWidth;

    function Get_padding
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_padding
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_padding;

    function Get_margin
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_margin
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_margin;

    function Get_accelerator
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_accelerator
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_accelerator;

    function Get_overflowX
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_overflowX
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_overflowX;

    function Get_overflowY
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_overflowY
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_overflowY;

    function Get_textTransform
     (This : IHTMLCurrentStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_textTransform
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_textTransform;

end MSHTML.IHTMLCurrentStyle_Interface;

