with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLDDElement_Interface is

   procedure Initialize (This : in out IHTMLDDElement_Type) is
   begin
      Set_IID (This, IID_IHTMLDDElement);
   end Initialize;

   function Pointer (This : IHTMLDDElement_Type)
     return Pointer_To_IHTMLDDElement
   is
   begin
      return To_Pointer_To_IHTMLDDElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLDDElement_Type;
                     Pointer : in     Pointer_To_IHTMLDDElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_noWrap
     (This : IHTMLDDElement_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_noWrap
         (Pointer (This),
          p));

   end Put_noWrap;

    function Get_noWrap
     (This : IHTMLDDElement_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_noWrap
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_noWrap;

end MSHTML.IHTMLDDElement_Interface;

