with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLDialog2_Interface is

   procedure Initialize (This : in out IHTMLDialog2_Type) is
   begin
      Set_IID (This, IID_IHTMLDialog2);
   end Initialize;

   function Pointer (This : IHTMLDialog2_Type)
     return Pointer_To_IHTMLDialog2
   is
   begin
      return To_Pointer_To_IHTMLDialog2 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLDialog2_Type;
                     Pointer : in     Pointer_To_IHTMLDialog2)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_status
     (This : IHTMLDialog2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_status
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_status;

    function Get_status
     (This : IHTMLDialog2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_status
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_status;

   procedure Put_resizable
     (This : IHTMLDialog2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_resizable
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_resizable;

    function Get_resizable
     (This : IHTMLDialog2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_resizable
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_resizable;

end MSHTML.IHTMLDialog2_Interface;

