with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLDivElement_Interface is

   procedure Initialize (This : in out IHTMLDivElement_Type) is
   begin
      Set_IID (This, IID_IHTMLDivElement);
   end Initialize;

   function Pointer (This : IHTMLDivElement_Type)
     return Pointer_To_IHTMLDivElement
   is
   begin
      return To_Pointer_To_IHTMLDivElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLDivElement_Type;
                     Pointer : in     Pointer_To_IHTMLDivElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_align
     (This : IHTMLDivElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_align
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_align;

    function Get_align
     (This : IHTMLDivElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_align
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_align;

   procedure Put_noWrap
     (This : IHTMLDivElement_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_noWrap
         (Pointer (This),
          p));

   end Put_noWrap;

    function Get_noWrap
     (This : IHTMLDivElement_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_noWrap
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_noWrap;

end MSHTML.IHTMLDivElement_Interface;

