with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLDListElement_Interface is

   procedure Initialize (This : in out IHTMLDListElement_Type) is
   begin
      Set_IID (This, IID_IHTMLDListElement);
   end Initialize;

   function Pointer (This : IHTMLDListElement_Type)
     return Pointer_To_IHTMLDListElement
   is
   begin
      return To_Pointer_To_IHTMLDListElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLDListElement_Type;
                     Pointer : in     Pointer_To_IHTMLDListElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_compact
     (This : IHTMLDListElement_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_compact
         (Pointer (This),
          p));

   end Put_compact;

    function Get_compact
     (This : IHTMLDListElement_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_compact
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_compact;

end MSHTML.IHTMLDListElement_Interface;

