with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLDocument2_Interface is

   procedure Initialize (This : in out IHTMLDocument2_Type) is
   begin
      Set_IID (This, IID_IHTMLDocument2);
   end Initialize;

   function Pointer (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLDocument2
   is
   begin
      return To_Pointer_To_IHTMLDocument2 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLDocument2_Type;
                     Pointer : in     Pointer_To_IHTMLDocument2)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_Script
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Script
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Script;

    function Get_all
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_all
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_all;

    function Get_body
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElement
   is
       RetVal : aliased Pointer_To_IHTMLElement;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_body
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_body;

    function Get_activeElement
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElement
   is
       RetVal : aliased Pointer_To_IHTMLElement;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_activeElement
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_activeElement;

    function Get_images
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_images
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_images;

    function Get_applets
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_applets
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_applets;

    function Get_links
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_links
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_links;

    function Get_forms
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_forms
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_forms;

    function Get_anchors
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_anchors
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_anchors;

   procedure Put_title
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_title
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_title;

    function Get_title
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_title
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_title;

    function Get_scripts
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_scripts
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_scripts;

   procedure Put_designMode
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_designMode
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_designMode;

    function Get_designMode
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_designMode
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_designMode;

    function Get_selection
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLSelectionObject
   is
       RetVal : aliased Pointer_To_IHTMLSelectionObject;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_selection
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_selection;

    function Get_readyState
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_readyState
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_readyState;

    function Get_frames
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLFramesCollection2
   is
       RetVal : aliased Pointer_To_IHTMLFramesCollection2;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_frames
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_frames;

    function Get_embeds
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_embeds
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_embeds;

    function Get_plugins
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_plugins
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_plugins;

   procedure Put_alinkColor
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_alinkColor
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_alinkColor;

    function Get_alinkColor
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_alinkColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_alinkColor;

   procedure Put_bgColor
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_bgColor
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_bgColor;

    function Get_bgColor
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_bgColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_bgColor;

   procedure Put_fgColor
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_fgColor
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_fgColor;

    function Get_fgColor
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fgColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fgColor;

   procedure Put_linkColor
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_linkColor
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_linkColor;

    function Get_linkColor
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_linkColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_linkColor;

   procedure Put_vlinkColor
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_vlinkColor
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_vlinkColor;

    function Get_vlinkColor
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_vlinkColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_vlinkColor;

    function Get_referrer
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_referrer
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_referrer;

    function Get_location
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLLocation
   is
       RetVal : aliased Pointer_To_IHTMLLocation;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_location
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_location;

    function Get_lastModified
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_lastModified
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_lastModified;

   procedure Put_url
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_url
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_url;

    function Get_url
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_url
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_url;

   procedure Put_domain
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_domain
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_domain;

    function Get_domain
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_domain
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_domain;

   procedure Put_cookie
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_cookie
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_cookie;

    function Get_cookie
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_cookie
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_cookie;

   procedure Put_expando
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_expando
         (Pointer (This),
          p));

   end Put_expando;

    function Get_expando
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_expando
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_expando;

   procedure Put_charset
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_charset
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_charset;

    function Get_charset
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_charset
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_charset;

   procedure Put_defaultCharset
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_defaultCharset
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_defaultCharset;

    function Get_defaultCharset
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_defaultCharset
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_defaultCharset;

    function Get_mimeType
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_mimeType
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_mimeType;

    function Get_fileSize
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fileSize
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fileSize;

    function Get_fileCreatedDate
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fileCreatedDate
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fileCreatedDate;

    function Get_fileModifiedDate
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fileModifiedDate
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fileModifiedDate;

    function Get_fileUpdatedDate
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fileUpdatedDate
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fileUpdatedDate;

    function Get_security
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_security
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_security;

    function Get_protocol
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_protocol
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_protocol;

    function Get_nameProp
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_nameProp
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_nameProp;

   procedure write
     (This    : IHTMLDocument2_Type;
      psarray : GNATCOM.Types.SAFEARRAY)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.write
         (Pointer (This),
          psarray));

   end write;

   procedure writeln
     (This    : IHTMLDocument2_Type;
      psarray : GNATCOM.Types.SAFEARRAY)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.writeln
         (Pointer (This),
          psarray));

   end writeln;

    function open
     (This            : IHTMLDocument2_Type;
      url             : GNATCOM.Types.BSTR;
      name            : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      features        : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      replace         : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free            : Boolean := True)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.open
         (Pointer (This),
          url,
          name,
          features,
          replace,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (url);
               GNATCOM.Interface.Free (name);
               GNATCOM.Interface.Free (features);
               GNATCOM.Interface.Free (replace);
      
      end if;

      return RetVal;
   end open;

   procedure close
     (This : IHTMLDocument2_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.close
         (Pointer (This)));

   end close;

   procedure clear
     (This : IHTMLDocument2_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.clear
         (Pointer (This)));

   end clear;

    function queryCommandSupported
     (This  : IHTMLDocument2_Type;
      cmdID : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.queryCommandSupported
         (Pointer (This),
          cmdID,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (cmdID);
      
      end if;

      return RetVal;
   end queryCommandSupported;

    function queryCommandEnabled
     (This  : IHTMLDocument2_Type;
      cmdID : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.queryCommandEnabled
         (Pointer (This),
          cmdID,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (cmdID);
      
      end if;

      return RetVal;
   end queryCommandEnabled;

    function queryCommandState
     (This  : IHTMLDocument2_Type;
      cmdID : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.queryCommandState
         (Pointer (This),
          cmdID,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (cmdID);
      
      end if;

      return RetVal;
   end queryCommandState;

    function queryCommandIndeterm
     (This  : IHTMLDocument2_Type;
      cmdID : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.queryCommandIndeterm
         (Pointer (This),
          cmdID,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (cmdID);
      
      end if;

      return RetVal;
   end queryCommandIndeterm;

    function queryCommandText
     (This     : IHTMLDocument2_Type;
      cmdID    : GNATCOM.Types.BSTR;
      Free     : Boolean := True)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.queryCommandText
         (Pointer (This),
          cmdID,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (cmdID);
      
      end if;

      return RetVal;
   end queryCommandText;

    function queryCommandValue
     (This      : IHTMLDocument2_Type;
      cmdID     : GNATCOM.Types.BSTR;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.queryCommandValue
         (Pointer (This),
          cmdID,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (cmdID);
      
      end if;

      return RetVal;
   end queryCommandValue;

    function execCommand
     (This   : IHTMLDocument2_Type;
      cmdID  : GNATCOM.Types.BSTR;
      showUI : GNATCOM.Types.VARIANT_BOOL;
      value  : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.execCommand
         (Pointer (This),
          cmdID,
          showUI,
          value,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (cmdID);
               GNATCOM.Interface.Free (value);
      
      end if;

      return RetVal;
   end execCommand;

    function execCommandShowHelp
     (This  : IHTMLDocument2_Type;
      cmdID : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.execCommandShowHelp
         (Pointer (This),
          cmdID,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (cmdID);
      
      end if;

      return RetVal;
   end execCommandShowHelp;

    function createElement
     (This    : IHTMLDocument2_Type;
      eTag    : GNATCOM.Types.BSTR;
      Free    : Boolean := True)
     return Pointer_To_IHTMLElement
   is
       RetVal : aliased Pointer_To_IHTMLElement;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.createElement
         (Pointer (This),
          eTag,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (eTag);
      
      end if;

      return RetVal;
   end createElement;

   procedure Put_onhelp
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onhelp
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onhelp;

    function Get_onhelp
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onhelp
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onhelp;

   procedure Put_onclick
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onclick
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onclick;

    function Get_onclick
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onclick
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onclick;

   procedure Put_ondblclick
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_ondblclick
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_ondblclick;

    function Get_ondblclick
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_ondblclick
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_ondblclick;

   procedure Put_onkeyup
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onkeyup
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onkeyup;

    function Get_onkeyup
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onkeyup
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onkeyup;

   procedure Put_onkeydown
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onkeydown
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onkeydown;

    function Get_onkeydown
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onkeydown
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onkeydown;

   procedure Put_onkeypress
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onkeypress
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onkeypress;

    function Get_onkeypress
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onkeypress
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onkeypress;

   procedure Put_onmouseup
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onmouseup
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onmouseup;

    function Get_onmouseup
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onmouseup
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onmouseup;

   procedure Put_onmousedown
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onmousedown
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onmousedown;

    function Get_onmousedown
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onmousedown
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onmousedown;

   procedure Put_onmousemove
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onmousemove
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onmousemove;

    function Get_onmousemove
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onmousemove
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onmousemove;

   procedure Put_onmouseout
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onmouseout
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onmouseout;

    function Get_onmouseout
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onmouseout
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onmouseout;

   procedure Put_onmouseover
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onmouseover
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onmouseover;

    function Get_onmouseover
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onmouseover
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onmouseover;

   procedure Put_onreadystatechange
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onreadystatechange
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onreadystatechange;

    function Get_onreadystatechange
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onreadystatechange
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onreadystatechange;

   procedure Put_onafterupdate
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onafterupdate
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onafterupdate;

    function Get_onafterupdate
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onafterupdate
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onafterupdate;

   procedure Put_onrowexit
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onrowexit
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onrowexit;

    function Get_onrowexit
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onrowexit
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onrowexit;

   procedure Put_onrowenter
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onrowenter
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onrowenter;

    function Get_onrowenter
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onrowenter
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onrowenter;

   procedure Put_ondragstart
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_ondragstart
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_ondragstart;

    function Get_ondragstart
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_ondragstart
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_ondragstart;

   procedure Put_onselectstart
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onselectstart
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onselectstart;

    function Get_onselectstart
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onselectstart
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onselectstart;

    function elementFromPoint
     (This       : IHTMLDocument2_Type;
      x          : Interfaces.C.long;
      y          : Interfaces.C.long)
     return Pointer_To_IHTMLElement
   is
       RetVal : aliased Pointer_To_IHTMLElement;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.elementFromPoint
         (Pointer (This),
          x,
          y,
          RetVal'Unchecked_Access));

      return RetVal;
   end elementFromPoint;

    function Get_parentWindow
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLWindow2
   is
       RetVal : aliased Pointer_To_IHTMLWindow2;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_parentWindow
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_parentWindow;

    function Get_styleSheets
     (This : IHTMLDocument2_Type)
     return Pointer_To_IHTMLStyleSheetsCollection
   is
       RetVal : aliased Pointer_To_IHTMLStyleSheetsCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_styleSheets
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_styleSheets;

   procedure Put_onbeforeupdate
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onbeforeupdate
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onbeforeupdate;

    function Get_onbeforeupdate
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onbeforeupdate
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onbeforeupdate;

   procedure Put_onerrorupdate
     (This : IHTMLDocument2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onerrorupdate
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onerrorupdate;

    function Get_onerrorupdate
     (This : IHTMLDocument2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onerrorupdate
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onerrorupdate;

    function toString
     (This   : IHTMLDocument2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.toString
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end toString;

    function createStyleSheet
     (This            : IHTMLDocument2_Type;
      bstrHref        : GNATCOM.Types.BSTR;
      lIndex          : Interfaces.C.long;
      Free            : Boolean := True)
     return Pointer_To_IHTMLStyleSheet
   is
       RetVal : aliased Pointer_To_IHTMLStyleSheet;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.createStyleSheet
         (Pointer (This),
          bstrHref,
          lIndex,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (bstrHref);
      
      end if;

      return RetVal;
   end createStyleSheet;

end MSHTML.IHTMLDocument2_Interface;

