with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLDOMTextNode_Interface is

   procedure Initialize (This : in out IHTMLDOMTextNode_Type) is
   begin
      Set_IID (This, IID_IHTMLDOMTextNode);
   end Initialize;

   function Pointer (This : IHTMLDOMTextNode_Type)
     return Pointer_To_IHTMLDOMTextNode
   is
   begin
      return To_Pointer_To_IHTMLDOMTextNode (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLDOMTextNode_Type;
                     Pointer : in     Pointer_To_IHTMLDOMTextNode)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_data
     (This : IHTMLDOMTextNode_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_data
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_data;

    function Get_data
     (This : IHTMLDOMTextNode_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_data
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_data;

    function toString
     (This   : IHTMLDOMTextNode_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.toString
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end toString;

    function Get_length
     (This : IHTMLDOMTextNode_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_length
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_length;

    function splitText
     (This     : IHTMLDOMTextNode_Type;
      offset   : Interfaces.C.long)
     return Pointer_To_IHTMLDOMNode
   is
       RetVal : aliased Pointer_To_IHTMLDOMNode;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.splitText
         (Pointer (This),
          offset,
          RetVal'Unchecked_Access));

      return RetVal;
   end splitText;

end MSHTML.IHTMLDOMTextNode_Interface;

