with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLFieldSetElement_Interface is

   procedure Initialize (This : in out IHTMLFieldSetElement_Type) is
   begin
      Set_IID (This, IID_IHTMLFieldSetElement);
   end Initialize;

   function Pointer (This : IHTMLFieldSetElement_Type)
     return Pointer_To_IHTMLFieldSetElement
   is
   begin
      return To_Pointer_To_IHTMLFieldSetElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLFieldSetElement_Type;
                     Pointer : in     Pointer_To_IHTMLFieldSetElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_align
     (This : IHTMLFieldSetElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_align
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_align;

    function Get_align
     (This : IHTMLFieldSetElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_align
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_align;

end MSHTML.IHTMLFieldSetElement_Interface;

