with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLFiltersCollection_Interface is

   procedure Initialize (This : in out IHTMLFiltersCollection_Type) is
   begin
      Set_IID (This, IID_IHTMLFiltersCollection);
   end Initialize;

   function Pointer (This : IHTMLFiltersCollection_Type)
     return Pointer_To_IHTMLFiltersCollection
   is
   begin
      return To_Pointer_To_IHTMLFiltersCollection (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLFiltersCollection_Type;
                     Pointer : in     Pointer_To_IHTMLFiltersCollection)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_length
     (This : IHTMLFiltersCollection_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_length
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_length;

    function Getu_newEnum
     (This : IHTMLFiltersCollection_Type)
     return GNATCOM.Types.Pointer_To_IUnknown
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IUnknown;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Getu_newEnum
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Getu_newEnum;

    function item
     (This       : IHTMLFiltersCollection_Type;
      pvarIndex  : access GNATCOM.Types.VARIANT :=
        GNATCOM.Types.PVARIANT_MISSING)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.item
         (Pointer (This),
          pvarIndex,
          RetVal'Unchecked_Access));

      return RetVal;
   end item;

end MSHTML.IHTMLFiltersCollection_Interface;

