with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLFormElement2_Interface is

   procedure Initialize (This : in out IHTMLFormElement2_Type) is
   begin
      Set_IID (This, IID_IHTMLFormElement2);
   end Initialize;

   function Pointer (This : IHTMLFormElement2_Type)
     return Pointer_To_IHTMLFormElement2
   is
   begin
      return To_Pointer_To_IHTMLFormElement2 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLFormElement2_Type;
                     Pointer : in     Pointer_To_IHTMLFormElement2)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_acceptCharset
     (This : IHTMLFormElement2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_acceptCharset
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_acceptCharset;

    function Get_acceptCharset
     (This : IHTMLFormElement2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_acceptCharset
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_acceptCharset;

    function urns
     (This  : IHTMLFormElement2_Type;
      urn   : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.urns
         (Pointer (This),
          urn,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (urn);
      
      end if;

      return RetVal;
   end urns;

end MSHTML.IHTMLFormElement2_Interface;

