with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLFrameBase_Interface is

   procedure Initialize (This : in out IHTMLFrameBase_Type) is
   begin
      Set_IID (This, IID_IHTMLFrameBase);
   end Initialize;

   function Pointer (This : IHTMLFrameBase_Type)
     return Pointer_To_IHTMLFrameBase
   is
   begin
      return To_Pointer_To_IHTMLFrameBase (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLFrameBase_Type;
                     Pointer : in     Pointer_To_IHTMLFrameBase)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_src
     (This : IHTMLFrameBase_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_src
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_src;

    function Get_src
     (This : IHTMLFrameBase_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_src
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_src;

   procedure Put_name
     (This : IHTMLFrameBase_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_name
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_name;

    function Get_name
     (This : IHTMLFrameBase_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_name
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_name;

   procedure Put_border
     (This : IHTMLFrameBase_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_border
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_border;

    function Get_border
     (This : IHTMLFrameBase_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_border
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_border;

   procedure Put_frameBorder
     (This : IHTMLFrameBase_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_frameBorder
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_frameBorder;

    function Get_frameBorder
     (This : IHTMLFrameBase_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_frameBorder
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_frameBorder;

   procedure Put_frameSpacing
     (This : IHTMLFrameBase_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_frameSpacing
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_frameSpacing;

    function Get_frameSpacing
     (This : IHTMLFrameBase_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_frameSpacing
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_frameSpacing;

   procedure Put_marginWidth
     (This : IHTMLFrameBase_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_marginWidth
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_marginWidth;

    function Get_marginWidth
     (This : IHTMLFrameBase_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_marginWidth
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_marginWidth;

   procedure Put_marginHeight
     (This : IHTMLFrameBase_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_marginHeight
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_marginHeight;

    function Get_marginHeight
     (This : IHTMLFrameBase_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_marginHeight
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_marginHeight;

   procedure Put_noResize
     (This : IHTMLFrameBase_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_noResize
         (Pointer (This),
          p));

   end Put_noResize;

    function Get_noResize
     (This : IHTMLFrameBase_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_noResize
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_noResize;

   procedure Put_scrolling
     (This : IHTMLFrameBase_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_scrolling
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_scrolling;

    function Get_scrolling
     (This : IHTMLFrameBase_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_scrolling
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_scrolling;

end MSHTML.IHTMLFrameBase_Interface;

