with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLGenericElement_Interface is

   procedure Initialize (This : in out IHTMLGenericElement_Type) is
   begin
      Set_IID (This, IID_IHTMLGenericElement);
   end Initialize;

   function Pointer (This : IHTMLGenericElement_Type)
     return Pointer_To_IHTMLGenericElement
   is
   begin
      return To_Pointer_To_IHTMLGenericElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLGenericElement_Type;
                     Pointer : in     Pointer_To_IHTMLGenericElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_recordset
     (This : IHTMLGenericElement_Type)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_recordset
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_recordset;

    function namedRecordset
     (This        : IHTMLGenericElement_Type;
      dataMember  : GNATCOM.Types.BSTR;
      hierarchy   : access GNATCOM.Types.VARIANT :=
        GNATCOM.Types.PVARIANT_MISSING;
      Free        : Boolean := True)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.namedRecordset
         (Pointer (This),
          dataMember,
          hierarchy,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (dataMember);
      
      end if;

      return RetVal;
   end namedRecordset;

end MSHTML.IHTMLGenericElement_Interface;

