with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLHRElement_Interface is

   procedure Initialize (This : in out IHTMLHRElement_Type) is
   begin
      Set_IID (This, IID_IHTMLHRElement);
   end Initialize;

   function Pointer (This : IHTMLHRElement_Type)
     return Pointer_To_IHTMLHRElement
   is
   begin
      return To_Pointer_To_IHTMLHRElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLHRElement_Type;
                     Pointer : in     Pointer_To_IHTMLHRElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_align
     (This : IHTMLHRElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_align
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_align;

    function Get_align
     (This : IHTMLHRElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_align
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_align;

   procedure Put_color
     (This : IHTMLHRElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_color
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_color;

    function Get_color
     (This : IHTMLHRElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_color
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_color;

   procedure Put_noShade
     (This : IHTMLHRElement_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_noShade
         (Pointer (This),
          p));

   end Put_noShade;

    function Get_noShade
     (This : IHTMLHRElement_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_noShade
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_noShade;

   procedure Put_width
     (This : IHTMLHRElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_width
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_width;

    function Get_width
     (This : IHTMLHRElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_width
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_width;

   procedure Put_size
     (This : IHTMLHRElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_size
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_size;

    function Get_size
     (This : IHTMLHRElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_size
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_size;

end MSHTML.IHTMLHRElement_Interface;

