with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLIFrameElement_Interface is

   procedure Initialize (This : in out IHTMLIFrameElement_Type) is
   begin
      Set_IID (This, IID_IHTMLIFrameElement);
   end Initialize;

   function Pointer (This : IHTMLIFrameElement_Type)
     return Pointer_To_IHTMLIFrameElement
   is
   begin
      return To_Pointer_To_IHTMLIFrameElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLIFrameElement_Type;
                     Pointer : in     Pointer_To_IHTMLIFrameElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_vspace
     (This : IHTMLIFrameElement_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_vspace
         (Pointer (This),
          p));

   end Put_vspace;

    function Get_vspace
     (This : IHTMLIFrameElement_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_vspace
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_vspace;

   procedure Put_hspace
     (This : IHTMLIFrameElement_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_hspace
         (Pointer (This),
          p));

   end Put_hspace;

    function Get_hspace
     (This : IHTMLIFrameElement_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_hspace
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_hspace;

   procedure Put_align
     (This : IHTMLIFrameElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_align
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_align;

    function Get_align
     (This : IHTMLIFrameElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_align
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_align;

end MSHTML.IHTMLIFrameElement_Interface;

