with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLIsIndexElement_Interface is

   procedure Initialize (This : in out IHTMLIsIndexElement_Type) is
   begin
      Set_IID (This, IID_IHTMLIsIndexElement);
   end Initialize;

   function Pointer (This : IHTMLIsIndexElement_Type)
     return Pointer_To_IHTMLIsIndexElement
   is
   begin
      return To_Pointer_To_IHTMLIsIndexElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLIsIndexElement_Type;
                     Pointer : in     Pointer_To_IHTMLIsIndexElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_prompt
     (This : IHTMLIsIndexElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_prompt
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_prompt;

    function Get_prompt
     (This : IHTMLIsIndexElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_prompt
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_prompt;

   procedure Put_action
     (This : IHTMLIsIndexElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_action
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_action;

    function Get_action
     (This : IHTMLIsIndexElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_action
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_action;

end MSHTML.IHTMLIsIndexElement_Interface;

