with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLLabelElement_Interface is

   procedure Initialize (This : in out IHTMLLabelElement_Type) is
   begin
      Set_IID (This, IID_IHTMLLabelElement);
   end Initialize;

   function Pointer (This : IHTMLLabelElement_Type)
     return Pointer_To_IHTMLLabelElement
   is
   begin
      return To_Pointer_To_IHTMLLabelElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLLabelElement_Type;
                     Pointer : in     Pointer_To_IHTMLLabelElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_htmlFor
     (This : IHTMLLabelElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_htmlFor
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_htmlFor;

    function Get_htmlFor
     (This : IHTMLLabelElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_htmlFor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_htmlFor;

   procedure Put_accessKey
     (This : IHTMLLabelElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_accessKey
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_accessKey;

    function Get_accessKey
     (This : IHTMLLabelElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_accessKey
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_accessKey;

end MSHTML.IHTMLLabelElement_Interface;

