with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLLIElement_Interface is

   procedure Initialize (This : in out IHTMLLIElement_Type) is
   begin
      Set_IID (This, IID_IHTMLLIElement);
   end Initialize;

   function Pointer (This : IHTMLLIElement_Type)
     return Pointer_To_IHTMLLIElement
   is
   begin
      return To_Pointer_To_IHTMLLIElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLLIElement_Type;
                     Pointer : in     Pointer_To_IHTMLLIElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_type
     (This : IHTMLLIElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_type
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_type;

    function Get_type
     (This : IHTMLLIElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_type
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_type;

   procedure Put_value
     (This : IHTMLLIElement_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_value
         (Pointer (This),
          p));

   end Put_value;

    function Get_value
     (This : IHTMLLIElement_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_value
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_value;

end MSHTML.IHTMLLIElement_Interface;

