with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLLinkElement2_Interface is

   procedure Initialize (This : in out IHTMLLinkElement2_Type) is
   begin
      Set_IID (This, IID_IHTMLLinkElement2);
   end Initialize;

   function Pointer (This : IHTMLLinkElement2_Type)
     return Pointer_To_IHTMLLinkElement2
   is
   begin
      return To_Pointer_To_IHTMLLinkElement2 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLLinkElement2_Type;
                     Pointer : in     Pointer_To_IHTMLLinkElement2)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_target
     (This : IHTMLLinkElement2_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_target
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_target;

    function Get_target
     (This : IHTMLLinkElement2_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_target
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_target;

end MSHTML.IHTMLLinkElement2_Interface;

