with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLLocation_Interface is

   procedure Initialize (This : in out IHTMLLocation_Type) is
   begin
      Set_IID (This, IID_IHTMLLocation);
   end Initialize;

   function Pointer (This : IHTMLLocation_Type)
     return Pointer_To_IHTMLLocation
   is
   begin
      return To_Pointer_To_IHTMLLocation (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLLocation_Type;
                     Pointer : in     Pointer_To_IHTMLLocation)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_href
     (This : IHTMLLocation_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_href
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_href;

    function Get_href
     (This : IHTMLLocation_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_href
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_href;

   procedure Put_protocol
     (This : IHTMLLocation_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_protocol
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_protocol;

    function Get_protocol
     (This : IHTMLLocation_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_protocol
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_protocol;

   procedure Put_host
     (This : IHTMLLocation_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_host
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_host;

    function Get_host
     (This : IHTMLLocation_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_host
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_host;

   procedure Put_hostname
     (This : IHTMLLocation_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_hostname
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_hostname;

    function Get_hostname
     (This : IHTMLLocation_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_hostname
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_hostname;

   procedure Put_port
     (This : IHTMLLocation_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_port
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_port;

    function Get_port
     (This : IHTMLLocation_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_port
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_port;

   procedure Put_pathname
     (This : IHTMLLocation_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_pathname
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_pathname;

    function Get_pathname
     (This : IHTMLLocation_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_pathname
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_pathname;

   procedure Put_search
     (This : IHTMLLocation_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_search
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_search;

    function Get_search
     (This : IHTMLLocation_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_search
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_search;

   procedure Put_hash
     (This : IHTMLLocation_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_hash
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_hash;

    function Get_hash
     (This : IHTMLLocation_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_hash
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_hash;

   procedure reload
     (This : IHTMLLocation_Type;
      flag : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.reload
         (Pointer (This),
          flag));

   end reload;

   procedure replace
     (This : IHTMLLocation_Type;
      bstr : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.replace
         (Pointer (This),
          bstr));

      if Free then
               GNATCOM.Interface.Free (bstr);
      
      end if;

   end replace;

   procedure assign
     (This : IHTMLLocation_Type;
      bstr : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.assign
         (Pointer (This),
          bstr));

      if Free then
               GNATCOM.Interface.Free (bstr);
      
      end if;

   end assign;

    function toString
     (This   : IHTMLLocation_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.toString
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end toString;

end MSHTML.IHTMLLocation_Interface;

