with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLMarqueeElement_Interface is

   procedure Initialize (This : in out IHTMLMarqueeElement_Type) is
   begin
      Set_IID (This, IID_IHTMLMarqueeElement);
   end Initialize;

   function Pointer (This : IHTMLMarqueeElement_Type)
     return Pointer_To_IHTMLMarqueeElement
   is
   begin
      return To_Pointer_To_IHTMLMarqueeElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLMarqueeElement_Type;
                     Pointer : in     Pointer_To_IHTMLMarqueeElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_bgColor
     (This : IHTMLMarqueeElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_bgColor
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_bgColor;

    function Get_bgColor
     (This : IHTMLMarqueeElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_bgColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_bgColor;

   procedure Put_scrollDelay
     (This : IHTMLMarqueeElement_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_scrollDelay
         (Pointer (This),
          p));

   end Put_scrollDelay;

    function Get_scrollDelay
     (This : IHTMLMarqueeElement_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_scrollDelay
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_scrollDelay;

   procedure Put_direction
     (This : IHTMLMarqueeElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_direction
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_direction;

    function Get_direction
     (This : IHTMLMarqueeElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_direction
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_direction;

   procedure Put_behavior
     (This : IHTMLMarqueeElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_behavior
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_behavior;

    function Get_behavior
     (This : IHTMLMarqueeElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_behavior
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_behavior;

   procedure Put_scrollAmount
     (This : IHTMLMarqueeElement_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_scrollAmount
         (Pointer (This),
          p));

   end Put_scrollAmount;

    function Get_scrollAmount
     (This : IHTMLMarqueeElement_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_scrollAmount
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_scrollAmount;

   procedure Put_loop
     (This : IHTMLMarqueeElement_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_loop
         (Pointer (This),
          p));

   end Put_loop;

    function Get_loop
     (This : IHTMLMarqueeElement_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_loop
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_loop;

   procedure Put_vspace
     (This : IHTMLMarqueeElement_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_vspace
         (Pointer (This),
          p));

   end Put_vspace;

    function Get_vspace
     (This : IHTMLMarqueeElement_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_vspace
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_vspace;

   procedure Put_hspace
     (This : IHTMLMarqueeElement_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_hspace
         (Pointer (This),
          p));

   end Put_hspace;

    function Get_hspace
     (This : IHTMLMarqueeElement_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_hspace
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_hspace;

   procedure Put_onfinish
     (This : IHTMLMarqueeElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onfinish
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onfinish;

    function Get_onfinish
     (This : IHTMLMarqueeElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onfinish
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onfinish;

   procedure Put_onstart
     (This : IHTMLMarqueeElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onstart
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onstart;

    function Get_onstart
     (This : IHTMLMarqueeElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onstart
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onstart;

   procedure Put_onbounce
     (This : IHTMLMarqueeElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onbounce
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onbounce;

    function Get_onbounce
     (This : IHTMLMarqueeElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onbounce
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onbounce;

   procedure Put_width
     (This : IHTMLMarqueeElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_width
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_width;

    function Get_width
     (This : IHTMLMarqueeElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_width
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_width;

   procedure Put_height
     (This : IHTMLMarqueeElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_height
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_height;

    function Get_height
     (This : IHTMLMarqueeElement_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_height
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_height;

   procedure Put_trueSpeed
     (This : IHTMLMarqueeElement_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_trueSpeed
         (Pointer (This),
          p));

   end Put_trueSpeed;

    function Get_trueSpeed
     (This : IHTMLMarqueeElement_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_trueSpeed
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_trueSpeed;

   procedure Start
     (This : IHTMLMarqueeElement_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Start
         (Pointer (This)));

   end Start;

   procedure stop
     (This : IHTMLMarqueeElement_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.stop
         (Pointer (This)));

   end stop;

end MSHTML.IHTMLMarqueeElement_Interface;

