with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLMetaElement_Interface is

   procedure Initialize (This : in out IHTMLMetaElement_Type) is
   begin
      Set_IID (This, IID_IHTMLMetaElement);
   end Initialize;

   function Pointer (This : IHTMLMetaElement_Type)
     return Pointer_To_IHTMLMetaElement
   is
   begin
      return To_Pointer_To_IHTMLMetaElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLMetaElement_Type;
                     Pointer : in     Pointer_To_IHTMLMetaElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_httpEquiv
     (This : IHTMLMetaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_httpEquiv
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_httpEquiv;

    function Get_httpEquiv
     (This : IHTMLMetaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_httpEquiv
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_httpEquiv;

   procedure Put_content
     (This : IHTMLMetaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_content
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_content;

    function Get_content
     (This : IHTMLMetaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_content
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_content;

   procedure Put_name
     (This : IHTMLMetaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_name
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_name;

    function Get_name
     (This : IHTMLMetaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_name
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_name;

   procedure Put_url
     (This : IHTMLMetaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_url
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_url;

    function Get_url
     (This : IHTMLMetaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_url
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_url;

   procedure Put_charset
     (This : IHTMLMetaElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_charset
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_charset;

    function Get_charset
     (This : IHTMLMetaElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_charset
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_charset;

end MSHTML.IHTMLMetaElement_Interface;

