with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLNextIdElement_Interface is

   procedure Initialize (This : in out IHTMLNextIdElement_Type) is
   begin
      Set_IID (This, IID_IHTMLNextIdElement);
   end Initialize;

   function Pointer (This : IHTMLNextIdElement_Type)
     return Pointer_To_IHTMLNextIdElement
   is
   begin
      return To_Pointer_To_IHTMLNextIdElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLNextIdElement_Type;
                     Pointer : in     Pointer_To_IHTMLNextIdElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_n
     (This : IHTMLNextIdElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_n
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_n;

    function Get_n
     (This : IHTMLNextIdElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_n
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_n;

end MSHTML.IHTMLNextIdElement_Interface;

