with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLOptionsHolder_Interface is

   procedure Initialize (This : in out IHTMLOptionsHolder_Type) is
   begin
      Set_IID (This, IID_IHTMLOptionsHolder);
   end Initialize;

   function Pointer (This : IHTMLOptionsHolder_Type)
     return Pointer_To_IHTMLOptionsHolder
   is
   begin
      return To_Pointer_To_IHTMLOptionsHolder (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLOptionsHolder_Type;
                     Pointer : in     Pointer_To_IHTMLOptionsHolder)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_document
     (This : IHTMLOptionsHolder_Type)
     return Pointer_To_IHTMLDocument2
   is
       RetVal : aliased Pointer_To_IHTMLDocument2;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_document
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_document;

    function Get_fonts
     (This : IHTMLOptionsHolder_Type)
     return Pointer_To_IHTMLFontNamesCollection
   is
       RetVal : aliased Pointer_To_IHTMLFontNamesCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fonts
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fonts;

   procedure Put_execArg
     (This : IHTMLOptionsHolder_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_execArg
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_execArg;

    function Get_execArg
     (This : IHTMLOptionsHolder_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_execArg
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_execArg;

   procedure Put_errorLine
     (This : IHTMLOptionsHolder_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_errorLine
         (Pointer (This),
          p));

   end Put_errorLine;

    function Get_errorLine
     (This : IHTMLOptionsHolder_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_errorLine
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_errorLine;

   procedure Put_errorCharacter
     (This : IHTMLOptionsHolder_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_errorCharacter
         (Pointer (This),
          p));

   end Put_errorCharacter;

    function Get_errorCharacter
     (This : IHTMLOptionsHolder_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_errorCharacter
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_errorCharacter;

   procedure Put_errorCode
     (This : IHTMLOptionsHolder_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_errorCode
         (Pointer (This),
          p));

   end Put_errorCode;

    function Get_errorCode
     (This : IHTMLOptionsHolder_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_errorCode
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_errorCode;

   procedure Put_errorMessage
     (This : IHTMLOptionsHolder_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_errorMessage
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_errorMessage;

    function Get_errorMessage
     (This : IHTMLOptionsHolder_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_errorMessage
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_errorMessage;

   procedure Put_errorDebug
     (This : IHTMLOptionsHolder_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_errorDebug
         (Pointer (This),
          p));

   end Put_errorDebug;

    function Get_errorDebug
     (This : IHTMLOptionsHolder_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_errorDebug
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_errorDebug;

    function Get_unsecuredWindowOfDocument
     (This : IHTMLOptionsHolder_Type)
     return Pointer_To_IHTMLWindow2
   is
       RetVal : aliased Pointer_To_IHTMLWindow2;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_unsecuredWindowOfDocument
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_unsecuredWindowOfDocument;

   procedure Put_findText
     (This : IHTMLOptionsHolder_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_findText
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_findText;

    function Get_findText
     (This : IHTMLOptionsHolder_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_findText
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_findText;

   procedure Put_anythingAfterFrameset
     (This : IHTMLOptionsHolder_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_anythingAfterFrameset
         (Pointer (This),
          p));

   end Put_anythingAfterFrameset;

    function Get_anythingAfterFrameset
     (This : IHTMLOptionsHolder_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_anythingAfterFrameset
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_anythingAfterFrameset;

    function sizes
     (This             : IHTMLOptionsHolder_Type;
      fontName         : GNATCOM.Types.BSTR;
      Free             : Boolean := True)
     return Pointer_To_IHTMLFontSizesCollection
   is
       RetVal : aliased Pointer_To_IHTMLFontSizesCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.sizes
         (Pointer (This),
          fontName,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (fontName);
      
      end if;

      return RetVal;
   end sizes;

    function openfiledlg
     (This     : IHTMLOptionsHolder_Type;
      initFile : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      initDir  : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      filter   : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      title    : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free     : Boolean := True)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.openfiledlg
         (Pointer (This),
          initFile,
          initDir,
          filter,
          title,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (initFile);
               GNATCOM.Interface.Free (initDir);
               GNATCOM.Interface.Free (filter);
               GNATCOM.Interface.Free (title);
      
      end if;

      return RetVal;
   end openfiledlg;

    function savefiledlg
     (This     : IHTMLOptionsHolder_Type;
      initFile : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      initDir  : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      filter   : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      title    : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free     : Boolean := True)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.savefiledlg
         (Pointer (This),
          initFile,
          initDir,
          filter,
          title,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (initFile);
               GNATCOM.Interface.Free (initDir);
               GNATCOM.Interface.Free (filter);
               GNATCOM.Interface.Free (title);
      
      end if;

      return RetVal;
   end savefiledlg;

    function choosecolordlg
     (This      : IHTMLOptionsHolder_Type;
      initColor : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free      : Boolean := True)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.choosecolordlg
         (Pointer (This),
          initColor,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (initColor);
      
      end if;

      return RetVal;
   end choosecolordlg;

   procedure showSecurityInfo
     (This : IHTMLOptionsHolder_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.showSecurityInfo
         (Pointer (This)));

   end showSecurityInfo;

    function isApartmentModel
     (This       : IHTMLOptionsHolder_Type;
      object     : Pointer_To_IHTMLObjectElement)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.isApartmentModel
         (Pointer (This),
          object,
          RetVal'Unchecked_Access));

      return RetVal;
   end isApartmentModel;

    function getCharset
     (This     : IHTMLOptionsHolder_Type;
      fontName : GNATCOM.Types.BSTR;
      Free     : Boolean := True)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.getCharset
         (Pointer (This),
          fontName,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (fontName);
      
      end if;

      return RetVal;
   end getCharset;

    function Get_secureConnectionInfo
     (This : IHTMLOptionsHolder_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_secureConnectionInfo
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_secureConnectionInfo;

end MSHTML.IHTMLOptionsHolder_Interface;

