with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLPluginsCollection_Interface is

   procedure Initialize (This : in out IHTMLPluginsCollection_Type) is
   begin
      Set_IID (This, IID_IHTMLPluginsCollection);
   end Initialize;

   function Pointer (This : IHTMLPluginsCollection_Type)
     return Pointer_To_IHTMLPluginsCollection
   is
   begin
      return To_Pointer_To_IHTMLPluginsCollection (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLPluginsCollection_Type;
                     Pointer : in     Pointer_To_IHTMLPluginsCollection)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_length
     (This : IHTMLPluginsCollection_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_length
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_length;

   procedure refresh
     (This   : IHTMLPluginsCollection_Type;
      reload : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.refresh
         (Pointer (This),
          reload));

   end refresh;

end MSHTML.IHTMLPluginsCollection_Interface;

