with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLRect_Interface is

   procedure Initialize (This : in out IHTMLRect_Type) is
   begin
      Set_IID (This, IID_IHTMLRect);
   end Initialize;

   function Pointer (This : IHTMLRect_Type)
     return Pointer_To_IHTMLRect
   is
   begin
      return To_Pointer_To_IHTMLRect (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLRect_Type;
                     Pointer : in     Pointer_To_IHTMLRect)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_left
     (This : IHTMLRect_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_left
         (Pointer (This),
          p));

   end Put_left;

    function Get_left
     (This : IHTMLRect_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_left
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_left;

   procedure Put_top
     (This : IHTMLRect_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_top
         (Pointer (This),
          p));

   end Put_top;

    function Get_top
     (This : IHTMLRect_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_top
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_top;

   procedure Put_right
     (This : IHTMLRect_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_right
         (Pointer (This),
          p));

   end Put_right;

    function Get_right
     (This : IHTMLRect_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_right
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_right;

   procedure Put_bottom
     (This : IHTMLRect_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_bottom
         (Pointer (This),
          p));

   end Put_bottom;

    function Get_bottom
     (This : IHTMLRect_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_bottom
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_bottom;

end MSHTML.IHTMLRect_Interface;

