with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLScreen_Interface is

   procedure Initialize (This : in out IHTMLScreen_Type) is
   begin
      Set_IID (This, IID_IHTMLScreen);
   end Initialize;

   function Pointer (This : IHTMLScreen_Type)
     return Pointer_To_IHTMLScreen
   is
   begin
      return To_Pointer_To_IHTMLScreen (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLScreen_Type;
                     Pointer : in     Pointer_To_IHTMLScreen)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_colorDepth
     (This : IHTMLScreen_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_colorDepth
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_colorDepth;

   procedure Put_bufferDepth
     (This : IHTMLScreen_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_bufferDepth
         (Pointer (This),
          p));

   end Put_bufferDepth;

    function Get_bufferDepth
     (This : IHTMLScreen_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_bufferDepth
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_bufferDepth;

    function Get_width
     (This : IHTMLScreen_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_width
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_width;

    function Get_height
     (This : IHTMLScreen_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_height
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_height;

   procedure Put_updateInterval
     (This : IHTMLScreen_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_updateInterval
         (Pointer (This),
          p));

   end Put_updateInterval;

    function Get_updateInterval
     (This : IHTMLScreen_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_updateInterval
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_updateInterval;

    function Get_availHeight
     (This : IHTMLScreen_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_availHeight
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_availHeight;

    function Get_availWidth
     (This : IHTMLScreen_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_availWidth
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_availWidth;

    function Get_fontSmoothingEnabled
     (This : IHTMLScreen_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fontSmoothingEnabled
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fontSmoothingEnabled;

end MSHTML.IHTMLScreen_Interface;

