with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLSelectionObject_Interface is

   procedure Initialize (This : in out IHTMLSelectionObject_Type) is
   begin
      Set_IID (This, IID_IHTMLSelectionObject);
   end Initialize;

   function Pointer (This : IHTMLSelectionObject_Type)
     return Pointer_To_IHTMLSelectionObject
   is
   begin
      return To_Pointer_To_IHTMLSelectionObject (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLSelectionObject_Type;
                     Pointer : in     Pointer_To_IHTMLSelectionObject)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function createRange
     (This   : IHTMLSelectionObject_Type)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.createRange
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end createRange;

   procedure empty
     (This : IHTMLSelectionObject_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.empty
         (Pointer (This)));

   end empty;

   procedure clear
     (This : IHTMLSelectionObject_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.clear
         (Pointer (This)));

   end clear;

    function Get_type
     (This : IHTMLSelectionObject_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_type
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_type;

end MSHTML.IHTMLSelectionObject_Interface;

