with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLStyleFontFace_Interface is

   procedure Initialize (This : in out IHTMLStyleFontFace_Type) is
   begin
      Set_IID (This, IID_IHTMLStyleFontFace);
   end Initialize;

   function Pointer (This : IHTMLStyleFontFace_Type)
     return Pointer_To_IHTMLStyleFontFace
   is
   begin
      return To_Pointer_To_IHTMLStyleFontFace (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLStyleFontFace_Type;
                     Pointer : in     Pointer_To_IHTMLStyleFontFace)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_fontsrc
     (This : IHTMLStyleFontFace_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_fontsrc
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_fontsrc;

    function Get_fontsrc
     (This : IHTMLStyleFontFace_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_fontsrc
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_fontsrc;

end MSHTML.IHTMLStyleFontFace_Interface;

