with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLTable2_Interface is

   procedure Initialize (This : in out IHTMLTable2_Type) is
   begin
      Set_IID (This, IID_IHTMLTable2);
   end Initialize;

   function Pointer (This : IHTMLTable2_Type)
     return Pointer_To_IHTMLTable2
   is
   begin
      return To_Pointer_To_IHTMLTable2 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLTable2_Type;
                     Pointer : in     Pointer_To_IHTMLTable2)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure firstPage
     (This : IHTMLTable2_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.firstPage
         (Pointer (This)));

   end firstPage;

   procedure lastPage
     (This : IHTMLTable2_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.lastPage
         (Pointer (This)));

   end lastPage;

    function Get_cells
     (This : IHTMLTable2_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_cells
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_cells;

    function moveRow
     (This      : IHTMLTable2_Type;
      indexFrom : Interfaces.C.long;
      indexTo   : Interfaces.C.long)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.moveRow
         (Pointer (This),
          indexFrom,
          indexTo,
          RetVal'Unchecked_Access));

      return RetVal;
   end moveRow;

end MSHTML.IHTMLTable2_Interface;

