with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLTable_Interface is

   procedure Initialize (This : in out IHTMLTable_Type) is
   begin
      Set_IID (This, IID_IHTMLTable);
   end Initialize;

   function Pointer (This : IHTMLTable_Type)
     return Pointer_To_IHTMLTable
   is
   begin
      return To_Pointer_To_IHTMLTable (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLTable_Type;
                     Pointer : in     Pointer_To_IHTMLTable)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_cols
     (This : IHTMLTable_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_cols
         (Pointer (This),
          p));

   end Put_cols;

    function Get_cols
     (This : IHTMLTable_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_cols
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_cols;

   procedure Put_border
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_border
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_border;

    function Get_border
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_border
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_border;

   procedure Put_frame
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_frame
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_frame;

    function Get_frame
     (This : IHTMLTable_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_frame
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_frame;

   procedure Put_rules
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_rules
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_rules;

    function Get_rules
     (This : IHTMLTable_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_rules
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_rules;

   procedure Put_cellSpacing
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_cellSpacing
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_cellSpacing;

    function Get_cellSpacing
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_cellSpacing
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_cellSpacing;

   procedure Put_cellPadding
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_cellPadding
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_cellPadding;

    function Get_cellPadding
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_cellPadding
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_cellPadding;

   procedure Put_background
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_background
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_background;

    function Get_background
     (This : IHTMLTable_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_background
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_background;

   procedure Put_bgColor
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_bgColor
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_bgColor;

    function Get_bgColor
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_bgColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_bgColor;

   procedure Put_borderColor
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_borderColor
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_borderColor;

    function Get_borderColor
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderColor
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderColor;

   procedure Put_borderColorLight
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_borderColorLight
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_borderColorLight;

    function Get_borderColorLight
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderColorLight
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderColorLight;

   procedure Put_borderColorDark
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_borderColorDark
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_borderColorDark;

    function Get_borderColorDark
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_borderColorDark
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_borderColorDark;

   procedure Put_align
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_align
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_align;

    function Get_align
     (This : IHTMLTable_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_align
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_align;

   procedure refresh
     (This : IHTMLTable_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.refresh
         (Pointer (This)));

   end refresh;

    function Get_rows
     (This : IHTMLTable_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_rows
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_rows;

   procedure Put_width
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_width
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_width;

    function Get_width
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_width
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_width;

   procedure Put_height
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_height
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_height;

    function Get_height
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_height
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_height;

   procedure Put_dataPageSize
     (This : IHTMLTable_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_dataPageSize
         (Pointer (This),
          p));

   end Put_dataPageSize;

    function Get_dataPageSize
     (This : IHTMLTable_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_dataPageSize
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_dataPageSize;

   procedure nextPage
     (This : IHTMLTable_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.nextPage
         (Pointer (This)));

   end nextPage;

   procedure previousPage
     (This : IHTMLTable_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.previousPage
         (Pointer (This)));

   end previousPage;

    function Get_tHead
     (This : IHTMLTable_Type)
     return Pointer_To_IHTMLTableSection
   is
       RetVal : aliased Pointer_To_IHTMLTableSection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_tHead
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_tHead;

    function Get_tFoot
     (This : IHTMLTable_Type)
     return Pointer_To_IHTMLTableSection
   is
       RetVal : aliased Pointer_To_IHTMLTableSection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_tFoot
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_tFoot;

    function Get_tBodies
     (This : IHTMLTable_Type)
     return Pointer_To_IHTMLElementCollection
   is
       RetVal : aliased Pointer_To_IHTMLElementCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_tBodies
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_tBodies;

    function Get_caption
     (This : IHTMLTable_Type)
     return Pointer_To_IHTMLTableCaption
   is
       RetVal : aliased Pointer_To_IHTMLTableCaption;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_caption
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_caption;

    function createTHead
     (This : IHTMLTable_Type)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.createTHead
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end createTHead;

   procedure deleteTHead
     (This : IHTMLTable_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.deleteTHead
         (Pointer (This)));

   end deleteTHead;

    function createTFoot
     (This : IHTMLTable_Type)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.createTFoot
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end createTFoot;

   procedure deleteTFoot
     (This : IHTMLTable_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.deleteTFoot
         (Pointer (This)));

   end deleteTFoot;

    function createCaption
     (This    : IHTMLTable_Type)
     return Pointer_To_IHTMLTableCaption
   is
       RetVal : aliased Pointer_To_IHTMLTableCaption;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.createCaption
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end createCaption;

   procedure deleteCaption
     (This : IHTMLTable_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.deleteCaption
         (Pointer (This)));

   end deleteCaption;

    function insertRow
     (This  : IHTMLTable_Type;
      index : Interfaces.C.long)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.insertRow
         (Pointer (This),
          index,
          RetVal'Unchecked_Access));

      return RetVal;
   end insertRow;

   procedure deleteRow
     (This  : IHTMLTable_Type;
      index : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.deleteRow
         (Pointer (This),
          index));

   end deleteRow;

    function Get_readyState
     (This : IHTMLTable_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_readyState
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_readyState;

   procedure Put_onreadystatechange
     (This : IHTMLTable_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_onreadystatechange
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_onreadystatechange;

    function Get_onreadystatechange
     (This : IHTMLTable_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onreadystatechange
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onreadystatechange;

end MSHTML.IHTMLTable_Interface;

