with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLTableCaption_Interface is

   procedure Initialize (This : in out IHTMLTableCaption_Type) is
   begin
      Set_IID (This, IID_IHTMLTableCaption);
   end Initialize;

   function Pointer (This : IHTMLTableCaption_Type)
     return Pointer_To_IHTMLTableCaption
   is
   begin
      return To_Pointer_To_IHTMLTableCaption (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLTableCaption_Type;
                     Pointer : in     Pointer_To_IHTMLTableCaption)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_align
     (This : IHTMLTableCaption_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_align
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_align;

    function Get_align
     (This : IHTMLTableCaption_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_align
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_align;

   procedure Put_vAlign
     (This : IHTMLTableCaption_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_vAlign
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_vAlign;

    function Get_vAlign
     (This : IHTMLTableCaption_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_vAlign
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_vAlign;

end MSHTML.IHTMLTableCaption_Interface;

