with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLTableRow2_Interface is

   procedure Initialize (This : in out IHTMLTableRow2_Type) is
   begin
      Set_IID (This, IID_IHTMLTableRow2);
   end Initialize;

   function Pointer (This : IHTMLTableRow2_Type)
     return Pointer_To_IHTMLTableRow2
   is
   begin
      return To_Pointer_To_IHTMLTableRow2 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLTableRow2_Type;
                     Pointer : in     Pointer_To_IHTMLTableRow2)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_height
     (This : IHTMLTableRow2_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_height
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_height;

    function Get_height
     (This : IHTMLTableRow2_Type)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_height
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_height;

end MSHTML.IHTMLTableRow2_Interface;

