with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLTitleElement_Interface is

   procedure Initialize (This : in out IHTMLTitleElement_Type) is
   begin
      Set_IID (This, IID_IHTMLTitleElement);
   end Initialize;

   function Pointer (This : IHTMLTitleElement_Type)
     return Pointer_To_IHTMLTitleElement
   is
   begin
      return To_Pointer_To_IHTMLTitleElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLTitleElement_Type;
                     Pointer : in     Pointer_To_IHTMLTitleElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_text
     (This : IHTMLTitleElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_text
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_text;

    function Get_text
     (This : IHTMLTitleElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_text
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_text;

end MSHTML.IHTMLTitleElement_Interface;

