with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLUListElement_Interface is

   procedure Initialize (This : in out IHTMLUListElement_Type) is
   begin
      Set_IID (This, IID_IHTMLUListElement);
   end Initialize;

   function Pointer (This : IHTMLUListElement_Type)
     return Pointer_To_IHTMLUListElement
   is
   begin
      return To_Pointer_To_IHTMLUListElement (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLUListElement_Type;
                     Pointer : in     Pointer_To_IHTMLUListElement)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_compact
     (This : IHTMLUListElement_Type;
      p    : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_compact
         (Pointer (This),
          p));

   end Put_compact;

    function Get_compact
     (This : IHTMLUListElement_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_compact
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_compact;

   procedure Put_type
     (This : IHTMLUListElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_type
         (Pointer (This),
          p));

      if Free then
               GNATCOM.Interface.Free (p);
      
      end if;

   end Put_type;

    function Get_type
     (This : IHTMLUListElement_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_type
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_type;

end MSHTML.IHTMLUListElement_Interface;

