with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLUniqueName_Interface is

   procedure Initialize (This : in out IHTMLUniqueName_Type) is
   begin
      Set_IID (This, IID_IHTMLUniqueName);
   end Initialize;

   function Pointer (This : IHTMLUniqueName_Type)
     return Pointer_To_IHTMLUniqueName
   is
   begin
      return To_Pointer_To_IHTMLUniqueName (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLUniqueName_Type;
                     Pointer : in     Pointer_To_IHTMLUniqueName)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_uniqueNumber
     (This : IHTMLUniqueName_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_uniqueNumber
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_uniqueNumber;

    function Get_uniqueID
     (This : IHTMLUniqueName_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_uniqueID
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_uniqueID;

end MSHTML.IHTMLUniqueName_Interface;

