with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IHTMLUrnCollection_Interface is

   procedure Initialize (This : in out IHTMLUrnCollection_Type) is
   begin
      Set_IID (This, IID_IHTMLUrnCollection);
   end Initialize;

   function Pointer (This : IHTMLUrnCollection_Type)
     return Pointer_To_IHTMLUrnCollection
   is
   begin
      return To_Pointer_To_IHTMLUrnCollection (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLUrnCollection_Type;
                     Pointer : in     Pointer_To_IHTMLUrnCollection)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_length
     (This : IHTMLUrnCollection_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_length
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_length;

    function item
     (This  : IHTMLUrnCollection_Type;
      index : Interfaces.C.long)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.item
         (Pointer (This),
          index,
          RetVal'Unchecked_Access));

      return RetVal;
   end item;

end MSHTML.IHTMLUrnCollection_Interface;

