with GNATCOM.Interface;

package MSHTML.IMarkupPointer_Interface is

   type IMarkupPointer_Type is
     new GNATCOM.Interface.Interface_Type with null record;

   procedure Initialize (This : in out IMarkupPointer_Type);

   function Pointer (This : IMarkupPointer_Type)
     return Pointer_To_IMarkupPointer;

   procedure Attach (This    : in out IMarkupPointer_Type;
                     Pointer : in     Pointer_To_IMarkupPointer);

   procedure OwningDoc
     (This  : IMarkupPointer_Type;
      ppDoc : Pointer_To_Pointer_To_IHTMLDocument2);

   procedure Gravity
     (This     : IMarkupPointer_Type;
      pGravity : Pointer_To_uPOINTER_GRAVITY);

   procedure SetGravity
     (This    : IMarkupPointer_Type;
      Gravity : uPOINTER_GRAVITY);

   procedure Cling
     (This    : IMarkupPointer_Type;
      pfCling : GNATCOM.Types.Pointer_To_long);

   procedure SetCling
     (This   : IMarkupPointer_Type;
      fCLing : Interfaces.C.long);

   procedure Unposition
     (This : IMarkupPointer_Type);

   procedure IsPositioned
     (This         : IMarkupPointer_Type;
      pfPositioned : GNATCOM.Types.Pointer_To_long);

   procedure GetContainer
     (This        : IMarkupPointer_Type;
      ppContainer : Pointer_To_Pointer_To_IMarkupContainer);

   procedure MoveAdjacentToElement
     (This     : IMarkupPointer_Type;
      pElement : Pointer_To_IHTMLElement;
      eAdj     : uELEMENT_ADJACENCY);

   procedure MoveToPointer
     (This     : IMarkupPointer_Type;
      pPointer : Pointer_To_IMarkupPointer);

   procedure MoveToContainer
     (This       : IMarkupPointer_Type;
      pContainer : Pointer_To_IMarkupContainer;
      fAtStart   : Interfaces.C.long);

   procedure left
     (This      : IMarkupPointer_Type;
      fMove     : Interfaces.C.long;
      pContext  : Pointer_To_uMARKUP_CONTEXT_TYPE;
      ppElement : Pointer_To_Pointer_To_IHTMLElement;
      pcch      : GNATCOM.Types.Pointer_To_long;
      pchText   : GNATCOM.Types.Pointer_To_unsigned_short);

   procedure right
     (This      : IMarkupPointer_Type;
      fMove     : Interfaces.C.long;
      pContext  : Pointer_To_uMARKUP_CONTEXT_TYPE;
      ppElement : Pointer_To_Pointer_To_IHTMLElement;
      pcch      : GNATCOM.Types.Pointer_To_long;
      pchText   : GNATCOM.Types.Pointer_To_unsigned_short);

   procedure CurrentScope
     (This          : IMarkupPointer_Type;
      ppElemCurrent : Pointer_To_Pointer_To_IHTMLElement);

   procedure IsLeftOf
     (This         : IMarkupPointer_Type;
      pPointerThat : Pointer_To_IMarkupPointer;
      pfResult     : GNATCOM.Types.Pointer_To_long);

   procedure IsLeftOfOrEqualTo
     (This         : IMarkupPointer_Type;
      pPointerThat : Pointer_To_IMarkupPointer;
      pfResult     : GNATCOM.Types.Pointer_To_long);

   procedure IsRightOf
     (This         : IMarkupPointer_Type;
      pPointerThat : Pointer_To_IMarkupPointer;
      pfResult     : GNATCOM.Types.Pointer_To_long);

   procedure IsRightOfOrEqualTo
     (This         : IMarkupPointer_Type;
      pPointerThat : Pointer_To_IMarkupPointer;
      pfResult     : GNATCOM.Types.Pointer_To_long);

   procedure IsEqualTo
     (This         : IMarkupPointer_Type;
      pPointerThat : Pointer_To_IMarkupPointer;
      pfAreEqual   : GNATCOM.Types.Pointer_To_long);

   procedure MoveUnit
     (This     : IMarkupPointer_Type;
      muAction : uMOVEUNIT_ACTION);

   procedure findText
     (This        : IMarkupPointer_Type;
      pchFindText : GNATCOM.Types.Pointer_To_unsigned_short;
      dwFlags     : Interfaces.C.unsigned_long;
      pIEndMatch  : Pointer_To_IMarkupPointer;
      pIEndSearch : Pointer_To_IMarkupPointer);

end MSHTML.IMarkupPointer_Interface;

