with GNATCOM.Interface;

package MSHTML.IMarkupServices_Interface is

   type IMarkupServices_Type is
     new GNATCOM.Interface.Interface_Type with null record;

   procedure Initialize (This : in out IMarkupServices_Type);

   function Pointer (This : IMarkupServices_Type)
     return Pointer_To_IMarkupServices;

   procedure Attach (This    : in out IMarkupServices_Type;
                     Pointer : in     Pointer_To_IMarkupServices);

   procedure CreateMarkupPointer
     (This      : IMarkupServices_Type;
      ppPointer : Pointer_To_Pointer_To_IMarkupPointer);

   procedure CreateMarkupContainer
     (This              : IMarkupServices_Type;
      ppMarkupContainer : Pointer_To_Pointer_To_IMarkupContainer);

   procedure createElement
     (This          : IMarkupServices_Type;
      tagID         : uELEMENT_TAG_ID;
      pchAttributes : GNATCOM.Types.Pointer_To_unsigned_short;
      ppElement     : Pointer_To_Pointer_To_IHTMLElement);

   procedure CloneElement
     (This              : IMarkupServices_Type;
      pElemCloneThis    : Pointer_To_IHTMLElement;
      ppElementTheClone : Pointer_To_Pointer_To_IHTMLElement);

   procedure InsertElement
     (This           : IMarkupServices_Type;
      pElementInsert : Pointer_To_IHTMLElement;
      pPointerStart  : Pointer_To_IMarkupPointer;
      pPointerFinish : Pointer_To_IMarkupPointer);

   procedure RemoveElement
     (This           : IMarkupServices_Type;
      pElementRemove : Pointer_To_IHTMLElement);

   procedure remove
     (This           : IMarkupServices_Type;
      pPointerStart  : Pointer_To_IMarkupPointer;
      pPointerFinish : Pointer_To_IMarkupPointer);

   procedure Copy
     (This                 : IMarkupServices_Type;
      pPointerSourceStart  : Pointer_To_IMarkupPointer;
      pPointerSourceFinish : Pointer_To_IMarkupPointer;
      pPointerTarget       : Pointer_To_IMarkupPointer);

   procedure move
     (This                 : IMarkupServices_Type;
      pPointerSourceStart  : Pointer_To_IMarkupPointer;
      pPointerSourceFinish : Pointer_To_IMarkupPointer;
      pPointerTarget       : Pointer_To_IMarkupPointer);

   procedure InsertText
     (This           : IMarkupServices_Type;
      pchText        : GNATCOM.Types.Pointer_To_unsigned_short;
      cch            : Interfaces.C.long;
      pPointerTarget : Pointer_To_IMarkupPointer);

   procedure ParseString
     (This              : IMarkupServices_Type;
      pchHTML           : GNATCOM.Types.Pointer_To_unsigned_short;
      dwFlags           : Interfaces.C.unsigned_long;
      ppContainerResult : Pointer_To_Pointer_To_IMarkupContainer;
      ppPointerStart    : Pointer_To_IMarkupPointer;
      ppPointerFinish   : Pointer_To_IMarkupPointer);

   procedure ParseGlobal
     (This              : IMarkupServices_Type;
      hglobalHTML       : wireHGLOBAL;
      dwFlags           : Interfaces.C.unsigned_long;
      ppContainerResult : Pointer_To_Pointer_To_IMarkupContainer;
      pPointerStart     : Pointer_To_IMarkupPointer;
      pPointerFinish    : Pointer_To_IMarkupPointer);

   procedure IsScopedElement
     (This     : IMarkupServices_Type;
      pElement : Pointer_To_IHTMLElement;
      pfScoped : GNATCOM.Types.Pointer_To_long);

   procedure GetElementTagId
     (This     : IMarkupServices_Type;
      pElement : Pointer_To_IHTMLElement;
      ptagId   : Pointer_To_uELEMENT_TAG_ID);

   procedure GetTagIDForName
     (This     : IMarkupServices_Type;
      bstrName : GNATCOM.Types.BSTR;
      ptagId   : Pointer_To_uELEMENT_TAG_ID;
      Free     : Boolean := True);

   procedure GetNameForTagID
     (This      : IMarkupServices_Type;
      tagID     : uELEMENT_TAG_ID;
      pbstrName : GNATCOM.Types.Pointer_To_BSTR);

   procedure MovePointersToRange
     (This           : IMarkupServices_Type;
      pIRange        : Pointer_To_IHTMLTxtRange;
      pPointerStart  : Pointer_To_IMarkupPointer;
      pPointerFinish : Pointer_To_IMarkupPointer);

   procedure MoveRangeToPointers
     (This           : IMarkupServices_Type;
      pPointerStart  : Pointer_To_IMarkupPointer;
      pPointerFinish : Pointer_To_IMarkupPointer;
      pIRange        : Pointer_To_IHTMLTxtRange);

   procedure BeginUndoUnit
     (This     : IMarkupServices_Type;
      pchTitle : GNATCOM.Types.Pointer_To_unsigned_short);

   procedure EndUndoUnit
     (This : IMarkupServices_Type);

end MSHTML.IMarkupServices_Interface;

