with GNATCOM.Errors;

package body MSHTML.IMarkupTextFrags_Interface is

   procedure Initialize (This : in out IMarkupTextFrags_Type) is
   begin
      Set_IID (This, IID_IMarkupTextFrags);
   end Initialize;

   function Pointer (This : IMarkupTextFrags_Type)
     return Pointer_To_IMarkupTextFrags
   is
   begin
      return To_Pointer_To_IMarkupTextFrags (Address (This));
   end Pointer;

   procedure Attach (This    : in out IMarkupTextFrags_Type;
                     Pointer : in     Pointer_To_IMarkupTextFrags)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure GetTextFragCount
     (This    : IMarkupTextFrags_Type;
      pcFrags : GNATCOM.Types.Pointer_To_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetTextFragCount
         (Pointer (This),
          pcFrags));

   end GetTextFragCount;

   procedure GetTextFrag
     (This         : IMarkupTextFrags_Type;
      iFrag        : Interfaces.C.long;
      pbstrFrag    : GNATCOM.Types.Pointer_To_BSTR;
      pPointerFrag : Pointer_To_IMarkupPointer)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetTextFrag
         (Pointer (This),
          iFrag,
          pbstrFrag,
          pPointerFrag));

   end GetTextFrag;

   procedure RemoveTextFrag
     (This  : IMarkupTextFrags_Type;
      iFrag : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.RemoveTextFrag
         (Pointer (This),
          iFrag));

   end RemoveTextFrag;

   procedure InsertTextFrag
     (This           : IMarkupTextFrags_Type;
      iFrag          : Interfaces.C.long;
      bstrInsert     : GNATCOM.Types.BSTR;
      pPointerInsert : Pointer_To_IMarkupPointer;
      Free           : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.InsertTextFrag
         (Pointer (This),
          iFrag,
          bstrInsert,
          pPointerInsert));

      if Free then
               GNATCOM.Interface.Free (bstrInsert);
      
      end if;

   end InsertTextFrag;

   procedure FindTextFragFromMarkupPointer
     (This         : IMarkupTextFrags_Type;
      pPointerFind : Pointer_To_IMarkupPointer;
      piFrag       : GNATCOM.Types.Pointer_To_long;
      pfFragFound  : GNATCOM.Types.Pointer_To_long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.FindTextFragFromMarkupPointer
         (Pointer (This),
          pPointerFind,
          piFrag,
          pfFragFound));

   end FindTextFragFromMarkupPointer;

end MSHTML.IMarkupTextFrags_Interface;

