with GNATCOM.Interface;

with GNATCOM.Errors;

package body MSHTML.IOmNavigator_Interface is

   procedure Initialize (This : in out IOmNavigator_Type) is
   begin
      Set_IID (This, IID_IOmNavigator);
   end Initialize;

   function Pointer (This : IOmNavigator_Type)
     return Pointer_To_IOmNavigator
   is
   begin
      return To_Pointer_To_IOmNavigator (Address (This));
   end Pointer;

   procedure Attach (This    : in out IOmNavigator_Type;
                     Pointer : in     Pointer_To_IOmNavigator)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_appCodeName
     (This : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_appCodeName
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_appCodeName;

    function Get_appName
     (This : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_appName
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_appName;

    function Get_appVersion
     (This : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_appVersion
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_appVersion;

    function Get_userAgent
     (This : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_userAgent
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_userAgent;

    function javaEnabled
     (This    : IOmNavigator_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.javaEnabled
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end javaEnabled;

    function taintEnabled
     (This    : IOmNavigator_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.taintEnabled
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end taintEnabled;

    function Get_mimeTypes
     (This : IOmNavigator_Type)
     return Pointer_To_IHTMLMimeTypesCollection
   is
       RetVal : aliased Pointer_To_IHTMLMimeTypesCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_mimeTypes
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_mimeTypes;

    function Get_plugins
     (This : IOmNavigator_Type)
     return Pointer_To_IHTMLPluginsCollection
   is
       RetVal : aliased Pointer_To_IHTMLPluginsCollection;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_plugins
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_plugins;

    function Get_cookieEnabled
     (This : IOmNavigator_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_cookieEnabled
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_cookieEnabled;

    function Get_opsProfile
     (This : IOmNavigator_Type)
     return Pointer_To_IHTMLOpsProfile
   is
       RetVal : aliased Pointer_To_IHTMLOpsProfile;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_opsProfile
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_opsProfile;

    function toString
     (This   : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.toString
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end toString;

    function Get_cpuClass
     (This : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_cpuClass
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_cpuClass;

    function Get_systemLanguage
     (This : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_systemLanguage
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_systemLanguage;

    function Get_browserLanguage
     (This : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_browserLanguage
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_browserLanguage;

    function Get_userLanguage
     (This : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_userLanguage
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_userLanguage;

    function Get_platform
     (This : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_platform
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_platform;

    function Get_appMinorVersion
     (This : IOmNavigator_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_appMinorVersion
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_appMinorVersion;

    function Get_connectionSpeed
     (This : IOmNavigator_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_connectionSpeed
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_connectionSpeed;

    function Get_onLine
     (This : IOmNavigator_Type)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_onLine
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_onLine;

    function Get_userProfile
     (This : IOmNavigator_Type)
     return Pointer_To_IHTMLOpsProfile
   is
       RetVal : aliased Pointer_To_IHTMLOpsProfile;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_userProfile
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_userProfile;

end MSHTML.IOmNavigator_Interface;

