with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAArray_Interface is

   type IDAArray_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAArray_Type);

   function Pointer (This : IDAArray_Type)
     return Pointer_To_IDAArray;

   procedure Attach (This    : in out IDAArray_Type;
                     Pointer : in     Pointer_To_IDAArray);

   function GetClassName
     (This       : IDAArray_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAArray_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAArray_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAArray_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAArray_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAArray_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAArray_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAArray_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAArray_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAArray_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAArray_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAArray_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAArray_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAArray_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function NthAnim
     (This    : IDAArray_Type;
      index_0 : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Length
     (This  : IDAArray_Type)
     return Pointer_To_IDANumber;

end StructuredGraphicControl.IDAArray_Interface;

