package body StructuredGraphicControl.IDAArray_Object is

   function GetClassName
     (This : IDAArray_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAArray_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDAArray_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAArray_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDAArray_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAArray_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDAArray_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAArray_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDAArray_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAArray_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDAArray_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAArray_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDAArray_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAArray_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDAArray_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAArray_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDAArray_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAArray_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDAArray_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAArray_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDAArray_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAArray_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDAArray_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAArray_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDAArray_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAArray_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDAArray_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAArray_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function NthAnim
     (This    : IDAArray_Type;
      index_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAArray_NthAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => index_0),
         Free);
   end NthAnim;

   function Length
     (This : IDAArray_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAArray_Length);
   end Length;

end StructuredGraphicControl.IDAArray_Object;

