with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDABbox2_Interface is

   type IDABbox2_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDABbox2_Type);

   function Pointer (This : IDABbox2_Type)
     return Pointer_To_IDABbox2;

   procedure Attach (This    : in out IDABbox2_Type;
                     Pointer : in     Pointer_To_IDABbox2);

   function GetClassName
     (This       : IDABbox2_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDABbox2_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDABbox2_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDABbox2_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDABbox2_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDABbox2_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDABbox2_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDABbox2_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDABbox2_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDABbox2_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDABbox2_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDABbox2_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDABbox2_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDABbox2_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Get_Min
     (This  : IDABbox2_Type)
     return Pointer_To_IDAPoint2;

   function Get_Max
     (This  : IDABbox2_Type)
     return Pointer_To_IDAPoint2;

end StructuredGraphicControl.IDABbox2_Interface;

