with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDABehavior_Interface is

   type IDABehavior_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDABehavior_Type);

   function Pointer (This : IDABehavior_Type)
     return Pointer_To_IDABehavior;

   procedure Attach (This    : in out IDABehavior_Type;
                     Pointer : in     Pointer_To_IDABehavior);

   function GetClassName
     (This       : IDABehavior_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDABehavior_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDABehavior_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDABehavior_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDABehavior_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDABehavior_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDABehavior_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDABehavior_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDABehavior_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDABehavior_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDABehavior_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDABehavior_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDABehavior_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDABehavior_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

end StructuredGraphicControl.IDABehavior_Interface;

