with GNATCOM.Interface;

with GNATCOM.Errors;

package body StructuredGraphicControl.IDABvrHook_Interface is

   procedure Initialize (This : in out IDABvrHook_Type) is
   begin
      Set_IID (This, IID_IDABvrHook);
   end Initialize;

   function Pointer (This : IDABvrHook_Type)
     return Pointer_To_IDABvrHook
   is
   begin
      return To_Pointer_To_IDABvrHook (Address (This));
   end Pointer;

   procedure Attach (This    : in out IDABvrHook_Type;
                     Pointer : in     Pointer_To_IDABvrHook)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Notify
     (This                : IDABvrHook_Type;
      id                  : Interfaces.C.long;
      startingPerformance : GNATCOM.Types.VARIANT_BOOL;
      startTime           : Interfaces.C.double;
      gTime               : Interfaces.C.double;
      lTime               : Interfaces.C.double;
      sampleVal           : Pointer_To_IDABehavior;
      curRunningBvr       : Pointer_To_IDABehavior)
     return Pointer_To_IDABehavior
   is
       RetVal : aliased Pointer_To_IDABehavior;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Notify
         (Pointer (This),
          id,
          startingPerformance,
          startTime,
          gTime,
          lTime,
          sampleVal,
          curRunningBvr,
          RetVal'Unchecked_Access));

      return RetVal;
   end Notify;

end StructuredGraphicControl.IDABvrHook_Interface;

