with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDACamera_Interface is

   type IDACamera_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDACamera_Type);

   function Pointer (This : IDACamera_Type)
     return Pointer_To_IDACamera;

   procedure Attach (This    : in out IDACamera_Type;
                     Pointer : in     Pointer_To_IDACamera);

   function GetClassName
     (This       : IDACamera_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDACamera_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDACamera_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDACamera_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDACamera_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDACamera_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDACamera_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDACamera_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDACamera_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDACamera_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDACamera_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDACamera_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDACamera_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDACamera_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Transform
     (This  : IDACamera_Type;
      xf_0  : Pointer_To_IDATransform3)
     return Pointer_To_IDACamera;

   function Depth
     (This    : IDACamera_Type;
      depth_0 : Interfaces.C.double)
     return Pointer_To_IDACamera;

   function DepthAnim
     (This    : IDACamera_Type;
      depth_0 : Pointer_To_IDANumber)
     return Pointer_To_IDACamera;

   function DepthResolution
     (This         : IDACamera_Type;
      resolution_0 : Interfaces.C.double)
     return Pointer_To_IDACamera;

   function DepthResolutionAnim
     (This         : IDACamera_Type;
      resolution_0 : Pointer_To_IDANumber)
     return Pointer_To_IDACamera;

end StructuredGraphicControl.IDACamera_Interface;

