package body StructuredGraphicControl.IDACamera_Object is

   function GetClassName
     (This : IDACamera_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDACamera_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDACamera_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDACamera_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDACamera_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDACamera_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDACamera_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDACamera_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDACamera_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDACamera_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDACamera_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDACamera_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDACamera_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDACamera_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDACamera_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDACamera_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDACamera_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDACamera_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDACamera_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDACamera_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDACamera_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function Transform
     (This : IDACamera_Type;
      xf_0 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_Transform,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xf_0),
         Free);
   end Transform;

   function Depth
     (This    : IDACamera_Type;
      depth_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_Depth,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => depth_0),
         Free);
   end Depth;

   function DepthAnim
     (This    : IDACamera_Type;
      depth_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_DepthAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => depth_0),
         Free);
   end DepthAnim;

   function DepthResolution
     (This         : IDACamera_Type;
      resolution_0 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_DepthResolution,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => resolution_0),
         Free);
   end DepthResolution;

   function DepthResolutionAnim
     (This         : IDACamera_Type;
      resolution_0 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDACamera_DepthResolutionAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => resolution_0),
         Free);
   end DepthResolutionAnim;

end StructuredGraphicControl.IDACamera_Object;

