with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAColor_Interface is

   type IDAColor_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAColor_Type);

   function Pointer (This : IDAColor_Type)
     return Pointer_To_IDAColor;

   procedure Attach (This    : in out IDAColor_Type;
                     Pointer : in     Pointer_To_IDAColor);

   function GetClassName
     (This       : IDAColor_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAColor_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAColor_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAColor_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAColor_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAColor_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAColor_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAColor_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAColor_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAColor_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAColor_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAColor_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAColor_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAColor_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Get_Red
     (This  : IDAColor_Type)
     return Pointer_To_IDANumber;

   function Get_Green
     (This  : IDAColor_Type)
     return Pointer_To_IDANumber;

   function Get_Blue
     (This  : IDAColor_Type)
     return Pointer_To_IDANumber;

   function Get_Hue
     (This  : IDAColor_Type)
     return Pointer_To_IDANumber;

   function Get_Saturation
     (This  : IDAColor_Type)
     return Pointer_To_IDANumber;

   function Get_Lightness
     (This  : IDAColor_Type)
     return Pointer_To_IDANumber;

end StructuredGraphicControl.IDAColor_Interface;

