package body StructuredGraphicControl.IDAColor_Object is

   function GetClassName
     (This : IDAColor_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAColor_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDAColor_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAColor_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDAColor_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAColor_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDAColor_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAColor_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDAColor_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAColor_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDAColor_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAColor_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDAColor_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAColor_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDAColor_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAColor_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDAColor_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAColor_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDAColor_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAColor_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDAColor_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAColor_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDAColor_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAColor_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDAColor_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAColor_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDAColor_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAColor_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function Get_Red
     (This : IDAColor_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAColor_Get_Red);
   end Get_Red;

   function Get_Green
     (This : IDAColor_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAColor_Get_Green);
   end Get_Green;

   function Get_Blue
     (This : IDAColor_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAColor_Get_Blue);
   end Get_Blue;

   function Get_Hue
     (This : IDAColor_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAColor_Get_Hue);
   end Get_Hue;

   function Get_Saturation
     (This : IDAColor_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAColor_Get_Saturation);
   end Get_Saturation;

   function Get_Lightness
     (This : IDAColor_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAColor_Get_Lightness);
   end Get_Lightness;

end StructuredGraphicControl.IDAColor_Object;

