with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDADrawingSurface_Interface is

   type IDADrawingSurface_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDADrawingSurface_Type);

   function Pointer (This : IDADrawingSurface_Type)
     return Pointer_To_IDADrawingSurface;

   procedure Attach (This    : in out IDADrawingSurface_Type;
                     Pointer : in     Pointer_To_IDADrawingSurface);

   function Get_Image
     (This : IDADrawingSurface_Type)
     return Pointer_To_IDAImage;

   procedure Put_LineStyle
     (This : IDADrawingSurface_Type;
      P1   : Pointer_To_IDALineStyle);

   procedure Put_BorderStyle
     (This : IDADrawingSurface_Type;
      P1   : Pointer_To_IDALineStyle);

   procedure Put_FontStyle
     (This : IDADrawingSurface_Type;
      P1   : Pointer_To_IDAFontStyle);

   procedure Put_ClipMatte
     (This : IDADrawingSurface_Type;
      P1   : Pointer_To_IDAMatte);

   procedure Put_MouseEventsEnabled
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT_BOOL);

   procedure Put_HatchFillTransparent
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT_BOOL);

   function Get_LocalContextImage
     (This : IDADrawingSurface_Type)
     return Pointer_To_IDAImage;

   procedure Reset
     (This : IDADrawingSurface_Type);

   procedure Clear
     (This : IDADrawingSurface_Type);

   procedure SaveGraphicsState
     (This : IDADrawingSurface_Type);

   procedure RestoreGraphicsState
     (This : IDADrawingSurface_Type);

   procedure Opacity
     (This : IDADrawingSurface_Type;
      opac : Interfaces.C.double);

   procedure OpacityAnim
     (This : IDADrawingSurface_Type;
      opac : Pointer_To_IDANumber);

   procedure Crop
     (This        : IDADrawingSurface_Type;
      lowerLeftX  : Interfaces.C.double;
      lowerLeftY  : Interfaces.C.double;
      upperRightX : Interfaces.C.double;
      upperRightY : Interfaces.C.double);

   procedure CropPoints
     (This : IDADrawingSurface_Type;
      Min  : Pointer_To_IDAPoint2;
      Max  : Pointer_To_IDAPoint2);

   procedure Transform
     (This  : IDADrawingSurface_Type;
      xform : Pointer_To_IDATransform2);

   procedure LineColor
     (This : IDADrawingSurface_Type;
      clr  : Pointer_To_IDAColor);

   procedure LineWidth
     (This : IDADrawingSurface_Type;
      w    : Interfaces.C.double);

   procedure LineDashStyle
     (This : IDADrawingSurface_Type;
      id   : DA_DASH_STYLE);

   procedure LineEndStyle
     (This : IDADrawingSurface_Type;
      id   : DA_END_STYLE);

   procedure LineJoinStyle
     (This : IDADrawingSurface_Type;
      id   : DA_JOIN_STYLE);

   procedure BorderColor
     (This : IDADrawingSurface_Type;
      clr  : Pointer_To_IDAColor);

   procedure BorderWidth
     (This : IDADrawingSurface_Type;
      w    : Interfaces.C.double);

   procedure BorderDashStyle
     (This : IDADrawingSurface_Type;
      id   : DA_DASH_STYLE);

   procedure BorderEndStyle
     (This     : IDADrawingSurface_Type;
      obsolete : DA_END_STYLE);

   procedure BorderJoinStyle
     (This : IDADrawingSurface_Type;
      id   : DA_JOIN_STYLE);

   procedure Font
     (This          : IDADrawingSurface_Type;
      FontFace      : GNATCOM.Types.BSTR;
      sizeInPoints  : Interfaces.C.long;
      Bold          : GNATCOM.Types.VARIANT_BOOL;
      Italic        : GNATCOM.Types.VARIANT_BOOL;
      Underline     : GNATCOM.Types.VARIANT_BOOL;
      Strikethrough : GNATCOM.Types.VARIANT_BOOL;
      Free          : Boolean := True);

   procedure TextureFill
     (This      : IDADrawingSurface_Type;
      obsolete1 : Pointer_To_IDAImage;
      obsolete2 : Interfaces.C.double;
      obsolete3 : Interfaces.C.double);

   procedure ImageFill
     (This      : IDADrawingSurface_Type;
      obsolete1 : Pointer_To_IDAImage;
      obsolete2 : Interfaces.C.double;
      obsolete3 : Interfaces.C.double);

   procedure FillTexture
     (This : IDADrawingSurface_Type;
      img  : Pointer_To_IDAImage);

   procedure FillImage
     (This : IDADrawingSurface_Type;
      img  : Pointer_To_IDAImage);

   procedure FillStyle
     (This : IDADrawingSurface_Type;
      id   : Interfaces.C.int);

   procedure FillColor
     (This       : IDADrawingSurface_Type;
      foreground : Pointer_To_IDAColor);

   procedure SecondaryFillColor
     (This : IDADrawingSurface_Type;
      val  : Pointer_To_IDAColor);

   procedure GradientShape
     (This : IDADrawingSurface_Type;
      pts  : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure GradientExtent
     (This    : IDADrawingSurface_Type;
      startx  : Interfaces.C.double;
      starty  : Interfaces.C.double;
      finishx : Interfaces.C.double;
      finishy : Interfaces.C.double);

   procedure GradientExtentPoints
     (This       : IDADrawingSurface_Type;
      startColor : Pointer_To_IDAPoint2;
      stopColor  : Pointer_To_IDAPoint2);

   procedure GradientRolloffPower
     (This  : IDADrawingSurface_Type;
      power : Interfaces.C.double);

   procedure GradientRolloffPowerAnim
     (This  : IDADrawingSurface_Type;
      power : Pointer_To_IDANumber);

   procedure FixedFillScale
     (This : IDADrawingSurface_Type);

   procedure HorizontalFillScale
     (This : IDADrawingSurface_Type);

   procedure VerticalFillScale
     (This : IDADrawingSurface_Type);

   procedure AutoSizeFillScale
     (This : IDADrawingSurface_Type);

   procedure PolylineEx
     (This   : IDADrawingSurface_Type;
      numPts : Interfaces.C.long;
      pts    : Pointer_To_Pointer_To_IDAPoint2);

   procedure Polyline
     (This : IDADrawingSurface_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure PolygonEx
     (This   : IDADrawingSurface_Type;
      numPts : Interfaces.C.long;
      pts    : Pointer_To_Pointer_To_IDAPoint2);

   procedure Polygon
     (This : IDADrawingSurface_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure LinePoints
     (This : IDADrawingSurface_Type;
      p1   : Pointer_To_IDAPoint2;
      p2   : Pointer_To_IDAPoint2);

   procedure Line
     (This   : IDADrawingSurface_Type;
      startx : Interfaces.C.double;
      starty : Interfaces.C.double;
      endX   : Interfaces.C.double;
      endY   : Interfaces.C.double);

   procedure ArcRadians
     (This       : IDADrawingSurface_Type;
      xPos       : Interfaces.C.double;
      yPos       : Interfaces.C.double;
      startAngle : Interfaces.C.double;
      endAngle   : Interfaces.C.double;
      arcWidth   : Interfaces.C.double;
      arcHeight  : Interfaces.C.double);

   procedure ArcDegrees
     (This       : IDADrawingSurface_Type;
      xPos       : Interfaces.C.double;
      yPos       : Interfaces.C.double;
      startAngle : Interfaces.C.double;
      endAngle   : Interfaces.C.double;
      arcWidth   : Interfaces.C.double;
      arcHeight  : Interfaces.C.double);

   procedure Oval
     (This : IDADrawingSurface_Type;
      xPos : Interfaces.C.double;
      yPos : Interfaces.C.double;
      w    : Interfaces.C.double;
      h    : Interfaces.C.double);

   procedure Rect
     (This : IDADrawingSurface_Type;
      xPos : Interfaces.C.double;
      yPos : Interfaces.C.double;
      w    : Interfaces.C.double;
      h    : Interfaces.C.double);

   procedure RoundRect
     (This      : IDADrawingSurface_Type;
      xPos      : Interfaces.C.double;
      yPos      : Interfaces.C.double;
      w         : Interfaces.C.double;
      h         : Interfaces.C.double;
      arcWidth  : Interfaces.C.double;
      arcHeight : Interfaces.C.double);

   procedure PieRadians
     (This       : IDADrawingSurface_Type;
      xPos       : Interfaces.C.double;
      yPos       : Interfaces.C.double;
      startAngle : Interfaces.C.double;
      endAngle   : Interfaces.C.double;
      arcWidth   : Interfaces.C.double;
      arcHeight  : Interfaces.C.double);

   procedure PieDegrees
     (This       : IDADrawingSurface_Type;
      xPos       : Interfaces.C.double;
      yPos       : Interfaces.C.double;
      startAngle : Interfaces.C.double;
      endAngle   : Interfaces.C.double;
      arcWidth   : Interfaces.C.double;
      arcHeight  : Interfaces.C.double);

   procedure Text
     (This : IDADrawingSurface_Type;
      str  : GNATCOM.Types.BSTR;
      xPos : Interfaces.C.double;
      yPos : Interfaces.C.double;
      Free : Boolean := True);

   procedure TextPoint
     (This  : IDADrawingSurface_Type;
      str   : GNATCOM.Types.BSTR;
      point : Pointer_To_IDAPoint2;
      Free  : Boolean := True);

   procedure FillPath
     (This : IDADrawingSurface_Type;
      path : Pointer_To_IDAPath2);

   procedure DrawPath
     (This : IDADrawingSurface_Type;
      path : Pointer_To_IDAPath2);

   procedure OverlayImage
     (This : IDADrawingSurface_Type;
      img  : Pointer_To_IDAImage);

end StructuredGraphicControl.IDADrawingSurface_Interface;

