package body StructuredGraphicControl.IDADrawingSurface_Object is

   function Get_Image
     (This : IDADrawingSurface_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDADrawingSurface_Get_Image);
   end Get_Image;

   procedure Put_LineStyle
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDADrawingSurface_Put_LineStyle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_LineStyle;

   procedure Put_BorderStyle
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDADrawingSurface_Put_BorderStyle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_BorderStyle;

   procedure Put_FontStyle
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDADrawingSurface_Put_FontStyle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_FontStyle;

   procedure Put_ClipMatte
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDADrawingSurface_Put_ClipMatte,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_ClipMatte;

   procedure Put_MouseEventsEnabled
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDADrawingSurface_Put_MouseEventsEnabled,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_MouseEventsEnabled;

   procedure Put_HatchFillTransparent
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDADrawingSurface_Put_HatchFillTransparent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_HatchFillTransparent;

   function Get_LocalContextImage
     (This : IDADrawingSurface_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDADrawingSurface_Get_LocalContextImage);
   end Get_LocalContextImage;

   procedure Reset
     (This : IDADrawingSurface_Type)
   is
   begin
      Invoke (This, IDADrawingSurface_Reset);
   end Reset;

   procedure Clear
     (This : IDADrawingSurface_Type)
   is
   begin
      Invoke (This, IDADrawingSurface_Clear);
   end Clear;

   procedure SaveGraphicsState
     (This : IDADrawingSurface_Type)
   is
   begin
      Invoke (This, IDADrawingSurface_SaveGraphicsState);
   end SaveGraphicsState;

   procedure RestoreGraphicsState
     (This : IDADrawingSurface_Type)
   is
   begin
      Invoke (This, IDADrawingSurface_RestoreGraphicsState);
   end RestoreGraphicsState;

   procedure Opacity
     (This : IDADrawingSurface_Type;
      opac : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_Opacity,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => opac),
         Free);
   end Opacity;

   procedure OpacityAnim
     (This : IDADrawingSurface_Type;
      opac : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_OpacityAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => opac),
         Free);
   end OpacityAnim;

   procedure Crop
     (This        : IDADrawingSurface_Type;
      lowerLeftX  : GNATCOM.Types.VARIANT;
      lowerLeftY  : GNATCOM.Types.VARIANT;
      upperRightX : GNATCOM.Types.VARIANT;
      upperRightY : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_Crop,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => upperRightY,
          2 => upperRightX,
          3 => lowerLeftY,
          4 => lowerLeftX),
         Free);
   end Crop;

   procedure CropPoints
     (This : IDADrawingSurface_Type;
      Min  : GNATCOM.Types.VARIANT;
      Max  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_CropPoints,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Max,
          2 => Min),
         Free);
   end CropPoints;

   procedure Transform
     (This  : IDADrawingSurface_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_Transform,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end Transform;

   procedure LineColor
     (This : IDADrawingSurface_Type;
      clr  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_LineColor,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => clr),
         Free);
   end LineColor;

   procedure LineWidth
     (This : IDADrawingSurface_Type;
      w    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_LineWidth,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => w),
         Free);
   end LineWidth;

   procedure LineDashStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_LineDashStyle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => id),
         Free);
   end LineDashStyle;

   procedure LineEndStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_LineEndStyle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => id),
         Free);
   end LineEndStyle;

   procedure LineJoinStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_LineJoinStyle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => id),
         Free);
   end LineJoinStyle;

   procedure BorderColor
     (This : IDADrawingSurface_Type;
      clr  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_BorderColor,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => clr),
         Free);
   end BorderColor;

   procedure BorderWidth
     (This : IDADrawingSurface_Type;
      w    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_BorderWidth,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => w),
         Free);
   end BorderWidth;

   procedure BorderDashStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_BorderDashStyle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => id),
         Free);
   end BorderDashStyle;

   procedure BorderEndStyle
     (This     : IDADrawingSurface_Type;
      obsolete : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_BorderEndStyle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsolete),
         Free);
   end BorderEndStyle;

   procedure BorderJoinStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_BorderJoinStyle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => id),
         Free);
   end BorderJoinStyle;

   procedure Font
     (This          : IDADrawingSurface_Type;
      FontFace      : GNATCOM.Types.VARIANT;
      sizeInPoints  : GNATCOM.Types.VARIANT;
      Bold          : GNATCOM.Types.VARIANT;
      Italic        : GNATCOM.Types.VARIANT;
      Underline     : GNATCOM.Types.VARIANT;
      Strikethrough : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_Font,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Strikethrough,
          2 => Underline,
          3 => Italic,
          4 => Bold,
          5 => sizeInPoints,
          6 => FontFace),
         Free);
   end Font;

   procedure TextureFill
     (This      : IDADrawingSurface_Type;
      obsolete1 : GNATCOM.Types.VARIANT;
      obsolete2 : GNATCOM.Types.VARIANT;
      obsolete3 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_TextureFill,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsolete3,
          2 => obsolete2,
          3 => obsolete1),
         Free);
   end TextureFill;

   procedure ImageFill
     (This      : IDADrawingSurface_Type;
      obsolete1 : GNATCOM.Types.VARIANT;
      obsolete2 : GNATCOM.Types.VARIANT;
      obsolete3 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_ImageFill,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsolete3,
          2 => obsolete2,
          3 => obsolete1),
         Free);
   end ImageFill;

   procedure FillTexture
     (This : IDADrawingSurface_Type;
      img  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_FillTexture,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => img),
         Free);
   end FillTexture;

   procedure FillImage
     (This : IDADrawingSurface_Type;
      img  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_FillImage,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => img),
         Free);
   end FillImage;

   procedure FillStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_FillStyle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => id),
         Free);
   end FillStyle;

   procedure FillColor
     (This       : IDADrawingSurface_Type;
      foreground : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_FillColor,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => foreground),
         Free);
   end FillColor;

   procedure SecondaryFillColor
     (This : IDADrawingSurface_Type;
      val  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_SecondaryFillColor,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => val),
         Free);
   end SecondaryFillColor;

   procedure GradientShape
     (This : IDADrawingSurface_Type;
      pts  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_GradientShape,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pts),
         Free);
   end GradientShape;

   procedure GradientExtent
     (This    : IDADrawingSurface_Type;
      startx  : GNATCOM.Types.VARIANT;
      starty  : GNATCOM.Types.VARIANT;
      finishx : GNATCOM.Types.VARIANT;
      finishy : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_GradientExtent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => finishy,
          2 => finishx,
          3 => starty,
          4 => startx),
         Free);
   end GradientExtent;

   procedure GradientExtentPoints
     (This       : IDADrawingSurface_Type;
      startColor : GNATCOM.Types.VARIANT;
      stopColor  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_GradientExtentPoints,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => stopColor,
          2 => startColor),
         Free);
   end GradientExtentPoints;

   procedure GradientRolloffPower
     (This  : IDADrawingSurface_Type;
      power : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_GradientRolloffPower,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => power),
         Free);
   end GradientRolloffPower;

   procedure GradientRolloffPowerAnim
     (This  : IDADrawingSurface_Type;
      power : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_GradientRolloffPowerAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => power),
         Free);
   end GradientRolloffPowerAnim;

   procedure FixedFillScale
     (This : IDADrawingSurface_Type)
   is
   begin
      Invoke (This, IDADrawingSurface_FixedFillScale);
   end FixedFillScale;

   procedure HorizontalFillScale
     (This : IDADrawingSurface_Type)
   is
   begin
      Invoke (This, IDADrawingSurface_HorizontalFillScale);
   end HorizontalFillScale;

   procedure VerticalFillScale
     (This : IDADrawingSurface_Type)
   is
   begin
      Invoke (This, IDADrawingSurface_VerticalFillScale);
   end VerticalFillScale;

   procedure AutoSizeFillScale
     (This : IDADrawingSurface_Type)
   is
   begin
      Invoke (This, IDADrawingSurface_AutoSizeFillScale);
   end AutoSizeFillScale;

   procedure PolylineEx
     (This   : IDADrawingSurface_Type;
      numPts : GNATCOM.Types.VARIANT;
      pts    : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_PolylineEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pts,
          2 => numPts),
         Free);
   end PolylineEx;

   procedure Polyline
     (This : IDADrawingSurface_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_Polyline,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v),
         Free);
   end Polyline;

   procedure PolygonEx
     (This   : IDADrawingSurface_Type;
      numPts : GNATCOM.Types.VARIANT;
      pts    : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_PolygonEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pts,
          2 => numPts),
         Free);
   end PolygonEx;

   procedure Polygon
     (This : IDADrawingSurface_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_Polygon,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v),
         Free);
   end Polygon;

   procedure LinePoints
     (This : IDADrawingSurface_Type;
      p1   : GNATCOM.Types.VARIANT;
      p2   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_LinePoints,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => p2,
          2 => p1),
         Free);
   end LinePoints;

   procedure Line
     (This   : IDADrawingSurface_Type;
      startx : GNATCOM.Types.VARIANT;
      starty : GNATCOM.Types.VARIANT;
      endX   : GNATCOM.Types.VARIANT;
      endY   : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_Line,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => endY,
          2 => endX,
          3 => starty,
          4 => startx),
         Free);
   end Line;

   procedure ArcRadians
     (This       : IDADrawingSurface_Type;
      xPos       : GNATCOM.Types.VARIANT;
      yPos       : GNATCOM.Types.VARIANT;
      startAngle : GNATCOM.Types.VARIANT;
      endAngle   : GNATCOM.Types.VARIANT;
      arcWidth   : GNATCOM.Types.VARIANT;
      arcHeight  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_ArcRadians,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight,
          2 => arcWidth,
          3 => endAngle,
          4 => startAngle,
          5 => yPos,
          6 => xPos),
         Free);
   end ArcRadians;

   procedure ArcDegrees
     (This       : IDADrawingSurface_Type;
      xPos       : GNATCOM.Types.VARIANT;
      yPos       : GNATCOM.Types.VARIANT;
      startAngle : GNATCOM.Types.VARIANT;
      endAngle   : GNATCOM.Types.VARIANT;
      arcWidth   : GNATCOM.Types.VARIANT;
      arcHeight  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_ArcDegrees,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight,
          2 => arcWidth,
          3 => endAngle,
          4 => startAngle,
          5 => yPos,
          6 => xPos),
         Free);
   end ArcDegrees;

   procedure Oval
     (This : IDADrawingSurface_Type;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      w    : GNATCOM.Types.VARIANT;
      h    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_Oval,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => h,
          2 => w,
          3 => yPos,
          4 => xPos),
         Free);
   end Oval;

   procedure Rect
     (This : IDADrawingSurface_Type;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      w    : GNATCOM.Types.VARIANT;
      h    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_Rect,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => h,
          2 => w,
          3 => yPos,
          4 => xPos),
         Free);
   end Rect;

   procedure RoundRect
     (This      : IDADrawingSurface_Type;
      xPos      : GNATCOM.Types.VARIANT;
      yPos      : GNATCOM.Types.VARIANT;
      w         : GNATCOM.Types.VARIANT;
      h         : GNATCOM.Types.VARIANT;
      arcWidth  : GNATCOM.Types.VARIANT;
      arcHeight : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_RoundRect,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight,
          2 => arcWidth,
          3 => h,
          4 => w,
          5 => yPos,
          6 => xPos),
         Free);
   end RoundRect;

   procedure PieRadians
     (This       : IDADrawingSurface_Type;
      xPos       : GNATCOM.Types.VARIANT;
      yPos       : GNATCOM.Types.VARIANT;
      startAngle : GNATCOM.Types.VARIANT;
      endAngle   : GNATCOM.Types.VARIANT;
      arcWidth   : GNATCOM.Types.VARIANT;
      arcHeight  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_PieRadians,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight,
          2 => arcWidth,
          3 => endAngle,
          4 => startAngle,
          5 => yPos,
          6 => xPos),
         Free);
   end PieRadians;

   procedure PieDegrees
     (This       : IDADrawingSurface_Type;
      xPos       : GNATCOM.Types.VARIANT;
      yPos       : GNATCOM.Types.VARIANT;
      startAngle : GNATCOM.Types.VARIANT;
      endAngle   : GNATCOM.Types.VARIANT;
      arcWidth   : GNATCOM.Types.VARIANT;
      arcHeight  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_PieDegrees,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight,
          2 => arcWidth,
          3 => endAngle,
          4 => startAngle,
          5 => yPos,
          6 => xPos),
         Free);
   end PieDegrees;

   procedure Text
     (This : IDADrawingSurface_Type;
      str  : GNATCOM.Types.VARIANT;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_Text,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => yPos,
          2 => xPos,
          3 => str),
         Free);
   end Text;

   procedure TextPoint
     (This  : IDADrawingSurface_Type;
      str   : GNATCOM.Types.VARIANT;
      point : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_TextPoint,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => point,
          2 => str),
         Free);
   end TextPoint;

   procedure FillPath
     (This : IDADrawingSurface_Type;
      path : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_FillPath,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => path),
         Free);
   end FillPath;

   procedure DrawPath
     (This : IDADrawingSurface_Type;
      path : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_DrawPath,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => path),
         Free);
   end DrawPath;

   procedure OverlayImage
     (This : IDADrawingSurface_Type;
      img  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDADrawingSurface_OverlayImage,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => img),
         Free);
   end OverlayImage;

end StructuredGraphicControl.IDADrawingSurface_Object;

