with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDADrawingSurface_Object is

   type IDADrawingSurface_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   function Get_Image
     (This : IDADrawingSurface_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_LineStyle
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Put_BorderStyle
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Put_FontStyle
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Put_ClipMatte
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Put_MouseEventsEnabled
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Put_HatchFillTransparent
     (This : IDADrawingSurface_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_LocalContextImage
     (This : IDADrawingSurface_Type)
     return GNATCOM.Types.VARIANT;

   procedure Reset
     (This : IDADrawingSurface_Type);

   procedure Clear
     (This : IDADrawingSurface_Type);

   procedure SaveGraphicsState
     (This : IDADrawingSurface_Type);

   procedure RestoreGraphicsState
     (This : IDADrawingSurface_Type);

   procedure Opacity
     (This : IDADrawingSurface_Type;
      opac : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure OpacityAnim
     (This : IDADrawingSurface_Type;
      opac : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Crop
     (This        : IDADrawingSurface_Type;
      lowerLeftX  : GNATCOM.Types.VARIANT;
      lowerLeftY  : GNATCOM.Types.VARIANT;
      upperRightX : GNATCOM.Types.VARIANT;
      upperRightY : GNATCOM.Types.VARIANT;
      Free        : Boolean := True);

   procedure CropPoints
     (This : IDADrawingSurface_Type;
      Min  : GNATCOM.Types.VARIANT;
      Max  : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Transform
     (This  : IDADrawingSurface_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True);

   procedure LineColor
     (This : IDADrawingSurface_Type;
      clr  : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure LineWidth
     (This : IDADrawingSurface_Type;
      w    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure LineDashStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure LineEndStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure LineJoinStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure BorderColor
     (This : IDADrawingSurface_Type;
      clr  : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure BorderWidth
     (This : IDADrawingSurface_Type;
      w    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure BorderDashStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure BorderEndStyle
     (This     : IDADrawingSurface_Type;
      obsolete : GNATCOM.Types.VARIANT;
      Free     : Boolean := True);

   procedure BorderJoinStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Font
     (This          : IDADrawingSurface_Type;
      FontFace      : GNATCOM.Types.VARIANT;
      sizeInPoints  : GNATCOM.Types.VARIANT;
      Bold          : GNATCOM.Types.VARIANT;
      Italic        : GNATCOM.Types.VARIANT;
      Underline     : GNATCOM.Types.VARIANT;
      Strikethrough : GNATCOM.Types.VARIANT;
      Free          : Boolean := True);

   procedure TextureFill
     (This      : IDADrawingSurface_Type;
      obsolete1 : GNATCOM.Types.VARIANT;
      obsolete2 : GNATCOM.Types.VARIANT;
      obsolete3 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True);

   procedure ImageFill
     (This      : IDADrawingSurface_Type;
      obsolete1 : GNATCOM.Types.VARIANT;
      obsolete2 : GNATCOM.Types.VARIANT;
      obsolete3 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True);

   procedure FillTexture
     (This : IDADrawingSurface_Type;
      img  : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure FillImage
     (This : IDADrawingSurface_Type;
      img  : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure FillStyle
     (This : IDADrawingSurface_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure FillColor
     (This       : IDADrawingSurface_Type;
      foreground : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);

   procedure SecondaryFillColor
     (This : IDADrawingSurface_Type;
      val  : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure GradientShape
     (This : IDADrawingSurface_Type;
      pts  : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure GradientExtent
     (This    : IDADrawingSurface_Type;
      startx  : GNATCOM.Types.VARIANT;
      starty  : GNATCOM.Types.VARIANT;
      finishx : GNATCOM.Types.VARIANT;
      finishy : GNATCOM.Types.VARIANT;
      Free    : Boolean := True);

   procedure GradientExtentPoints
     (This       : IDADrawingSurface_Type;
      startColor : GNATCOM.Types.VARIANT;
      stopColor  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);

   procedure GradientRolloffPower
     (This  : IDADrawingSurface_Type;
      power : GNATCOM.Types.VARIANT;
      Free  : Boolean := True);

   procedure GradientRolloffPowerAnim
     (This  : IDADrawingSurface_Type;
      power : GNATCOM.Types.VARIANT;
      Free  : Boolean := True);

   procedure FixedFillScale
     (This : IDADrawingSurface_Type);

   procedure HorizontalFillScale
     (This : IDADrawingSurface_Type);

   procedure VerticalFillScale
     (This : IDADrawingSurface_Type);

   procedure AutoSizeFillScale
     (This : IDADrawingSurface_Type);

   procedure PolylineEx
     (This   : IDADrawingSurface_Type;
      numPts : GNATCOM.Types.VARIANT;
      pts    : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);

   procedure Polyline
     (This : IDADrawingSurface_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure PolygonEx
     (This   : IDADrawingSurface_Type;
      numPts : GNATCOM.Types.VARIANT;
      pts    : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);

   procedure Polygon
     (This : IDADrawingSurface_Type;
      v    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure LinePoints
     (This : IDADrawingSurface_Type;
      p1   : GNATCOM.Types.VARIANT;
      p2   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Line
     (This   : IDADrawingSurface_Type;
      startx : GNATCOM.Types.VARIANT;
      starty : GNATCOM.Types.VARIANT;
      endX   : GNATCOM.Types.VARIANT;
      endY   : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);

   procedure ArcRadians
     (This       : IDADrawingSurface_Type;
      xPos       : GNATCOM.Types.VARIANT;
      yPos       : GNATCOM.Types.VARIANT;
      startAngle : GNATCOM.Types.VARIANT;
      endAngle   : GNATCOM.Types.VARIANT;
      arcWidth   : GNATCOM.Types.VARIANT;
      arcHeight  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);

   procedure ArcDegrees
     (This       : IDADrawingSurface_Type;
      xPos       : GNATCOM.Types.VARIANT;
      yPos       : GNATCOM.Types.VARIANT;
      startAngle : GNATCOM.Types.VARIANT;
      endAngle   : GNATCOM.Types.VARIANT;
      arcWidth   : GNATCOM.Types.VARIANT;
      arcHeight  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);

   procedure Oval
     (This : IDADrawingSurface_Type;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      w    : GNATCOM.Types.VARIANT;
      h    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Rect
     (This : IDADrawingSurface_Type;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      w    : GNATCOM.Types.VARIANT;
      h    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure RoundRect
     (This      : IDADrawingSurface_Type;
      xPos      : GNATCOM.Types.VARIANT;
      yPos      : GNATCOM.Types.VARIANT;
      w         : GNATCOM.Types.VARIANT;
      h         : GNATCOM.Types.VARIANT;
      arcWidth  : GNATCOM.Types.VARIANT;
      arcHeight : GNATCOM.Types.VARIANT;
      Free      : Boolean := True);

   procedure PieRadians
     (This       : IDADrawingSurface_Type;
      xPos       : GNATCOM.Types.VARIANT;
      yPos       : GNATCOM.Types.VARIANT;
      startAngle : GNATCOM.Types.VARIANT;
      endAngle   : GNATCOM.Types.VARIANT;
      arcWidth   : GNATCOM.Types.VARIANT;
      arcHeight  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);

   procedure PieDegrees
     (This       : IDADrawingSurface_Type;
      xPos       : GNATCOM.Types.VARIANT;
      yPos       : GNATCOM.Types.VARIANT;
      startAngle : GNATCOM.Types.VARIANT;
      endAngle   : GNATCOM.Types.VARIANT;
      arcWidth   : GNATCOM.Types.VARIANT;
      arcHeight  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);

   procedure Text
     (This : IDADrawingSurface_Type;
      str  : GNATCOM.Types.VARIANT;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure TextPoint
     (This  : IDADrawingSurface_Type;
      str   : GNATCOM.Types.VARIANT;
      point : GNATCOM.Types.VARIANT;
      Free  : Boolean := True);

   procedure FillPath
     (This : IDADrawingSurface_Type;
      path : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure DrawPath
     (This : IDADrawingSurface_Type;
      path : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure OverlayImage
     (This : IDADrawingSurface_Type;
      img  : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

end StructuredGraphicControl.IDADrawingSurface_Object;

