with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAEvent_Interface is

   type IDAEvent_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAEvent_Type);

   function Pointer (This : IDAEvent_Type)
     return Pointer_To_IDAEvent;

   procedure Attach (This    : in out IDAEvent_Type;
                     Pointer : in     Pointer_To_IDAEvent);

   function GetClassName
     (This       : IDAEvent_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAEvent_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAEvent_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAEvent_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAEvent_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAEvent_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAEvent_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAEvent_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAEvent_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAEvent_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAEvent_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAEvent_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAEvent_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAEvent_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Notify
     (This       : IDAEvent_Type;
      notifier_0 : Pointer_To_IDAUntilNotifier)
     return Pointer_To_IDAEvent;

   function Snapshot
     (This  : IDAEvent_Type;
      b_0   : Pointer_To_IDABehavior)
     return Pointer_To_IDAEvent;

   function AttachData
     (This   : IDAEvent_Type;
      data_0 : Pointer_To_IDABehavior)
     return Pointer_To_IDAEvent;

   function ScriptCallback
     (This        : IDAEvent_Type;
      scriptlet_0 : GNATCOM.Types.BSTR;
      language_1  : GNATCOM.Types.BSTR;
      Free        : Boolean := True)
     return Pointer_To_IDAEvent;

end StructuredGraphicControl.IDAEvent_Interface;

