with GNATCOM.Interface;

with GNATCOM.Errors;

package body StructuredGraphicControl.IDAFontStyle_Interface is

   procedure Initialize (This : in out IDAFontStyle_Type) is
   begin
      Set_IID (This, IID_IDAFontStyle);
   end Initialize;

   function Pointer (This : IDAFontStyle_Type)
     return Pointer_To_IDAFontStyle
   is
   begin
      return To_Pointer_To_IDAFontStyle (Address (This));
   end Pointer;

   procedure Attach (This    : in out IDAFontStyle_Type;
                     Pointer : in     Pointer_To_IDAFontStyle)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function GetClassName
     (This       : IDAFontStyle_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetClassName
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end GetClassName;

   procedure Init
     (This  : IDAFontStyle_Type;
      toBvr : Pointer_To_IDABehavior)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Init
         (Pointer (This),
          toBvr));

   end Init;

    function Importance
     (This               : IDAFontStyle_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior
   is
       RetVal : aliased Pointer_To_IDABehavior;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Importance
         (Pointer (This),
          relativeImportance,
          RetVal'Unchecked_Access));

      return RetVal;
   end Importance;

    function RunOnce
     (This : IDAFontStyle_Type)
     return Pointer_To_IDABehavior
   is
       RetVal : aliased Pointer_To_IDABehavior;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.RunOnce
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end RunOnce;

    function SubstituteTime
     (This  : IDAFontStyle_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior
   is
       RetVal : aliased Pointer_To_IDABehavior;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SubstituteTime
         (Pointer (This),
          xform,
          RetVal'Unchecked_Access));

      return RetVal;
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDAFontStyle_Type;
      SwitchTo : Pointer_To_IDABehavior)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SwitchTo
         (Pointer (This),
          SwitchTo));

   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDAFontStyle_Type;
      numToSwitchTo : Interfaces.C.double)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SwitchToNumber
         (Pointer (This),
          numToSwitchTo));

   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDAFontStyle_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SwitchToString
         (Pointer (This),
          strToSwitchTo));

      if Free then
               GNATCOM.Interface.Free (strToSwitchTo);
      
      end if;

   end SwitchToString;

    function Hook
     (This     : IDAFontStyle_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior
   is
       RetVal : aliased Pointer_To_IDABehavior;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Hook
         (Pointer (This),
          notifier,
          RetVal'Unchecked_Access));

      return RetVal;
   end Hook;

    function Duration
     (This     : IDAFontStyle_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior
   is
       RetVal : aliased Pointer_To_IDABehavior;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Duration
         (Pointer (This),
          Duration,
          RetVal'Unchecked_Access));

      return RetVal;
   end Duration;

    function DurationAnim
     (This     : IDAFontStyle_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior
   is
       RetVal : aliased Pointer_To_IDABehavior;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.DurationAnim
         (Pointer (This),
          Duration,
          RetVal'Unchecked_Access));

      return RetVal;
   end DurationAnim;

    function Repeat
     (This  : IDAFontStyle_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior
   is
       RetVal : aliased Pointer_To_IDABehavior;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Repeat
         (Pointer (This),
          count,
          RetVal'Unchecked_Access));

      return RetVal;
   end Repeat;

    function RepeatForever
     (This : IDAFontStyle_Type)
     return Pointer_To_IDABehavior
   is
       RetVal : aliased Pointer_To_IDABehavior;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.RepeatForever
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end RepeatForever;

    function IsReady
     (This   : IDAFontStyle_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL
   is
       RetVal : aliased GNATCOM.Types.VARIANT_BOOL;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.IsReady
         (Pointer (This),
          bBlock,
          RetVal'Unchecked_Access));

      return RetVal;
   end IsReady;

    function Bold
     (This  : IDAFontStyle_Type)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Bold
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Bold;

    function Italic
     (This  : IDAFontStyle_Type)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Italic
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Italic;

    function Underline
     (This  : IDAFontStyle_Type)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Underline
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Underline;

    function Strikethrough
     (This  : IDAFontStyle_Type)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Strikethrough
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Strikethrough;

    function AntiAliasing
     (This      : IDAFontStyle_Type;
      aaStyle_0 : Interfaces.C.double)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.AntiAliasing
         (Pointer (This),
          aaStyle_0,
          RetVal'Unchecked_Access));

      return RetVal;
   end AntiAliasing;

    function Color
     (This  : IDAFontStyle_Type;
      col_0 : Pointer_To_IDAColor)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Color
         (Pointer (This),
          col_0,
          RetVal'Unchecked_Access));

      return RetVal;
   end Color;

    function FamilyAnim
     (This   : IDAFontStyle_Type;
      face_0 : Pointer_To_IDAString)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.FamilyAnim
         (Pointer (This),
          face_0,
          RetVal'Unchecked_Access));

      return RetVal;
   end FamilyAnim;

    function Family
     (This   : IDAFontStyle_Type;
      face_0 : GNATCOM.Types.BSTR;
      Free   : Boolean := True)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Family
         (Pointer (This),
          face_0,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (face_0);
      
      end if;

      return RetVal;
   end Family;

    function SizeAnim
     (This   : IDAFontStyle_Type;
      size_0 : Pointer_To_IDANumber)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SizeAnim
         (Pointer (This),
          size_0,
          RetVal'Unchecked_Access));

      return RetVal;
   end SizeAnim;

    function Size
     (This   : IDAFontStyle_Type;
      size_0 : Interfaces.C.double)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Size
         (Pointer (This),
          size_0,
          RetVal'Unchecked_Access));

      return RetVal;
   end Size;

    function Weight
     (This     : IDAFontStyle_Type;
      weight_0 : Interfaces.C.double)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Weight
         (Pointer (This),
          weight_0,
          RetVal'Unchecked_Access));

      return RetVal;
   end Weight;

    function WeightAnim
     (This     : IDAFontStyle_Type;
      weight_0 : Pointer_To_IDANumber)
     return Pointer_To_IDAFontStyle
   is
       RetVal : aliased Pointer_To_IDAFontStyle;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.WeightAnim
         (Pointer (This),
          weight_0,
          RetVal'Unchecked_Access));

      return RetVal;
   end WeightAnim;

end StructuredGraphicControl.IDAFontStyle_Interface;

