with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAGeometry_Interface is

   type IDAGeometry_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAGeometry_Type);

   function Pointer (This : IDAGeometry_Type)
     return Pointer_To_IDAGeometry;

   procedure Attach (This    : in out IDAGeometry_Type;
                     Pointer : in     Pointer_To_IDAGeometry);

   function GetClassName
     (This       : IDAGeometry_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAGeometry_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAGeometry_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAGeometry_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAGeometry_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAGeometry_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAGeometry_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAGeometry_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAGeometry_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAGeometry_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAGeometry_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAGeometry_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAGeometry_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAGeometry_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function RenderSound
     (This  : IDAGeometry_Type;
      mic_0 : Pointer_To_IDAMicrophone)
     return Pointer_To_IDASound;

   function Pickable
     (This  : IDAGeometry_Type)
     return Pointer_To_IDAPickableResult;

   function PickableOccluded
     (This  : IDAGeometry_Type)
     return Pointer_To_IDAPickableResult;

   function Undetectable
     (This  : IDAGeometry_Type)
     return Pointer_To_IDAGeometry;

   function EmissiveColor
     (This  : IDAGeometry_Type;
      col_0 : Pointer_To_IDAColor)
     return Pointer_To_IDAGeometry;

   function DiffuseColor
     (This  : IDAGeometry_Type;
      col_0 : Pointer_To_IDAColor)
     return Pointer_To_IDAGeometry;

   function SpecularColor
     (This  : IDAGeometry_Type;
      col_0 : Pointer_To_IDAColor)
     return Pointer_To_IDAGeometry;

   function SpecularExponent
     (This    : IDAGeometry_Type;
      power_0 : Interfaces.C.double)
     return Pointer_To_IDAGeometry;

   function SpecularExponentAnim
     (This    : IDAGeometry_Type;
      power_0 : Pointer_To_IDANumber)
     return Pointer_To_IDAGeometry;

   function Texture
     (This      : IDAGeometry_Type;
      texture_0 : Pointer_To_IDAImage)
     return Pointer_To_IDAGeometry;

   function Opacity
     (This    : IDAGeometry_Type;
      level_0 : Interfaces.C.double)
     return Pointer_To_IDAGeometry;

   function OpacityAnim
     (This    : IDAGeometry_Type;
      level_0 : Pointer_To_IDANumber)
     return Pointer_To_IDAGeometry;

   function Transform
     (This  : IDAGeometry_Type;
      xf_0  : Pointer_To_IDATransform3)
     return Pointer_To_IDAGeometry;

   function Get_BoundingBox
     (This  : IDAGeometry_Type)
     return Pointer_To_IDABbox3;

   function Render
     (This  : IDAGeometry_Type;
      cam_0 : Pointer_To_IDACamera)
     return Pointer_To_IDAImage;

   function LightColor
     (This    : IDAGeometry_Type;
      color_0 : Pointer_To_IDAColor)
     return Pointer_To_IDAGeometry;

   function LightAttenuationAnim
     (This        : IDAGeometry_Type;
      constant_0  : Pointer_To_IDANumber;
      linear_1    : Pointer_To_IDANumber;
      quadratic_2 : Pointer_To_IDANumber)
     return Pointer_To_IDAGeometry;

   function LightAttenuation
     (This        : IDAGeometry_Type;
      constant_0  : Interfaces.C.double;
      linear_1    : Interfaces.C.double;
      quadratic_2 : Interfaces.C.double)
     return Pointer_To_IDAGeometry;

end StructuredGraphicControl.IDAGeometry_Interface;

