package body StructuredGraphicControl.IDAGeometry_Object is

   function GetClassName
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAGeometry_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDAGeometry_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAGeometry_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDAGeometry_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAGeometry_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDAGeometry_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDAGeometry_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAGeometry_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDAGeometry_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAGeometry_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDAGeometry_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAGeometry_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDAGeometry_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDAGeometry_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDAGeometry_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDAGeometry_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAGeometry_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDAGeometry_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function RenderSound
     (This  : IDAGeometry_Type;
      mic_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_RenderSound,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => mic_0),
         Free);
   end RenderSound;

   function Pickable
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAGeometry_Pickable);
   end Pickable;

   function PickableOccluded
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAGeometry_PickableOccluded);
   end PickableOccluded;

   function Undetectable
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAGeometry_Undetectable);
   end Undetectable;

   function EmissiveColor
     (This  : IDAGeometry_Type;
      col_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_EmissiveColor,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => col_0),
         Free);
   end EmissiveColor;

   function DiffuseColor
     (This  : IDAGeometry_Type;
      col_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_DiffuseColor,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => col_0),
         Free);
   end DiffuseColor;

   function SpecularColor
     (This  : IDAGeometry_Type;
      col_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_SpecularColor,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => col_0),
         Free);
   end SpecularColor;

   function SpecularExponent
     (This    : IDAGeometry_Type;
      power_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_SpecularExponent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => power_0),
         Free);
   end SpecularExponent;

   function SpecularExponentAnim
     (This    : IDAGeometry_Type;
      power_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_SpecularExponentAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => power_0),
         Free);
   end SpecularExponentAnim;

   function Texture
     (This      : IDAGeometry_Type;
      texture_0 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_Texture,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => texture_0),
         Free);
   end Texture;

   function Opacity
     (This    : IDAGeometry_Type;
      level_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_Opacity,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => level_0),
         Free);
   end Opacity;

   function OpacityAnim
     (This    : IDAGeometry_Type;
      level_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_OpacityAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => level_0),
         Free);
   end OpacityAnim;

   function Transform
     (This : IDAGeometry_Type;
      xf_0 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_Transform,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xf_0),
         Free);
   end Transform;

   function Get_BoundingBox
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAGeometry_Get_BoundingBox);
   end Get_BoundingBox;

   function Render
     (This  : IDAGeometry_Type;
      cam_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_Render,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => cam_0),
         Free);
   end Render;

   function LightColor
     (This    : IDAGeometry_Type;
      color_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_LightColor,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => color_0),
         Free);
   end LightColor;

   function LightAttenuationAnim
     (This        : IDAGeometry_Type;
      constant_0  : GNATCOM.Types.VARIANT;
      linear_1    : GNATCOM.Types.VARIANT;
      quadratic_2 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_LightAttenuationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => quadratic_2,
          2 => linear_1,
          3 => constant_0),
         Free);
   end LightAttenuationAnim;

   function LightAttenuation
     (This        : IDAGeometry_Type;
      constant_0  : GNATCOM.Types.VARIANT;
      linear_1    : GNATCOM.Types.VARIANT;
      quadratic_2 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAGeometry_LightAttenuation,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => quadratic_2,
          2 => linear_1,
          3 => constant_0),
         Free);
   end LightAttenuation;

end StructuredGraphicControl.IDAGeometry_Object;

