with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAGeometry_Object is

   type IDAGeometry_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   function GetClassName
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT;

   procedure Init
     (This  : IDAGeometry_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True);

   function Importance
     (This               : IDAGeometry_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RunOnce
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT;

   function SubstituteTime
     (This  : IDAGeometry_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure SwitchTo
     (This     : IDAGeometry_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True);

   procedure SwitchToNumber
     (This          : IDAGeometry_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True);

   procedure SwitchToString
     (This          : IDAGeometry_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True);

   function Hook
     (This     : IDAGeometry_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Duration
     (This     : IDAGeometry_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DurationAnim
     (This     : IDAGeometry_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Repeat
     (This  : IDAGeometry_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RepeatForever
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT;

   function IsReady
     (This   : IDAGeometry_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RenderSound
     (This  : IDAGeometry_Type;
      mic_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Pickable
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT;

   function PickableOccluded
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT;

   function Undetectable
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT;

   function EmissiveColor
     (This  : IDAGeometry_Type;
      col_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DiffuseColor
     (This  : IDAGeometry_Type;
      col_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SpecularColor
     (This  : IDAGeometry_Type;
      col_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SpecularExponent
     (This    : IDAGeometry_Type;
      power_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SpecularExponentAnim
     (This    : IDAGeometry_Type;
      power_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Texture
     (This      : IDAGeometry_Type;
      texture_0 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Opacity
     (This    : IDAGeometry_Type;
      level_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function OpacityAnim
     (This    : IDAGeometry_Type;
      level_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Transform
     (This : IDAGeometry_Type;
      xf_0 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_BoundingBox
     (This : IDAGeometry_Type)
     return GNATCOM.Types.VARIANT;

   function Render
     (This  : IDAGeometry_Type;
      cam_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function LightColor
     (This    : IDAGeometry_Type;
      color_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function LightAttenuationAnim
     (This        : IDAGeometry_Type;
      constant_0  : GNATCOM.Types.VARIANT;
      linear_1    : GNATCOM.Types.VARIANT;
      quadratic_2 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function LightAttenuation
     (This        : IDAGeometry_Type;
      constant_0  : GNATCOM.Types.VARIANT;
      linear_1    : GNATCOM.Types.VARIANT;
      quadratic_2 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

end StructuredGraphicControl.IDAGeometry_Object;

