with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAImage_Interface is

   type IDAImage_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAImage_Type);

   function Pointer (This : IDAImage_Type)
     return Pointer_To_IDAImage;

   procedure Attach (This    : in out IDAImage_Type;
                     Pointer : in     Pointer_To_IDAImage);

   function GetClassName
     (This       : IDAImage_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAImage_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAImage_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAImage_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAImage_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAImage_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAImage_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAImage_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAImage_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAImage_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAImage_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAImage_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAImage_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAImage_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Pickable
     (This  : IDAImage_Type)
     return Pointer_To_IDAPickableResult;

   function PickableOccluded
     (This  : IDAImage_Type)
     return Pointer_To_IDAPickableResult;

   function ApplyBitmapEffect
     (This               : IDAImage_Type;
      effectToApply_0    : GNATCOM.Types.Pointer_To_IUnknown;
      firesWhenChanged_1 : Pointer_To_IDAEvent)
     return Pointer_To_IDAImage;

   function Get_BoundingBox
     (This  : IDAImage_Type)
     return Pointer_To_IDABbox2;

   function Crop
     (This  : IDAImage_Type;
      min_0 : Pointer_To_IDAPoint2;
      max_1 : Pointer_To_IDAPoint2)
     return Pointer_To_IDAImage;

   function Transform
     (This  : IDAImage_Type;
      xf_0  : Pointer_To_IDATransform2)
     return Pointer_To_IDAImage;

   function OpacityAnim
     (This      : IDAImage_Type;
      opacity_0 : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function Opacity
     (This      : IDAImage_Type;
      opacity_0 : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function Undetectable
     (This  : IDAImage_Type)
     return Pointer_To_IDAImage;

   function Tile
     (This  : IDAImage_Type)
     return Pointer_To_IDAImage;

   function Clip
     (This  : IDAImage_Type;
      m_0   : Pointer_To_IDAMatte)
     return Pointer_To_IDAImage;

   function MapToUnitSquare
     (This  : IDAImage_Type)
     return Pointer_To_IDAImage;

   function ClipPolygonImageEx
     (This         : IDAImage_Type;
      points_0size : Interfaces.C.long;
      points_0     : Pointer_To_Pointer_To_IDAPoint2)
     return Pointer_To_IDAImage;

   function ClipPolygonImage
     (This     : IDAImage_Type;
      points_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return Pointer_To_IDAImage;

end StructuredGraphicControl.IDAImage_Interface;

