package body StructuredGraphicControl.IDAImage_Object is

   function GetClassName
     (This : IDAImage_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAImage_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDAImage_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAImage_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDAImage_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDAImage_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAImage_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDAImage_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDAImage_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAImage_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDAImage_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAImage_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDAImage_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAImage_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDAImage_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDAImage_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDAImage_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDAImage_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDAImage_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAImage_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDAImage_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function Pickable
     (This : IDAImage_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAImage_Pickable);
   end Pickable;

   function PickableOccluded
     (This : IDAImage_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAImage_PickableOccluded);
   end PickableOccluded;

   function ApplyBitmapEffect
     (This               : IDAImage_Type;
      effectToApply_0    : GNATCOM.Types.VARIANT;
      firesWhenChanged_1 : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_ApplyBitmapEffect,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => firesWhenChanged_1,
          2 => effectToApply_0),
         Free);
   end ApplyBitmapEffect;

   function Get_BoundingBox
     (This : IDAImage_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAImage_Get_BoundingBox);
   end Get_BoundingBox;

   function Crop
     (This  : IDAImage_Type;
      min_0 : GNATCOM.Types.VARIANT;
      max_1 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_Crop,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => max_1,
          2 => min_0),
         Free);
   end Crop;

   function Transform
     (This : IDAImage_Type;
      xf_0 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_Transform,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xf_0),
         Free);
   end Transform;

   function OpacityAnim
     (This      : IDAImage_Type;
      opacity_0 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_OpacityAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => opacity_0),
         Free);
   end OpacityAnim;

   function Opacity
     (This      : IDAImage_Type;
      opacity_0 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_Opacity,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => opacity_0),
         Free);
   end Opacity;

   function Undetectable
     (This : IDAImage_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAImage_Undetectable);
   end Undetectable;

   function Tile
     (This : IDAImage_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAImage_Tile);
   end Tile;

   function Clip
     (This : IDAImage_Type;
      m_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_Clip,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => m_0),
         Free);
   end Clip;

   function MapToUnitSquare
     (This : IDAImage_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAImage_MapToUnitSquare);
   end MapToUnitSquare;

   function ClipPolygonImageEx
     (This         : IDAImage_Type;
      points_0size : GNATCOM.Types.VARIANT;
      points_0     : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_ClipPolygonImageEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => points_0,
          2 => points_0size),
         Free);
   end ClipPolygonImageEx;

   function ClipPolygonImage
     (This     : IDAImage_Type;
      points_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAImage_ClipPolygonImage,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => points_0),
         Free);
   end ClipPolygonImage;

end StructuredGraphicControl.IDAImage_Object;

