with GNATCOM.Interface;

with GNATCOM.Errors;

package body StructuredGraphicControl.IDAImportationResult_Interface is

   procedure Initialize (This : in out IDAImportationResult_Type) is
   begin
      Set_IID (This, IID_IDAImportationResult);
   end Initialize;

   function Pointer (This : IDAImportationResult_Type)
     return Pointer_To_IDAImportationResult
   is
   begin
      return To_Pointer_To_IDAImportationResult (Address (This));
   end Pointer;

   procedure Attach (This    : in out IDAImportationResult_Type;
                     Pointer : in     Pointer_To_IDAImportationResult)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_Image
     (This    : IDAImportationResult_Type)
     return Pointer_To_IDAImage
   is
       RetVal : aliased Pointer_To_IDAImage;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Image
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Image;

    function Get_Sound
     (This    : IDAImportationResult_Type)
     return Pointer_To_IDASound
   is
       RetVal : aliased Pointer_To_IDASound;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Sound
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Sound;

    function Get_Geometry
     (This       : IDAImportationResult_Type)
     return Pointer_To_IDAGeometry
   is
       RetVal : aliased Pointer_To_IDAGeometry;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Geometry
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Geometry;

    function Get_Duration
     (This       : IDAImportationResult_Type)
     return Pointer_To_IDANumber
   is
       RetVal : aliased Pointer_To_IDANumber;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Duration
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Duration;

    function Get_CompletionEvent
     (This              : IDAImportationResult_Type)
     return Pointer_To_IDAEvent
   is
       RetVal : aliased Pointer_To_IDAEvent;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_CompletionEvent
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_CompletionEvent;

    function Get_Progress
     (This       : IDAImportationResult_Type)
     return Pointer_To_IDANumber
   is
       RetVal : aliased Pointer_To_IDANumber;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Progress
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Progress;

    function Get_Size
     (This          : IDAImportationResult_Type)
     return Pointer_To_IDANumber
   is
       RetVal : aliased Pointer_To_IDANumber;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Size
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Size;

end StructuredGraphicControl.IDAImportationResult_Interface;

