with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAImportationResult_Interface is

   type IDAImportationResult_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAImportationResult_Type);

   function Pointer (This : IDAImportationResult_Type)
     return Pointer_To_IDAImportationResult;

   procedure Attach (This    : in out IDAImportationResult_Type;
                     Pointer : in     Pointer_To_IDAImportationResult);

   function Get_Image
     (This    : IDAImportationResult_Type)
     return Pointer_To_IDAImage;
   --  Image from import

   function Get_Sound
     (This    : IDAImportationResult_Type)
     return Pointer_To_IDASound;
   --  Sound from import

   function Get_Geometry
     (This       : IDAImportationResult_Type)
     return Pointer_To_IDAGeometry;
   --  Geometry from import

   function Get_Duration
     (This       : IDAImportationResult_Type)
     return Pointer_To_IDANumber;
   --  Media duration in seconds

   function Get_CompletionEvent
     (This              : IDAImportationResult_Type)
     return Pointer_To_IDAEvent;
   --  Event that fires on download completion

   function Get_Progress
     (This       : IDAImportationResult_Type)
     return Pointer_To_IDANumber;
   --  Percentage progress (from 0 to 1).

   function Get_Size
     (This          : IDAImportationResult_Type)
     return Pointer_To_IDANumber;
   --  Media size in bytes

end StructuredGraphicControl.IDAImportationResult_Interface;

