with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDALineStyle_Interface is

   type IDALineStyle_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDALineStyle_Type);

   function Pointer (This : IDALineStyle_Type)
     return Pointer_To_IDALineStyle;

   procedure Attach (This    : in out IDALineStyle_Type;
                     Pointer : in     Pointer_To_IDALineStyle);

   function GetClassName
     (This       : IDALineStyle_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDALineStyle_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDALineStyle_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDALineStyle_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDALineStyle_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDALineStyle_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDALineStyle_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDALineStyle_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDALineStyle_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDALineStyle_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDALineStyle_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDALineStyle_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDALineStyle_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDALineStyle_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function uEnd
     (This       : IDALineStyle_Type;
      obsolete_0 : Pointer_To_IDAEndStyle)
     return Pointer_To_IDALineStyle;

   function Join
     (This       : IDALineStyle_Type;
      obsolete_0 : Pointer_To_IDAJoinStyle)
     return Pointer_To_IDALineStyle;

   function Dash
     (This       : IDALineStyle_Type;
      obsolete_0 : Pointer_To_IDADashStyle)
     return Pointer_To_IDALineStyle;

   function WidthAnim
     (This  : IDALineStyle_Type;
      sty_0 : Pointer_To_IDANumber)
     return Pointer_To_IDALineStyle;

   function width
     (This  : IDALineStyle_Type;
      sty_0 : Interfaces.C.double)
     return Pointer_To_IDALineStyle;

   function AntiAliasing
     (This      : IDALineStyle_Type;
      aaStyle_0 : Interfaces.C.double)
     return Pointer_To_IDALineStyle;

   function Detail
     (This  : IDALineStyle_Type)
     return Pointer_To_IDALineStyle;

   function Color
     (This  : IDALineStyle_Type;
      clr_0 : Pointer_To_IDAColor)
     return Pointer_To_IDALineStyle;

end StructuredGraphicControl.IDALineStyle_Interface;

