with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAMatte_Interface is

   type IDAMatte_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAMatte_Type);

   function Pointer (This : IDAMatte_Type)
     return Pointer_To_IDAMatte;

   procedure Attach (This    : in out IDAMatte_Type;
                     Pointer : in     Pointer_To_IDAMatte);

   function GetClassName
     (This       : IDAMatte_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAMatte_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAMatte_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAMatte_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAMatte_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAMatte_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAMatte_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAMatte_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAMatte_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAMatte_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAMatte_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAMatte_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAMatte_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAMatte_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Transform
     (This  : IDAMatte_Type;
      xf_0  : Pointer_To_IDATransform2)
     return Pointer_To_IDAMatte;

end StructuredGraphicControl.IDAMatte_Interface;

