package body StructuredGraphicControl.IDAMatte_Object is

   function GetClassName
     (This : IDAMatte_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAMatte_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDAMatte_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAMatte_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDAMatte_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAMatte_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDAMatte_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAMatte_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDAMatte_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAMatte_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDAMatte_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAMatte_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDAMatte_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAMatte_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDAMatte_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAMatte_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDAMatte_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAMatte_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDAMatte_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAMatte_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDAMatte_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAMatte_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDAMatte_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAMatte_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDAMatte_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAMatte_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDAMatte_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAMatte_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function Transform
     (This : IDAMatte_Type;
      xf_0 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAMatte_Transform,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xf_0),
         Free);
   end Transform;

end StructuredGraphicControl.IDAMatte_Object;

