with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAMontage_Interface is

   type IDAMontage_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAMontage_Type);

   function Pointer (This : IDAMontage_Type)
     return Pointer_To_IDAMontage;

   procedure Attach (This    : in out IDAMontage_Type;
                     Pointer : in     Pointer_To_IDAMontage);

   function GetClassName
     (This       : IDAMontage_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAMontage_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAMontage_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAMontage_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAMontage_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAMontage_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAMontage_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAMontage_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAMontage_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAMontage_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAMontage_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAMontage_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAMontage_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAMontage_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Render
     (This  : IDAMontage_Type)
     return Pointer_To_IDAImage;

end StructuredGraphicControl.IDAMontage_Interface;

