package body StructuredGraphicControl.IDANumber_Object is

   function GetClassName
     (This : IDANumber_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDANumber_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDANumber_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDANumber_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDANumber_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDANumber_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDANumber_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDANumber_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDANumber_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDANumber_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDANumber_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDANumber_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDANumber_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDANumber_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDANumber_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDANumber_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDANumber_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDANumber_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDANumber_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDANumber_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDANumber_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDANumber_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDANumber_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDANumber_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDANumber_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDANumber_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDANumber_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDANumber_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function Extract
     (This : IDANumber_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDANumber_Extract);
   end Extract;

   function AnimateProperty
     (This                : IDANumber_Type;
      propertyPath_0      : GNATCOM.Types.VARIANT;
      scriptingLanguage_1 : GNATCOM.Types.VARIANT;
      invokeAsMethod_2    : GNATCOM.Types.VARIANT;
      minUpdateInterval_3 : GNATCOM.Types.VARIANT;
      Free                : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDANumber_AnimateProperty,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => minUpdateInterval_3,
          2 => invokeAsMethod_2,
          3 => scriptingLanguage_1,
          4 => propertyPath_0),
         Free);
   end AnimateProperty;

   function ToStringAnim
     (This        : IDANumber_Type;
      precision_0 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDANumber_ToStringAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => precision_0),
         Free);
   end ToStringAnim;

   function ToString
     (This        : IDANumber_Type;
      precision_0 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDANumber_ToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => precision_0),
         Free);
   end ToString;

end StructuredGraphicControl.IDANumber_Object;

