with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAPath2_Interface is

   type IDAPath2_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAPath2_Type);

   function Pointer (This : IDAPath2_Type)
     return Pointer_To_IDAPath2;

   procedure Attach (This    : in out IDAPath2_Type;
                     Pointer : in     Pointer_To_IDAPath2);

   function GetClassName
     (This       : IDAPath2_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAPath2_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAPath2_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAPath2_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAPath2_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAPath2_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAPath2_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAPath2_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAPath2_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAPath2_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAPath2_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAPath2_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAPath2_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAPath2_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Transform
     (This  : IDAPath2_Type;
      xf_0  : Pointer_To_IDATransform2)
     return Pointer_To_IDAPath2;

   function BoundingBox
     (This    : IDAPath2_Type;
      style_0 : Pointer_To_IDALineStyle)
     return Pointer_To_IDABbox2;

   function Fill
     (This     : IDAPath2_Type;
      border_0 : Pointer_To_IDALineStyle;
      fill_1   : Pointer_To_IDAImage)
     return Pointer_To_IDAImage;

   function Draw
     (This     : IDAPath2_Type;
      border_0 : Pointer_To_IDALineStyle)
     return Pointer_To_IDAImage;

   function Close
     (This  : IDAPath2_Type)
     return Pointer_To_IDAPath2;

end StructuredGraphicControl.IDAPath2_Interface;

