with GNATCOM.Interface;

with GNATCOM.Errors;

package body StructuredGraphicControl.IDAPickableResult_Interface is

   procedure Initialize (This : in out IDAPickableResult_Type) is
   begin
      Set_IID (This, IID_IDAPickableResult);
   end Initialize;

   function Pointer (This : IDAPickableResult_Type)
     return Pointer_To_IDAPickableResult
   is
   begin
      return To_Pointer_To_IDAPickableResult (Address (This));
   end Pointer;

   procedure Attach (This    : in out IDAPickableResult_Type;
                     Pointer : in     Pointer_To_IDAPickableResult)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_Image
     (This    : IDAPickableResult_Type)
     return Pointer_To_IDAImage
   is
       RetVal : aliased Pointer_To_IDAImage;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Image
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Image;

    function Get_Geometry
     (This       : IDAPickableResult_Type)
     return Pointer_To_IDAGeometry
   is
       RetVal : aliased Pointer_To_IDAGeometry;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Geometry
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Geometry;

    function Get_PickEvent
     (This        : IDAPickableResult_Type)
     return Pointer_To_IDAEvent
   is
       RetVal : aliased Pointer_To_IDAEvent;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_PickEvent
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_PickEvent;

end StructuredGraphicControl.IDAPickableResult_Interface;

