with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAPoint2_Interface is

   type IDAPoint2_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAPoint2_Type);

   function Pointer (This : IDAPoint2_Type)
     return Pointer_To_IDAPoint2;

   procedure Attach (This    : in out IDAPoint2_Type;
                     Pointer : in     Pointer_To_IDAPoint2);

   function GetClassName
     (This       : IDAPoint2_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAPoint2_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAPoint2_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAPoint2_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAPoint2_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAPoint2_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAPoint2_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAPoint2_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAPoint2_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAPoint2_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAPoint2_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAPoint2_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAPoint2_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAPoint2_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function AnimateControlPosition
     (This                : IDAPoint2_Type;
      propertyPath_0      : GNATCOM.Types.BSTR;
      scriptingLanguage_1 : GNATCOM.Types.BSTR;
      invokeAsMethod_2    : GNATCOM.Types.VARIANT_BOOL;
      minUpdateInterval_3 : Interfaces.C.double;
      Free                : Boolean := True)
     return Pointer_To_IDAPoint2;

   function AnimateControlPositionPixel
     (This                : IDAPoint2_Type;
      propertyPath_0      : GNATCOM.Types.BSTR;
      scriptingLanguage_1 : GNATCOM.Types.BSTR;
      invokeAsMethod_2    : GNATCOM.Types.VARIANT_BOOL;
      minUpdateInterval_3 : Interfaces.C.double;
      Free                : Boolean := True)
     return Pointer_To_IDAPoint2;

   function Get_X
     (This  : IDAPoint2_Type)
     return Pointer_To_IDANumber;

   function Get_Y
     (This  : IDAPoint2_Type)
     return Pointer_To_IDANumber;

   function Get_PolarCoordAngle
     (This  : IDAPoint2_Type)
     return Pointer_To_IDANumber;

   function Get_PolarCoordLength
     (This  : IDAPoint2_Type)
     return Pointer_To_IDANumber;

   function Transform
     (This  : IDAPoint2_Type;
      xf_0  : Pointer_To_IDATransform2)
     return Pointer_To_IDAPoint2;

end StructuredGraphicControl.IDAPoint2_Interface;

