package body StructuredGraphicControl.IDAPoint2_Object is

   function GetClassName
     (This : IDAPoint2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAPoint2_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDAPoint2_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAPoint2_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDAPoint2_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAPoint2_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDAPoint2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAPoint2_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDAPoint2_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAPoint2_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDAPoint2_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAPoint2_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDAPoint2_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAPoint2_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDAPoint2_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAPoint2_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDAPoint2_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAPoint2_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDAPoint2_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAPoint2_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDAPoint2_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAPoint2_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDAPoint2_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAPoint2_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDAPoint2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAPoint2_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDAPoint2_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAPoint2_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function AnimateControlPosition
     (This                : IDAPoint2_Type;
      propertyPath_0      : GNATCOM.Types.VARIANT;
      scriptingLanguage_1 : GNATCOM.Types.VARIANT;
      invokeAsMethod_2    : GNATCOM.Types.VARIANT;
      minUpdateInterval_3 : GNATCOM.Types.VARIANT;
      Free                : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAPoint2_AnimateControlPosition,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => minUpdateInterval_3,
          2 => invokeAsMethod_2,
          3 => scriptingLanguage_1,
          4 => propertyPath_0),
         Free);
   end AnimateControlPosition;

   function AnimateControlPositionPixel
     (This                : IDAPoint2_Type;
      propertyPath_0      : GNATCOM.Types.VARIANT;
      scriptingLanguage_1 : GNATCOM.Types.VARIANT;
      invokeAsMethod_2    : GNATCOM.Types.VARIANT;
      minUpdateInterval_3 : GNATCOM.Types.VARIANT;
      Free                : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAPoint2_AnimateControlPositionPixel,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => minUpdateInterval_3,
          2 => invokeAsMethod_2,
          3 => scriptingLanguage_1,
          4 => propertyPath_0),
         Free);
   end AnimateControlPositionPixel;

   function Get_X
     (This : IDAPoint2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAPoint2_Get_X);
   end Get_X;

   function Get_Y
     (This : IDAPoint2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAPoint2_Get_Y);
   end Get_Y;

   function Get_PolarCoordAngle
     (This : IDAPoint2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAPoint2_Get_PolarCoordAngle);
   end Get_PolarCoordAngle;

   function Get_PolarCoordLength
     (This : IDAPoint2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAPoint2_Get_PolarCoordLength);
   end Get_PolarCoordLength;

   function Transform
     (This : IDAPoint2_Type;
      xf_0 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAPoint2_Transform,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xf_0),
         Free);
   end Transform;

end StructuredGraphicControl.IDAPoint2_Object;

