with GNATCOM.Interface;

with GNATCOM.Errors;

package body StructuredGraphicControl.IDAPreferences_Interface is

   procedure Initialize (This : in out IDAPreferences_Type) is
   begin
      Set_IID (This, IID_IDAPreferences);
   end Initialize;

   function Pointer (This : IDAPreferences_Type)
     return Pointer_To_IDAPreferences
   is
   begin
      return To_Pointer_To_IDAPreferences (Address (This));
   end Pointer;

   procedure Attach (This    : in out IDAPreferences_Type;
                     Pointer : in     Pointer_To_IDAPreferences)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure PutPreference
     (This           : IDAPreferences_Type;
      preferenceName : GNATCOM.Types.BSTR;
      value          : GNATCOM.Types.VARIANT;
      Free           : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.PutPreference
         (Pointer (This),
          preferenceName,
          value));

      if Free then
               GNATCOM.Interface.Free (preferenceName);
               GNATCOM.Interface.Free (value);
      
      end if;

   end PutPreference;

    function GetPreference
     (This           : IDAPreferences_Type;
      preferenceName : GNATCOM.Types.BSTR;
      Free           : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
       RetVal : aliased GNATCOM.Types.VARIANT;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.GetPreference
         (Pointer (This),
          preferenceName,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (preferenceName);
      
      end if;

      return RetVal;
   end GetPreference;

   procedure Propagate
     (This : IDAPreferences_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Propagate
         (Pointer (This)));

   end Propagate;

end StructuredGraphicControl.IDAPreferences_Interface;

