with GNATCOM.Interface;

with GNATCOM.Errors;

package body StructuredGraphicControl.IDASite_Interface is

   procedure Initialize (This : in out IDASite_Type) is
   begin
      Set_IID (This, IID_IDASite);
   end Initialize;

   function Pointer (This : IDASite_Type)
     return Pointer_To_IDASite
   is
   begin
      return To_Pointer_To_IDASite (Address (This));
   end Pointer;

   procedure Attach (This    : in out IDASite_Type;
                     Pointer : in     Pointer_To_IDASite)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure SetStatusText
     (This       : IDASite_Type;
      StatusText : GNATCOM.Types.BSTR;
      Free       : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetStatusText
         (Pointer (This),
          StatusText));

      if Free then
               GNATCOM.Interface.Free (StatusText);
      
      end if;

   end SetStatusText;

   procedure ReportError
     (This      : IDASite_Type;
      hr        : GNATCOM.Types.HRESULT;
      ErrorText : GNATCOM.Types.BSTR;
      Free      : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.ReportError
         (Pointer (This),
          hr,
          ErrorText));

      if Free then
               GNATCOM.Interface.Free (ErrorText);
      
      end if;

   end ReportError;

   procedure ReportGC
     (This      : IDASite_Type;
      bStarting : GNATCOM.Types.VARIANT_BOOL)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.ReportGC
         (Pointer (This),
          bStarting));

   end ReportGC;

end StructuredGraphicControl.IDASite_Interface;

