with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDASound_Interface is

   type IDASound_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDASound_Type);

   function Pointer (This : IDASound_Type)
     return Pointer_To_IDASound;

   procedure Attach (This    : in out IDASound_Type;
                     Pointer : in     Pointer_To_IDASound);

   function GetClassName
     (This       : IDASound_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDASound_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDASound_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDASound_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDASound_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDASound_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDASound_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDASound_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDASound_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDASound_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDASound_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDASound_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDASound_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDASound_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function PhaseAnim
     (This       : IDASound_Type;
      phaseAmt_0 : Pointer_To_IDANumber)
     return Pointer_To_IDASound;

   function Phase
     (This       : IDASound_Type;
      phaseAmt_0 : Interfaces.C.double)
     return Pointer_To_IDASound;

   function RateAnim
     (This         : IDASound_Type;
      pitchShift_0 : Pointer_To_IDANumber)
     return Pointer_To_IDASound;

   function Rate
     (This         : IDASound_Type;
      pitchShift_0 : Interfaces.C.double)
     return Pointer_To_IDASound;

   function PanAnim
     (This     : IDASound_Type;
      panAmt_0 : Pointer_To_IDANumber)
     return Pointer_To_IDASound;

   function Pan
     (This     : IDASound_Type;
      panAmt_0 : Interfaces.C.double)
     return Pointer_To_IDASound;

   function GainAnim
     (This      : IDASound_Type;
      gainAmt_0 : Pointer_To_IDANumber)
     return Pointer_To_IDASound;

   function Gain
     (This      : IDASound_Type;
      gainAmt_0 : Interfaces.C.double)
     return Pointer_To_IDASound;

   function uLoop
     (This  : IDASound_Type)
     return Pointer_To_IDASound;

end StructuredGraphicControl.IDASound_Interface;

