package body StructuredGraphicControl.IDASound_Object is

   function GetClassName
     (This : IDASound_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDASound_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDASound_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDASound_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDASound_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDASound_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDASound_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDASound_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDASound_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDASound_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDASound_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDASound_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDASound_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDASound_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDASound_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDASound_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDASound_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDASound_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDASound_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDASound_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDASound_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function PhaseAnim
     (This       : IDASound_Type;
      phaseAmt_0 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_PhaseAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => phaseAmt_0),
         Free);
   end PhaseAnim;

   function Phase
     (This       : IDASound_Type;
      phaseAmt_0 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_Phase,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => phaseAmt_0),
         Free);
   end Phase;

   function RateAnim
     (This         : IDASound_Type;
      pitchShift_0 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_RateAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pitchShift_0),
         Free);
   end RateAnim;

   function Rate
     (This         : IDASound_Type;
      pitchShift_0 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pitchShift_0),
         Free);
   end Rate;

   function PanAnim
     (This     : IDASound_Type;
      panAmt_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_PanAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => panAmt_0),
         Free);
   end PanAnim;

   function Pan
     (This     : IDASound_Type;
      panAmt_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_Pan,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => panAmt_0),
         Free);
   end Pan;

   function GainAnim
     (This      : IDASound_Type;
      gainAmt_0 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_GainAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => gainAmt_0),
         Free);
   end GainAnim;

   function Gain
     (This      : IDASound_Type;
      gainAmt_0 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDASound_Gain,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => gainAmt_0),
         Free);
   end Gain;

   function uLoop
     (This : IDASound_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDASound_uLoop);
   end uLoop;

end StructuredGraphicControl.IDASound_Object;

