with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAStatics_Interface is

   type IDAStatics_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAStatics_Type);

   function Pointer (This : IDAStatics_Type)
     return Pointer_To_IDAStatics;

   procedure Attach (This    : in out IDAStatics_Type;
                     Pointer : in     Pointer_To_IDAStatics);

   function Get_VersionString
     (This : IDAStatics_Type)
     return GNATCOM.Types.BSTR;

   function Get_Site
     (This  : IDAStatics_Type)
     return Pointer_To_IDASite;

   procedure Put_Site
     (This  : IDAStatics_Type;
      pSite : Pointer_To_IDASite);

   procedure Put_ClientSite
     (This        : IDAStatics_Type;
      pClientSite : Pointer_To_IOleClientSite);

   function Get_ClientSite
     (This        : IDAStatics_Type)
     return Pointer_To_IOleClientSite;

   procedure Put_PixelConstructionMode
     (This  : IDAStatics_Type;
      bMode : GNATCOM.Types.VARIANT_BOOL);

   function Get_PixelConstructionMode
     (This  : IDAStatics_Type)
     return GNATCOM.Types.VARIANT_BOOL;

   procedure TriggerEvent
     (This  : IDAStatics_Type;
      event : Pointer_To_IDAEvent;
      Data  : Pointer_To_IDABehavior);

   function NewDrawingSurface
     (This : IDAStatics_Type)
     return Pointer_To_IDADrawingSurface;

   function ImportMovie
     (This     : IDAStatics_Type;
      url      : GNATCOM.Types.BSTR;
      Free     : Boolean := True)
     return Pointer_To_IDAImportationResult;

   function ImportMovieAsync
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.BSTR;
      pImageStandIn : Pointer_To_IDAImage;
      pSoundStandIn : Pointer_To_IDASound;
      Free          : Boolean := True)
     return Pointer_To_IDAImportationResult;

   function ImportImage
     (This    : IDAStatics_Type;
      url     : GNATCOM.Types.BSTR;
      Free    : Boolean := True)
     return Pointer_To_IDAImage;

   function ImportImageAsync
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.BSTR;
      pImageStandIn : Pointer_To_IDAImage;
      Free          : Boolean := True)
     return Pointer_To_IDAImportationResult;

   function ImportImageColorKey
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.BSTR;
      colorKeyRed   : Interfaces.C.unsigned_char;
      colorKeyGreen : Interfaces.C.unsigned_char;
      colorKeyBlue  : Interfaces.C.unsigned_char;
      Free          : Boolean := True)
     return Pointer_To_IDAImage;

   function ImportImageAsyncColorKey
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.BSTR;
      pImageStandIn : Pointer_To_IDAImage;
      colorKeyRed   : Interfaces.C.unsigned_char;
      colorKeyGreen : Interfaces.C.unsigned_char;
      colorKeyBlue  : Interfaces.C.unsigned_char;
      Free          : Boolean := True)
     return Pointer_To_IDAImportationResult;

   function ImportSound
     (This     : IDAStatics_Type;
      url      : GNATCOM.Types.BSTR;
      Free     : Boolean := True)
     return Pointer_To_IDAImportationResult;

   function ImportSoundAsync
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.BSTR;
      pSoundStandIn : Pointer_To_IDASound;
      Free          : Boolean := True)
     return Pointer_To_IDAImportationResult;

   function ImportGeometry
     (This       : IDAStatics_Type;
      url        : GNATCOM.Types.BSTR;
      Free       : Boolean := True)
     return Pointer_To_IDAGeometry;

   function ImportGeometryAsync
     (This        : IDAStatics_Type;
      url         : GNATCOM.Types.BSTR;
      pGeoStandIn : Pointer_To_IDAGeometry;
      Free        : Boolean := True)
     return Pointer_To_IDAImportationResult;

   function ImportDirectDrawSurface
     (This        : IDAStatics_Type;
      dds         : GNATCOM.Types.Pointer_To_IUnknown;
      updateEvent : Pointer_To_IDAEvent)
     return Pointer_To_IDAImage;

   function Cond
     (This     : IDAStatics_Type;
      c        : Pointer_To_IDABoolean;
      i        : Pointer_To_IDABehavior;
      e        : Pointer_To_IDABehavior)
     return Pointer_To_IDABehavior;

   function DAArrayEx
     (This  : IDAStatics_Type;
      s     : Interfaces.C.long;
      pBvrs : Pointer_To_Pointer_To_IDABehavior)
     return Pointer_To_IDAArray;

   function DAArray
     (This : IDAStatics_Type;
      bvrs : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return Pointer_To_IDAArray;

   function DATupleEx
     (This  : IDAStatics_Type;
      s     : Interfaces.C.long;
      pBvrs : Pointer_To_Pointer_To_IDABehavior)
     return Pointer_To_IDATuple;

   function DATuple
     (This : IDAStatics_Type;
      bvrs : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return Pointer_To_IDATuple;

   function ModifiableBehavior
     (This : IDAStatics_Type;
      orig : Pointer_To_IDABehavior)
     return Pointer_To_IDABehavior;

   function UninitializedArray
     (This    : IDAStatics_Type;
      typeTmp : Pointer_To_IDAArray)
     return Pointer_To_IDAArray;

   function UninitializedTuple
     (This    : IDAStatics_Type;
      typeTmp : Pointer_To_IDATuple)
     return Pointer_To_IDATuple;

   function NumberBSplineEx
     (This      : IDAStatics_Type;
      degree    : Interfaces.C.int;
      numKnots  : Interfaces.C.long;
      knots     : Pointer_To_Pointer_To_IDANumber;
      numPts    : Interfaces.C.long;
      ctrlPts   : Pointer_To_Pointer_To_IDANumber;
      numWts    : Interfaces.C.long;
      weights   : Pointer_To_Pointer_To_IDANumber;
      evaluator : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function NumberBSpline
     (This      : IDAStatics_Type;
      degree    : Interfaces.C.int;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : Pointer_To_IDANumber;
      Free      : Boolean := True)
     return Pointer_To_IDANumber;

   function Point2BSplineEx
     (This      : IDAStatics_Type;
      degree    : Interfaces.C.int;
      numKnots  : Interfaces.C.long;
      knots     : Pointer_To_Pointer_To_IDANumber;
      numPts    : Interfaces.C.long;
      ctrlPts   : Pointer_To_Pointer_To_IDAPoint2;
      numWts    : Interfaces.C.long;
      weights   : Pointer_To_Pointer_To_IDANumber;
      evaluator : Pointer_To_IDANumber)
     return Pointer_To_IDAPoint2;

   function Point2BSpline
     (This      : IDAStatics_Type;
      degree    : Interfaces.C.int;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : Pointer_To_IDANumber;
      Free      : Boolean := True)
     return Pointer_To_IDAPoint2;

   function Point3BSplineEx
     (This      : IDAStatics_Type;
      degree    : Interfaces.C.int;
      numKnots  : Interfaces.C.long;
      knots     : Pointer_To_Pointer_To_IDANumber;
      numPts    : Interfaces.C.long;
      ctrlPts   : Pointer_To_Pointer_To_IDAPoint3;
      numWts    : Interfaces.C.long;
      weights   : Pointer_To_Pointer_To_IDANumber;
      evaluator : Pointer_To_IDANumber)
     return Pointer_To_IDAPoint3;

   function Point3BSpline
     (This      : IDAStatics_Type;
      degree    : Interfaces.C.int;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : Pointer_To_IDANumber;
      Free      : Boolean := True)
     return Pointer_To_IDAPoint3;

   function Vector2BSplineEx
     (This      : IDAStatics_Type;
      degree    : Interfaces.C.int;
      numKnots  : Interfaces.C.long;
      knots     : Pointer_To_Pointer_To_IDANumber;
      numPts    : Interfaces.C.long;
      ctrlPts   : Pointer_To_Pointer_To_IDAVector2;
      numWts    : Interfaces.C.long;
      weights   : Pointer_To_Pointer_To_IDANumber;
      evaluator : Pointer_To_IDANumber)
     return Pointer_To_IDAVector2;

   function Vector2BSpline
     (This      : IDAStatics_Type;
      degree    : Interfaces.C.int;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : Pointer_To_IDANumber;
      Free      : Boolean := True)
     return Pointer_To_IDAVector2;

   function Vector3BSplineEx
     (This      : IDAStatics_Type;
      degree    : Interfaces.C.int;
      numKnots  : Interfaces.C.long;
      knots     : Pointer_To_Pointer_To_IDANumber;
      numPts    : Interfaces.C.long;
      ctrlPts   : Pointer_To_Pointer_To_IDAVector3;
      numWts    : Interfaces.C.long;
      weights   : Pointer_To_Pointer_To_IDANumber;
      evaluator : Pointer_To_IDANumber)
     return Pointer_To_IDAVector3;

   function Vector3BSpline
     (This      : IDAStatics_Type;
      degree    : Interfaces.C.int;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : Pointer_To_IDANumber;
      Free      : Boolean := True)
     return Pointer_To_IDAVector3;

   function Pow
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function uAbs
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Sqrt
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Floor
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Round
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Ceiling
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Asin
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Acos
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Atan
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Sin
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Cos
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Tan
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Exp
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Ln
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Log10
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function ToDegrees
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function ToRadians
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function uMod
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Atan2
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Add
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Sub
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Mul
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Div
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function LT
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDABoolean;

   function LTE
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDABoolean;

   function GT
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDABoolean;

   function GTE
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDABoolean;

   function EQ
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDABoolean;

   function NE
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDABoolean;

   function Neg
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function InterpolateAnim
     (This       : IDAStatics_Type;
      from_0     : Pointer_To_IDANumber;
      to_1       : Pointer_To_IDANumber;
      duration_2 : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Interpolate
     (This       : IDAStatics_Type;
      from_0     : Interfaces.C.double;
      to_1       : Interfaces.C.double;
      duration_2 : Interfaces.C.double)
     return Pointer_To_IDANumber;

   function SlowInSlowOutAnim
     (This        : IDAStatics_Type;
      from_0      : Pointer_To_IDANumber;
      to_1        : Pointer_To_IDANumber;
      duration_2  : Pointer_To_IDANumber;
      sharpness_3 : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function SlowInSlowOut
     (This        : IDAStatics_Type;
      from_0      : Interfaces.C.double;
      to_1        : Interfaces.C.double;
      duration_2  : Interfaces.C.double;
      sharpness_3 : Interfaces.C.double)
     return Pointer_To_IDANumber;

   function SoundSource
     (This  : IDAStatics_Type;
      snd_0 : Pointer_To_IDASound)
     return Pointer_To_IDAGeometry;

   function Mix
     (This    : IDAStatics_Type;
      left_0  : Pointer_To_IDASound;
      right_1 : Pointer_To_IDASound)
     return Pointer_To_IDASound;

   function uAnd
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDABoolean;
      b_1   : Pointer_To_IDABoolean)
     return Pointer_To_IDABoolean;

   function uOr
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDABoolean;
      b_1   : Pointer_To_IDABoolean)
     return Pointer_To_IDABoolean;

   function uNot
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDABoolean)
     return Pointer_To_IDABoolean;

   function Integral
     (This  : IDAStatics_Type;
      b_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function Derivative
     (This  : IDAStatics_Type;
      b_0   : Pointer_To_IDANumber)
     return Pointer_To_IDANumber;

   function IntegralVector2
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAVector2)
     return Pointer_To_IDAVector2;

   function IntegralVector3
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAVector3)
     return Pointer_To_IDAVector3;

   function DerivativeVector2
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAVector2)
     return Pointer_To_IDAVector2;

   function DerivativeVector3
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAVector3)
     return Pointer_To_IDAVector3;

   function DerivativePoint2
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAPoint2)
     return Pointer_To_IDAVector2;

   function DerivativePoint3
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAPoint3)
     return Pointer_To_IDAVector3;

   function KeyState
     (This  : IDAStatics_Type;
      n_0   : Pointer_To_IDANumber)
     return Pointer_To_IDABoolean;

   function KeyUp
     (This  : IDAStatics_Type;
      arg_0 : Interfaces.C.long)
     return Pointer_To_IDAEvent;

   function KeyDown
     (This  : IDAStatics_Type;
      arg_0 : Interfaces.C.long)
     return Pointer_To_IDAEvent;

   function DANumber
     (This  : IDAStatics_Type;
      num_0 : Interfaces.C.double)
     return Pointer_To_IDANumber;

   function DAString
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.BSTR;
      Free  : Boolean := True)
     return Pointer_To_IDAString;

   function DABoolean
     (This  : IDAStatics_Type;
      num_0 : GNATCOM.Types.VARIANT_BOOL)
     return Pointer_To_IDABoolean;

   function SeededRandom
     (This  : IDAStatics_Type;
      arg_0 : Interfaces.C.double)
     return Pointer_To_IDANumber;

   function Get_MousePosition
     (This  : IDAStatics_Type)
     return Pointer_To_IDAPoint2;

   function Get_LeftButtonState
     (This  : IDAStatics_Type)
     return Pointer_To_IDABoolean;

   function Get_RightButtonState
     (This  : IDAStatics_Type)
     return Pointer_To_IDABoolean;

   function Get_DATrue
     (This  : IDAStatics_Type)
     return Pointer_To_IDABoolean;

   function Get_DAFalse
     (This  : IDAStatics_Type)
     return Pointer_To_IDABoolean;

   function Get_LocalTime
     (This  : IDAStatics_Type)
     return Pointer_To_IDANumber;

   function Get_GlobalTime
     (This  : IDAStatics_Type)
     return Pointer_To_IDANumber;

   function Get_Pixel
     (This  : IDAStatics_Type)
     return Pointer_To_IDANumber;

   function UserData
     (This   : IDAStatics_Type;
      data_0 : GNATCOM.Types.Pointer_To_IUnknown)
     return Pointer_To_IDAUserData;

   function UntilNotify
     (This       : IDAStatics_Type;
      b0_0       : Pointer_To_IDABehavior;
      event_1    : Pointer_To_IDAEvent;
      notifier_2 : Pointer_To_IDAUntilNotifier)
     return Pointer_To_IDABehavior;

   function uUntil
     (This    : IDAStatics_Type;
      b0_0    : Pointer_To_IDABehavior;
      event_1 : Pointer_To_IDAEvent;
      b1_2    : Pointer_To_IDABehavior)
     return Pointer_To_IDABehavior;

   function UntilEx
     (This    : IDAStatics_Type;
      b0_0    : Pointer_To_IDABehavior;
      event_1 : Pointer_To_IDAEvent)
     return Pointer_To_IDABehavior;

   function Sequence
     (This  : IDAStatics_Type;
      s1_0  : Pointer_To_IDABehavior;
      s2_1  : Pointer_To_IDABehavior)
     return Pointer_To_IDABehavior;

   function FollowPath
     (This       : IDAStatics_Type;
      path_0     : Pointer_To_IDAPath2;
      duration_1 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function FollowPathAngle
     (This       : IDAStatics_Type;
      path_0     : Pointer_To_IDAPath2;
      duration_1 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function FollowPathAngleUpright
     (This       : IDAStatics_Type;
      path_0     : Pointer_To_IDAPath2;
      duration_1 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function FollowPathEval
     (This   : IDAStatics_Type;
      path_0 : Pointer_To_IDAPath2;
      eval_1 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function FollowPathAngleEval
     (This   : IDAStatics_Type;
      path_0 : Pointer_To_IDAPath2;
      eval_1 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function FollowPathAngleUprightEval
     (This   : IDAStatics_Type;
      path_0 : Pointer_To_IDAPath2;
      eval_1 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function FollowPathAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : Pointer_To_IDAPath2;
      obsoleted2_1 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function FollowPathAngleAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : Pointer_To_IDAPath2;
      obsoleted2_1 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function FollowPathAngleUprightAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : Pointer_To_IDAPath2;
      obsoleted2_1 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function ConcatString
     (This  : IDAStatics_Type;
      s1_0  : Pointer_To_IDAString;
      s2_1  : Pointer_To_IDAString)
     return Pointer_To_IDAString;

   function PerspectiveCamera
     (This        : IDAStatics_Type;
      focalDist_0 : Interfaces.C.double;
      nearClip_1  : Interfaces.C.double)
     return Pointer_To_IDACamera;

   function PerspectiveCameraAnim
     (This        : IDAStatics_Type;
      focalDist_0 : Pointer_To_IDANumber;
      nearClip_1  : Pointer_To_IDANumber)
     return Pointer_To_IDACamera;

   function ParallelCamera
     (This       : IDAStatics_Type;
      nearClip_0 : Interfaces.C.double)
     return Pointer_To_IDACamera;

   function ParallelCameraAnim
     (This       : IDAStatics_Type;
      nearClip_0 : Pointer_To_IDANumber)
     return Pointer_To_IDACamera;

   function ColorRgbAnim
     (This    : IDAStatics_Type;
      red_0   : Pointer_To_IDANumber;
      green_1 : Pointer_To_IDANumber;
      blue_2  : Pointer_To_IDANumber)
     return Pointer_To_IDAColor;

   function ColorRgb
     (This    : IDAStatics_Type;
      red_0   : Interfaces.C.double;
      green_1 : Interfaces.C.double;
      blue_2  : Interfaces.C.double)
     return Pointer_To_IDAColor;

   function ColorRgb255
     (This    : IDAStatics_Type;
      red_0   : Interfaces.C.short;
      green_1 : Interfaces.C.short;
      blue_2  : Interfaces.C.short)
     return Pointer_To_IDAColor;

   function ColorHsl
     (This         : IDAStatics_Type;
      hue_0        : Interfaces.C.double;
      saturation_1 : Interfaces.C.double;
      lum_2        : Interfaces.C.double)
     return Pointer_To_IDAColor;

   function ColorHslAnim
     (This         : IDAStatics_Type;
      hue_0        : Pointer_To_IDANumber;
      saturation_1 : Pointer_To_IDANumber;
      lum_2        : Pointer_To_IDANumber)
     return Pointer_To_IDAColor;

   function Get_Red
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Green
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Blue
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Cyan
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Magenta
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Yellow
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Black
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_White
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Aqua
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Fuchsia
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Gray
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Lime
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Maroon
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Navy
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Olive
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Purple
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Silver
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Get_Teal
     (This  : IDAStatics_Type)
     return Pointer_To_IDAColor;

   function Predicate
     (This  : IDAStatics_Type;
      b_0   : Pointer_To_IDABoolean)
     return Pointer_To_IDAEvent;

   function NotEvent
     (This    : IDAStatics_Type;
      event_0 : Pointer_To_IDAEvent)
     return Pointer_To_IDAEvent;

   function AndEvent
     (This  : IDAStatics_Type;
      e1_0  : Pointer_To_IDAEvent;
      e2_1  : Pointer_To_IDAEvent)
     return Pointer_To_IDAEvent;

   function OrEvent
     (This  : IDAStatics_Type;
      e1_0  : Pointer_To_IDAEvent;
      e2_1  : Pointer_To_IDAEvent)
     return Pointer_To_IDAEvent;

   function ThenEvent
     (This  : IDAStatics_Type;
      e1_0  : Pointer_To_IDAEvent;
      e2_1  : Pointer_To_IDAEvent)
     return Pointer_To_IDAEvent;

   function Get_LeftButtonDown
     (This  : IDAStatics_Type)
     return Pointer_To_IDAEvent;

   function Get_LeftButtonUp
     (This  : IDAStatics_Type)
     return Pointer_To_IDAEvent;

   function Get_RightButtonDown
     (This  : IDAStatics_Type)
     return Pointer_To_IDAEvent;

   function Get_RightButtonUp
     (This  : IDAStatics_Type)
     return Pointer_To_IDAEvent;

   function Get_Always
     (This  : IDAStatics_Type)
     return Pointer_To_IDAEvent;

   function Get_Never
     (This  : IDAStatics_Type)
     return Pointer_To_IDAEvent;

   function TimerAnim
     (This  : IDAStatics_Type;
      n_0   : Pointer_To_IDANumber)
     return Pointer_To_IDAEvent;

   function Timer
     (This  : IDAStatics_Type;
      n_0   : Interfaces.C.double)
     return Pointer_To_IDAEvent;

   function AppTriggeredEvent
     (This  : IDAStatics_Type)
     return Pointer_To_IDAEvent;

   function ScriptCallback
     (This        : IDAStatics_Type;
      obsolete1_0 : GNATCOM.Types.BSTR;
      obsolete2_1 : Pointer_To_IDAEvent;
      obsolete3_2 : GNATCOM.Types.BSTR;
      Free        : Boolean := True)
     return Pointer_To_IDAEvent;

   function Get_EmptyGeometry
     (This  : IDAStatics_Type)
     return Pointer_To_IDAGeometry;

   function UnionGeometry
     (This  : IDAStatics_Type;
      g1_0  : Pointer_To_IDAGeometry;
      g2_1  : Pointer_To_IDAGeometry)
     return Pointer_To_IDAGeometry;

   function UnionGeometryArrayEx
     (This       : IDAStatics_Type;
      imgs_0size : Interfaces.C.long;
      imgs_0     : Pointer_To_Pointer_To_IDAGeometry)
     return Pointer_To_IDAGeometry;

   function UnionGeometryArray
     (This   : IDAStatics_Type;
      imgs_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return Pointer_To_IDAGeometry;

   function Get_EmptyImage
     (This  : IDAStatics_Type)
     return Pointer_To_IDAImage;

   function Get_DetectableEmptyImage
     (This  : IDAStatics_Type)
     return Pointer_To_IDAImage;

   function SolidColorImage
     (This  : IDAStatics_Type;
      col_0 : Pointer_To_IDAColor)
     return Pointer_To_IDAImage;

   function GradientPolygonEx
     (This         : IDAStatics_Type;
      points_0size : Interfaces.C.long;
      points_0     : Pointer_To_Pointer_To_IDAPoint2;
      colors_1size : Interfaces.C.long;
      colors_1     : Pointer_To_Pointer_To_IDAColor)
     return Pointer_To_IDAImage;

   function GradientPolygon
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      colors_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return Pointer_To_IDAImage;

   function RadialGradientPolygonEx
     (This         : IDAStatics_Type;
      inner_0      : Pointer_To_IDAColor;
      outer_1      : Pointer_To_IDAColor;
      points_2size : Interfaces.C.long;
      points_2     : Pointer_To_Pointer_To_IDAPoint2;
      fallOff_3    : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function RadialGradientPolygon
     (This      : IDAStatics_Type;
      inner_0   : Pointer_To_IDAColor;
      outer_1   : Pointer_To_IDAColor;
      points_2  : GNATCOM.Types.VARIANT;
      fallOff_3 : Interfaces.C.double;
      Free      : Boolean := True)
     return Pointer_To_IDAImage;

   function RadialGradientPolygonAnimEx
     (This         : IDAStatics_Type;
      inner_0      : Pointer_To_IDAColor;
      outer_1      : Pointer_To_IDAColor;
      points_2size : Interfaces.C.long;
      points_2     : Pointer_To_Pointer_To_IDAPoint2;
      fallOff_3    : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function RadialGradientPolygonAnim
     (This      : IDAStatics_Type;
      inner_0   : Pointer_To_IDAColor;
      outer_1   : Pointer_To_IDAColor;
      points_2  : GNATCOM.Types.VARIANT;
      fallOff_3 : Pointer_To_IDANumber;
      Free      : Boolean := True)
     return Pointer_To_IDAImage;

   function GradientSquare
     (This         : IDAStatics_Type;
      lowerLeft_0  : Pointer_To_IDAColor;
      upperLeft_1  : Pointer_To_IDAColor;
      upperRight_2 : Pointer_To_IDAColor;
      lowerRight_3 : Pointer_To_IDAColor)
     return Pointer_To_IDAImage;

   function RadialGradientSquare
     (This      : IDAStatics_Type;
      inner_0   : Pointer_To_IDAColor;
      outer_1   : Pointer_To_IDAColor;
      fallOff_2 : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function RadialGradientSquareAnim
     (This      : IDAStatics_Type;
      inner_0   : Pointer_To_IDAColor;
      outer_1   : Pointer_To_IDAColor;
      fallOff_2 : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function RadialGradientRegularPoly
     (This       : IDAStatics_Type;
      inner_0    : Pointer_To_IDAColor;
      outer_1    : Pointer_To_IDAColor;
      numEdges_2 : Interfaces.C.double;
      fallOff_3  : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function RadialGradientRegularPolyAnim
     (This       : IDAStatics_Type;
      inner_0    : Pointer_To_IDAColor;
      outer_1    : Pointer_To_IDAColor;
      numEdges_2 : Pointer_To_IDANumber;
      fallOff_3  : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function GradientHorizontal
     (This      : IDAStatics_Type;
      start_0   : Pointer_To_IDAColor;
      stop_1    : Pointer_To_IDAColor;
      fallOff_2 : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function GradientHorizontalAnim
     (This      : IDAStatics_Type;
      start_0   : Pointer_To_IDAColor;
      stop_1    : Pointer_To_IDAColor;
      fallOff_2 : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function HatchHorizontal
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function HatchHorizontalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function HatchVertical
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function HatchVerticalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function HatchForwardDiagonal
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function HatchForwardDiagonalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function HatchBackwardDiagonal
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function HatchBackwardDiagonalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function HatchCross
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function HatchCrossAnim
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function HatchDiagonalCross
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Interfaces.C.double)
     return Pointer_To_IDAImage;

   function HatchDiagonalCrossAnim
     (This      : IDAStatics_Type;
      lineClr_0 : Pointer_To_IDAColor;
      spacing_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAImage;

   function Overlay
     (This     : IDAStatics_Type;
      top_0    : Pointer_To_IDAImage;
      bottom_1 : Pointer_To_IDAImage)
     return Pointer_To_IDAImage;

   function OverlayArrayEx
     (This       : IDAStatics_Type;
      imgs_0size : Interfaces.C.long;
      imgs_0     : Pointer_To_Pointer_To_IDAImage)
     return Pointer_To_IDAImage;

   function OverlayArray
     (This   : IDAStatics_Type;
      imgs_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return Pointer_To_IDAImage;

   function Get_AmbientLight
     (This  : IDAStatics_Type)
     return Pointer_To_IDAGeometry;

   function Get_DirectionalLight
     (This  : IDAStatics_Type)
     return Pointer_To_IDAGeometry;

   function Get_PointLight
     (This  : IDAStatics_Type)
     return Pointer_To_IDAGeometry;

   function SpotLightAnim
     (This       : IDAStatics_Type;
      fullcone_0 : Pointer_To_IDANumber;
      cutoff_1   : Pointer_To_IDANumber)
     return Pointer_To_IDAGeometry;

   function SpotLight
     (This       : IDAStatics_Type;
      fullcone_0 : Pointer_To_IDANumber;
      cutoff_1   : Interfaces.C.double)
     return Pointer_To_IDAGeometry;

   function Get_DefaultLineStyle
     (This  : IDAStatics_Type)
     return Pointer_To_IDALineStyle;

   function Get_EmptyLineStyle
     (This  : IDAStatics_Type)
     return Pointer_To_IDALineStyle;

   function Get_JoinStyleBevel
     (This  : IDAStatics_Type)
     return Pointer_To_IDAJoinStyle;

   function Get_JoinStyleRound
     (This  : IDAStatics_Type)
     return Pointer_To_IDAJoinStyle;

   function Get_JoinStyleMiter
     (This  : IDAStatics_Type)
     return Pointer_To_IDAJoinStyle;

   function Get_EndStyleFlat
     (This  : IDAStatics_Type)
     return Pointer_To_IDAEndStyle;

   function Get_EndStyleSquare
     (This  : IDAStatics_Type)
     return Pointer_To_IDAEndStyle;

   function Get_EndStyleRound
     (This  : IDAStatics_Type)
     return Pointer_To_IDAEndStyle;

   function Get_DashStyleSolid
     (This  : IDAStatics_Type)
     return Pointer_To_IDADashStyle;

   function Get_DashStyleDashed
     (This  : IDAStatics_Type)
     return Pointer_To_IDADashStyle;

   function Get_DefaultMicrophone
     (This  : IDAStatics_Type)
     return Pointer_To_IDAMicrophone;

   function Get_OpaqueMatte
     (This  : IDAStatics_Type)
     return Pointer_To_IDAMatte;

   function Get_ClearMatte
     (This  : IDAStatics_Type)
     return Pointer_To_IDAMatte;

   function UnionMatte
     (This  : IDAStatics_Type;
      m1_0  : Pointer_To_IDAMatte;
      m2_1  : Pointer_To_IDAMatte)
     return Pointer_To_IDAMatte;

   function IntersectMatte
     (This  : IDAStatics_Type;
      m1_0  : Pointer_To_IDAMatte;
      m2_1  : Pointer_To_IDAMatte)
     return Pointer_To_IDAMatte;

   function DifferenceMatte
     (This  : IDAStatics_Type;
      m1_0  : Pointer_To_IDAMatte;
      m2_1  : Pointer_To_IDAMatte)
     return Pointer_To_IDAMatte;

   function FillMatte
     (This  : IDAStatics_Type;
      p_0   : Pointer_To_IDAPath2)
     return Pointer_To_IDAMatte;

   function TextMatte
     (This  : IDAStatics_Type;
      str_0 : Pointer_To_IDAString;
      fs_1  : Pointer_To_IDAFontStyle)
     return Pointer_To_IDAMatte;

   function Get_EmptyMontage
     (This  : IDAStatics_Type)
     return Pointer_To_IDAMontage;

   function ImageMontage
     (This    : IDAStatics_Type;
      im_0    : Pointer_To_IDAImage;
      depth_1 : Interfaces.C.double)
     return Pointer_To_IDAMontage;

   function ImageMontageAnim
     (This    : IDAStatics_Type;
      im_0    : Pointer_To_IDAImage;
      depth_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAMontage;

   function UnionMontage
     (This  : IDAStatics_Type;
      m1_0  : Pointer_To_IDAMontage;
      m2_1  : Pointer_To_IDAMontage)
     return Pointer_To_IDAMontage;

   function Concat
     (This  : IDAStatics_Type;
      p1_0  : Pointer_To_IDAPath2;
      p2_1  : Pointer_To_IDAPath2)
     return Pointer_To_IDAPath2;

   function ConcatArrayEx
     (This        : IDAStatics_Type;
      paths_0size : Interfaces.C.long;
      paths_0     : Pointer_To_Pointer_To_IDAPath2)
     return Pointer_To_IDAPath2;

   function ConcatArray
     (This    : IDAStatics_Type;
      paths_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return Pointer_To_IDAPath2;

   function Line
     (This  : IDAStatics_Type;
      p1_0  : Pointer_To_IDAPoint2;
      p2_1  : Pointer_To_IDAPoint2)
     return Pointer_To_IDAPath2;

   function Ray
     (This  : IDAStatics_Type;
      pt_0  : Pointer_To_IDAPoint2)
     return Pointer_To_IDAPath2;

   function StringPathAnim
     (This  : IDAStatics_Type;
      str_0 : Pointer_To_IDAString;
      fs_1  : Pointer_To_IDAFontStyle)
     return Pointer_To_IDAPath2;

   function StringPath
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.BSTR;
      fs_1  : Pointer_To_IDAFontStyle;
      Free  : Boolean := True)
     return Pointer_To_IDAPath2;

   function PolylineEx
     (This         : IDAStatics_Type;
      points_0size : Interfaces.C.long;
      points_0     : Pointer_To_Pointer_To_IDAPoint2)
     return Pointer_To_IDAPath2;

   function Polyline
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return Pointer_To_IDAPath2;

   function PolydrawPathEx
     (This         : IDAStatics_Type;
      points_0size : Interfaces.C.long;
      points_0     : Pointer_To_Pointer_To_IDAPoint2;
      codes_1size  : Interfaces.C.long;
      codes_1      : Pointer_To_Pointer_To_IDANumber)
     return Pointer_To_IDAPath2;

   function PolydrawPath
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      codes_1  : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return Pointer_To_IDAPath2;

   function ArcRadians
     (This         : IDAStatics_Type;
      startAngle_0 : Interfaces.C.double;
      endAngle_1   : Interfaces.C.double;
      arcWidth_2   : Interfaces.C.double;
      arcHeight_3  : Interfaces.C.double)
     return Pointer_To_IDAPath2;

   function ArcRadiansAnim
     (This         : IDAStatics_Type;
      startAngle_0 : Pointer_To_IDANumber;
      endAngle_1   : Pointer_To_IDANumber;
      arcWidth_2   : Pointer_To_IDANumber;
      arcHeight_3  : Pointer_To_IDANumber)
     return Pointer_To_IDAPath2;

   function ArcDegrees
     (This         : IDAStatics_Type;
      startAngle_0 : Interfaces.C.double;
      endAngle_1   : Interfaces.C.double;
      arcWidth_2   : Interfaces.C.double;
      arcHeight_3  : Interfaces.C.double)
     return Pointer_To_IDAPath2;

   function PieRadians
     (This         : IDAStatics_Type;
      startAngle_0 : Interfaces.C.double;
      endAngle_1   : Interfaces.C.double;
      arcWidth_2   : Interfaces.C.double;
      arcHeight_3  : Interfaces.C.double)
     return Pointer_To_IDAPath2;

   function PieRadiansAnim
     (This         : IDAStatics_Type;
      startAngle_0 : Pointer_To_IDANumber;
      endAngle_1   : Pointer_To_IDANumber;
      arcWidth_2   : Pointer_To_IDANumber;
      arcHeight_3  : Pointer_To_IDANumber)
     return Pointer_To_IDAPath2;

   function PieDegrees
     (This         : IDAStatics_Type;
      startAngle_0 : Interfaces.C.double;
      endAngle_1   : Interfaces.C.double;
      arcWidth_2   : Interfaces.C.double;
      arcHeight_3  : Interfaces.C.double)
     return Pointer_To_IDAPath2;

   function Oval
     (This     : IDAStatics_Type;
      width_0  : Interfaces.C.double;
      height_1 : Interfaces.C.double)
     return Pointer_To_IDAPath2;

   function OvalAnim
     (This     : IDAStatics_Type;
      width_0  : Pointer_To_IDANumber;
      height_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAPath2;

   function Rect
     (This     : IDAStatics_Type;
      width_0  : Interfaces.C.double;
      height_1 : Interfaces.C.double)
     return Pointer_To_IDAPath2;

   function RectAnim
     (This     : IDAStatics_Type;
      width_0  : Pointer_To_IDANumber;
      height_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAPath2;

   function RoundRect
     (This              : IDAStatics_Type;
      width_0           : Interfaces.C.double;
      height_1          : Interfaces.C.double;
      cornerArcWidth_2  : Interfaces.C.double;
      cornerArcHeight_3 : Interfaces.C.double)
     return Pointer_To_IDAPath2;

   function RoundRectAnim
     (This              : IDAStatics_Type;
      width_0           : Pointer_To_IDANumber;
      height_1          : Pointer_To_IDANumber;
      cornerArcWidth_2  : Pointer_To_IDANumber;
      cornerArcHeight_3 : Pointer_To_IDANumber)
     return Pointer_To_IDAPath2;

   function CubicBSplinePathEx
     (This         : IDAStatics_Type;
      points_0size : Interfaces.C.long;
      points_0     : Pointer_To_Pointer_To_IDAPoint2;
      knots_1size  : Interfaces.C.long;
      knots_1      : Pointer_To_Pointer_To_IDANumber)
     return Pointer_To_IDAPath2;

   function CubicBSplinePath
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      knots_1  : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return Pointer_To_IDAPath2;

   function TextPath
     (This        : IDAStatics_Type;
      obsolete1_0 : Pointer_To_IDAString;
      obsolete2_1 : Pointer_To_IDAFontStyle)
     return Pointer_To_IDAPath2;

   function Get_Silence
     (This  : IDAStatics_Type)
     return Pointer_To_IDASound;

   function MixArrayEx
     (This       : IDAStatics_Type;
      snds_0size : Interfaces.C.long;
      snds_0     : Pointer_To_Pointer_To_IDASound)
     return Pointer_To_IDASound;

   function MixArray
     (This   : IDAStatics_Type;
      snds_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return Pointer_To_IDASound;

   function Get_SinSynth
     (This  : IDAStatics_Type)
     return Pointer_To_IDASound;

   function Get_DefaultFont
     (This  : IDAStatics_Type)
     return Pointer_To_IDAFontStyle;

   function FontAnim
     (This   : IDAStatics_Type;
      str_0  : Pointer_To_IDAString;
      size_1 : Pointer_To_IDANumber;
      col_2  : Pointer_To_IDAColor)
     return Pointer_To_IDAFontStyle;

   function Font
     (This   : IDAStatics_Type;
      str_0  : GNATCOM.Types.BSTR;
      size_1 : Interfaces.C.double;
      col_2  : Pointer_To_IDAColor;
      Free   : Boolean := True)
     return Pointer_To_IDAFontStyle;

   function StringImageAnim
     (This  : IDAStatics_Type;
      str_0 : Pointer_To_IDAString;
      fs_1  : Pointer_To_IDAFontStyle)
     return Pointer_To_IDAImage;

   function StringImage
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.BSTR;
      fs_1  : Pointer_To_IDAFontStyle;
      Free  : Boolean := True)
     return Pointer_To_IDAImage;

   function TextImageAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : Pointer_To_IDAString;
      obsoleted2_1 : Pointer_To_IDAFontStyle)
     return Pointer_To_IDAImage;

   function TextImage
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.BSTR;
      obsoleted2_1 : Pointer_To_IDAFontStyle;
      Free         : Boolean := True)
     return Pointer_To_IDAImage;

   function Get_XVector2
     (This  : IDAStatics_Type)
     return Pointer_To_IDAVector2;

   function Get_YVector2
     (This  : IDAStatics_Type)
     return Pointer_To_IDAVector2;

   function Get_ZeroVector2
     (This  : IDAStatics_Type)
     return Pointer_To_IDAVector2;

   function Get_Origin2
     (This  : IDAStatics_Type)
     return Pointer_To_IDAPoint2;

   function Vector2Anim
     (This  : IDAStatics_Type;
      x_0   : Pointer_To_IDANumber;
      y_1   : Pointer_To_IDANumber)
     return Pointer_To_IDAVector2;

   function Vector2
     (This  : IDAStatics_Type;
      x_0   : Interfaces.C.double;
      y_1   : Interfaces.C.double)
     return Pointer_To_IDAVector2;

   function Point2Anim
     (This  : IDAStatics_Type;
      x_0   : Pointer_To_IDANumber;
      y_1   : Pointer_To_IDANumber)
     return Pointer_To_IDAPoint2;

   function Point2
     (This  : IDAStatics_Type;
      x_0   : Interfaces.C.double;
      y_1   : Interfaces.C.double)
     return Pointer_To_IDAPoint2;

   function Vector2PolarAnim
     (This     : IDAStatics_Type;
      theta_0  : Pointer_To_IDANumber;
      radius_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAVector2;

   function Vector2Polar
     (This     : IDAStatics_Type;
      theta_0  : Interfaces.C.double;
      radius_1 : Interfaces.C.double)
     return Pointer_To_IDAVector2;

   function Vector2PolarDegrees
     (This     : IDAStatics_Type;
      theta_0  : Interfaces.C.double;
      radius_1 : Interfaces.C.double)
     return Pointer_To_IDAVector2;

   function Point2PolarAnim
     (This     : IDAStatics_Type;
      theta_0  : Pointer_To_IDANumber;
      radius_1 : Pointer_To_IDANumber)
     return Pointer_To_IDAPoint2;

   function Point2Polar
     (This     : IDAStatics_Type;
      theta_0  : Interfaces.C.double;
      radius_1 : Interfaces.C.double)
     return Pointer_To_IDAPoint2;

   function DotVector2
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAVector2;
      u_1   : Pointer_To_IDAVector2)
     return Pointer_To_IDANumber;

   function NegVector2
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAVector2)
     return Pointer_To_IDAVector2;

   function SubVector2
     (This  : IDAStatics_Type;
      v1_0  : Pointer_To_IDAVector2;
      v2_1  : Pointer_To_IDAVector2)
     return Pointer_To_IDAVector2;

   function AddVector2
     (This  : IDAStatics_Type;
      v1_0  : Pointer_To_IDAVector2;
      v2_1  : Pointer_To_IDAVector2)
     return Pointer_To_IDAVector2;

   function AddPoint2Vector
     (This  : IDAStatics_Type;
      p_0   : Pointer_To_IDAPoint2;
      v_1   : Pointer_To_IDAVector2)
     return Pointer_To_IDAPoint2;

   function SubPoint2Vector
     (This  : IDAStatics_Type;
      p_0   : Pointer_To_IDAPoint2;
      v_1   : Pointer_To_IDAVector2)
     return Pointer_To_IDAPoint2;

   function SubPoint2
     (This  : IDAStatics_Type;
      p1_0  : Pointer_To_IDAPoint2;
      p2_1  : Pointer_To_IDAPoint2)
     return Pointer_To_IDAVector2;

   function DistancePoint2
     (This  : IDAStatics_Type;
      p_0   : Pointer_To_IDAPoint2;
      q_1   : Pointer_To_IDAPoint2)
     return Pointer_To_IDANumber;

   function DistanceSquaredPoint2
     (This  : IDAStatics_Type;
      p_0   : Pointer_To_IDAPoint2;
      q_1   : Pointer_To_IDAPoint2)
     return Pointer_To_IDANumber;

   function Get_XVector3
     (This  : IDAStatics_Type)
     return Pointer_To_IDAVector3;

   function Get_YVector3
     (This  : IDAStatics_Type)
     return Pointer_To_IDAVector3;

   function Get_ZVector3
     (This  : IDAStatics_Type)
     return Pointer_To_IDAVector3;

   function Get_ZeroVector3
     (This  : IDAStatics_Type)
     return Pointer_To_IDAVector3;

   function Get_Origin3
     (This  : IDAStatics_Type)
     return Pointer_To_IDAPoint3;

   function Vector3Anim
     (This  : IDAStatics_Type;
      x_0   : Pointer_To_IDANumber;
      y_1   : Pointer_To_IDANumber;
      z_2   : Pointer_To_IDANumber)
     return Pointer_To_IDAVector3;

   function Vector3
     (This  : IDAStatics_Type;
      x_0   : Interfaces.C.double;
      y_1   : Interfaces.C.double;
      z_2   : Interfaces.C.double)
     return Pointer_To_IDAVector3;

   function Point3Anim
     (This  : IDAStatics_Type;
      x_0   : Pointer_To_IDANumber;
      y_1   : Pointer_To_IDANumber;
      z_2   : Pointer_To_IDANumber)
     return Pointer_To_IDAPoint3;

   function Point3
     (This  : IDAStatics_Type;
      x_0   : Interfaces.C.double;
      y_1   : Interfaces.C.double;
      z_2   : Interfaces.C.double)
     return Pointer_To_IDAPoint3;

   function Vector3SphericalAnim
     (This      : IDAStatics_Type;
      xyAngle_0 : Pointer_To_IDANumber;
      yzAngle_1 : Pointer_To_IDANumber;
      radius_2  : Pointer_To_IDANumber)
     return Pointer_To_IDAVector3;

   function Vector3Spherical
     (This      : IDAStatics_Type;
      xyAngle_0 : Interfaces.C.double;
      yzAngle_1 : Interfaces.C.double;
      radius_2  : Interfaces.C.double)
     return Pointer_To_IDAVector3;

   function Point3SphericalAnim
     (This      : IDAStatics_Type;
      zxAngle_0 : Pointer_To_IDANumber;
      xyAngle_1 : Pointer_To_IDANumber;
      radius_2  : Pointer_To_IDANumber)
     return Pointer_To_IDAPoint3;

   function Point3Spherical
     (This      : IDAStatics_Type;
      zxAngle_0 : Interfaces.C.double;
      xyAngle_1 : Interfaces.C.double;
      radius_2  : Interfaces.C.double)
     return Pointer_To_IDAPoint3;

   function DotVector3
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAVector3;
      u_1   : Pointer_To_IDAVector3)
     return Pointer_To_IDANumber;

   function CrossVector3
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAVector3;
      u_1   : Pointer_To_IDAVector3)
     return Pointer_To_IDAVector3;

   function NegVector3
     (This  : IDAStatics_Type;
      v_0   : Pointer_To_IDAVector3)
     return Pointer_To_IDAVector3;

   function SubVector3
     (This  : IDAStatics_Type;
      v1_0  : Pointer_To_IDAVector3;
      v2_1  : Pointer_To_IDAVector3)
     return Pointer_To_IDAVector3;

   function AddVector3
     (This  : IDAStatics_Type;
      v1_0  : Pointer_To_IDAVector3;
      v2_1  : Pointer_To_IDAVector3)
     return Pointer_To_IDAVector3;

   function AddPoint3Vector
     (This  : IDAStatics_Type;
      p_0   : Pointer_To_IDAPoint3;
      v_1   : Pointer_To_IDAVector3)
     return Pointer_To_IDAPoint3;

   function SubPoint3Vector
     (This  : IDAStatics_Type;
      p_0   : Pointer_To_IDAPoint3;
      v_1   : Pointer_To_IDAVector3)
     return Pointer_To_IDAPoint3;

   function SubPoint3
     (This  : IDAStatics_Type;
      p1_0  : Pointer_To_IDAPoint3;
      p2_1  : Pointer_To_IDAPoint3)
     return Pointer_To_IDAVector3;

   function DistancePoint3
     (This  : IDAStatics_Type;
      p_0   : Pointer_To_IDAPoint3;
      q_1   : Pointer_To_IDAPoint3)
     return Pointer_To_IDANumber;

   function DistanceSquaredPoint3
     (This  : IDAStatics_Type;
      p_0   : Pointer_To_IDAPoint3;
      q_1   : Pointer_To_IDAPoint3)
     return Pointer_To_IDANumber;

   function Get_IdentityTransform3
     (This  : IDAStatics_Type)
     return Pointer_To_IDATransform3;

   function Translate3Anim
     (This  : IDAStatics_Type;
      tx_0  : Pointer_To_IDANumber;
      ty_1  : Pointer_To_IDANumber;
      tz_2  : Pointer_To_IDANumber)
     return Pointer_To_IDATransform3;

   function Translate3
     (This  : IDAStatics_Type;
      tx_0  : Interfaces.C.double;
      ty_1  : Interfaces.C.double;
      tz_2  : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function Translate3Rate
     (This  : IDAStatics_Type;
      tx_0  : Interfaces.C.double;
      ty_1  : Interfaces.C.double;
      tz_2  : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function Translate3Vector
     (This    : IDAStatics_Type;
      delta_0 : Pointer_To_IDAVector3)
     return Pointer_To_IDATransform3;

   function Translate3Point
     (This         : IDAStatics_Type;
      new_origin_0 : Pointer_To_IDAPoint3)
     return Pointer_To_IDATransform3;

   function Scale3Anim
     (This  : IDAStatics_Type;
      x_0   : Pointer_To_IDANumber;
      y_1   : Pointer_To_IDANumber;
      z_2   : Pointer_To_IDANumber)
     return Pointer_To_IDATransform3;

   function Scale3
     (This  : IDAStatics_Type;
      x_0   : Interfaces.C.double;
      y_1   : Interfaces.C.double;
      z_2   : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function Scale3Rate
     (This  : IDAStatics_Type;
      x_0   : Interfaces.C.double;
      y_1   : Interfaces.C.double;
      z_2   : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function Scale3Vector
     (This        : IDAStatics_Type;
      scale_vec_0 : Pointer_To_IDAVector3)
     return Pointer_To_IDATransform3;

   function Scale3UniformAnim
     (This            : IDAStatics_Type;
      uniform_scale_0 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform3;

   function Scale3Uniform
     (This            : IDAStatics_Type;
      uniform_scale_0 : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function Scale3UniformRate
     (This            : IDAStatics_Type;
      uniform_scale_0 : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function Rotate3Anim
     (This    : IDAStatics_Type;
      axis_0  : Pointer_To_IDAVector3;
      angle_1 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform3;

   function Rotate3
     (This    : IDAStatics_Type;
      axis_0  : Pointer_To_IDAVector3;
      angle_1 : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function Rotate3Rate
     (This    : IDAStatics_Type;
      axis_0  : Pointer_To_IDAVector3;
      angle_1 : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function Rotate3Degrees
     (This    : IDAStatics_Type;
      axis_0  : Pointer_To_IDAVector3;
      angle_1 : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function Rotate3RateDegrees
     (This    : IDAStatics_Type;
      axis_0  : Pointer_To_IDAVector3;
      angle_1 : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function XShear3Anim
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDANumber;
      b_1   : Pointer_To_IDANumber)
     return Pointer_To_IDATransform3;

   function XShear3
     (This  : IDAStatics_Type;
      a_0   : Interfaces.C.double;
      b_1   : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function XShear3Rate
     (This  : IDAStatics_Type;
      a_0   : Interfaces.C.double;
      b_1   : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function YShear3Anim
     (This  : IDAStatics_Type;
      c_0   : Pointer_To_IDANumber;
      d_1   : Pointer_To_IDANumber)
     return Pointer_To_IDATransform3;

   function YShear3
     (This  : IDAStatics_Type;
      c_0   : Interfaces.C.double;
      d_1   : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function YShear3Rate
     (This  : IDAStatics_Type;
      c_0   : Interfaces.C.double;
      d_1   : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function ZShear3Anim
     (This  : IDAStatics_Type;
      e_0   : Pointer_To_IDANumber;
      f_1   : Pointer_To_IDANumber)
     return Pointer_To_IDATransform3;

   function ZShear3
     (This  : IDAStatics_Type;
      e_0   : Interfaces.C.double;
      f_1   : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function ZShear3Rate
     (This  : IDAStatics_Type;
      e_0   : Interfaces.C.double;
      f_1   : Interfaces.C.double)
     return Pointer_To_IDATransform3;

   function Transform4x4AnimEx
     (This    : IDAStatics_Type;
      m_0size : Interfaces.C.long;
      m_0     : Pointer_To_Pointer_To_IDANumber)
     return Pointer_To_IDATransform3;

   function Transform4x4Anim
     (This  : IDAStatics_Type;
      m_0   : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return Pointer_To_IDATransform3;

   function Compose3
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDATransform3;
      b_1   : Pointer_To_IDATransform3)
     return Pointer_To_IDATransform3;

   function Compose3ArrayEx
     (This      : IDAStatics_Type;
      xfs_0size : Interfaces.C.long;
      xfs_0     : Pointer_To_Pointer_To_IDATransform3)
     return Pointer_To_IDATransform3;

   function Compose3Array
     (This  : IDAStatics_Type;
      xfs_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return Pointer_To_IDATransform3;

   function LookAtFrom
     (This   : IDAStatics_Type;
      to_0   : Pointer_To_IDAPoint3;
      from_1 : Pointer_To_IDAPoint3;
      up_2   : Pointer_To_IDAVector3)
     return Pointer_To_IDATransform3;

   function Get_IdentityTransform2
     (This  : IDAStatics_Type)
     return Pointer_To_IDATransform2;

   function Translate2Anim
     (This  : IDAStatics_Type;
      tx_0  : Pointer_To_IDANumber;
      ty_1  : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function Translate2
     (This  : IDAStatics_Type;
      tx_0  : Interfaces.C.double;
      ty_1  : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function Translate2Rate
     (This  : IDAStatics_Type;
      tx_0  : Interfaces.C.double;
      ty_1  : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function Translate2Vector
     (This    : IDAStatics_Type;
      delta_0 : Pointer_To_IDAVector2)
     return Pointer_To_IDATransform2;

   function Translate2Point
     (This  : IDAStatics_Type;
      pos_0 : Pointer_To_IDAPoint2)
     return Pointer_To_IDATransform2;

   function Scale2Anim
     (This  : IDAStatics_Type;
      x_0   : Pointer_To_IDANumber;
      y_1   : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function Scale2
     (This  : IDAStatics_Type;
      x_0   : Interfaces.C.double;
      y_1   : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function Scale2Rate
     (This  : IDAStatics_Type;
      x_0   : Interfaces.C.double;
      y_1   : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function Scale2Vector2
     (This             : IDAStatics_Type;
      obsoleteMethod_0 : Pointer_To_IDAVector2)
     return Pointer_To_IDATransform2;

   function Scale2Vector
     (This        : IDAStatics_Type;
      scale_vec_0 : Pointer_To_IDAVector2)
     return Pointer_To_IDATransform2;

   function Scale2UniformAnim
     (This            : IDAStatics_Type;
      uniform_scale_0 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function Scale2Uniform
     (This            : IDAStatics_Type;
      uniform_scale_0 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function Scale2UniformRate
     (This            : IDAStatics_Type;
      uniform_scale_0 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function Rotate2Anim
     (This    : IDAStatics_Type;
      angle_0 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function Rotate2
     (This    : IDAStatics_Type;
      angle_0 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function Rotate2Rate
     (This    : IDAStatics_Type;
      angle_0 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function Rotate2Degrees
     (This    : IDAStatics_Type;
      angle_0 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function Rotate2RateDegrees
     (This    : IDAStatics_Type;
      angle_0 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function XShear2Anim
     (This  : IDAStatics_Type;
      arg_0 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function XShear2
     (This  : IDAStatics_Type;
      arg_0 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function XShear2Rate
     (This  : IDAStatics_Type;
      arg_0 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function YShear2Anim
     (This  : IDAStatics_Type;
      arg_0 : Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function YShear2
     (This  : IDAStatics_Type;
      arg_0 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function YShear2Rate
     (This  : IDAStatics_Type;
      arg_0 : Interfaces.C.double)
     return Pointer_To_IDATransform2;

   function Transform3x2AnimEx
     (This    : IDAStatics_Type;
      m_0size : Interfaces.C.long;
      m_0     : Pointer_To_Pointer_To_IDANumber)
     return Pointer_To_IDATransform2;

   function Transform3x2Anim
     (This  : IDAStatics_Type;
      m_0   : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return Pointer_To_IDATransform2;

   function Compose2
     (This  : IDAStatics_Type;
      a_0   : Pointer_To_IDATransform2;
      b_1   : Pointer_To_IDATransform2)
     return Pointer_To_IDATransform2;

   function Compose2ArrayEx
     (This      : IDAStatics_Type;
      xfs_0size : Interfaces.C.long;
      xfs_0     : Pointer_To_Pointer_To_IDATransform2)
     return Pointer_To_IDATransform2;

   function Compose2Array
     (This  : IDAStatics_Type;
      xfs_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return Pointer_To_IDATransform2;

   function Tuple
     (This      : IDAStatics_Type;
      obsolete1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return Pointer_To_IDATuple;
   --  Obsolete method: Use DATuple instead

   function uArray
     (This      : IDAStatics_Type;
      obsolete1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return Pointer_To_IDAArray;
   --  Obsolete method: Use DAArray instead

   function Get_AreBlockingImportsComplete
     (This      : IDAStatics_Type)
     return GNATCOM.Types.VARIANT_BOOL;

end StructuredGraphicControl.IDAStatics_Interface;

