package body StructuredGraphicControl.IDAStatics_Object is

   function Get_VersionString
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_VersionString);
   end Get_VersionString;

   function Get_Site
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Site);
   end Get_Site;

   procedure Put_Site
     (This : IDAStatics_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDAStatics_Put_Site,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_Site;

   procedure Put_ClientSite
     (This : IDAStatics_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDAStatics_Put_ClientSite,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_ClientSite;

   function Get_ClientSite
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_ClientSite);
   end Get_ClientSite;

   procedure Put_PixelConstructionMode
     (This : IDAStatics_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDAStatics_Put_PixelConstructionMode,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_PixelConstructionMode;

   function Get_PixelConstructionMode
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_PixelConstructionMode);
   end Get_PixelConstructionMode;

   procedure TriggerEvent
     (This  : IDAStatics_Type;
      event : GNATCOM.Types.VARIANT;
      Data  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAStatics_TriggerEvent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Data,
          2 => event),
         Free);
   end TriggerEvent;

   function NewDrawingSurface
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAStatics_NewDrawingSurface);
   end NewDrawingSurface;

   function ImportMovie
     (This : IDAStatics_Type;
      url  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportMovie,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => url),
         Free);
   end ImportMovie;

   function ImportMovieAsync
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.VARIANT;
      pImageStandIn : GNATCOM.Types.VARIANT;
      pSoundStandIn : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportMovieAsync,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pSoundStandIn,
          2 => pImageStandIn,
          3 => url),
         Free);
   end ImportMovieAsync;

   function ImportImage
     (This : IDAStatics_Type;
      url  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportImage,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => url),
         Free);
   end ImportImage;

   function ImportImageAsync
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.VARIANT;
      pImageStandIn : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportImageAsync,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pImageStandIn,
          2 => url),
         Free);
   end ImportImageAsync;

   function ImportImageColorKey
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.VARIANT;
      colorKeyRed   : GNATCOM.Types.VARIANT;
      colorKeyGreen : GNATCOM.Types.VARIANT;
      colorKeyBlue  : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportImageColorKey,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => colorKeyBlue,
          2 => colorKeyGreen,
          3 => colorKeyRed,
          4 => url),
         Free);
   end ImportImageColorKey;

   function ImportImageAsyncColorKey
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.VARIANT;
      pImageStandIn : GNATCOM.Types.VARIANT;
      colorKeyRed   : GNATCOM.Types.VARIANT;
      colorKeyGreen : GNATCOM.Types.VARIANT;
      colorKeyBlue  : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportImageAsyncColorKey,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => colorKeyBlue,
          2 => colorKeyGreen,
          3 => colorKeyRed,
          4 => pImageStandIn,
          5 => url),
         Free);
   end ImportImageAsyncColorKey;

   function ImportSound
     (This : IDAStatics_Type;
      url  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportSound,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => url),
         Free);
   end ImportSound;

   function ImportSoundAsync
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.VARIANT;
      pSoundStandIn : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportSoundAsync,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pSoundStandIn,
          2 => url),
         Free);
   end ImportSoundAsync;

   function ImportGeometry
     (This : IDAStatics_Type;
      url  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportGeometry,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => url),
         Free);
   end ImportGeometry;

   function ImportGeometryAsync
     (This        : IDAStatics_Type;
      url         : GNATCOM.Types.VARIANT;
      pGeoStandIn : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportGeometryAsync,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pGeoStandIn,
          2 => url),
         Free);
   end ImportGeometryAsync;

   function ImportDirectDrawSurface
     (This        : IDAStatics_Type;
      dds         : GNATCOM.Types.VARIANT;
      updateEvent : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImportDirectDrawSurface,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => updateEvent,
          2 => dds),
         Free);
   end ImportDirectDrawSurface;

   function Cond
     (This : IDAStatics_Type;
      c    : GNATCOM.Types.VARIANT;
      i    : GNATCOM.Types.VARIANT;
      e    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Cond,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => e,
          2 => i,
          3 => c),
         Free);
   end Cond;

   function DAArrayEx
     (This  : IDAStatics_Type;
      s     : GNATCOM.Types.VARIANT;
      pBvrs : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DAArrayEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pBvrs,
          2 => s),
         Free);
   end DAArrayEx;

   function DAArray
     (This : IDAStatics_Type;
      bvrs : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DAArray,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bvrs),
         Free);
   end DAArray;

   function DATupleEx
     (This  : IDAStatics_Type;
      s     : GNATCOM.Types.VARIANT;
      pBvrs : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DATupleEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pBvrs,
          2 => s),
         Free);
   end DATupleEx;

   function DATuple
     (This : IDAStatics_Type;
      bvrs : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DATuple,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bvrs),
         Free);
   end DATuple;

   function ModifiableBehavior
     (This : IDAStatics_Type;
      orig : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ModifiableBehavior,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => orig),
         Free);
   end ModifiableBehavior;

   function UninitializedArray
     (This    : IDAStatics_Type;
      typeTmp : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_UninitializedArray,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => typeTmp),
         Free);
   end UninitializedArray;

   function UninitializedTuple
     (This    : IDAStatics_Type;
      typeTmp : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_UninitializedTuple,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => typeTmp),
         Free);
   end UninitializedTuple;

   function NumberBSplineEx
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      numKnots  : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      numPts    : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      numWts    : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_NumberBSplineEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => evaluator,
          2 => weights,
          3 => numWts,
          4 => ctrlPts,
          5 => numPts,
          6 => knots,
          7 => numKnots,
          8 => degree),
         Free);
   end NumberBSplineEx;

   function NumberBSpline
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_NumberBSpline,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => evaluator,
          2 => weights,
          3 => ctrlPts,
          4 => knots,
          5 => degree),
         Free);
   end NumberBSpline;

   function Point2BSplineEx
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      numKnots  : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      numPts    : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      numWts    : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point2BSplineEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => evaluator,
          2 => weights,
          3 => numWts,
          4 => ctrlPts,
          5 => numPts,
          6 => knots,
          7 => numKnots,
          8 => degree),
         Free);
   end Point2BSplineEx;

   function Point2BSpline
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point2BSpline,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => evaluator,
          2 => weights,
          3 => ctrlPts,
          4 => knots,
          5 => degree),
         Free);
   end Point2BSpline;

   function Point3BSplineEx
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      numKnots  : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      numPts    : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      numWts    : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point3BSplineEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => evaluator,
          2 => weights,
          3 => numWts,
          4 => ctrlPts,
          5 => numPts,
          6 => knots,
          7 => numKnots,
          8 => degree),
         Free);
   end Point3BSplineEx;

   function Point3BSpline
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point3BSpline,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => evaluator,
          2 => weights,
          3 => ctrlPts,
          4 => knots,
          5 => degree),
         Free);
   end Point3BSpline;

   function Vector2BSplineEx
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      numKnots  : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      numPts    : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      numWts    : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector2BSplineEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => evaluator,
          2 => weights,
          3 => numWts,
          4 => ctrlPts,
          5 => numPts,
          6 => knots,
          7 => numKnots,
          8 => degree),
         Free);
   end Vector2BSplineEx;

   function Vector2BSpline
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector2BSpline,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => evaluator,
          2 => weights,
          3 => ctrlPts,
          4 => knots,
          5 => degree),
         Free);
   end Vector2BSpline;

   function Vector3BSplineEx
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      numKnots  : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      numPts    : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      numWts    : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector3BSplineEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => evaluator,
          2 => weights,
          3 => numWts,
          4 => ctrlPts,
          5 => numPts,
          6 => knots,
          7 => numKnots,
          8 => degree),
         Free);
   end Vector3BSplineEx;

   function Vector3BSpline
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector3BSpline,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => evaluator,
          2 => weights,
          3 => ctrlPts,
          4 => knots,
          5 => degree),
         Free);
   end Vector3BSpline;

   function Pow
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Pow,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end Pow;

   function uAbs
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_uAbs,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end uAbs;

   function Sqrt
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Sqrt,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Sqrt;

   function Floor
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Floor,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Floor;

   function Round
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Round,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Round;

   function Ceiling
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Ceiling,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Ceiling;

   function Asin
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Asin,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Asin;

   function Acos
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Acos,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Acos;

   function Atan
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Atan,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Atan;

   function Sin
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Sin,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Sin;

   function Cos
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Cos,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Cos;

   function Tan
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Tan,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Tan;

   function Exp
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Exp,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Exp;

   function Ln
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Ln,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Ln;

   function Log10
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Log10,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Log10;

   function ToDegrees
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ToDegrees,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end ToDegrees;

   function ToRadians
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ToRadians,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end ToRadians;

   function uMod
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_uMod,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end uMod;

   function Atan2
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Atan2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end Atan2;

   function Add
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Add,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end Add;

   function Sub
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Sub,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end Sub;

   function Mul
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Mul,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end Mul;

   function Div
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Div,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end Div;

   function LT
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_LT,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end LT;

   function LTE
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_LTE,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end LTE;

   function GT
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_GT,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end GT;

   function GTE
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_GTE,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end GTE;

   function EQ
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_EQ,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end EQ;

   function NE
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_NE,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end NE;

   function Neg
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Neg,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end Neg;

   function InterpolateAnim
     (This       : IDAStatics_Type;
      from_0     : GNATCOM.Types.VARIANT;
      to_1       : GNATCOM.Types.VARIANT;
      duration_2 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_InterpolateAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => duration_2,
          2 => to_1,
          3 => from_0),
         Free);
   end InterpolateAnim;

   function Interpolate
     (This       : IDAStatics_Type;
      from_0     : GNATCOM.Types.VARIANT;
      to_1       : GNATCOM.Types.VARIANT;
      duration_2 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Interpolate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => duration_2,
          2 => to_1,
          3 => from_0),
         Free);
   end Interpolate;

   function SlowInSlowOutAnim
     (This        : IDAStatics_Type;
      from_0      : GNATCOM.Types.VARIANT;
      to_1        : GNATCOM.Types.VARIANT;
      duration_2  : GNATCOM.Types.VARIANT;
      sharpness_3 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SlowInSlowOutAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => sharpness_3,
          2 => duration_2,
          3 => to_1,
          4 => from_0),
         Free);
   end SlowInSlowOutAnim;

   function SlowInSlowOut
     (This        : IDAStatics_Type;
      from_0      : GNATCOM.Types.VARIANT;
      to_1        : GNATCOM.Types.VARIANT;
      duration_2  : GNATCOM.Types.VARIANT;
      sharpness_3 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SlowInSlowOut,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => sharpness_3,
          2 => duration_2,
          3 => to_1,
          4 => from_0),
         Free);
   end SlowInSlowOut;

   function SoundSource
     (This  : IDAStatics_Type;
      snd_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SoundSource,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => snd_0),
         Free);
   end SoundSource;

   function Mix
     (This    : IDAStatics_Type;
      left_0  : GNATCOM.Types.VARIANT;
      right_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Mix,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => right_1,
          2 => left_0),
         Free);
   end Mix;

   function uAnd
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_uAnd,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end uAnd;

   function uOr
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_uOr,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end uOr;

   function uNot
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_uNot,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => a_0),
         Free);
   end uNot;

   function Integral
     (This : IDAStatics_Type;
      b_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Integral,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_0),
         Free);
   end Integral;

   function Derivative
     (This : IDAStatics_Type;
      b_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Derivative,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_0),
         Free);
   end Derivative;

   function IntegralVector2
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_IntegralVector2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_0),
         Free);
   end IntegralVector2;

   function IntegralVector3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_IntegralVector3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_0),
         Free);
   end IntegralVector3;

   function DerivativeVector2
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DerivativeVector2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_0),
         Free);
   end DerivativeVector2;

   function DerivativeVector3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DerivativeVector3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_0),
         Free);
   end DerivativeVector3;

   function DerivativePoint2
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DerivativePoint2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_0),
         Free);
   end DerivativePoint2;

   function DerivativePoint3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DerivativePoint3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_0),
         Free);
   end DerivativePoint3;

   function KeyState
     (This : IDAStatics_Type;
      n_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_KeyState,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => n_0),
         Free);
   end KeyState;

   function KeyUp
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_KeyUp,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arg_0),
         Free);
   end KeyUp;

   function KeyDown
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_KeyDown,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arg_0),
         Free);
   end KeyDown;

   function DANumber
     (This  : IDAStatics_Type;
      num_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DANumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => num_0),
         Free);
   end DANumber;

   function DAString
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DAString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => str_0),
         Free);
   end DAString;

   function DABoolean
     (This  : IDAStatics_Type;
      num_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DABoolean,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => num_0),
         Free);
   end DABoolean;

   function SeededRandom
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SeededRandom,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arg_0),
         Free);
   end SeededRandom;

   function Get_MousePosition
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_MousePosition);
   end Get_MousePosition;

   function Get_LeftButtonState
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_LeftButtonState);
   end Get_LeftButtonState;

   function Get_RightButtonState
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_RightButtonState);
   end Get_RightButtonState;

   function Get_DATrue
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_DATrue);
   end Get_DATrue;

   function Get_DAFalse
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_DAFalse);
   end Get_DAFalse;

   function Get_LocalTime
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_LocalTime);
   end Get_LocalTime;

   function Get_GlobalTime
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_GlobalTime);
   end Get_GlobalTime;

   function Get_Pixel
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Pixel);
   end Get_Pixel;

   function UserData
     (This   : IDAStatics_Type;
      data_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_UserData,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => data_0),
         Free);
   end UserData;

   function UntilNotify
     (This       : IDAStatics_Type;
      b0_0       : GNATCOM.Types.VARIANT;
      event_1    : GNATCOM.Types.VARIANT;
      notifier_2 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_UntilNotify,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier_2,
          2 => event_1,
          3 => b0_0),
         Free);
   end UntilNotify;

   function uUntil
     (This    : IDAStatics_Type;
      b0_0    : GNATCOM.Types.VARIANT;
      event_1 : GNATCOM.Types.VARIANT;
      b1_2    : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_uUntil,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b1_2,
          2 => event_1,
          3 => b0_0),
         Free);
   end uUntil;

   function UntilEx
     (This    : IDAStatics_Type;
      b0_0    : GNATCOM.Types.VARIANT;
      event_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_UntilEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => event_1,
          2 => b0_0),
         Free);
   end UntilEx;

   function Sequence
     (This : IDAStatics_Type;
      s1_0 : GNATCOM.Types.VARIANT;
      s2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Sequence,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => s2_1,
          2 => s1_0),
         Free);
   end Sequence;

   function FollowPath
     (This       : IDAStatics_Type;
      path_0     : GNATCOM.Types.VARIANT;
      duration_1 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FollowPath,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => duration_1,
          2 => path_0),
         Free);
   end FollowPath;

   function FollowPathAngle
     (This       : IDAStatics_Type;
      path_0     : GNATCOM.Types.VARIANT;
      duration_1 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FollowPathAngle,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => duration_1,
          2 => path_0),
         Free);
   end FollowPathAngle;

   function FollowPathAngleUpright
     (This       : IDAStatics_Type;
      path_0     : GNATCOM.Types.VARIANT;
      duration_1 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FollowPathAngleUpright,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => duration_1,
          2 => path_0),
         Free);
   end FollowPathAngleUpright;

   function FollowPathEval
     (This   : IDAStatics_Type;
      path_0 : GNATCOM.Types.VARIANT;
      eval_1 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FollowPathEval,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => eval_1,
          2 => path_0),
         Free);
   end FollowPathEval;

   function FollowPathAngleEval
     (This   : IDAStatics_Type;
      path_0 : GNATCOM.Types.VARIANT;
      eval_1 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FollowPathAngleEval,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => eval_1,
          2 => path_0),
         Free);
   end FollowPathAngleEval;

   function FollowPathAngleUprightEval
     (This   : IDAStatics_Type;
      path_0 : GNATCOM.Types.VARIANT;
      eval_1 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FollowPathAngleUprightEval,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => eval_1,
          2 => path_0),
         Free);
   end FollowPathAngleUprightEval;

   function FollowPathAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.VARIANT;
      obsoleted2_1 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FollowPathAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsoleted2_1,
          2 => obsoleted1_0),
         Free);
   end FollowPathAnim;

   function FollowPathAngleAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.VARIANT;
      obsoleted2_1 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FollowPathAngleAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsoleted2_1,
          2 => obsoleted1_0),
         Free);
   end FollowPathAngleAnim;

   function FollowPathAngleUprightAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.VARIANT;
      obsoleted2_1 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FollowPathAngleUprightAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsoleted2_1,
          2 => obsoleted1_0),
         Free);
   end FollowPathAngleUprightAnim;

   function ConcatString
     (This : IDAStatics_Type;
      s1_0 : GNATCOM.Types.VARIANT;
      s2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ConcatString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => s2_1,
          2 => s1_0),
         Free);
   end ConcatString;

   function PerspectiveCamera
     (This        : IDAStatics_Type;
      focalDist_0 : GNATCOM.Types.VARIANT;
      nearClip_1  : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_PerspectiveCamera,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => nearClip_1,
          2 => focalDist_0),
         Free);
   end PerspectiveCamera;

   function PerspectiveCameraAnim
     (This        : IDAStatics_Type;
      focalDist_0 : GNATCOM.Types.VARIANT;
      nearClip_1  : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_PerspectiveCameraAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => nearClip_1,
          2 => focalDist_0),
         Free);
   end PerspectiveCameraAnim;

   function ParallelCamera
     (This       : IDAStatics_Type;
      nearClip_0 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ParallelCamera,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => nearClip_0),
         Free);
   end ParallelCamera;

   function ParallelCameraAnim
     (This       : IDAStatics_Type;
      nearClip_0 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ParallelCameraAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => nearClip_0),
         Free);
   end ParallelCameraAnim;

   function ColorRgbAnim
     (This    : IDAStatics_Type;
      red_0   : GNATCOM.Types.VARIANT;
      green_1 : GNATCOM.Types.VARIANT;
      blue_2  : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ColorRgbAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => blue_2,
          2 => green_1,
          3 => red_0),
         Free);
   end ColorRgbAnim;

   function ColorRgb
     (This    : IDAStatics_Type;
      red_0   : GNATCOM.Types.VARIANT;
      green_1 : GNATCOM.Types.VARIANT;
      blue_2  : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ColorRgb,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => blue_2,
          2 => green_1,
          3 => red_0),
         Free);
   end ColorRgb;

   function ColorRgb255
     (This    : IDAStatics_Type;
      red_0   : GNATCOM.Types.VARIANT;
      green_1 : GNATCOM.Types.VARIANT;
      blue_2  : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ColorRgb255,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => blue_2,
          2 => green_1,
          3 => red_0),
         Free);
   end ColorRgb255;

   function ColorHsl
     (This         : IDAStatics_Type;
      hue_0        : GNATCOM.Types.VARIANT;
      saturation_1 : GNATCOM.Types.VARIANT;
      lum_2        : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ColorHsl,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => lum_2,
          2 => saturation_1,
          3 => hue_0),
         Free);
   end ColorHsl;

   function ColorHslAnim
     (This         : IDAStatics_Type;
      hue_0        : GNATCOM.Types.VARIANT;
      saturation_1 : GNATCOM.Types.VARIANT;
      lum_2        : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ColorHslAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => lum_2,
          2 => saturation_1,
          3 => hue_0),
         Free);
   end ColorHslAnim;

   function Get_Red
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Red);
   end Get_Red;

   function Get_Green
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Green);
   end Get_Green;

   function Get_Blue
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Blue);
   end Get_Blue;

   function Get_Cyan
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Cyan);
   end Get_Cyan;

   function Get_Magenta
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Magenta);
   end Get_Magenta;

   function Get_Yellow
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Yellow);
   end Get_Yellow;

   function Get_Black
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Black);
   end Get_Black;

   function Get_White
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_White);
   end Get_White;

   function Get_Aqua
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Aqua);
   end Get_Aqua;

   function Get_Fuchsia
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Fuchsia);
   end Get_Fuchsia;

   function Get_Gray
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Gray);
   end Get_Gray;

   function Get_Lime
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Lime);
   end Get_Lime;

   function Get_Maroon
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Maroon);
   end Get_Maroon;

   function Get_Navy
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Navy);
   end Get_Navy;

   function Get_Olive
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Olive);
   end Get_Olive;

   function Get_Purple
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Purple);
   end Get_Purple;

   function Get_Silver
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Silver);
   end Get_Silver;

   function Get_Teal
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Teal);
   end Get_Teal;

   function Predicate
     (This : IDAStatics_Type;
      b_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Predicate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_0),
         Free);
   end Predicate;

   function NotEvent
     (This    : IDAStatics_Type;
      event_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_NotEvent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => event_0),
         Free);
   end NotEvent;

   function AndEvent
     (This : IDAStatics_Type;
      e1_0 : GNATCOM.Types.VARIANT;
      e2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_AndEvent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => e2_1,
          2 => e1_0),
         Free);
   end AndEvent;

   function OrEvent
     (This : IDAStatics_Type;
      e1_0 : GNATCOM.Types.VARIANT;
      e2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_OrEvent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => e2_1,
          2 => e1_0),
         Free);
   end OrEvent;

   function ThenEvent
     (This : IDAStatics_Type;
      e1_0 : GNATCOM.Types.VARIANT;
      e2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ThenEvent,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => e2_1,
          2 => e1_0),
         Free);
   end ThenEvent;

   function Get_LeftButtonDown
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_LeftButtonDown);
   end Get_LeftButtonDown;

   function Get_LeftButtonUp
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_LeftButtonUp);
   end Get_LeftButtonUp;

   function Get_RightButtonDown
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_RightButtonDown);
   end Get_RightButtonDown;

   function Get_RightButtonUp
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_RightButtonUp);
   end Get_RightButtonUp;

   function Get_Always
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Always);
   end Get_Always;

   function Get_Never
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Never);
   end Get_Never;

   function TimerAnim
     (This : IDAStatics_Type;
      n_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_TimerAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => n_0),
         Free);
   end TimerAnim;

   function Timer
     (This : IDAStatics_Type;
      n_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Timer,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => n_0),
         Free);
   end Timer;

   function AppTriggeredEvent
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAStatics_AppTriggeredEvent);
   end AppTriggeredEvent;

   function ScriptCallback
     (This        : IDAStatics_Type;
      obsolete1_0 : GNATCOM.Types.VARIANT;
      obsolete2_1 : GNATCOM.Types.VARIANT;
      obsolete3_2 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ScriptCallback,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsolete3_2,
          2 => obsolete2_1,
          3 => obsolete1_0),
         Free);
   end ScriptCallback;

   function Get_EmptyGeometry
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_EmptyGeometry);
   end Get_EmptyGeometry;

   function UnionGeometry
     (This : IDAStatics_Type;
      g1_0 : GNATCOM.Types.VARIANT;
      g2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_UnionGeometry,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => g2_1,
          2 => g1_0),
         Free);
   end UnionGeometry;

   function UnionGeometryArrayEx
     (This       : IDAStatics_Type;
      imgs_0size : GNATCOM.Types.VARIANT;
      imgs_0     : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_UnionGeometryArrayEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => imgs_0,
          2 => imgs_0size),
         Free);
   end UnionGeometryArrayEx;

   function UnionGeometryArray
     (This   : IDAStatics_Type;
      imgs_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_UnionGeometryArray,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => imgs_0),
         Free);
   end UnionGeometryArray;

   function Get_EmptyImage
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_EmptyImage);
   end Get_EmptyImage;

   function Get_DetectableEmptyImage
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_DetectableEmptyImage);
   end Get_DetectableEmptyImage;

   function SolidColorImage
     (This  : IDAStatics_Type;
      col_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SolidColorImage,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => col_0),
         Free);
   end SolidColorImage;

   function GradientPolygonEx
     (This         : IDAStatics_Type;
      points_0size : GNATCOM.Types.VARIANT;
      points_0     : GNATCOM.Types.VARIANT;
      colors_1size : GNATCOM.Types.VARIANT;
      colors_1     : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_GradientPolygonEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => colors_1,
          2 => colors_1size,
          3 => points_0,
          4 => points_0size),
         Free);
   end GradientPolygonEx;

   function GradientPolygon
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      colors_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_GradientPolygon,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => colors_1,
          2 => points_0),
         Free);
   end GradientPolygon;

   function RadialGradientPolygonEx
     (This         : IDAStatics_Type;
      inner_0      : GNATCOM.Types.VARIANT;
      outer_1      : GNATCOM.Types.VARIANT;
      points_2size : GNATCOM.Types.VARIANT;
      points_2     : GNATCOM.Types.VARIANT;
      fallOff_3    : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RadialGradientPolygonEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fallOff_3,
          2 => points_2,
          3 => points_2size,
          4 => outer_1,
          5 => inner_0),
         Free);
   end RadialGradientPolygonEx;

   function RadialGradientPolygon
     (This      : IDAStatics_Type;
      inner_0   : GNATCOM.Types.VARIANT;
      outer_1   : GNATCOM.Types.VARIANT;
      points_2  : GNATCOM.Types.VARIANT;
      fallOff_3 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RadialGradientPolygon,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fallOff_3,
          2 => points_2,
          3 => outer_1,
          4 => inner_0),
         Free);
   end RadialGradientPolygon;

   function RadialGradientPolygonAnimEx
     (This         : IDAStatics_Type;
      inner_0      : GNATCOM.Types.VARIANT;
      outer_1      : GNATCOM.Types.VARIANT;
      points_2size : GNATCOM.Types.VARIANT;
      points_2     : GNATCOM.Types.VARIANT;
      fallOff_3    : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RadialGradientPolygonAnimEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fallOff_3,
          2 => points_2,
          3 => points_2size,
          4 => outer_1,
          5 => inner_0),
         Free);
   end RadialGradientPolygonAnimEx;

   function RadialGradientPolygonAnim
     (This      : IDAStatics_Type;
      inner_0   : GNATCOM.Types.VARIANT;
      outer_1   : GNATCOM.Types.VARIANT;
      points_2  : GNATCOM.Types.VARIANT;
      fallOff_3 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RadialGradientPolygonAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fallOff_3,
          2 => points_2,
          3 => outer_1,
          4 => inner_0),
         Free);
   end RadialGradientPolygonAnim;

   function GradientSquare
     (This         : IDAStatics_Type;
      lowerLeft_0  : GNATCOM.Types.VARIANT;
      upperLeft_1  : GNATCOM.Types.VARIANT;
      upperRight_2 : GNATCOM.Types.VARIANT;
      lowerRight_3 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_GradientSquare,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => lowerRight_3,
          2 => upperRight_2,
          3 => upperLeft_1,
          4 => lowerLeft_0),
         Free);
   end GradientSquare;

   function RadialGradientSquare
     (This      : IDAStatics_Type;
      inner_0   : GNATCOM.Types.VARIANT;
      outer_1   : GNATCOM.Types.VARIANT;
      fallOff_2 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RadialGradientSquare,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fallOff_2,
          2 => outer_1,
          3 => inner_0),
         Free);
   end RadialGradientSquare;

   function RadialGradientSquareAnim
     (This      : IDAStatics_Type;
      inner_0   : GNATCOM.Types.VARIANT;
      outer_1   : GNATCOM.Types.VARIANT;
      fallOff_2 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RadialGradientSquareAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fallOff_2,
          2 => outer_1,
          3 => inner_0),
         Free);
   end RadialGradientSquareAnim;

   function RadialGradientRegularPoly
     (This       : IDAStatics_Type;
      inner_0    : GNATCOM.Types.VARIANT;
      outer_1    : GNATCOM.Types.VARIANT;
      numEdges_2 : GNATCOM.Types.VARIANT;
      fallOff_3  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RadialGradientRegularPoly,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fallOff_3,
          2 => numEdges_2,
          3 => outer_1,
          4 => inner_0),
         Free);
   end RadialGradientRegularPoly;

   function RadialGradientRegularPolyAnim
     (This       : IDAStatics_Type;
      inner_0    : GNATCOM.Types.VARIANT;
      outer_1    : GNATCOM.Types.VARIANT;
      numEdges_2 : GNATCOM.Types.VARIANT;
      fallOff_3  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RadialGradientRegularPolyAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fallOff_3,
          2 => numEdges_2,
          3 => outer_1,
          4 => inner_0),
         Free);
   end RadialGradientRegularPolyAnim;

   function GradientHorizontal
     (This      : IDAStatics_Type;
      start_0   : GNATCOM.Types.VARIANT;
      stop_1    : GNATCOM.Types.VARIANT;
      fallOff_2 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_GradientHorizontal,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fallOff_2,
          2 => stop_1,
          3 => start_0),
         Free);
   end GradientHorizontal;

   function GradientHorizontalAnim
     (This      : IDAStatics_Type;
      start_0   : GNATCOM.Types.VARIANT;
      stop_1    : GNATCOM.Types.VARIANT;
      fallOff_2 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_GradientHorizontalAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fallOff_2,
          2 => stop_1,
          3 => start_0),
         Free);
   end GradientHorizontalAnim;

   function HatchHorizontal
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchHorizontal,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchHorizontal;

   function HatchHorizontalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchHorizontalAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchHorizontalAnim;

   function HatchVertical
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchVertical,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchVertical;

   function HatchVerticalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchVerticalAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchVerticalAnim;

   function HatchForwardDiagonal
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchForwardDiagonal,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchForwardDiagonal;

   function HatchForwardDiagonalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchForwardDiagonalAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchForwardDiagonalAnim;

   function HatchBackwardDiagonal
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchBackwardDiagonal,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchBackwardDiagonal;

   function HatchBackwardDiagonalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchBackwardDiagonalAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchBackwardDiagonalAnim;

   function HatchCross
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchCross,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchCross;

   function HatchCrossAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchCrossAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchCrossAnim;

   function HatchDiagonalCross
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchDiagonalCross,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchDiagonalCross;

   function HatchDiagonalCrossAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_HatchDiagonalCrossAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => spacing_1,
          2 => lineClr_0),
         Free);
   end HatchDiagonalCrossAnim;

   function Overlay
     (This     : IDAStatics_Type;
      top_0    : GNATCOM.Types.VARIANT;
      bottom_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Overlay,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bottom_1,
          2 => top_0),
         Free);
   end Overlay;

   function OverlayArrayEx
     (This       : IDAStatics_Type;
      imgs_0size : GNATCOM.Types.VARIANT;
      imgs_0     : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_OverlayArrayEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => imgs_0,
          2 => imgs_0size),
         Free);
   end OverlayArrayEx;

   function OverlayArray
     (This   : IDAStatics_Type;
      imgs_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_OverlayArray,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => imgs_0),
         Free);
   end OverlayArray;

   function Get_AmbientLight
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_AmbientLight);
   end Get_AmbientLight;

   function Get_DirectionalLight
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_DirectionalLight);
   end Get_DirectionalLight;

   function Get_PointLight
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_PointLight);
   end Get_PointLight;

   function SpotLightAnim
     (This       : IDAStatics_Type;
      fullcone_0 : GNATCOM.Types.VARIANT;
      cutoff_1   : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SpotLightAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => cutoff_1,
          2 => fullcone_0),
         Free);
   end SpotLightAnim;

   function SpotLight
     (This       : IDAStatics_Type;
      fullcone_0 : GNATCOM.Types.VARIANT;
      cutoff_1   : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SpotLight,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => cutoff_1,
          2 => fullcone_0),
         Free);
   end SpotLight;

   function Get_DefaultLineStyle
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_DefaultLineStyle);
   end Get_DefaultLineStyle;

   function Get_EmptyLineStyle
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_EmptyLineStyle);
   end Get_EmptyLineStyle;

   function Get_JoinStyleBevel
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_JoinStyleBevel);
   end Get_JoinStyleBevel;

   function Get_JoinStyleRound
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_JoinStyleRound);
   end Get_JoinStyleRound;

   function Get_JoinStyleMiter
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_JoinStyleMiter);
   end Get_JoinStyleMiter;

   function Get_EndStyleFlat
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_EndStyleFlat);
   end Get_EndStyleFlat;

   function Get_EndStyleSquare
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_EndStyleSquare);
   end Get_EndStyleSquare;

   function Get_EndStyleRound
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_EndStyleRound);
   end Get_EndStyleRound;

   function Get_DashStyleSolid
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_DashStyleSolid);
   end Get_DashStyleSolid;

   function Get_DashStyleDashed
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_DashStyleDashed);
   end Get_DashStyleDashed;

   function Get_DefaultMicrophone
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_DefaultMicrophone);
   end Get_DefaultMicrophone;

   function Get_OpaqueMatte
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_OpaqueMatte);
   end Get_OpaqueMatte;

   function Get_ClearMatte
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_ClearMatte);
   end Get_ClearMatte;

   function UnionMatte
     (This : IDAStatics_Type;
      m1_0 : GNATCOM.Types.VARIANT;
      m2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_UnionMatte,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => m2_1,
          2 => m1_0),
         Free);
   end UnionMatte;

   function IntersectMatte
     (This : IDAStatics_Type;
      m1_0 : GNATCOM.Types.VARIANT;
      m2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_IntersectMatte,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => m2_1,
          2 => m1_0),
         Free);
   end IntersectMatte;

   function DifferenceMatte
     (This : IDAStatics_Type;
      m1_0 : GNATCOM.Types.VARIANT;
      m2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DifferenceMatte,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => m2_1,
          2 => m1_0),
         Free);
   end DifferenceMatte;

   function FillMatte
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FillMatte,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => p_0),
         Free);
   end FillMatte;

   function TextMatte
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      fs_1  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_TextMatte,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fs_1,
          2 => str_0),
         Free);
   end TextMatte;

   function Get_EmptyMontage
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_EmptyMontage);
   end Get_EmptyMontage;

   function ImageMontage
     (This    : IDAStatics_Type;
      im_0    : GNATCOM.Types.VARIANT;
      depth_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImageMontage,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => depth_1,
          2 => im_0),
         Free);
   end ImageMontage;

   function ImageMontageAnim
     (This    : IDAStatics_Type;
      im_0    : GNATCOM.Types.VARIANT;
      depth_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ImageMontageAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => depth_1,
          2 => im_0),
         Free);
   end ImageMontageAnim;

   function UnionMontage
     (This : IDAStatics_Type;
      m1_0 : GNATCOM.Types.VARIANT;
      m2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_UnionMontage,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => m2_1,
          2 => m1_0),
         Free);
   end UnionMontage;

   function Concat
     (This : IDAStatics_Type;
      p1_0 : GNATCOM.Types.VARIANT;
      p2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Concat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => p2_1,
          2 => p1_0),
         Free);
   end Concat;

   function ConcatArrayEx
     (This        : IDAStatics_Type;
      paths_0size : GNATCOM.Types.VARIANT;
      paths_0     : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ConcatArrayEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => paths_0,
          2 => paths_0size),
         Free);
   end ConcatArrayEx;

   function ConcatArray
     (This    : IDAStatics_Type;
      paths_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ConcatArray,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => paths_0),
         Free);
   end ConcatArray;

   function Line
     (This : IDAStatics_Type;
      p1_0 : GNATCOM.Types.VARIANT;
      p2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Line,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => p2_1,
          2 => p1_0),
         Free);
   end Line;

   function Ray
     (This : IDAStatics_Type;
      pt_0 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Ray,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pt_0),
         Free);
   end Ray;

   function StringPathAnim
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      fs_1  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_StringPathAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fs_1,
          2 => str_0),
         Free);
   end StringPathAnim;

   function StringPath
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      fs_1  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_StringPath,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fs_1,
          2 => str_0),
         Free);
   end StringPath;

   function PolylineEx
     (This         : IDAStatics_Type;
      points_0size : GNATCOM.Types.VARIANT;
      points_0     : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_PolylineEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => points_0,
          2 => points_0size),
         Free);
   end PolylineEx;

   function Polyline
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Polyline,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => points_0),
         Free);
   end Polyline;

   function PolydrawPathEx
     (This         : IDAStatics_Type;
      points_0size : GNATCOM.Types.VARIANT;
      points_0     : GNATCOM.Types.VARIANT;
      codes_1size  : GNATCOM.Types.VARIANT;
      codes_1      : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_PolydrawPathEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => codes_1,
          2 => codes_1size,
          3 => points_0,
          4 => points_0size),
         Free);
   end PolydrawPathEx;

   function PolydrawPath
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      codes_1  : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_PolydrawPath,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => codes_1,
          2 => points_0),
         Free);
   end PolydrawPath;

   function ArcRadians
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ArcRadians,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight_3,
          2 => arcWidth_2,
          3 => endAngle_1,
          4 => startAngle_0),
         Free);
   end ArcRadians;

   function ArcRadiansAnim
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ArcRadiansAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight_3,
          2 => arcWidth_2,
          3 => endAngle_1,
          4 => startAngle_0),
         Free);
   end ArcRadiansAnim;

   function ArcDegrees
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ArcDegrees,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight_3,
          2 => arcWidth_2,
          3 => endAngle_1,
          4 => startAngle_0),
         Free);
   end ArcDegrees;

   function PieRadians
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_PieRadians,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight_3,
          2 => arcWidth_2,
          3 => endAngle_1,
          4 => startAngle_0),
         Free);
   end PieRadians;

   function PieRadiansAnim
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_PieRadiansAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight_3,
          2 => arcWidth_2,
          3 => endAngle_1,
          4 => startAngle_0),
         Free);
   end PieRadiansAnim;

   function PieDegrees
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_PieDegrees,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arcHeight_3,
          2 => arcWidth_2,
          3 => endAngle_1,
          4 => startAngle_0),
         Free);
   end PieDegrees;

   function Oval
     (This     : IDAStatics_Type;
      width_0  : GNATCOM.Types.VARIANT;
      height_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Oval,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => height_1,
          2 => width_0),
         Free);
   end Oval;

   function OvalAnim
     (This     : IDAStatics_Type;
      width_0  : GNATCOM.Types.VARIANT;
      height_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_OvalAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => height_1,
          2 => width_0),
         Free);
   end OvalAnim;

   function Rect
     (This     : IDAStatics_Type;
      width_0  : GNATCOM.Types.VARIANT;
      height_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rect,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => height_1,
          2 => width_0),
         Free);
   end Rect;

   function RectAnim
     (This     : IDAStatics_Type;
      width_0  : GNATCOM.Types.VARIANT;
      height_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RectAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => height_1,
          2 => width_0),
         Free);
   end RectAnim;

   function RoundRect
     (This              : IDAStatics_Type;
      width_0           : GNATCOM.Types.VARIANT;
      height_1          : GNATCOM.Types.VARIANT;
      cornerArcWidth_2  : GNATCOM.Types.VARIANT;
      cornerArcHeight_3 : GNATCOM.Types.VARIANT;
      Free              : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RoundRect,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => cornerArcHeight_3,
          2 => cornerArcWidth_2,
          3 => height_1,
          4 => width_0),
         Free);
   end RoundRect;

   function RoundRectAnim
     (This              : IDAStatics_Type;
      width_0           : GNATCOM.Types.VARIANT;
      height_1          : GNATCOM.Types.VARIANT;
      cornerArcWidth_2  : GNATCOM.Types.VARIANT;
      cornerArcHeight_3 : GNATCOM.Types.VARIANT;
      Free              : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_RoundRectAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => cornerArcHeight_3,
          2 => cornerArcWidth_2,
          3 => height_1,
          4 => width_0),
         Free);
   end RoundRectAnim;

   function CubicBSplinePathEx
     (This         : IDAStatics_Type;
      points_0size : GNATCOM.Types.VARIANT;
      points_0     : GNATCOM.Types.VARIANT;
      knots_1size  : GNATCOM.Types.VARIANT;
      knots_1      : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_CubicBSplinePathEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => knots_1,
          2 => knots_1size,
          3 => points_0,
          4 => points_0size),
         Free);
   end CubicBSplinePathEx;

   function CubicBSplinePath
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      knots_1  : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_CubicBSplinePath,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => knots_1,
          2 => points_0),
         Free);
   end CubicBSplinePath;

   function TextPath
     (This        : IDAStatics_Type;
      obsolete1_0 : GNATCOM.Types.VARIANT;
      obsolete2_1 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_TextPath,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsolete2_1,
          2 => obsolete1_0),
         Free);
   end TextPath;

   function Get_Silence
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Silence);
   end Get_Silence;

   function MixArrayEx
     (This       : IDAStatics_Type;
      snds_0size : GNATCOM.Types.VARIANT;
      snds_0     : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_MixArrayEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => snds_0,
          2 => snds_0size),
         Free);
   end MixArrayEx;

   function MixArray
     (This   : IDAStatics_Type;
      snds_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_MixArray,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => snds_0),
         Free);
   end MixArray;

   function Get_SinSynth
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_SinSynth);
   end Get_SinSynth;

   function Get_DefaultFont
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_DefaultFont);
   end Get_DefaultFont;

   function FontAnim
     (This   : IDAStatics_Type;
      str_0  : GNATCOM.Types.VARIANT;
      size_1 : GNATCOM.Types.VARIANT;
      col_2  : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_FontAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => col_2,
          2 => size_1,
          3 => str_0),
         Free);
   end FontAnim;

   function Font
     (This   : IDAStatics_Type;
      str_0  : GNATCOM.Types.VARIANT;
      size_1 : GNATCOM.Types.VARIANT;
      col_2  : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Font,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => col_2,
          2 => size_1,
          3 => str_0),
         Free);
   end Font;

   function StringImageAnim
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      fs_1  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_StringImageAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fs_1,
          2 => str_0),
         Free);
   end StringImageAnim;

   function StringImage
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      fs_1  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_StringImage,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => fs_1,
          2 => str_0),
         Free);
   end StringImage;

   function TextImageAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.VARIANT;
      obsoleted2_1 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_TextImageAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsoleted2_1,
          2 => obsoleted1_0),
         Free);
   end TextImageAnim;

   function TextImage
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.VARIANT;
      obsoleted2_1 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_TextImage,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsoleted2_1,
          2 => obsoleted1_0),
         Free);
   end TextImage;

   function Get_XVector2
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_XVector2);
   end Get_XVector2;

   function Get_YVector2
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_YVector2);
   end Get_YVector2;

   function Get_ZeroVector2
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_ZeroVector2);
   end Get_ZeroVector2;

   function Get_Origin2
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Origin2);
   end Get_Origin2;

   function Vector2Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector2Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => y_1,
          2 => x_0),
         Free);
   end Vector2Anim;

   function Vector2
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => y_1,
          2 => x_0),
         Free);
   end Vector2;

   function Point2Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point2Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => y_1,
          2 => x_0),
         Free);
   end Point2Anim;

   function Point2
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => y_1,
          2 => x_0),
         Free);
   end Point2;

   function Vector2PolarAnim
     (This     : IDAStatics_Type;
      theta_0  : GNATCOM.Types.VARIANT;
      radius_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector2PolarAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => radius_1,
          2 => theta_0),
         Free);
   end Vector2PolarAnim;

   function Vector2Polar
     (This     : IDAStatics_Type;
      theta_0  : GNATCOM.Types.VARIANT;
      radius_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector2Polar,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => radius_1,
          2 => theta_0),
         Free);
   end Vector2Polar;

   function Vector2PolarDegrees
     (This     : IDAStatics_Type;
      theta_0  : GNATCOM.Types.VARIANT;
      radius_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector2PolarDegrees,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => radius_1,
          2 => theta_0),
         Free);
   end Vector2PolarDegrees;

   function Point2PolarAnim
     (This     : IDAStatics_Type;
      theta_0  : GNATCOM.Types.VARIANT;
      radius_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point2PolarAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => radius_1,
          2 => theta_0),
         Free);
   end Point2PolarAnim;

   function Point2Polar
     (This     : IDAStatics_Type;
      theta_0  : GNATCOM.Types.VARIANT;
      radius_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point2Polar,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => radius_1,
          2 => theta_0),
         Free);
   end Point2Polar;

   function DotVector2
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      u_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DotVector2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => u_1,
          2 => v_0),
         Free);
   end DotVector2;

   function NegVector2
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_NegVector2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_0),
         Free);
   end NegVector2;

   function SubVector2
     (This : IDAStatics_Type;
      v1_0 : GNATCOM.Types.VARIANT;
      v2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SubVector2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v2_1,
          2 => v1_0),
         Free);
   end SubVector2;

   function AddVector2
     (This : IDAStatics_Type;
      v1_0 : GNATCOM.Types.VARIANT;
      v2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_AddVector2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v2_1,
          2 => v1_0),
         Free);
   end AddVector2;

   function AddPoint2Vector
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      v_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_AddPoint2Vector,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_1,
          2 => p_0),
         Free);
   end AddPoint2Vector;

   function SubPoint2Vector
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      v_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SubPoint2Vector,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_1,
          2 => p_0),
         Free);
   end SubPoint2Vector;

   function SubPoint2
     (This : IDAStatics_Type;
      p1_0 : GNATCOM.Types.VARIANT;
      p2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SubPoint2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => p2_1,
          2 => p1_0),
         Free);
   end SubPoint2;

   function DistancePoint2
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      q_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DistancePoint2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => q_1,
          2 => p_0),
         Free);
   end DistancePoint2;

   function DistanceSquaredPoint2
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      q_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DistanceSquaredPoint2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => q_1,
          2 => p_0),
         Free);
   end DistanceSquaredPoint2;

   function Get_XVector3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_XVector3);
   end Get_XVector3;

   function Get_YVector3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_YVector3);
   end Get_YVector3;

   function Get_ZVector3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_ZVector3);
   end Get_ZVector3;

   function Get_ZeroVector3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_ZeroVector3);
   end Get_ZeroVector3;

   function Get_Origin3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_Origin3);
   end Get_Origin3;

   function Vector3Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector3Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => z_2,
          2 => y_1,
          3 => x_0),
         Free);
   end Vector3Anim;

   function Vector3
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => z_2,
          2 => y_1,
          3 => x_0),
         Free);
   end Vector3;

   function Point3Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point3Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => z_2,
          2 => y_1,
          3 => x_0),
         Free);
   end Point3Anim;

   function Point3
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => z_2,
          2 => y_1,
          3 => x_0),
         Free);
   end Point3;

   function Vector3SphericalAnim
     (This      : IDAStatics_Type;
      xyAngle_0 : GNATCOM.Types.VARIANT;
      yzAngle_1 : GNATCOM.Types.VARIANT;
      radius_2  : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector3SphericalAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => radius_2,
          2 => yzAngle_1,
          3 => xyAngle_0),
         Free);
   end Vector3SphericalAnim;

   function Vector3Spherical
     (This      : IDAStatics_Type;
      xyAngle_0 : GNATCOM.Types.VARIANT;
      yzAngle_1 : GNATCOM.Types.VARIANT;
      radius_2  : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Vector3Spherical,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => radius_2,
          2 => yzAngle_1,
          3 => xyAngle_0),
         Free);
   end Vector3Spherical;

   function Point3SphericalAnim
     (This      : IDAStatics_Type;
      zxAngle_0 : GNATCOM.Types.VARIANT;
      xyAngle_1 : GNATCOM.Types.VARIANT;
      radius_2  : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point3SphericalAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => radius_2,
          2 => xyAngle_1,
          3 => zxAngle_0),
         Free);
   end Point3SphericalAnim;

   function Point3Spherical
     (This      : IDAStatics_Type;
      zxAngle_0 : GNATCOM.Types.VARIANT;
      xyAngle_1 : GNATCOM.Types.VARIANT;
      radius_2  : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Point3Spherical,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => radius_2,
          2 => xyAngle_1,
          3 => zxAngle_0),
         Free);
   end Point3Spherical;

   function DotVector3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      u_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DotVector3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => u_1,
          2 => v_0),
         Free);
   end DotVector3;

   function CrossVector3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      u_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_CrossVector3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => u_1,
          2 => v_0),
         Free);
   end CrossVector3;

   function NegVector3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_NegVector3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_0),
         Free);
   end NegVector3;

   function SubVector3
     (This : IDAStatics_Type;
      v1_0 : GNATCOM.Types.VARIANT;
      v2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SubVector3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v2_1,
          2 => v1_0),
         Free);
   end SubVector3;

   function AddVector3
     (This : IDAStatics_Type;
      v1_0 : GNATCOM.Types.VARIANT;
      v2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_AddVector3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v2_1,
          2 => v1_0),
         Free);
   end AddVector3;

   function AddPoint3Vector
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      v_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_AddPoint3Vector,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_1,
          2 => p_0),
         Free);
   end AddPoint3Vector;

   function SubPoint3Vector
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      v_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SubPoint3Vector,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => v_1,
          2 => p_0),
         Free);
   end SubPoint3Vector;

   function SubPoint3
     (This : IDAStatics_Type;
      p1_0 : GNATCOM.Types.VARIANT;
      p2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_SubPoint3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => p2_1,
          2 => p1_0),
         Free);
   end SubPoint3;

   function DistancePoint3
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      q_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DistancePoint3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => q_1,
          2 => p_0),
         Free);
   end DistancePoint3;

   function DistanceSquaredPoint3
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      q_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_DistanceSquaredPoint3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => q_1,
          2 => p_0),
         Free);
   end DistanceSquaredPoint3;

   function Get_IdentityTransform3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_IdentityTransform3);
   end Get_IdentityTransform3;

   function Translate3Anim
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      tz_2 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Translate3Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => tz_2,
          2 => ty_1,
          3 => tx_0),
         Free);
   end Translate3Anim;

   function Translate3
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      tz_2 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Translate3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => tz_2,
          2 => ty_1,
          3 => tx_0),
         Free);
   end Translate3;

   function Translate3Rate
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      tz_2 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Translate3Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => tz_2,
          2 => ty_1,
          3 => tx_0),
         Free);
   end Translate3Rate;

   function Translate3Vector
     (This    : IDAStatics_Type;
      delta_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Translate3Vector,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => delta_0),
         Free);
   end Translate3Vector;

   function Translate3Point
     (This         : IDAStatics_Type;
      new_origin_0 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Translate3Point,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => new_origin_0),
         Free);
   end Translate3Point;

   function Scale3Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale3Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => z_2,
          2 => y_1,
          3 => x_0),
         Free);
   end Scale3Anim;

   function Scale3
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => z_2,
          2 => y_1,
          3 => x_0),
         Free);
   end Scale3;

   function Scale3Rate
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale3Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => z_2,
          2 => y_1,
          3 => x_0),
         Free);
   end Scale3Rate;

   function Scale3Vector
     (This        : IDAStatics_Type;
      scale_vec_0 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale3Vector,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => scale_vec_0),
         Free);
   end Scale3Vector;

   function Scale3UniformAnim
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale3UniformAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => uniform_scale_0),
         Free);
   end Scale3UniformAnim;

   function Scale3Uniform
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale3Uniform,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => uniform_scale_0),
         Free);
   end Scale3Uniform;

   function Scale3UniformRate
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale3UniformRate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => uniform_scale_0),
         Free);
   end Scale3UniformRate;

   function Rotate3Anim
     (This    : IDAStatics_Type;
      axis_0  : GNATCOM.Types.VARIANT;
      angle_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rotate3Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => angle_1,
          2 => axis_0),
         Free);
   end Rotate3Anim;

   function Rotate3
     (This    : IDAStatics_Type;
      axis_0  : GNATCOM.Types.VARIANT;
      angle_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rotate3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => angle_1,
          2 => axis_0),
         Free);
   end Rotate3;

   function Rotate3Rate
     (This    : IDAStatics_Type;
      axis_0  : GNATCOM.Types.VARIANT;
      angle_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rotate3Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => angle_1,
          2 => axis_0),
         Free);
   end Rotate3Rate;

   function Rotate3Degrees
     (This    : IDAStatics_Type;
      axis_0  : GNATCOM.Types.VARIANT;
      angle_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rotate3Degrees,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => angle_1,
          2 => axis_0),
         Free);
   end Rotate3Degrees;

   function Rotate3RateDegrees
     (This    : IDAStatics_Type;
      axis_0  : GNATCOM.Types.VARIANT;
      angle_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rotate3RateDegrees,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => angle_1,
          2 => axis_0),
         Free);
   end Rotate3RateDegrees;

   function XShear3Anim
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_XShear3Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end XShear3Anim;

   function XShear3
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_XShear3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end XShear3;

   function XShear3Rate
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_XShear3Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end XShear3Rate;

   function YShear3Anim
     (This : IDAStatics_Type;
      c_0  : GNATCOM.Types.VARIANT;
      d_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_YShear3Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => d_1,
          2 => c_0),
         Free);
   end YShear3Anim;

   function YShear3
     (This : IDAStatics_Type;
      c_0  : GNATCOM.Types.VARIANT;
      d_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_YShear3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => d_1,
          2 => c_0),
         Free);
   end YShear3;

   function YShear3Rate
     (This : IDAStatics_Type;
      c_0  : GNATCOM.Types.VARIANT;
      d_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_YShear3Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => d_1,
          2 => c_0),
         Free);
   end YShear3Rate;

   function ZShear3Anim
     (This : IDAStatics_Type;
      e_0  : GNATCOM.Types.VARIANT;
      f_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ZShear3Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => f_1,
          2 => e_0),
         Free);
   end ZShear3Anim;

   function ZShear3
     (This : IDAStatics_Type;
      e_0  : GNATCOM.Types.VARIANT;
      f_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ZShear3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => f_1,
          2 => e_0),
         Free);
   end ZShear3;

   function ZShear3Rate
     (This : IDAStatics_Type;
      e_0  : GNATCOM.Types.VARIANT;
      f_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_ZShear3Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => f_1,
          2 => e_0),
         Free);
   end ZShear3Rate;

   function Transform4x4AnimEx
     (This    : IDAStatics_Type;
      m_0size : GNATCOM.Types.VARIANT;
      m_0     : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Transform4x4AnimEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => m_0,
          2 => m_0size),
         Free);
   end Transform4x4AnimEx;

   function Transform4x4Anim
     (This : IDAStatics_Type;
      m_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Transform4x4Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => m_0),
         Free);
   end Transform4x4Anim;

   function Compose3
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Compose3,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end Compose3;

   function Compose3ArrayEx
     (This      : IDAStatics_Type;
      xfs_0size : GNATCOM.Types.VARIANT;
      xfs_0     : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Compose3ArrayEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xfs_0,
          2 => xfs_0size),
         Free);
   end Compose3ArrayEx;

   function Compose3Array
     (This  : IDAStatics_Type;
      xfs_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Compose3Array,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xfs_0),
         Free);
   end Compose3Array;

   function LookAtFrom
     (This   : IDAStatics_Type;
      to_0   : GNATCOM.Types.VARIANT;
      from_1 : GNATCOM.Types.VARIANT;
      up_2   : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_LookAtFrom,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => up_2,
          2 => from_1,
          3 => to_0),
         Free);
   end LookAtFrom;

   function Get_IdentityTransform2
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_IdentityTransform2);
   end Get_IdentityTransform2;

   function Translate2Anim
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Translate2Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => ty_1,
          2 => tx_0),
         Free);
   end Translate2Anim;

   function Translate2
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Translate2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => ty_1,
          2 => tx_0),
         Free);
   end Translate2;

   function Translate2Rate
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Translate2Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => ty_1,
          2 => tx_0),
         Free);
   end Translate2Rate;

   function Translate2Vector
     (This    : IDAStatics_Type;
      delta_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Translate2Vector,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => delta_0),
         Free);
   end Translate2Vector;

   function Translate2Point
     (This  : IDAStatics_Type;
      pos_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Translate2Point,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => pos_0),
         Free);
   end Translate2Point;

   function Scale2Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale2Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => y_1,
          2 => x_0),
         Free);
   end Scale2Anim;

   function Scale2
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => y_1,
          2 => x_0),
         Free);
   end Scale2;

   function Scale2Rate
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale2Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => y_1,
          2 => x_0),
         Free);
   end Scale2Rate;

   function Scale2Vector2
     (This             : IDAStatics_Type;
      obsoleteMethod_0 : GNATCOM.Types.VARIANT;
      Free             : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale2Vector2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsoleteMethod_0),
         Free);
   end Scale2Vector2;

   function Scale2Vector
     (This        : IDAStatics_Type;
      scale_vec_0 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale2Vector,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => scale_vec_0),
         Free);
   end Scale2Vector;

   function Scale2UniformAnim
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale2UniformAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => uniform_scale_0),
         Free);
   end Scale2UniformAnim;

   function Scale2Uniform
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale2Uniform,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => uniform_scale_0),
         Free);
   end Scale2Uniform;

   function Scale2UniformRate
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Scale2UniformRate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => uniform_scale_0),
         Free);
   end Scale2UniformRate;

   function Rotate2Anim
     (This    : IDAStatics_Type;
      angle_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rotate2Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => angle_0),
         Free);
   end Rotate2Anim;

   function Rotate2
     (This    : IDAStatics_Type;
      angle_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rotate2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => angle_0),
         Free);
   end Rotate2;

   function Rotate2Rate
     (This    : IDAStatics_Type;
      angle_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rotate2Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => angle_0),
         Free);
   end Rotate2Rate;

   function Rotate2Degrees
     (This    : IDAStatics_Type;
      angle_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rotate2Degrees,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => angle_0),
         Free);
   end Rotate2Degrees;

   function Rotate2RateDegrees
     (This    : IDAStatics_Type;
      angle_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Rotate2RateDegrees,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => angle_0),
         Free);
   end Rotate2RateDegrees;

   function XShear2Anim
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_XShear2Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arg_0),
         Free);
   end XShear2Anim;

   function XShear2
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_XShear2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arg_0),
         Free);
   end XShear2;

   function XShear2Rate
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_XShear2Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arg_0),
         Free);
   end XShear2Rate;

   function YShear2Anim
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_YShear2Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arg_0),
         Free);
   end YShear2Anim;

   function YShear2
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_YShear2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arg_0),
         Free);
   end YShear2;

   function YShear2Rate
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_YShear2Rate,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => arg_0),
         Free);
   end YShear2Rate;

   function Transform3x2AnimEx
     (This    : IDAStatics_Type;
      m_0size : GNATCOM.Types.VARIANT;
      m_0     : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Transform3x2AnimEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => m_0,
          2 => m_0size),
         Free);
   end Transform3x2AnimEx;

   function Transform3x2Anim
     (This : IDAStatics_Type;
      m_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Transform3x2Anim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => m_0),
         Free);
   end Transform3x2Anim;

   function Compose2
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Compose2,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => b_1,
          2 => a_0),
         Free);
   end Compose2;

   function Compose2ArrayEx
     (This      : IDAStatics_Type;
      xfs_0size : GNATCOM.Types.VARIANT;
      xfs_0     : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Compose2ArrayEx,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xfs_0,
          2 => xfs_0size),
         Free);
   end Compose2ArrayEx;

   function Compose2Array
     (This  : IDAStatics_Type;
      xfs_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Compose2Array,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xfs_0),
         Free);
   end Compose2Array;

   function Tuple
     (This      : IDAStatics_Type;
      obsolete1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_Tuple,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsolete1),
         Free);
   end Tuple;

   function uArray
     (This      : IDAStatics_Type;
      obsolete1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAStatics_uArray,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => obsolete1),
         Free);
   end uArray;

   function Get_AreBlockingImportsComplete
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAStatics_Get_AreBlockingImportsComplete);
   end Get_AreBlockingImportsComplete;

end StructuredGraphicControl.IDAStatics_Object;

