with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAStatics_Object is

   type IDAStatics_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   function Get_VersionString
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Site
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_Site
     (This : IDAStatics_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Put_ClientSite
     (This : IDAStatics_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ClientSite
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_PixelConstructionMode
     (This : IDAStatics_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_PixelConstructionMode
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   procedure TriggerEvent
     (This  : IDAStatics_Type;
      event : GNATCOM.Types.VARIANT;
      Data  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True);

   function NewDrawingSurface
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function ImportMovie
     (This : IDAStatics_Type;
      url  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImportMovieAsync
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.VARIANT;
      pImageStandIn : GNATCOM.Types.VARIANT;
      pSoundStandIn : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImportImage
     (This : IDAStatics_Type;
      url  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImportImageAsync
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.VARIANT;
      pImageStandIn : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImportImageColorKey
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.VARIANT;
      colorKeyRed   : GNATCOM.Types.VARIANT;
      colorKeyGreen : GNATCOM.Types.VARIANT;
      colorKeyBlue  : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImportImageAsyncColorKey
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.VARIANT;
      pImageStandIn : GNATCOM.Types.VARIANT;
      colorKeyRed   : GNATCOM.Types.VARIANT;
      colorKeyGreen : GNATCOM.Types.VARIANT;
      colorKeyBlue  : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImportSound
     (This : IDAStatics_Type;
      url  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImportSoundAsync
     (This          : IDAStatics_Type;
      url           : GNATCOM.Types.VARIANT;
      pSoundStandIn : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImportGeometry
     (This : IDAStatics_Type;
      url  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImportGeometryAsync
     (This        : IDAStatics_Type;
      url         : GNATCOM.Types.VARIANT;
      pGeoStandIn : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImportDirectDrawSurface
     (This        : IDAStatics_Type;
      dds         : GNATCOM.Types.VARIANT;
      updateEvent : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Cond
     (This : IDAStatics_Type;
      c    : GNATCOM.Types.VARIANT;
      i    : GNATCOM.Types.VARIANT;
      e    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DAArrayEx
     (This  : IDAStatics_Type;
      s     : GNATCOM.Types.VARIANT;
      pBvrs : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DAArray
     (This : IDAStatics_Type;
      bvrs : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DATupleEx
     (This  : IDAStatics_Type;
      s     : GNATCOM.Types.VARIANT;
      pBvrs : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DATuple
     (This : IDAStatics_Type;
      bvrs : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ModifiableBehavior
     (This : IDAStatics_Type;
      orig : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function UninitializedArray
     (This    : IDAStatics_Type;
      typeTmp : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function UninitializedTuple
     (This    : IDAStatics_Type;
      typeTmp : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function NumberBSplineEx
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      numKnots  : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      numPts    : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      numWts    : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function NumberBSpline
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point2BSplineEx
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      numKnots  : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      numPts    : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      numWts    : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point2BSpline
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point3BSplineEx
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      numKnots  : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      numPts    : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      numWts    : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point3BSpline
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector2BSplineEx
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      numKnots  : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      numPts    : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      numWts    : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector2BSpline
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector3BSplineEx
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      numKnots  : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      numPts    : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      numWts    : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector3BSpline
     (This      : IDAStatics_Type;
      degree    : GNATCOM.Types.VARIANT;
      knots     : GNATCOM.Types.VARIANT;
      ctrlPts   : GNATCOM.Types.VARIANT;
      weights   : GNATCOM.Types.VARIANT;
      evaluator : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Pow
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function uAbs
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Sqrt
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Floor
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Round
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Ceiling
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Asin
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Acos
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Atan
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Sin
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Cos
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Tan
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Exp
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Ln
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Log10
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ToDegrees
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ToRadians
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function uMod
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Atan2
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Add
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Sub
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Mul
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Div
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function LT
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function LTE
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function GT
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function GTE
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function EQ
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function NE
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Neg
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function InterpolateAnim
     (This       : IDAStatics_Type;
      from_0     : GNATCOM.Types.VARIANT;
      to_1       : GNATCOM.Types.VARIANT;
      duration_2 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Interpolate
     (This       : IDAStatics_Type;
      from_0     : GNATCOM.Types.VARIANT;
      to_1       : GNATCOM.Types.VARIANT;
      duration_2 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SlowInSlowOutAnim
     (This        : IDAStatics_Type;
      from_0      : GNATCOM.Types.VARIANT;
      to_1        : GNATCOM.Types.VARIANT;
      duration_2  : GNATCOM.Types.VARIANT;
      sharpness_3 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SlowInSlowOut
     (This        : IDAStatics_Type;
      from_0      : GNATCOM.Types.VARIANT;
      to_1        : GNATCOM.Types.VARIANT;
      duration_2  : GNATCOM.Types.VARIANT;
      sharpness_3 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SoundSource
     (This  : IDAStatics_Type;
      snd_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Mix
     (This    : IDAStatics_Type;
      left_0  : GNATCOM.Types.VARIANT;
      right_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function uAnd
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function uOr
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function uNot
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Integral
     (This : IDAStatics_Type;
      b_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Derivative
     (This : IDAStatics_Type;
      b_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function IntegralVector2
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function IntegralVector3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DerivativeVector2
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DerivativeVector3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DerivativePoint2
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DerivativePoint3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function KeyState
     (This : IDAStatics_Type;
      n_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function KeyUp
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function KeyDown
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DANumber
     (This  : IDAStatics_Type;
      num_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DAString
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DABoolean
     (This  : IDAStatics_Type;
      num_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SeededRandom
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_MousePosition
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_LeftButtonState
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_RightButtonState
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_DATrue
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_DAFalse
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_LocalTime
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_GlobalTime
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Pixel
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function UserData
     (This   : IDAStatics_Type;
      data_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function UntilNotify
     (This       : IDAStatics_Type;
      b0_0       : GNATCOM.Types.VARIANT;
      event_1    : GNATCOM.Types.VARIANT;
      notifier_2 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function uUntil
     (This    : IDAStatics_Type;
      b0_0    : GNATCOM.Types.VARIANT;
      event_1 : GNATCOM.Types.VARIANT;
      b1_2    : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function UntilEx
     (This    : IDAStatics_Type;
      b0_0    : GNATCOM.Types.VARIANT;
      event_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Sequence
     (This : IDAStatics_Type;
      s1_0 : GNATCOM.Types.VARIANT;
      s2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FollowPath
     (This       : IDAStatics_Type;
      path_0     : GNATCOM.Types.VARIANT;
      duration_1 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FollowPathAngle
     (This       : IDAStatics_Type;
      path_0     : GNATCOM.Types.VARIANT;
      duration_1 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FollowPathAngleUpright
     (This       : IDAStatics_Type;
      path_0     : GNATCOM.Types.VARIANT;
      duration_1 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FollowPathEval
     (This   : IDAStatics_Type;
      path_0 : GNATCOM.Types.VARIANT;
      eval_1 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FollowPathAngleEval
     (This   : IDAStatics_Type;
      path_0 : GNATCOM.Types.VARIANT;
      eval_1 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FollowPathAngleUprightEval
     (This   : IDAStatics_Type;
      path_0 : GNATCOM.Types.VARIANT;
      eval_1 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FollowPathAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.VARIANT;
      obsoleted2_1 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FollowPathAngleAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.VARIANT;
      obsoleted2_1 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FollowPathAngleUprightAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.VARIANT;
      obsoleted2_1 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ConcatString
     (This : IDAStatics_Type;
      s1_0 : GNATCOM.Types.VARIANT;
      s2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function PerspectiveCamera
     (This        : IDAStatics_Type;
      focalDist_0 : GNATCOM.Types.VARIANT;
      nearClip_1  : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function PerspectiveCameraAnim
     (This        : IDAStatics_Type;
      focalDist_0 : GNATCOM.Types.VARIANT;
      nearClip_1  : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ParallelCamera
     (This       : IDAStatics_Type;
      nearClip_0 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ParallelCameraAnim
     (This       : IDAStatics_Type;
      nearClip_0 : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ColorRgbAnim
     (This    : IDAStatics_Type;
      red_0   : GNATCOM.Types.VARIANT;
      green_1 : GNATCOM.Types.VARIANT;
      blue_2  : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ColorRgb
     (This    : IDAStatics_Type;
      red_0   : GNATCOM.Types.VARIANT;
      green_1 : GNATCOM.Types.VARIANT;
      blue_2  : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ColorRgb255
     (This    : IDAStatics_Type;
      red_0   : GNATCOM.Types.VARIANT;
      green_1 : GNATCOM.Types.VARIANT;
      blue_2  : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ColorHsl
     (This         : IDAStatics_Type;
      hue_0        : GNATCOM.Types.VARIANT;
      saturation_1 : GNATCOM.Types.VARIANT;
      lum_2        : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ColorHslAnim
     (This         : IDAStatics_Type;
      hue_0        : GNATCOM.Types.VARIANT;
      saturation_1 : GNATCOM.Types.VARIANT;
      lum_2        : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_Red
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Green
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Blue
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Cyan
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Magenta
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Yellow
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Black
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_White
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Aqua
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Fuchsia
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Gray
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Lime
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Maroon
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Navy
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Olive
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Purple
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Silver
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Teal
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Predicate
     (This : IDAStatics_Type;
      b_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function NotEvent
     (This    : IDAStatics_Type;
      event_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function AndEvent
     (This : IDAStatics_Type;
      e1_0 : GNATCOM.Types.VARIANT;
      e2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function OrEvent
     (This : IDAStatics_Type;
      e1_0 : GNATCOM.Types.VARIANT;
      e2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ThenEvent
     (This : IDAStatics_Type;
      e1_0 : GNATCOM.Types.VARIANT;
      e2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_LeftButtonDown
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_LeftButtonUp
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_RightButtonDown
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_RightButtonUp
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Always
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Never
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function TimerAnim
     (This : IDAStatics_Type;
      n_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Timer
     (This : IDAStatics_Type;
      n_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function AppTriggeredEvent
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function ScriptCallback
     (This        : IDAStatics_Type;
      obsolete1_0 : GNATCOM.Types.VARIANT;
      obsolete2_1 : GNATCOM.Types.VARIANT;
      obsolete3_2 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_EmptyGeometry
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function UnionGeometry
     (This : IDAStatics_Type;
      g1_0 : GNATCOM.Types.VARIANT;
      g2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function UnionGeometryArrayEx
     (This       : IDAStatics_Type;
      imgs_0size : GNATCOM.Types.VARIANT;
      imgs_0     : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function UnionGeometryArray
     (This   : IDAStatics_Type;
      imgs_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_EmptyImage
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_DetectableEmptyImage
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function SolidColorImage
     (This  : IDAStatics_Type;
      col_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function GradientPolygonEx
     (This         : IDAStatics_Type;
      points_0size : GNATCOM.Types.VARIANT;
      points_0     : GNATCOM.Types.VARIANT;
      colors_1size : GNATCOM.Types.VARIANT;
      colors_1     : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function GradientPolygon
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      colors_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RadialGradientPolygonEx
     (This         : IDAStatics_Type;
      inner_0      : GNATCOM.Types.VARIANT;
      outer_1      : GNATCOM.Types.VARIANT;
      points_2size : GNATCOM.Types.VARIANT;
      points_2     : GNATCOM.Types.VARIANT;
      fallOff_3    : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RadialGradientPolygon
     (This      : IDAStatics_Type;
      inner_0   : GNATCOM.Types.VARIANT;
      outer_1   : GNATCOM.Types.VARIANT;
      points_2  : GNATCOM.Types.VARIANT;
      fallOff_3 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RadialGradientPolygonAnimEx
     (This         : IDAStatics_Type;
      inner_0      : GNATCOM.Types.VARIANT;
      outer_1      : GNATCOM.Types.VARIANT;
      points_2size : GNATCOM.Types.VARIANT;
      points_2     : GNATCOM.Types.VARIANT;
      fallOff_3    : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RadialGradientPolygonAnim
     (This      : IDAStatics_Type;
      inner_0   : GNATCOM.Types.VARIANT;
      outer_1   : GNATCOM.Types.VARIANT;
      points_2  : GNATCOM.Types.VARIANT;
      fallOff_3 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function GradientSquare
     (This         : IDAStatics_Type;
      lowerLeft_0  : GNATCOM.Types.VARIANT;
      upperLeft_1  : GNATCOM.Types.VARIANT;
      upperRight_2 : GNATCOM.Types.VARIANT;
      lowerRight_3 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RadialGradientSquare
     (This      : IDAStatics_Type;
      inner_0   : GNATCOM.Types.VARIANT;
      outer_1   : GNATCOM.Types.VARIANT;
      fallOff_2 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RadialGradientSquareAnim
     (This      : IDAStatics_Type;
      inner_0   : GNATCOM.Types.VARIANT;
      outer_1   : GNATCOM.Types.VARIANT;
      fallOff_2 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RadialGradientRegularPoly
     (This       : IDAStatics_Type;
      inner_0    : GNATCOM.Types.VARIANT;
      outer_1    : GNATCOM.Types.VARIANT;
      numEdges_2 : GNATCOM.Types.VARIANT;
      fallOff_3  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RadialGradientRegularPolyAnim
     (This       : IDAStatics_Type;
      inner_0    : GNATCOM.Types.VARIANT;
      outer_1    : GNATCOM.Types.VARIANT;
      numEdges_2 : GNATCOM.Types.VARIANT;
      fallOff_3  : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function GradientHorizontal
     (This      : IDAStatics_Type;
      start_0   : GNATCOM.Types.VARIANT;
      stop_1    : GNATCOM.Types.VARIANT;
      fallOff_2 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function GradientHorizontalAnim
     (This      : IDAStatics_Type;
      start_0   : GNATCOM.Types.VARIANT;
      stop_1    : GNATCOM.Types.VARIANT;
      fallOff_2 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchHorizontal
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchHorizontalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchVertical
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchVerticalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchForwardDiagonal
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchForwardDiagonalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchBackwardDiagonal
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchBackwardDiagonalAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchCross
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchCrossAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchDiagonalCross
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function HatchDiagonalCrossAnim
     (This      : IDAStatics_Type;
      lineClr_0 : GNATCOM.Types.VARIANT;
      spacing_1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Overlay
     (This     : IDAStatics_Type;
      top_0    : GNATCOM.Types.VARIANT;
      bottom_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function OverlayArrayEx
     (This       : IDAStatics_Type;
      imgs_0size : GNATCOM.Types.VARIANT;
      imgs_0     : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function OverlayArray
     (This   : IDAStatics_Type;
      imgs_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_AmbientLight
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_DirectionalLight
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_PointLight
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function SpotLightAnim
     (This       : IDAStatics_Type;
      fullcone_0 : GNATCOM.Types.VARIANT;
      cutoff_1   : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SpotLight
     (This       : IDAStatics_Type;
      fullcone_0 : GNATCOM.Types.VARIANT;
      cutoff_1   : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_DefaultLineStyle
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_EmptyLineStyle
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_JoinStyleBevel
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_JoinStyleRound
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_JoinStyleMiter
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_EndStyleFlat
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_EndStyleSquare
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_EndStyleRound
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_DashStyleSolid
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_DashStyleDashed
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_DefaultMicrophone
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_OpaqueMatte
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_ClearMatte
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function UnionMatte
     (This : IDAStatics_Type;
      m1_0 : GNATCOM.Types.VARIANT;
      m2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function IntersectMatte
     (This : IDAStatics_Type;
      m1_0 : GNATCOM.Types.VARIANT;
      m2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DifferenceMatte
     (This : IDAStatics_Type;
      m1_0 : GNATCOM.Types.VARIANT;
      m2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function FillMatte
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function TextMatte
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      fs_1  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_EmptyMontage
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function ImageMontage
     (This    : IDAStatics_Type;
      im_0    : GNATCOM.Types.VARIANT;
      depth_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ImageMontageAnim
     (This    : IDAStatics_Type;
      im_0    : GNATCOM.Types.VARIANT;
      depth_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function UnionMontage
     (This : IDAStatics_Type;
      m1_0 : GNATCOM.Types.VARIANT;
      m2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Concat
     (This : IDAStatics_Type;
      p1_0 : GNATCOM.Types.VARIANT;
      p2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ConcatArrayEx
     (This        : IDAStatics_Type;
      paths_0size : GNATCOM.Types.VARIANT;
      paths_0     : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ConcatArray
     (This    : IDAStatics_Type;
      paths_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Line
     (This : IDAStatics_Type;
      p1_0 : GNATCOM.Types.VARIANT;
      p2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Ray
     (This : IDAStatics_Type;
      pt_0 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function StringPathAnim
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      fs_1  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function StringPath
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      fs_1  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function PolylineEx
     (This         : IDAStatics_Type;
      points_0size : GNATCOM.Types.VARIANT;
      points_0     : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Polyline
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function PolydrawPathEx
     (This         : IDAStatics_Type;
      points_0size : GNATCOM.Types.VARIANT;
      points_0     : GNATCOM.Types.VARIANT;
      codes_1size  : GNATCOM.Types.VARIANT;
      codes_1      : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function PolydrawPath
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      codes_1  : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ArcRadians
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ArcRadiansAnim
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ArcDegrees
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function PieRadians
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function PieRadiansAnim
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function PieDegrees
     (This         : IDAStatics_Type;
      startAngle_0 : GNATCOM.Types.VARIANT;
      endAngle_1   : GNATCOM.Types.VARIANT;
      arcWidth_2   : GNATCOM.Types.VARIANT;
      arcHeight_3  : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Oval
     (This     : IDAStatics_Type;
      width_0  : GNATCOM.Types.VARIANT;
      height_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function OvalAnim
     (This     : IDAStatics_Type;
      width_0  : GNATCOM.Types.VARIANT;
      height_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rect
     (This     : IDAStatics_Type;
      width_0  : GNATCOM.Types.VARIANT;
      height_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RectAnim
     (This     : IDAStatics_Type;
      width_0  : GNATCOM.Types.VARIANT;
      height_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RoundRect
     (This              : IDAStatics_Type;
      width_0           : GNATCOM.Types.VARIANT;
      height_1          : GNATCOM.Types.VARIANT;
      cornerArcWidth_2  : GNATCOM.Types.VARIANT;
      cornerArcHeight_3 : GNATCOM.Types.VARIANT;
      Free              : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function RoundRectAnim
     (This              : IDAStatics_Type;
      width_0           : GNATCOM.Types.VARIANT;
      height_1          : GNATCOM.Types.VARIANT;
      cornerArcWidth_2  : GNATCOM.Types.VARIANT;
      cornerArcHeight_3 : GNATCOM.Types.VARIANT;
      Free              : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function CubicBSplinePathEx
     (This         : IDAStatics_Type;
      points_0size : GNATCOM.Types.VARIANT;
      points_0     : GNATCOM.Types.VARIANT;
      knots_1size  : GNATCOM.Types.VARIANT;
      knots_1      : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function CubicBSplinePath
     (This     : IDAStatics_Type;
      points_0 : GNATCOM.Types.VARIANT;
      knots_1  : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function TextPath
     (This        : IDAStatics_Type;
      obsolete1_0 : GNATCOM.Types.VARIANT;
      obsolete2_1 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_Silence
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function MixArrayEx
     (This       : IDAStatics_Type;
      snds_0size : GNATCOM.Types.VARIANT;
      snds_0     : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function MixArray
     (This   : IDAStatics_Type;
      snds_0 : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_SinSynth
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_DefaultFont
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function FontAnim
     (This   : IDAStatics_Type;
      str_0  : GNATCOM.Types.VARIANT;
      size_1 : GNATCOM.Types.VARIANT;
      col_2  : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Font
     (This   : IDAStatics_Type;
      str_0  : GNATCOM.Types.VARIANT;
      size_1 : GNATCOM.Types.VARIANT;
      col_2  : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function StringImageAnim
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      fs_1  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function StringImage
     (This  : IDAStatics_Type;
      str_0 : GNATCOM.Types.VARIANT;
      fs_1  : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function TextImageAnim
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.VARIANT;
      obsoleted2_1 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function TextImage
     (This         : IDAStatics_Type;
      obsoleted1_0 : GNATCOM.Types.VARIANT;
      obsoleted2_1 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_XVector2
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_YVector2
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_ZeroVector2
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Origin2
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Vector2Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector2
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point2Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point2
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector2PolarAnim
     (This     : IDAStatics_Type;
      theta_0  : GNATCOM.Types.VARIANT;
      radius_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector2Polar
     (This     : IDAStatics_Type;
      theta_0  : GNATCOM.Types.VARIANT;
      radius_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector2PolarDegrees
     (This     : IDAStatics_Type;
      theta_0  : GNATCOM.Types.VARIANT;
      radius_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point2PolarAnim
     (This     : IDAStatics_Type;
      theta_0  : GNATCOM.Types.VARIANT;
      radius_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point2Polar
     (This     : IDAStatics_Type;
      theta_0  : GNATCOM.Types.VARIANT;
      radius_1 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DotVector2
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      u_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function NegVector2
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SubVector2
     (This : IDAStatics_Type;
      v1_0 : GNATCOM.Types.VARIANT;
      v2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function AddVector2
     (This : IDAStatics_Type;
      v1_0 : GNATCOM.Types.VARIANT;
      v2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function AddPoint2Vector
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      v_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SubPoint2Vector
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      v_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SubPoint2
     (This : IDAStatics_Type;
      p1_0 : GNATCOM.Types.VARIANT;
      p2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DistancePoint2
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      q_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DistanceSquaredPoint2
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      q_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_XVector3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_YVector3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_ZVector3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_ZeroVector3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Get_Origin3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Vector3Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector3
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point3Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point3
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector3SphericalAnim
     (This      : IDAStatics_Type;
      xyAngle_0 : GNATCOM.Types.VARIANT;
      yzAngle_1 : GNATCOM.Types.VARIANT;
      radius_2  : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Vector3Spherical
     (This      : IDAStatics_Type;
      xyAngle_0 : GNATCOM.Types.VARIANT;
      yzAngle_1 : GNATCOM.Types.VARIANT;
      radius_2  : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point3SphericalAnim
     (This      : IDAStatics_Type;
      zxAngle_0 : GNATCOM.Types.VARIANT;
      xyAngle_1 : GNATCOM.Types.VARIANT;
      radius_2  : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Point3Spherical
     (This      : IDAStatics_Type;
      zxAngle_0 : GNATCOM.Types.VARIANT;
      xyAngle_1 : GNATCOM.Types.VARIANT;
      radius_2  : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DotVector3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      u_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function CrossVector3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      u_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function NegVector3
     (This : IDAStatics_Type;
      v_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SubVector3
     (This : IDAStatics_Type;
      v1_0 : GNATCOM.Types.VARIANT;
      v2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function AddVector3
     (This : IDAStatics_Type;
      v1_0 : GNATCOM.Types.VARIANT;
      v2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function AddPoint3Vector
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      v_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SubPoint3Vector
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      v_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function SubPoint3
     (This : IDAStatics_Type;
      p1_0 : GNATCOM.Types.VARIANT;
      p2_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DistancePoint3
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      q_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function DistanceSquaredPoint3
     (This : IDAStatics_Type;
      p_0  : GNATCOM.Types.VARIANT;
      q_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_IdentityTransform3
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Translate3Anim
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      tz_2 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Translate3
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      tz_2 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Translate3Rate
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      tz_2 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Translate3Vector
     (This    : IDAStatics_Type;
      delta_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Translate3Point
     (This         : IDAStatics_Type;
      new_origin_0 : GNATCOM.Types.VARIANT;
      Free         : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale3Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale3
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale3Rate
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      z_2  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale3Vector
     (This        : IDAStatics_Type;
      scale_vec_0 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale3UniformAnim
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale3Uniform
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale3UniformRate
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rotate3Anim
     (This    : IDAStatics_Type;
      axis_0  : GNATCOM.Types.VARIANT;
      angle_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rotate3
     (This    : IDAStatics_Type;
      axis_0  : GNATCOM.Types.VARIANT;
      angle_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rotate3Rate
     (This    : IDAStatics_Type;
      axis_0  : GNATCOM.Types.VARIANT;
      angle_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rotate3Degrees
     (This    : IDAStatics_Type;
      axis_0  : GNATCOM.Types.VARIANT;
      angle_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rotate3RateDegrees
     (This    : IDAStatics_Type;
      axis_0  : GNATCOM.Types.VARIANT;
      angle_1 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function XShear3Anim
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function XShear3
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function XShear3Rate
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function YShear3Anim
     (This : IDAStatics_Type;
      c_0  : GNATCOM.Types.VARIANT;
      d_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function YShear3
     (This : IDAStatics_Type;
      c_0  : GNATCOM.Types.VARIANT;
      d_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function YShear3Rate
     (This : IDAStatics_Type;
      c_0  : GNATCOM.Types.VARIANT;
      d_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ZShear3Anim
     (This : IDAStatics_Type;
      e_0  : GNATCOM.Types.VARIANT;
      f_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ZShear3
     (This : IDAStatics_Type;
      e_0  : GNATCOM.Types.VARIANT;
      f_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function ZShear3Rate
     (This : IDAStatics_Type;
      e_0  : GNATCOM.Types.VARIANT;
      f_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Transform4x4AnimEx
     (This    : IDAStatics_Type;
      m_0size : GNATCOM.Types.VARIANT;
      m_0     : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Transform4x4Anim
     (This : IDAStatics_Type;
      m_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Compose3
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Compose3ArrayEx
     (This      : IDAStatics_Type;
      xfs_0size : GNATCOM.Types.VARIANT;
      xfs_0     : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Compose3Array
     (This  : IDAStatics_Type;
      xfs_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function LookAtFrom
     (This   : IDAStatics_Type;
      to_0   : GNATCOM.Types.VARIANT;
      from_1 : GNATCOM.Types.VARIANT;
      up_2   : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Get_IdentityTransform2
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

   function Translate2Anim
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Translate2
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Translate2Rate
     (This : IDAStatics_Type;
      tx_0 : GNATCOM.Types.VARIANT;
      ty_1 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Translate2Vector
     (This    : IDAStatics_Type;
      delta_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Translate2Point
     (This  : IDAStatics_Type;
      pos_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale2Anim
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale2
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale2Rate
     (This : IDAStatics_Type;
      x_0  : GNATCOM.Types.VARIANT;
      y_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale2Vector2
     (This             : IDAStatics_Type;
      obsoleteMethod_0 : GNATCOM.Types.VARIANT;
      Free             : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale2Vector
     (This        : IDAStatics_Type;
      scale_vec_0 : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale2UniformAnim
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale2Uniform
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Scale2UniformRate
     (This            : IDAStatics_Type;
      uniform_scale_0 : GNATCOM.Types.VARIANT;
      Free            : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rotate2Anim
     (This    : IDAStatics_Type;
      angle_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rotate2
     (This    : IDAStatics_Type;
      angle_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rotate2Rate
     (This    : IDAStatics_Type;
      angle_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rotate2Degrees
     (This    : IDAStatics_Type;
      angle_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Rotate2RateDegrees
     (This    : IDAStatics_Type;
      angle_0 : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function XShear2Anim
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function XShear2
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function XShear2Rate
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function YShear2Anim
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function YShear2
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function YShear2Rate
     (This  : IDAStatics_Type;
      arg_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Transform3x2AnimEx
     (This    : IDAStatics_Type;
      m_0size : GNATCOM.Types.VARIANT;
      m_0     : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Transform3x2Anim
     (This : IDAStatics_Type;
      m_0  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Compose2
     (This : IDAStatics_Type;
      a_0  : GNATCOM.Types.VARIANT;
      b_1  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Compose2ArrayEx
     (This      : IDAStatics_Type;
      xfs_0size : GNATCOM.Types.VARIANT;
      xfs_0     : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Compose2Array
     (This  : IDAStatics_Type;
      xfs_0 : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;

   function Tuple
     (This      : IDAStatics_Type;
      obsolete1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;
   --  Obsolete method: Use DATuple instead

   function uArray
     (This      : IDAStatics_Type;
      obsolete1 : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
     return GNATCOM.Types.VARIANT;
   --  Obsolete method: Use DAArray instead

   function Get_AreBlockingImportsComplete
     (This : IDAStatics_Type)
     return GNATCOM.Types.VARIANT;

end StructuredGraphicControl.IDAStatics_Object;

