with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAString_Interface is

   type IDAString_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAString_Type);

   function Pointer (This : IDAString_Type)
     return Pointer_To_IDAString;

   procedure Attach (This    : in out IDAString_Type;
                     Pointer : in     Pointer_To_IDAString);

   function GetClassName
     (This       : IDAString_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAString_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAString_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAString_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAString_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAString_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAString_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAString_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAString_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAString_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAString_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAString_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAString_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAString_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Extract
     (This  : IDAString_Type)
     return GNATCOM.Types.BSTR;

   function AnimateProperty
     (This                : IDAString_Type;
      propertyPath_0      : GNATCOM.Types.BSTR;
      scriptingLanguage_1 : GNATCOM.Types.BSTR;
      invokeAsMethod_2    : GNATCOM.Types.VARIANT_BOOL;
      minUpdateInterval_3 : Interfaces.C.double;
      Free                : Boolean := True)
     return Pointer_To_IDAString;

end StructuredGraphicControl.IDAString_Interface;

