with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDATransform2_Interface is

   type IDATransform2_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDATransform2_Type);

   function Pointer (This : IDATransform2_Type)
     return Pointer_To_IDATransform2;

   procedure Attach (This    : in out IDATransform2_Type;
                     Pointer : in     Pointer_To_IDATransform2);

   function GetClassName
     (This       : IDATransform2_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDATransform2_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDATransform2_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDATransform2_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDATransform2_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDATransform2_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDATransform2_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDATransform2_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDATransform2_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDATransform2_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDATransform2_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDATransform2_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDATransform2_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDATransform2_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Inverse
     (This  : IDATransform2_Type)
     return Pointer_To_IDATransform2;

   function Get_IsSingular
     (This  : IDATransform2_Type)
     return Pointer_To_IDABoolean;

end StructuredGraphicControl.IDATransform2_Interface;

