with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDATransform3_Interface is

   type IDATransform3_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDATransform3_Type);

   function Pointer (This : IDATransform3_Type)
     return Pointer_To_IDATransform3;

   procedure Attach (This    : in out IDATransform3_Type;
                     Pointer : in     Pointer_To_IDATransform3);

   function GetClassName
     (This       : IDATransform3_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDATransform3_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDATransform3_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDATransform3_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDATransform3_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDATransform3_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDATransform3_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDATransform3_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDATransform3_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDATransform3_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDATransform3_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDATransform3_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDATransform3_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDATransform3_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Inverse
     (This  : IDATransform3_Type)
     return Pointer_To_IDATransform3;

   function Get_IsSingular
     (This  : IDATransform3_Type)
     return Pointer_To_IDABoolean;

   function ParallelTransform2
     (This  : IDATransform3_Type)
     return Pointer_To_IDATransform2;

end StructuredGraphicControl.IDATransform3_Interface;

