with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDATuple_Interface is

   type IDATuple_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDATuple_Type);

   function Pointer (This : IDATuple_Type)
     return Pointer_To_IDATuple;

   procedure Attach (This    : in out IDATuple_Type;
                     Pointer : in     Pointer_To_IDATuple);

   function GetClassName
     (This       : IDATuple_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDATuple_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDATuple_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDATuple_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDATuple_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDATuple_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDATuple_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDATuple_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDATuple_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDATuple_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDATuple_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDATuple_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDATuple_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDATuple_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Nth
     (This    : IDATuple_Type;
      index_0 : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function Get_Length
     (This  : IDATuple_Type)
     return Interfaces.C.long;

end StructuredGraphicControl.IDATuple_Interface;

