with GNATCOM.Interface;

with GNATCOM.Errors;

package body StructuredGraphicControl.IDAUntilNotifier_Interface is

   procedure Initialize (This : in out IDAUntilNotifier_Type) is
   begin
      Set_IID (This, IID_IDAUntilNotifier);
   end Initialize;

   function Pointer (This : IDAUntilNotifier_Type)
     return Pointer_To_IDAUntilNotifier
   is
   begin
      return To_Pointer_To_IDAUntilNotifier (Address (This));
   end Pointer;

   procedure Attach (This    : in out IDAUntilNotifier_Type;
                     Pointer : in     Pointer_To_IDAUntilNotifier)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Notify
     (This          : IDAUntilNotifier_Type;
      eventData     : Pointer_To_IDABehavior;
      curRunningBvr : Pointer_To_IDABehavior;
      curView       : Pointer_To_IDAView)
     return Pointer_To_IDABehavior
   is
       RetVal : aliased Pointer_To_IDABehavior;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Notify
         (Pointer (This),
          eventData,
          curRunningBvr,
          curView,
          RetVal'Unchecked_Access));

      return RetVal;
   end Notify;

end StructuredGraphicControl.IDAUntilNotifier_Interface;

