with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAUserData_Interface is

   type IDAUserData_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAUserData_Type);

   function Pointer (This : IDAUserData_Type)
     return Pointer_To_IDAUserData;

   procedure Attach (This    : in out IDAUserData_Type;
                     Pointer : in     Pointer_To_IDAUserData);

   function GetClassName
     (This       : IDAUserData_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAUserData_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAUserData_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAUserData_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAUserData_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAUserData_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAUserData_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAUserData_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAUserData_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAUserData_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAUserData_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAUserData_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAUserData_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAUserData_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Get_Data
     (This  : IDAUserData_Type)
     return GNATCOM.Types.Pointer_To_IUnknown;

end StructuredGraphicControl.IDAUserData_Interface;

