with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAVector2_Interface is

   type IDAVector2_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IDAVector2_Type);

   function Pointer (This : IDAVector2_Type)
     return Pointer_To_IDAVector2;

   procedure Attach (This    : in out IDAVector2_Type;
                     Pointer : in     Pointer_To_IDAVector2);

   function GetClassName
     (This       : IDAVector2_Type)
     return GNATCOM.Types.BSTR;

   procedure Init
     (This  : IDAVector2_Type;
      toBvr : Pointer_To_IDABehavior);

   function Importance
     (This               : IDAVector2_Type;
      relativeImportance : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function RunOnce
     (This : IDAVector2_Type)
     return Pointer_To_IDABehavior;

   function SubstituteTime
     (This  : IDAVector2_Type;
      xform : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   procedure SwitchTo
     (This     : IDAVector2_Type;
      SwitchTo : Pointer_To_IDABehavior);

   procedure SwitchToNumber
     (This          : IDAVector2_Type;
      numToSwitchTo : Interfaces.C.double);

   procedure SwitchToString
     (This          : IDAVector2_Type;
      strToSwitchTo : GNATCOM.Types.BSTR;
      Free          : Boolean := True);

   function Hook
     (This     : IDAVector2_Type;
      notifier : Pointer_To_IDABvrHook)
     return Pointer_To_IDABehavior;

   function Duration
     (This     : IDAVector2_Type;
      Duration : Interfaces.C.double)
     return Pointer_To_IDABehavior;

   function DurationAnim
     (This     : IDAVector2_Type;
      Duration : Pointer_To_IDANumber)
     return Pointer_To_IDABehavior;

   function Repeat
     (This  : IDAVector2_Type;
      count : Interfaces.C.long)
     return Pointer_To_IDABehavior;

   function RepeatForever
     (This : IDAVector2_Type)
     return Pointer_To_IDABehavior;

   function IsReady
     (This   : IDAVector2_Type;
      bBlock : GNATCOM.Types.VARIANT_BOOL)
     return GNATCOM.Types.VARIANT_BOOL;

   function Get_Length
     (This  : IDAVector2_Type)
     return Pointer_To_IDANumber;

   function Get_LengthSquared
     (This  : IDAVector2_Type)
     return Pointer_To_IDANumber;

   function Normalize
     (This  : IDAVector2_Type)
     return Pointer_To_IDAVector2;

   function MulAnim
     (This     : IDAVector2_Type;
      scalar_0 : Pointer_To_IDANumber)
     return Pointer_To_IDAVector2;

   function Mul
     (This     : IDAVector2_Type;
      scalar_0 : Interfaces.C.double)
     return Pointer_To_IDAVector2;

   function DivAnim
     (This     : IDAVector2_Type;
      scalar_0 : Pointer_To_IDANumber)
     return Pointer_To_IDAVector2;

   function Div
     (This     : IDAVector2_Type;
      scalar_0 : Interfaces.C.double)
     return Pointer_To_IDAVector2;

   function Get_X
     (This  : IDAVector2_Type)
     return Pointer_To_IDANumber;

   function Get_Y
     (This  : IDAVector2_Type)
     return Pointer_To_IDANumber;

   function Get_PolarCoordAngle
     (This  : IDAVector2_Type)
     return Pointer_To_IDANumber;

   function Get_PolarCoordLength
     (This  : IDAVector2_Type)
     return Pointer_To_IDANumber;

   function Transform
     (This  : IDAVector2_Type;
      xf_0  : Pointer_To_IDATransform2)
     return Pointer_To_IDAVector2;

end StructuredGraphicControl.IDAVector2_Interface;

