package body StructuredGraphicControl.IDAVector2_Object is

   function GetClassName
     (This : IDAVector2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAVector2_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDAVector2_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAVector2_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDAVector2_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDAVector2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAVector2_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDAVector2_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDAVector2_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAVector2_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDAVector2_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAVector2_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDAVector2_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAVector2_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDAVector2_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDAVector2_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDAVector2_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDAVector2_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDAVector2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAVector2_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDAVector2_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function Get_Length
     (This : IDAVector2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector2_Get_Length);
   end Get_Length;

   function Get_LengthSquared
     (This : IDAVector2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector2_Get_LengthSquared);
   end Get_LengthSquared;

   function Normalize
     (This : IDAVector2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAVector2_Normalize);
   end Normalize;

   function MulAnim
     (This     : IDAVector2_Type;
      scalar_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_MulAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => scalar_0),
         Free);
   end MulAnim;

   function Mul
     (This     : IDAVector2_Type;
      scalar_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_Mul,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => scalar_0),
         Free);
   end Mul;

   function DivAnim
     (This     : IDAVector2_Type;
      scalar_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_DivAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => scalar_0),
         Free);
   end DivAnim;

   function Div
     (This     : IDAVector2_Type;
      scalar_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_Div,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => scalar_0),
         Free);
   end Div;

   function Get_X
     (This : IDAVector2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector2_Get_X);
   end Get_X;

   function Get_Y
     (This : IDAVector2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector2_Get_Y);
   end Get_Y;

   function Get_PolarCoordAngle
     (This : IDAVector2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector2_Get_PolarCoordAngle);
   end Get_PolarCoordAngle;

   function Get_PolarCoordLength
     (This : IDAVector2_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector2_Get_PolarCoordLength);
   end Get_PolarCoordLength;

   function Transform
     (This : IDAVector2_Type;
      xf_0 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector2_Transform,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xf_0),
         Free);
   end Transform;

end StructuredGraphicControl.IDAVector2_Object;

