package body StructuredGraphicControl.IDAVector3_Object is

   function GetClassName
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAVector3_GetClassName);
   end GetClassName;

   procedure Init
     (This  : IDAVector3_Type;
      toBvr : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAVector3_Init,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => toBvr),
         Free);
   end Init;

   function Importance
     (This               : IDAVector3_Type;
      relativeImportance : GNATCOM.Types.VARIANT;
      Free               : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_Importance,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => relativeImportance),
         Free);
   end Importance;

   function RunOnce
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAVector3_RunOnce);
   end RunOnce;

   function SubstituteTime
     (This  : IDAVector3_Type;
      xform : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_SubstituteTime,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xform),
         Free);
   end SubstituteTime;

   procedure SwitchTo
     (This     : IDAVector3_Type;
      SwitchTo : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAVector3_SwitchTo,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => SwitchTo),
         Free);
   end SwitchTo;

   procedure SwitchToNumber
     (This          : IDAVector3_Type;
      numToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAVector3_SwitchToNumber,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => numToSwitchTo),
         Free);
   end SwitchToNumber;

   procedure SwitchToString
     (This          : IDAVector3_Type;
      strToSwitchTo : GNATCOM.Types.VARIANT;
      Free          : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAVector3_SwitchToString,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => strToSwitchTo),
         Free);
   end SwitchToString;

   function Hook
     (This     : IDAVector3_Type;
      notifier : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_Hook,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => notifier),
         Free);
   end Hook;

   function Duration
     (This     : IDAVector3_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_Duration,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end Duration;

   function DurationAnim
     (This     : IDAVector3_Type;
      Duration : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_DurationAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => Duration),
         Free);
   end DurationAnim;

   function Repeat
     (This  : IDAVector3_Type;
      count : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_Repeat,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => count),
         Free);
   end Repeat;

   function RepeatForever
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAVector3_RepeatForever);
   end RepeatForever;

   function IsReady
     (This   : IDAVector3_Type;
      bBlock : GNATCOM.Types.VARIANT;
      Free   : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_IsReady,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bBlock),
         Free);
   end IsReady;

   function Get_Length
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector3_Get_Length);
   end Get_Length;

   function Get_LengthSquared
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector3_Get_LengthSquared);
   end Get_LengthSquared;

   function Normalize
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke (This, IDAVector3_Normalize);
   end Normalize;

   function MulAnim
     (This     : IDAVector3_Type;
      scalar_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_MulAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => scalar_0),
         Free);
   end MulAnim;

   function Mul
     (This     : IDAVector3_Type;
      scalar_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_Mul,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => scalar_0),
         Free);
   end Mul;

   function DivAnim
     (This     : IDAVector3_Type;
      scalar_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_DivAnim,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => scalar_0),
         Free);
   end DivAnim;

   function Div
     (This     : IDAVector3_Type;
      scalar_0 : GNATCOM.Types.VARIANT;
      Free     : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_Div,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => scalar_0),
         Free);
   end Div;

   function Get_X
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector3_Get_X);
   end Get_X;

   function Get_Y
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector3_Get_Y);
   end Get_Y;

   function Get_Z
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector3_Get_Z);
   end Get_Z;

   function Get_SphericalCoordXYAngle
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector3_Get_SphericalCoordXYAngle);
   end Get_SphericalCoordXYAngle;

   function Get_SphericalCoordYZAngle
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector3_Get_SphericalCoordYZAngle);
   end Get_SphericalCoordYZAngle;

   function Get_SphericalCoordLength
     (This : IDAVector3_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAVector3_Get_SphericalCoordLength);
   end Get_SphericalCoordLength;

   function Transform
     (This : IDAVector3_Type;
      xf_0 : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAVector3_Transform,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => xf_0),
         Free);
   end Transform;

end StructuredGraphicControl.IDAVector3_Object;

