package body StructuredGraphicControl.IDAView_Object is

   function Get_SimulationTime
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAView_Get_SimulationTime);
   end Get_SimulationTime;

   function Tick
     (This    : IDAView_Type;
      simTime : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAView_Tick,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => simTime),
         Free);
   end Tick;

   procedure Render
     (This : IDAView_Type)
   is
   begin
      Invoke (This, IDAView_Render);
   end Render;

   function AddBvrToRun
     (This : IDAView_Type;
      bvr  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAView_AddBvrToRun,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bvr),
         Free);
   end AddBvrToRun;

   procedure RemoveRunningBvr
     (This : IDAView_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAView_RemoveRunningBvr,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => id),
         Free);
   end RemoveRunningBvr;

   procedure StartModel
     (This      : IDAView_Type;
      pImage    : GNATCOM.Types.VARIANT;
      pSound    : GNATCOM.Types.VARIANT;
      startTime : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAView_StartModel,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => startTime,
          2 => pSound,
          3 => pImage),
         Free);
   end StartModel;

   procedure StopModel
     (This : IDAView_Type)
   is
   begin
      Invoke (This, IDAView_StopModel);
   end StopModel;

   function Get_Window
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAView_Get_Window);
   end Get_Window;

   procedure Put_Window
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDAView_Put_Window,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_Window;

   function Get_IDirectDrawSurface
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAView_Get_IDirectDrawSurface);
   end Get_IDirectDrawSurface;

   procedure Put_IDirectDrawSurface
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDAView_Put_IDirectDrawSurface,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_IDirectDrawSurface;

   function Get_DC
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAView_Get_DC);
   end Get_DC;

   procedure Put_DC
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDAView_Put_DC,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_DC;

   function Get_CompositeDirectlyToTarget
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAView_Get_CompositeDirectlyToTarget);
   end Get_CompositeDirectlyToTarget;

   procedure Put_CompositeDirectlyToTarget
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDAView_Put_CompositeDirectlyToTarget,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_CompositeDirectlyToTarget;

   procedure SetViewport
     (This : IDAView_Type;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      w    : GNATCOM.Types.VARIANT;
      h    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAView_SetViewport,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => h,
          2 => w,
          3 => yPos,
          4 => xPos),
         Free);
   end SetViewport;

   procedure SetClipRect
     (This : IDAView_Type;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      w    : GNATCOM.Types.VARIANT;
      h    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAView_SetClipRect,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => h,
          2 => w,
          3 => yPos,
          4 => xPos),
         Free);
   end SetClipRect;

   procedure RePaint
     (This : IDAView_Type;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      w    : GNATCOM.Types.VARIANT;
      h    : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAView_RePaint,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => h,
          2 => w,
          3 => yPos,
          4 => xPos),
         Free);
   end RePaint;

   procedure PaletteChanged
     (This : IDAView_Type;
      bNew : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAView_PaletteChanged,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bNew),
         Free);
   end PaletteChanged;

   function Get_Site
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAView_Get_Site);
   end Get_Site;

   procedure Put_Site
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDAView_Put_Site,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_Site;

   procedure Put_ClientSite
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IDAView_Put_ClientSite,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Put_ClientSite;

   function Get_ClientSite
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAView_Get_ClientSite);
   end Get_ClientSite;

   procedure OnMouseMove
     (This      : IDAView_Type;
      uwhen     : GNATCOM.Types.VARIANT;
      xPos      : GNATCOM.Types.VARIANT;
      yPos      : GNATCOM.Types.VARIANT;
      modifiers : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAView_OnMouseMove,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => modifiers,
          2 => yPos,
          3 => xPos,
          4 => uwhen),
         Free);
   end OnMouseMove;

   procedure OnMouseButton
     (This      : IDAView_Type;
      uwhen     : GNATCOM.Types.VARIANT;
      xPos      : GNATCOM.Types.VARIANT;
      yPos      : GNATCOM.Types.VARIANT;
      button    : GNATCOM.Types.VARIANT;
      bPressed  : GNATCOM.Types.VARIANT;
      modifiers : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAView_OnMouseButton,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => modifiers,
          2 => bPressed,
          3 => button,
          4 => yPos,
          5 => xPos,
          6 => uwhen),
         Free);
   end OnMouseButton;

   procedure OnKey
     (This      : IDAView_Type;
      uwhen     : GNATCOM.Types.VARIANT;
      key       : GNATCOM.Types.VARIANT;
      bPressed  : GNATCOM.Types.VARIANT;
      modifiers : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAView_OnKey,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => modifiers,
          2 => bPressed,
          3 => key,
          4 => uwhen),
         Free);
   end OnKey;

   procedure OnFocus
     (This      : IDAView_Type;
      bHasFocus : GNATCOM.Types.VARIANT;
      Free      : Boolean := True)
   is
   begin
      Invoke
        (This,
         IDAView_OnFocus,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => bHasFocus),
         Free);
   end OnFocus;

   function Get_Preferences
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IDAView_Get_Preferences);
   end Get_Preferences;

   function QueryHitPoint
     (This       : IDAView_Type;
      dwAspect   : GNATCOM.Types.VARIANT;
      prcBounds  : GNATCOM.Types.VARIANT;
      ptLoc      : GNATCOM.Types.VARIANT;
      lCloseHint : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Invoke
        (This,
         IDAView_QueryHitPoint,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => lCloseHint,
          2 => ptLoc,
          3 => prcBounds,
          4 => dwAspect),
         Free);
   end QueryHitPoint;

end StructuredGraphicControl.IDAView_Object;

