with GNATCOM.Dispinterface;

package StructuredGraphicControl.IDAView_Object is

   type IDAView_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   function Get_SimulationTime
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT;
   --  The current simulation time.

   function Tick
     (This    : IDAView_Type;
      simTime : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure Render
     (This : IDAView_Type);

   function AddBvrToRun
     (This : IDAView_Type;
      bvr  : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
     return GNATCOM.Types.VARIANT;

   procedure RemoveRunningBvr
     (This : IDAView_Type;
      id   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure StartModel
     (This      : IDAView_Type;
      pImage    : GNATCOM.Types.VARIANT;
      pSound    : GNATCOM.Types.VARIANT;
      startTime : GNATCOM.Types.VARIANT;
      Free      : Boolean := True);

   procedure StopModel
     (This : IDAView_Type);

   function Get_Window
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT;
   --  The window to display the view in.

   procedure Put_Window
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  The window to display the view in.

   function Get_IDirectDrawSurface
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT;
   --  The DirectDraw Surface to display the view in.

   procedure Put_IDirectDrawSurface
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  The DirectDraw Surface to display the view in.

   function Get_DC
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT;
   --  The HDC to display the view in.

   procedure Put_DC
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  The HDC to display the view in.

   function Get_CompositeDirectlyToTarget
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT;
   --  Composition mode: compose to backbuffer or directly to target

   procedure Put_CompositeDirectlyToTarget
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Composition mode: compose to backbuffer or directly to target

   procedure SetViewport
     (This : IDAView_Type;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      w    : GNATCOM.Types.VARIANT;
      h    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure SetClipRect
     (This : IDAView_Type;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      w    : GNATCOM.Types.VARIANT;
      h    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure RePaint
     (This : IDAView_Type;
      xPos : GNATCOM.Types.VARIANT;
      yPos : GNATCOM.Types.VARIANT;
      w    : GNATCOM.Types.VARIANT;
      h    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure PaletteChanged
     (This : IDAView_Type;
      bNew : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_Site
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_Site
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   procedure Put_ClientSite
     (This : IDAView_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_ClientSite
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT;

   procedure OnMouseMove
     (This      : IDAView_Type;
      uwhen     : GNATCOM.Types.VARIANT;
      xPos      : GNATCOM.Types.VARIANT;
      yPos      : GNATCOM.Types.VARIANT;
      modifiers : GNATCOM.Types.VARIANT;
      Free      : Boolean := True);

   procedure OnMouseButton
     (This      : IDAView_Type;
      uwhen     : GNATCOM.Types.VARIANT;
      xPos      : GNATCOM.Types.VARIANT;
      yPos      : GNATCOM.Types.VARIANT;
      button    : GNATCOM.Types.VARIANT;
      bPressed  : GNATCOM.Types.VARIANT;
      modifiers : GNATCOM.Types.VARIANT;
      Free      : Boolean := True);

   procedure OnKey
     (This      : IDAView_Type;
      uwhen     : GNATCOM.Types.VARIANT;
      key       : GNATCOM.Types.VARIANT;
      bPressed  : GNATCOM.Types.VARIANT;
      modifiers : GNATCOM.Types.VARIANT;
      Free      : Boolean := True);

   procedure OnFocus
     (This      : IDAView_Type;
      bHasFocus : GNATCOM.Types.VARIANT;
      Free      : Boolean := True);

   function Get_Preferences
     (This : IDAView_Type)
     return GNATCOM.Types.VARIANT;

   function QueryHitPoint
     (This       : IDAView_Type;
      dwAspect   : GNATCOM.Types.VARIANT;
      prcBounds  : GNATCOM.Types.VARIANT;
      ptLoc      : GNATCOM.Types.VARIANT;
      lCloseHint : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.VARIANT;

end StructuredGraphicControl.IDAView_Object;

