with GNATCOM.Interface;

with GNATCOM.Errors;

package body StructuredGraphicControl.IDAViewSite_Interface is

   procedure Initialize (This : in out IDAViewSite_Type) is
   begin
      Set_IID (This, IID_IDAViewSite);
   end Initialize;

   function Pointer (This : IDAViewSite_Type)
     return Pointer_To_IDAViewSite
   is
   begin
      return To_Pointer_To_IDAViewSite (Address (This));
   end Pointer;

   procedure Attach (This    : in out IDAViewSite_Type;
                     Pointer : in     Pointer_To_IDAViewSite)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure SetStatusText
     (This       : IDAViewSite_Type;
      StatusText : GNATCOM.Types.BSTR;
      Free       : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.SetStatusText
         (Pointer (This),
          StatusText));

      if Free then
               GNATCOM.Interface.Free (StatusText);
      
      end if;

   end SetStatusText;

end StructuredGraphicControl.IDAViewSite_Interface;

