with GNATCOM.Dispinterface;

package StructuredGraphicControl.IMMSeq_Interface is

   type IMMSeq_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IMMSeq_Type);

   function Pointer (This : IMMSeq_Type)
     return Pointer_To_IMMSeq;

   procedure Attach (This    : in out IMMSeq_Type;
                     Pointer : in     Pointer_To_IMMSeq);

   function Get_Time
     (This            : IMMSeq_Type)
     return Interfaces.C.double;

   function Get_PlayState
     (This        : IMMSeq_Type)
     return Interfaces.C.int;

   procedure Putu_Cookie
     (This     : IMMSeq_Type;
      plCookie : Interfaces.C.long);

   function Getu_Cookie
     (This     : IMMSeq_Type)
     return Interfaces.C.long;

   procedure Play
     (This : IMMSeq_Type);

   procedure Pause
     (This : IMMSeq_Type);

   procedure Stop
     (This : IMMSeq_Type);

   procedure uAt
     (This              : IMMSeq_Type;
      varStartTime      : GNATCOM.Types.VARIANT;
      bstrScriptlet     : GNATCOM.Types.BSTR;
      varRepeatCount    : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      varSampleRate     : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      varTiebreakNumber : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      varDropTolerance  : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free              : Boolean := True);

   procedure Clear
     (This : IMMSeq_Type);

   procedure Seek
     (This        : IMMSeq_Type;
      dblSeekTime : Interfaces.C.double);

end StructuredGraphicControl.IMMSeq_Interface;

