package body StructuredGraphicControl.IMMSeq_Object is

   function Get_Time
     (This : IMMSeq_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IMMSeq_Get_Time);
   end Get_Time;

   function Get_PlayState
     (This : IMMSeq_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IMMSeq_Get_PlayState);
   end Get_PlayState;

   procedure Putu_Cookie
     (This : IMMSeq_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True)
   is
   begin
      Put
        (This,
         IMMSeq_Putu_Cookie,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => P1),
         Free);
   end Putu_Cookie;

   function Getu_Cookie
     (This : IMMSeq_Type)
     return GNATCOM.Types.VARIANT
   is
   begin
      return Get (This, IMMSeq_Getu_Cookie);
   end Getu_Cookie;

   procedure Play
     (This : IMMSeq_Type)
   is
   begin
      Invoke (This, IMMSeq_Play);
   end Play;

   procedure Pause
     (This : IMMSeq_Type)
   is
   begin
      Invoke (This, IMMSeq_Pause);
   end Pause;

   procedure Stop
     (This : IMMSeq_Type)
   is
   begin
      Invoke (This, IMMSeq_Stop);
   end Stop;

   procedure uAt
     (This              : IMMSeq_Type;
      varStartTime      : GNATCOM.Types.VARIANT;
      bstrScriptlet     : GNATCOM.Types.VARIANT;
      varRepeatCount    : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      varSampleRate     : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      varTiebreakNumber : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      varDropTolerance  : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free              : Boolean := True)
   is
   begin
      Invoke
        (This,
         IMMSeq_uAt,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => varDropTolerance,
          2 => varTiebreakNumber,
          3 => varSampleRate,
          4 => varRepeatCount,
          5 => bstrScriptlet,
          6 => varStartTime),
         Free);
   end uAt;

   procedure Clear
     (This : IMMSeq_Type)
   is
   begin
      Invoke (This, IMMSeq_Clear);
   end Clear;

   procedure Seek
     (This        : IMMSeq_Type;
      dblSeekTime : GNATCOM.Types.VARIANT;
      Free        : Boolean := True)
   is
   begin
      Invoke
        (This,
         IMMSeq_Seek,
         GNATCOM.Dispinterface.Parameter_Array'
         (1 => dblSeekTime),
         Free);
   end Seek;

end StructuredGraphicControl.IMMSeq_Object;

