with GNATCOM.Interface;

with GNATCOM.Errors;

package body StructuredGraphicControl.IMMSeqMgr_Interface is

   procedure Initialize (This : in out IMMSeqMgr_Type) is
   begin
      Set_IID (This, IID_IMMSeqMgr);
   end Initialize;

   function Pointer (This : IMMSeqMgr_Type)
     return Pointer_To_IMMSeqMgr
   is
   begin
      return To_Pointer_To_IMMSeqMgr (Address (This));
   end Pointer;

   procedure Attach (This    : in out IMMSeqMgr_Type;
                     Pointer : in     Pointer_To_IMMSeqMgr)
   is
   begin
      Attach (This, GNATCOM.Interface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

    function Get_Item
     (This       : IMMSeqMgr_Type;
      variant    : GNATCOM.Types.VARIANT;
      Free       : Boolean := True)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Item
         (Pointer (This),
          variant,
          RetVal'Unchecked_Access));

      if Free then
               GNATCOM.Interface.Free (variant);
      
      end if;

      return RetVal;
   end Get_Item;

    function Getu_NewEnum
     (This : IMMSeqMgr_Type)
     return GNATCOM.Types.Pointer_To_IUnknown
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IUnknown;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Getu_NewEnum
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Getu_NewEnum;

    function Get_Count
     (This    : IMMSeqMgr_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_Count
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_Count;

   procedure RelayEvent
     (This        : IMMSeqMgr_Type;
      dispid      : Interfaces.C.long;
      lCookie     : Interfaces.C.long;
      dblSeekTime : Interfaces.C.double)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.RelayEvent
         (Pointer (This),
          dispid,
          lCookie,
          dblSeekTime));

   end RelayEvent;

end StructuredGraphicControl.IMMSeqMgr_Interface;

