package body StructuredGraphicControl.IMMSeqMgrEvents_Events is

   procedure Invoke
     (dispidMember : in Interfaces.C.long;
      wFlags       : in Interfaces.C.unsigned_short;
      pdispparams  : in GNATCOM.Types.Pointer_To_DISPPARAMS;
      Event_Object : in GNATCOM.Events.Event_Object.Event_Pointer)
   is
      use type Interfaces.C.long;
   begin
      case dispidMember is
         when IMMSeqMgrEvents_oninit=>
            oninit
              (IMMSeqMgrEvents_Event'Class (Event_Object.all));
         when IMMSeqMgrEvents_onplay=>
            onplay
              (IMMSeqMgrEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when IMMSeqMgrEvents_onstop=>
            onstop
              (IMMSeqMgrEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when IMMSeqMgrEvents_onpause=>
            onpause
              (IMMSeqMgrEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when IMMSeqMgrEvents_onseek=>
            onseek
              (IMMSeqMgrEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (1),
               pdispparams.rgvarg (0));
         when others =>
            null;
      end case;
   end Invoke;

   function Create (From : in GNATCOM.Events.Event_Object.Event_Pointer)
     return GNATCOM.Create.COM_Interface.Pointer_To_COM_Interface_Type
   is
   begin
      return GNATCOM.Events.Event_Object.Create
        (Invoke'Access,
         IID_IMMSeqMgrEvents,
         From);
   end Create;

   procedure Set_Events
     (This            : in out GNATCOM.Events.IConnectionPoint_Type;
      For_Object      : in     GNATCOM.Interface.Interface_Type'Class;
      Event_Interface :
        access GNATCOM.Create.COM_Interface.COM_Interface_Type;
      Free            : Boolean := True)
   is
   begin
      GNATCOM.Events.Set_Events
        (This,
         For_Object,
         IID_IMMSeqMgrEvents,
         Event_Interface,
         Free);
   end Set_Events;

   procedure oninit
     (This : IMMSeqMgrEvents_Event)
   is
   begin
      null;
   end oninit;

   procedure onplay
     (This         : IMMSeqMgrEvents_Event;
      bstrTimeline : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onplay;

   procedure onstop
     (This         : IMMSeqMgrEvents_Event;
      bstrTimeline : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onstop;

   procedure onpause
     (This         : IMMSeqMgrEvents_Event;
      bstrTimeline : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onpause;

   procedure onseek
     (This         : IMMSeqMgrEvents_Event;
      bstrTimeline : GNATCOM.Types.VARIANT;
      dblSeekTime  : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onseek;

end StructuredGraphicControl.IMMSeqMgrEvents_Events;

