package body StructuredGraphicControl.IPathCtlEvents_Events is

   procedure Invoke
     (dispidMember : in Interfaces.C.long;
      wFlags       : in Interfaces.C.unsigned_short;
      pdispparams  : in GNATCOM.Types.Pointer_To_DISPPARAMS;
      Event_Object : in GNATCOM.Events.Event_Object.Event_Pointer)
   is
      use type Interfaces.C.long;
   begin
      case dispidMember is
         when IPathCtlEvents_onstop=>
            onstop
              (IPathCtlEvents_Event'Class (Event_Object.all));
         when IPathCtlEvents_onplay=>
            onplay
              (IPathCtlEvents_Event'Class (Event_Object.all));
         when IPathCtlEvents_onpause=>
            onpause
              (IPathCtlEvents_Event'Class (Event_Object.all));
         when IPathCtlEvents_onseek=>
            onseek
              (IPathCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when IPathCtlEvents_onplaymarker=>
            onplaymarker
              (IPathCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when IPathCtlEvents_onmarker=>
            onmarker
              (IPathCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when others =>
            null;
      end case;
   end Invoke;

   function Create (From : in GNATCOM.Events.Event_Object.Event_Pointer)
     return GNATCOM.Create.COM_Interface.Pointer_To_COM_Interface_Type
   is
   begin
      return GNATCOM.Events.Event_Object.Create
        (Invoke'Access,
         IID_IPathCtlEvents,
         From);
   end Create;

   procedure Set_Events
     (This            : in out GNATCOM.Events.IConnectionPoint_Type;
      For_Object      : in     GNATCOM.Interface.Interface_Type'Class;
      Event_Interface :
        access GNATCOM.Create.COM_Interface.COM_Interface_Type;
      Free            : Boolean := True)
   is
   begin
      GNATCOM.Events.Set_Events
        (This,
         For_Object,
         IID_IPathCtlEvents,
         Event_Interface,
         Free);
   end Set_Events;

   procedure onstop
     (This : IPathCtlEvents_Event)
   is
   begin
      null;
   end onstop;

   procedure onplay
     (This : IPathCtlEvents_Event)
   is
   begin
      null;
   end onplay;

   procedure onpause
     (This : IPathCtlEvents_Event)
   is
   begin
      null;
   end onpause;

   procedure onseek
     (This    : IPathCtlEvents_Event;
      dblTime : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onseek;

   procedure onplaymarker
     (This : IPathCtlEvents_Event;
      name : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onplaymarker;

   procedure onmarker
     (This : IPathCtlEvents_Event;
      name : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onmarker;

end StructuredGraphicControl.IPathCtlEvents_Events;

