with GNATCOM.Dispinterface;

package StructuredGraphicControl.ISGrfxCtl_Object is

   type ISGrfxCtl_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   function Get_SourceURL
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Sets or returns the URL of a file containing Structured Graphics drawing
   --  primitives

   procedure Put_SourceURL
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Sets or returns the URL of a file containing Structured Graphics drawing
   --  primitives

   function Get_CoordinateSystem
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Sets or returns the coordinate system to use for the world

   procedure Put_CoordinateSystem
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Sets or returns the coordinate system to use for the world

   function Get_MouseEventsEnabled
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Enables or disables mouse events

   procedure Put_MouseEventsEnabled
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Enables or disables mouse events

   function Get_ExtentTop
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Sets or returns the vertical coordinates for the top edge of the logical
   --  coordinate system

   procedure Put_ExtentTop
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Sets or returns the vertical coordinates for the top edge of the logical
   --  coordinate system

   function Get_ExtentLeft
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Sets or returns the horizontal coordinates for the left edge of the
   --  logical coordinate system

   procedure Put_ExtentLeft
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Sets or returns the horizontal coordinates for the left edge of the
   --  logical coordinate system

   function Get_ExtentWidth
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Sets or returns the width of the logical coordinate system

   procedure Put_ExtentWidth
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Sets or returns the width of the logical coordinate system

   function Get_ExtentHeight
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Sets or returns the height of the logical coordinate system

   procedure Put_ExtentHeight
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Sets or returns the height of the logical coordinate system

   function Get_HighQuality
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Enables or disables anti-aliasing

   procedure Put_HighQuality
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Enables or disables anti-aliasing

   function Get_Library
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Gets the Direct Animation Library

   function Get_Image
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Sets or returns the current DirectAnimation Image

   procedure Put_Image
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Sets or returns the current DirectAnimation Image

   function Get_Transform
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Sets or returns the current DirectAnimation transform

   procedure Put_Transform
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Sets or returns the current DirectAnimation transform

   function Get_DrawingSurface
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Sets or returns the current DirectAnimation Drawing Surface

   procedure Put_DrawingSurface
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Sets or returns the current DirectAnimation Drawing Surface

   function Get_DrawSurface
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_DrawSurface
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_PreserveAspectRatio
     (This : ISGrfxCtl_Type)
     return GNATCOM.Types.VARIANT;
   --  Sets or returns a value indicating if aspect ratio should be preserved
   --  when extents are set

   procedure Put_PreserveAspectRatio
     (This : ISGrfxCtl_Type;
      P1   : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Sets or returns a value indicating if aspect ratio should be preserved
   --  when extents are set

   procedure Clear
     (This : ISGrfxCtl_Type);
   --  Clears the drawing area

   procedure Rotate
     (This        : ISGrfxCtl_Type;
      dblXRot     : GNATCOM.Types.VARIANT;
      dblYRot     : GNATCOM.Types.VARIANT;
      dblZRot     : GNATCOM.Types.VARIANT;
      varReserved : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free        : Boolean := True);
   --  Rotates the coordinate space

   procedure Scale
     (This        : ISGrfxCtl_Type;
      dblXScale   : GNATCOM.Types.VARIANT;
      dblYScale   : GNATCOM.Types.VARIANT;
      dblZScale   : GNATCOM.Types.VARIANT;
      varReserved : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free        : Boolean := True);
   --  Scales the coordinate space

   procedure SetIdentity
     (This : ISGrfxCtl_Type);
   --  Clears any transforms, restoring the control to its initial settings

   procedure Transform4x4
     (This   : ISGrfxCtl_Type;
      matrix : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);
   --  Sets scaling, rotation, and translation information all at once, using a
   --  transform matrix

   procedure Translate
     (This        : ISGrfxCtl_Type;
      dblXOrigin  : GNATCOM.Types.VARIANT;
      dblYOrigin  : GNATCOM.Types.VARIANT;
      dblZOrigin  : GNATCOM.Types.VARIANT;
      varReserved : GNATCOM.Types.VARIANT
        := GNATCOM.Types.VARIANT_MISSING;
      Free        : Boolean := True);
   --  Sets the X, Y and Z location of the world

end StructuredGraphicControl.ISGrfxCtl_Object;

