with GNATCOM.Dispinterface;

package StructuredGraphicControl.ISGrfxCtlEvents_Object is

   type ISGrfxCtlEvents_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure onmousemove
     (This   : ISGrfxCtlEvents_Type;
      Button : GNATCOM.Types.VARIANT;
      Shift  : GNATCOM.Types.VARIANT;
      X      : GNATCOM.Types.VARIANT;
      Y      : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);
   --  Occurs when the mouse moves over an opaque region of the control

   procedure onmouseover
     (This : ISGrfxCtlEvents_Type);
   --  Occurs when the mouse enters an opaque region of the control

   procedure onmouseout
     (This : ISGrfxCtlEvents_Type);
   --  Occurs when the mouse leaves an opaque region of the control

   procedure onmousedown
     (This   : ISGrfxCtlEvents_Type;
      Button : GNATCOM.Types.VARIANT;
      Shift  : GNATCOM.Types.VARIANT;
      X      : GNATCOM.Types.VARIANT;
      Y      : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);
   --  Occurs when the mouse pointer is over an opaque region of the control
   --  and a mouse button is depressed

   procedure onmouseup
     (This   : ISGrfxCtlEvents_Type;
      Button : GNATCOM.Types.VARIANT;
      Shift  : GNATCOM.Types.VARIANT;
      X      : GNATCOM.Types.VARIANT;
      Y      : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);
   --  Occurs when the mouse pointer is over an opaque region of the control
   --  and a mouse button is released

   procedure ondblclick
     (This : ISGrfxCtlEvents_Type);
   --  Occurs when the mouse pointer is over an opaque region of the control
   --  and the mouse button is double-clicked

   procedure onclick
     (This : ISGrfxCtlEvents_Type);
   --  Occurs when the mouse pointer is over an opaque region of the control
   --  and the mouse button is clicked once

end StructuredGraphicControl.ISGrfxCtlEvents_Object;

