package body StructuredGraphicControl.ISpriteCtlEvents_Events is

   procedure Invoke
     (dispidMember : in Interfaces.C.long;
      wFlags       : in Interfaces.C.unsigned_short;
      pdispparams  : in GNATCOM.Types.Pointer_To_DISPPARAMS;
      Event_Object : in GNATCOM.Events.Event_Object.Event_Pointer)
   is
      use type Interfaces.C.long;
   begin
      case dispidMember is
         when ISpriteCtlEvents_onplaymarker=>
            onplaymarker
              (ISpriteCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when ISpriteCtlEvents_onmarker=>
            onmarker
              (ISpriteCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when ISpriteCtlEvents_onmousemove=>
            onmousemove
              (ISpriteCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (3),
               pdispparams.rgvarg (2),
               pdispparams.rgvarg (1),
               pdispparams.rgvarg (0));
         when ISpriteCtlEvents_onmouseover=>
            onmouseover
              (ISpriteCtlEvents_Event'Class (Event_Object.all));
         when ISpriteCtlEvents_onmouseout=>
            onmouseout
              (ISpriteCtlEvents_Event'Class (Event_Object.all));
         when ISpriteCtlEvents_onmousedown=>
            onmousedown
              (ISpriteCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (3),
               pdispparams.rgvarg (2),
               pdispparams.rgvarg (1),
               pdispparams.rgvarg (0));
         when ISpriteCtlEvents_onmouseup=>
            onmouseup
              (ISpriteCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (3),
               pdispparams.rgvarg (2),
               pdispparams.rgvarg (1),
               pdispparams.rgvarg (0));
         when ISpriteCtlEvents_ondblclick=>
            ondblclick
              (ISpriteCtlEvents_Event'Class (Event_Object.all));
         when ISpriteCtlEvents_onclick=>
            onclick
              (ISpriteCtlEvents_Event'Class (Event_Object.all));
         when ISpriteCtlEvents_onmedialoaded=>
            onmedialoaded
              (ISpriteCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when ISpriteCtlEvents_onseek=>
            onseek
              (ISpriteCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when ISpriteCtlEvents_onframeseek=>
            onframeseek
              (ISpriteCtlEvents_Event'Class (Event_Object.all),
               pdispparams.rgvarg (0));
         when ISpriteCtlEvents_onstop=>
            onstop
              (ISpriteCtlEvents_Event'Class (Event_Object.all));
         when ISpriteCtlEvents_onpause=>
            onpause
              (ISpriteCtlEvents_Event'Class (Event_Object.all));
         when ISpriteCtlEvents_onplay=>
            onplay
              (ISpriteCtlEvents_Event'Class (Event_Object.all));
         when others =>
            null;
      end case;
   end Invoke;

   function Create (From : in GNATCOM.Events.Event_Object.Event_Pointer)
     return GNATCOM.Create.COM_Interface.Pointer_To_COM_Interface_Type
   is
   begin
      return GNATCOM.Events.Event_Object.Create
        (Invoke'Access,
         IID_ISpriteCtlEvents,
         From);
   end Create;

   procedure Set_Events
     (This            : in out GNATCOM.Events.IConnectionPoint_Type;
      For_Object      : in     GNATCOM.Interface.Interface_Type'Class;
      Event_Interface :
        access GNATCOM.Create.COM_Interface.COM_Interface_Type;
      Free            : Boolean := True)
   is
   begin
      GNATCOM.Events.Set_Events
        (This,
         For_Object,
         IID_ISpriteCtlEvents,
         Event_Interface,
         Free);
   end Set_Events;

   procedure onplaymarker
     (This       : ISpriteCtlEvents_Event;
      MarkerName : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onplaymarker;

   procedure onmarker
     (This       : ISpriteCtlEvents_Event;
      MarkerName : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onmarker;

   procedure onmousemove
     (This   : ISpriteCtlEvents_Event;
      Button : GNATCOM.Types.VARIANT;
      Shift  : GNATCOM.Types.VARIANT;
      X      : GNATCOM.Types.VARIANT;
      Y      : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onmousemove;

   procedure onmouseover
     (This : ISpriteCtlEvents_Event)
   is
   begin
      null;
   end onmouseover;

   procedure onmouseout
     (This : ISpriteCtlEvents_Event)
   is
   begin
      null;
   end onmouseout;

   procedure onmousedown
     (This   : ISpriteCtlEvents_Event;
      Button : GNATCOM.Types.VARIANT;
      Shift  : GNATCOM.Types.VARIANT;
      X      : GNATCOM.Types.VARIANT;
      Y      : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onmousedown;

   procedure onmouseup
     (This   : ISpriteCtlEvents_Event;
      Button : GNATCOM.Types.VARIANT;
      Shift  : GNATCOM.Types.VARIANT;
      X      : GNATCOM.Types.VARIANT;
      Y      : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onmouseup;

   procedure ondblclick
     (This : ISpriteCtlEvents_Event)
   is
   begin
      null;
   end ondblclick;

   procedure onclick
     (This : ISpriteCtlEvents_Event)
   is
   begin
      null;
   end onclick;

   procedure onmedialoaded
     (This : ISpriteCtlEvents_Event;
      URL  : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onmedialoaded;

   procedure onseek
     (This : ISpriteCtlEvents_Event;
      Time : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onseek;

   procedure onframeseek
     (This  : ISpriteCtlEvents_Event;
      Frame : GNATCOM.Types.VARIANT)
   is
   begin
      null;
   end onframeseek;

   procedure onstop
     (This : ISpriteCtlEvents_Event)
   is
   begin
      null;
   end onstop;

   procedure onpause
     (This : ISpriteCtlEvents_Event)
   is
   begin
      null;
   end onpause;

   procedure onplay
     (This : ISpriteCtlEvents_Event)
   is
   begin
      null;
   end onplay;

end StructuredGraphicControl.ISpriteCtlEvents_Events;

