with GNATCOM.Dispinterface;

package StructuredGraphicControl.ISpriteCtlEvents_Object is

   type ISpriteCtlEvents_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure onplaymarker
     (This       : ISpriteCtlEvents_Type;
      MarkerName : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);
   --  Occurs when a marker is reached during sprite playback

   procedure onmarker
     (This       : ISpriteCtlEvents_Type;
      MarkerName : GNATCOM.Types.VARIANT;
      Free       : Boolean := True);
   --  Occurs when a marker is reached

   procedure onmousemove
     (This   : ISpriteCtlEvents_Type;
      Button : GNATCOM.Types.VARIANT;
      Shift  : GNATCOM.Types.VARIANT;
      X      : GNATCOM.Types.VARIANT;
      Y      : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);
   --  Occurs when the mouse moves over an opaque region of the control

   procedure onmouseover
     (This : ISpriteCtlEvents_Type);
   --  Occurs when the mouse enters an opaque region of the control

   procedure onmouseout
     (This : ISpriteCtlEvents_Type);
   --  Occurs when the mouse leaves an opaque region of the control

   procedure onmousedown
     (This   : ISpriteCtlEvents_Type;
      Button : GNATCOM.Types.VARIANT;
      Shift  : GNATCOM.Types.VARIANT;
      X      : GNATCOM.Types.VARIANT;
      Y      : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);
   --  Occurs when the mouse pointer is over an opaque region of the control
   --  and a mouse button is depressed

   procedure onmouseup
     (This   : ISpriteCtlEvents_Type;
      Button : GNATCOM.Types.VARIANT;
      Shift  : GNATCOM.Types.VARIANT;
      X      : GNATCOM.Types.VARIANT;
      Y      : GNATCOM.Types.VARIANT;
      Free   : Boolean := True);
   --  Occurs when the mouse pointer is over an opaque region of the control
   --  and a mouse button is released

   procedure ondblclick
     (This : ISpriteCtlEvents_Type);
   --  Occurs when the mouse pointer is over an opaque region of the control
   --  and the mouse button is double-clicked

   procedure onclick
     (This : ISpriteCtlEvents_Type);
   --  Occurs when the mouse pointer is over an opaque region of the control
   --  and the mouse button is clicked once

   procedure onmedialoaded
     (This : ISpriteCtlEvents_Type;
      URL  : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Occurs when the sprite media is completely downloaded

   procedure onseek
     (This : ISpriteCtlEvents_Type;
      Time : GNATCOM.Types.VARIANT;
      Free : Boolean := True);
   --  Occurs after the Seek method is called

   function onframeseek
     (This  : ISpriteCtlEvents_Type;
      Frame : GNATCOM.Types.VARIANT;
      Free  : Boolean := True)
     return GNATCOM.Types.VARIANT;
   --  Occurs after the FrameSeek method is called

   function onstop
     (This : ISpriteCtlEvents_Type)
     return GNATCOM.Types.VARIANT;
   --  Occurs when sprite playback stops

   function onpause
     (This : ISpriteCtlEvents_Type)
     return GNATCOM.Types.VARIANT;
   --  Occurs when sprite playback is paused

   function onplay
     (This : ISpriteCtlEvents_Type)
     return GNATCOM.Types.VARIANT;
   --  Occurs when sprite playback starts

end StructuredGraphicControl.ISpriteCtlEvents_Object;

